﻿// ***********************************************************************
// Solution         : KC.Foundation
// Project          : KC.Foundation
// File             : InvalidEnumCodeException.cs
// Modified         : 2017-04-17  3:01 PM
// ***********************************************************************
// <copyright>
//     Copyright © 2016 - 2018 Kolibre Credit Team. All rights reserved.
// </copyright>
// ***********************************************************************

using System;
using System.Runtime.Serialization;
using KC.Foundation.Sys;

namespace KC.Foundation.Exceptions
{
    [Serializable]
    public class InvalidEnumCodeException : InvalidOperationException
    {
        public InvalidEnumCodeException(int initCode, Type enumType) : base(SR.InvalidOperation_InvalidEnumCode)
        {
            InitCode = initCode;
            EnumType = enumType;
        }

        public InvalidEnumCodeException(string message, int initCode, Type enumType) : base(message)
        {
            InitCode = initCode;
            EnumType = enumType;
        }

        public InvalidEnumCodeException(string message, int initCode, Type enumType, Exception innerException) : base(message, innerException)
        {
            InitCode = initCode;
            EnumType = enumType;
        }

        public InvalidEnumCodeException(SerializationInfo info, StreamingContext cxt) : base(info, cxt)
        {
        }

        public int InitCode { get; }

        public Type EnumType { get; }


        public override string Message => base.Message.FormatWithValues(InitCode, EnumType.FullName);
    }
}