﻿// ***********************************************************************
// Solution         : KC.Foundation
// Project          : KC.Foundation
// File             : InvalidEnumValueException.cs
// Modified         : 2017-04-17  3:01 PM
// ***********************************************************************
// <copyright>
//     Copyright © 2016 - 2018 Kolibre Credit Team. All rights reserved.
// </copyright>
// ***********************************************************************

using System;
using System.Runtime.Serialization;
using KC.Foundation.Sys;

namespace KC.Foundation.Exceptions
{
    public class InvalidEnumValueException : InvalidOperationException
    {
        public InvalidEnumValueException(string initValue, Type enumType) : base(SR.InvalidOperation_InvalidEnumValue)
        {
            InitValue = initValue;
            EnumType = enumType;
        }

        public InvalidEnumValueException(string message, string initValue, Type enumType) : base(message)
        {
            InitValue = initValue;
            EnumType = enumType;
        }

        public InvalidEnumValueException(string message, string initValue, Type enumType, Exception innerException) : base(message, innerException)
        {
            InitValue = initValue;
            EnumType = enumType;
        }

        public InvalidEnumValueException(SerializationInfo info, StreamingContext cxt) : base(info, cxt)
        {
        }

        public string InitValue { get; }

        public Type EnumType { get; }

        public override string Message => base.Message.FormatWithValues(InitValue, EnumType.FullName);
    }
}