﻿// ***********************************************************************
// Solution         : KC.Foundation
// Project          : KC.Foundation
// File             : Environment.cs
// ***********************************************************************
// <copyright>
//     Copyright © 2016 - 2018 Kolibre Credit Team. All rights reserved.
// </copyright>
// ***********************************************************************

namespace KC.Foundation.Model
{
    /// <summary>
    ///     Environment
    /// </summary>
    public class Environment : EnumClass<Environment>
    {
        static Environment()
        {
            Add(None);
            Add(Local);
            Add(Development);
            Add(Test);
            Add(Staging);
            Add(Production);
        }

        public Environment(int code, string value)
            : base(code, value)
        {
        }

        public static Environment None { get; } = new Environment(0, "None");

        public static Environment Local { get; } = new Environment(10, "Local");

        public static Environment Development { get; } = new Environment(20, "Development");

        public static Environment Test { get; } = new Environment(30, "Test");

        public static Environment Staging { get; } = new Environment(40, "Staging");

        public static Environment Production { get; } = new Environment(50, "Production");
    }
}