﻿// ***********************************************************************
// Solution         : KC.Foundation
// Project          : KC.Foundation
// File             : Error.cs
// Modified         : 2017-04-17  3:01 PM
// ***********************************************************************
// <copyright>
//     Copyright © 2016 - 2018 Kolibre Credit Team. All rights reserved.
// </copyright>
// ***********************************************************************

using System.Collections.Generic;

namespace KC.Foundation
{
    /// <summary>
    ///     Encapsulates an error from the subsystem.
    /// </summary>
    public class Error
    {
        /// <summary>
        ///     Gets or sets the code for this error.
        /// </summary>
        /// <value>
        ///     The code for this error.
        /// </value>
        public int Code { get; set; }

        /// <summary>
        ///     Gets or sets the message for this error.
        /// </summary>
        /// <value>
        ///     The message for this error.
        /// </value>
        public string Message { get; set; }

        /// <summary>
        ///     Gets or sets the data for this error.
        /// </summary>
        /// <value>
        ///     The data for this error.
        /// </value>
        public IDictionary<string, object> Data { get; set; }
    }
}