﻿// ***********************************************************************
// Solution         : KC.Foundation
// Project          : KC.Foundation
// File             : ClientContext.cs
// Updated          : 2017-06-01 6:28 PM
// ***********************************************************************
// <copyright>
//     Copyright © 2016 - 2018 Kolibre Credit Team. All rights reserved.
// </copyright>
// ***********************************************************************

namespace KC.Foundation
{
    public class ClientContext
    {
        /// <summary>
        ///     Client 的唯一标识，一般为 Guid 形式的唯一字符串。
        /// </summary>
        /// <example>
        ///     145427B9E7444D23A076015EDDDB0891
        /// </example>
        public string ClientId { get; set; }

        /// <summary>
        ///     Client 的 Ip 地址。
        /// </summary>
        /// <example>
        ///     168.63.136.135, 192.168.1.1, 172.0.0.1, localhost, ::1
        /// </example>
        public string ClientIp { get; set; }

        /// <summary>
        ///     Client 的经纬度。
        /// </summary>
        /// <example>
        ///     121.511922,31.239504
        /// </example>
        public string ClientLocation { get; set; }                  

        /// <summary>
        ///     Client 类型，用 ',' 分割的多个类型值。
        /// </summary>
        /// <example>
        ///     iPhone.Apple.iPhone,iOS.5.1,Mobile Safari.5.1
        /// </example>
        public string ClientType { get; set; }

        /// <summary>
        ///     Cliant UserAgent.
        /// </summary>
        /// <example>
        ///     Mozilla/5.0 (iPhone; CPU iPhone OS 5_1_1 like Mac OS X) AppleWebKit/534.46 (KHTML, like Gecko) Version/5.1 Mobile/9B206 Safari/7534.48.3
        /// </example>
        public string ClientModel { get; set; }

        /// <summary>
        ///     Cliant Version.
        /// </summary>
        /// <example>
        ///     3.1.2-dev
        /// </example>
        public string ClientVersion { get; set; }
    }
}