﻿// ***********************************************************************
// Solution         : KC.Foundation
// Project          : KC.Foundation
// File             : ServiceCallContext.cs
// Updated          : 2017-11-14 1:31 PM
// ***********************************************************************
// <copyright>
//     Copyright © 2016 - 2018 Kolibre Credit Team. All rights reserved.
// </copyright>
// ***********************************************************************

using System.Collections.Generic;
using KC.Foundation.Utilities;

namespace KC.Foundation
{
    public class ServiceCallContext
    {
        /// <summary>
        ///     <see cref="RequestContext.Id"/>.
        /// </summary>
        public string SourceOperationId { get; set; }

        /// <summary>
        ///     <see cref="RequestContext.Name"/>.
        /// </summary>
        public string RequestName { get; set; }

        /// <summary>
        ///     <see cref="RequestContext.Method"/>.
        /// </summary>
        public string Method { get; set; }

        /// <summary>
        ///     <see cref="RequestContext.Uri"/>.
        /// </summary>
        public string Uri { get; set; }

        /// <summary>
        ///     <see cref="ClientContext.ClientId"/>.
        /// </summary>
        public string ClientId { get; set; }

        /// <summary>
        ///     <see cref="ClientContext.ClientIp"/>.
        /// </summary>
        public string ClientIp { get; set; }

        /// <summary>
        ///     <see cref="ClientContext.ClientLocation"/>.
        /// </summary>
        public string ClientLocation { get; set; }

        /// <summary>
        ///     <see cref="ClientContext.ClientType"/>.
        /// </summary>
        public string ClientType { get; set; }

        /// <summary>
        ///     <see cref="ClientContext.ClientModel"/>.
        /// </summary>
        public string ClientModel { get; set; }

        /// <summary>
        ///     <see cref="ClientContext.ClientVersion"/>.
        /// </summary>
        public string ClientVersion { get; set; }

        /// <summary>
        ///     <see cref="UserContext.UserId"/>.
        /// </summary>
        public string AnonymousUserId { get; set; }

        /// <summary>
        ///     <see cref="UserContext.UserId"/> and <see cref="UserContext.Authenticated"/>.
        /// </summary>
        public string AuthenticatedUserId { get; set; }

        /// <summary>
        ///     <see cref="UserContext.UserName"/>.
        /// </summary>
        public string UserName { get; set; }

        /// <summary>
        ///     <see cref="UserContext.SessionId"/>.
        /// </summary>
        public string SessionId { get; set; }

        /// <summary>
        ///     <see cref="RequestContext.Data"/>.
        /// </summary>
        public IDictionary<string, string> Data { get; set; } = new Dictionary<string, string>();

        /// <summary>
        ///     标识本次请求的序列值，有足够的随机性，但不保证唯一性。
        /// </summary>
        public string SequenceNumber { get; set; } = ID.GuidShortCode();
    }
}