﻿// ***********************************************************************
// Solution         : KC.Foundation
// Project          : KC.Foundation
// File             : ServiceCallContextFactory.cs
// Updated          : 2017-11-14 1:37 PM
// ***********************************************************************
// <copyright>
//     Copyright © 2016 - 2018 Kolibre Credit Team. All rights reserved.
// </copyright>
// ***********************************************************************

using KC.Foundation.Sys;
using KC.Foundation.Utilities;

namespace KC.Foundation
{
    public static class ServiceCallContextFactory
    {
        public static ServiceCallContext BuildForLocalCall(string requestName, string requestUri, string anonymousUserId = "", bool authenticated = false, string userName = "")
        {
            return new ServiceCallContext
            {
                SourceOperationId = string.Empty,
                RequestName = $"{requestName} " + requestUri,
                Uri = requestUri,
                ClientId = ID.NewSequentialGuid().ToGuidString(),
                ClientIp = HostServer.IP,
                ClientType = "Client," + HostServer.OS,
                ClientModel = "Mozilla/5.0 (Windows Server 2016; Win64; x64)",
                AnonymousUserId = anonymousUserId,
                AuthenticatedUserId = authenticated ? anonymousUserId : "",
                UserName = userName,
                SessionId = ID.NewSequentialGuid().ToGuidString()
            };
        }
    }
}