﻿// ***********************************************************************
// Solution         : KC.Foundation
// Project          : KC.Foundation
// File             : UserContext.cs
// Updated          : 2017-05-30 2:53 PM
// ***********************************************************************
// <copyright>
//     Copyright © 2016 - 2018 Kolibre Credit Team. All rights reserved.
// </copyright>
// ***********************************************************************

using KC.Foundation.Sys;
using KC.Foundation.Utilities;

namespace KC.Foundation
{
    public class UserContext
    {
        /// <summary>
        ///     User 的唯一标识，一般为 Guid 形式的唯一字符串。
        /// </summary>
        /// <example>
        ///     35D535A46FF64BB8B9F2015EDDE715A0
        /// </example>
        public string UserId { get; set; } = ID.NewSequentialGuid().ToGuidString();

        /// <summary>
        ///     User 是否是认证通过的用户。
        /// </summary>
        public bool Authenticated { get; set; }

        /// <summary>
        ///     User 的可阅读名称，不是可用于查询的标识符。
        /// </summary>
        /// <example>
        ///     Administrator, Developer_Jack, Tim 
        /// </example>
        public string UserName { get; set; }

        /// <summary>
        ///     Session 的唯一标识，一般为 Guid 形式的唯一字符串。
        /// </summary>
        /// <example>
        ///     E4506354227346A19E1B015EDDE71913
        /// </example>
        public string SessionId { get; set; }
    }
}