﻿// ***********************************************************************
// Solution         : KC.Foundation
// Project          : KC.Foundation
// File             : Field.cs
// Modified         : 2017-04-17  3:05 PM
// ***********************************************************************
// <copyright>
//     Copyright © 2016 - 2018 Kolibre Credit Team. All rights reserved.
// </copyright>
// ***********************************************************************

using System;
using System.Reflection;

#pragma warning disable 1591

namespace KC.Foundation.Reflection
{
    public static class FieldInfoExtensions
    {
        public static IProperty ToIProperty(this FieldInfo info)
        {
            return new Field { FieldInfo = info };
        }
    }

    public class Field : IProperty
    {
        internal FieldInfo FieldInfo { get; set; }

        #region IProperty Members

        public string Name => FieldInfo.Name;

        public Type PropertyType => FieldInfo.FieldType;

        public object GetValue(object obj, object[] index)
        {
            return FieldInfo.GetValue(obj);
        }

        public void SetValue(object obj, object val, object[] index)
        {
            FieldInfo.SetValue(obj, val);
        }

        #endregion IProperty Members
    }
}