﻿// ***********************************************************************
// Solution         : KC.Foundation
// Project          : KC.Foundation
// File             : Property.cs
// Modified         : 2017-04-17  3:06 PM
// ***********************************************************************
// <copyright>
//     Copyright © 2016 - 2018 Kolibre Credit Team. All rights reserved.
// </copyright>
// ***********************************************************************

using System;
using System.Reflection;

#pragma warning disable 1591

namespace KC.Foundation.Reflection
{
    public static class PropertyInfoExtensions
    {
        public static IProperty ToIProperty(this PropertyInfo info)
        {
            return new Property { PropertyInfo = info };
        }
    }

    public class Property : IProperty
    {
        internal PropertyInfo PropertyInfo { get; set; }

        #region IProperty Members

        public string Name => PropertyInfo.Name;

        public Type PropertyType => PropertyInfo.PropertyType;

        public object GetValue(object obj, object[] index)
        {
            return PropertyInfo.GetValue(obj, index);
        }

        public void SetValue(object obj, object val, object[] index)
        {
            PropertyInfo.SetValue(obj, val, index);
        }

        #endregion IProperty Members
    }
}