﻿// ***********************************************************************
// Solution         : KC.Foundation
// Project          : KC.Foundation
// File             : ReflectionDynamicInstanceObject.cs
// Modified         : 2017-04-17  3:14 PM
// ***********************************************************************
// <copyright>
//     Copyright © 2016 - 2018 Kolibre Credit Team. All rights reserved.
// </copyright>
// ***********************************************************************

using System;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Reflection;

#pragma warning disable 1591

namespace KC.Foundation.Reflection
{
    public class ReflectionDynamicInstanceObject : ReflectionDynamicObjectBase
    {
        private static readonly IDictionary<Type, IDictionary<string, IProperty>> s_propertiesOnType = new ConcurrentDictionary<Type, IDictionary<string, IProperty>>();
        private readonly object _instance;

        public ReflectionDynamicInstanceObject(object instance)
        {
            _instance = instance;
        }

        public override object RealObject => Instance;

        internal override IDictionary<Type, IDictionary<string, IProperty>> PropertiesOnType => s_propertiesOnType;

        protected override BindingFlags BindingFlags => BindingFlags.Instance | BindingFlags.Public | BindingFlags.NonPublic;

        protected override object Instance => _instance;

        // For instance calls, we get the type from the instance
        protected override Type TargetType => _instance.GetType();
    }
}