﻿// ***********************************************************************
// Solution         : KC.Foundation
// Project          : KC.Foundation
// File             : ReflectionUsingDynamicExtensions.cs
// Modified         : 2017-04-17  3:07 PM
// ***********************************************************************
// <copyright>
//     Copyright © 2016 - 2018 Kolibre Credit Team. All rights reserved.
// </copyright>
// ***********************************************************************

using System;

#pragma warning disable 1591

namespace KC.Foundation.Reflection
{
    public static class ReflectionUsingDynamicExtensions
    {
        public static dynamic AsDynamic(this object o)
        {
            // Don't wrap primitive types, which don't have many interesting internal APIs
            if (o == null || o.GetType().IsPrimitive || o is string || o is ReflectionDynamicObjectBase)
                return o;

            return new ReflectionDynamicInstanceObject(o);
        }

        public static dynamic AsDynamicType(this Type type)
        {
            return new ReflectionDynamicStaticObject(type);
        }
    }
}