﻿// ***********************************************************************
// Solution         : KC.Foundation
// Project          : KC.Foundation
// File             : PasswordVerificationResult.cs
// Updated          : 2017-06-01 3:21 PM
// ***********************************************************************
// <copyright>
//     Copyright © 2016 - 2018 Kolibre Credit Team. All rights reserved.
// </copyright>
// ***********************************************************************

namespace KC.Foundation.Utilities.Cryptography
{
    /// <summary>
    ///     Specifies the results for password verification.
    /// </summary>
    public enum PasswordVerificationResult
    {
        /// <summary>
        ///     Indicates password verification unsuccessfully.
        /// </summary>
        Failed = 0,

        /// <summary>
        ///     Indicates password verification was successful.
        /// </summary>
        Success = 1,

        /// <summary>
        ///     Indicates password verification was successful however the password was encoded using a deprecated algorithm
        ///     and should be rehashed and updated.
        /// </summary>
        SuccessRehashNeeded = 2
    }
}