﻿// ReSharper disable InconsistentNaming

namespace KC.Foundation
{
    /// <summary>
    /// String Resources
    /// </summary>
    public static class SR
    {
        /// <summary>
        ///   Looks up a localized string similar to Cannot create an abstract class..
        /// </summary>
        public static string Acc_CreateAbst
        {
            get { return Resource.Acc_CreateAbst; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot create an instance of {0} because it is an abstract class..
        /// </summary>
        public static string Acc_CreateAbstEx
        {
            get { return Resource.Acc_CreateAbstEx; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot dynamically create an instance of ArgIterator..
        /// </summary>
        public static string Acc_CreateArgIterator
        {
            get { return Resource.Acc_CreateArgIterator; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot create a type for which Type.ContainsGenericParameters is true..
        /// </summary>
        public static string Acc_CreateGeneric
        {
            get { return Resource.Acc_CreateGeneric; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot create an instance of {0} because Type.ContainsGenericParameters is true..
        /// </summary>
        public static string Acc_CreateGenericEx
        {
            get { return Resource.Acc_CreateGenericEx; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot create an instance of an interface..
        /// </summary>
        public static string Acc_CreateInterface
        {
            get { return Resource.Acc_CreateInterface; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot create an instance of {0} because it is an interface..
        /// </summary>
        public static string Acc_CreateInterfaceEx
        {
            get { return Resource.Acc_CreateInterfaceEx; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot dynamically create an instance of System.Void..
        /// </summary>
        public static string Acc_CreateVoid
        {
            get { return Resource.Acc_CreateVoid; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type initializer was not callable..
        /// </summary>
        public static string Acc_NotClassInit
        {
            get { return Resource.Acc_NotClassInit; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot set a constant field..
        /// </summary>
        public static string Acc_ReadOnly
        {
            get { return Resource.Acc_ReadOnly; }
        }

        /// <summary>
        ///   Looks up a localized string similar to SkipVerification permission is needed to modify an image-based (RVA) static field..
        /// </summary>
        public static string Acc_RvaStatic
        {
            get { return Resource.Acc_RvaStatic; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot create an instance of void..
        /// </summary>
        public static string Access_Void
        {
            get { return Resource.Access_Void; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Length of the access control list exceed the allowed maximum..
        /// </summary>
        public static string AccessControl_AclTooLong
        {
            get { return Resource.AccessControl_AclTooLong; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The access rule is not the correct type..
        /// </summary>
        public static string AccessControl_InvalidAccessRuleType
        {
            get { return Resource.AccessControl_InvalidAccessRuleType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The audit rule is not the correct type..
        /// </summary>
        public static string AccessControl_InvalidAuditRuleType
        {
            get { return Resource.AccessControl_InvalidAuditRuleType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The security identifier is not allowed to be the primary group of this object..
        /// </summary>
        public static string AccessControl_InvalidGroup
        {
            get { return Resource.AccessControl_InvalidGroup; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The supplied handle is invalid. This can happen when trying to set an ACL on an anonymous kernel object..
        /// </summary>
        public static string AccessControl_InvalidHandle
        {
            get { return Resource.AccessControl_InvalidHandle; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The security identifier is not allowed to be the owner of this object..
        /// </summary>
        public static string AccessControl_InvalidOwner
        {
            get { return Resource.AccessControl_InvalidOwner; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Security descriptor with revision other than &apos;1&apos; are not legal..
        /// </summary>
        public static string AccessControl_InvalidSecurityDescriptorRevision
        {
            get { return Resource.AccessControl_InvalidSecurityDescriptorRevision; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Security descriptor must be in the self-relative form..
        /// </summary>
        public static string AccessControl_InvalidSecurityDescriptorSelfRelativeForm
        {
            get { return Resource.AccessControl_InvalidSecurityDescriptorSelfRelativeForm; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The SDDL string contains an invalid sid or a sid that cannot be translated..
        /// </summary>
        public static string AccessControl_InvalidSidInSDDLString
        {
            get { return Resource.AccessControl_InvalidSidInSDDLString; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The named parameter must be a container ACL..
        /// </summary>
        public static string AccessControl_MustSpecifyContainerAcl
        {
            get { return Resource.AccessControl_MustSpecifyContainerAcl; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The named parameter must be a directory-object ACL..
        /// </summary>
        public static string AccessControl_MustSpecifyDirectoryObjectAcl
        {
            get { return Resource.AccessControl_MustSpecifyDirectoryObjectAcl; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The named parameter must be a non-container ACL..
        /// </summary>
        public static string AccessControl_MustSpecifyLeafObjectAcl
        {
            get { return Resource.AccessControl_MustSpecifyLeafObjectAcl; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The named parameter must be a non-directory-object ACL..
        /// </summary>
        public static string AccessControl_MustSpecifyNonDirectoryObjectAcl
        {
            get { return Resource.AccessControl_MustSpecifyNonDirectoryObjectAcl; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to perform a security operation on an object that has no associated security. This can happen when trying to get an ACL of an anonymous kernel object..
        /// </summary>
        public static string AccessControl_NoAssociatedSecurity
        {
            get { return Resource.AccessControl_NoAssociatedSecurity; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Method unsuccessfully with unexpected error code {0}..
        /// </summary>
        public static string AccessControl_UnexpectedError
        {
            get { return Resource.AccessControl_UnexpectedError; }
        }

        /// <summary>
        ///   Looks up a localized string similar to One or more errors occurred..
        /// </summary>
        public static string AggregateException_ctor_DefaultMessage
        {
            get { return Resource.AggregateException_ctor_DefaultMessage; }
        }

        /// <summary>
        ///   Looks up a localized string similar to An element of innerExceptions was null..
        /// </summary>
        public static string AggregateException_ctor_InnerExceptionNull
        {
            get { return Resource.AggregateException_ctor_InnerExceptionNull; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The serialization stream contains no inner exceptions..
        /// </summary>
        public static string AggregateException_DeserializationFailure
        {
            get { return Resource.AggregateException_DeserializationFailure; }
        }

        /// <summary>
        ///   Looks up a localized string similar to {0}{1}--- (Inner Exception #{2}) {3}{4}{5}.
        /// </summary>
        public static string AggregateException_ToString
        {
            get { return Resource.AggregateException_ToString; }
        }

        /// <summary>
        ///   Looks up a localized string similar to All code.
        /// </summary>
        public static string All_ToString
        {
            get { return Resource.All_ToString; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Allocated from:.
        /// </summary>
        public static string AllocatedFrom
        {
            get { return Resource.AllocatedFrom; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The ApplicationBase must be set before retrieving this property..
        /// </summary>
        public static string AppDomain_AppBaseNotSet
        {
            get { return Resource.AppDomain_AppBaseNotSet; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Binding model is already locked for the AppDomain and cannot be reset..
        /// </summary>
        public static string AppDomain_BindingModelIsLocked
        {
            get { return Resource.AppDomain_BindingModelIsLocked; }
        }

        /// <summary>
        ///   Looks up a localized string similar to ApplicationName must be set before the DynamicBase can be set..
        /// </summary>
        public static string AppDomain_RequireApplicationName
        {
            get { return Resource.AppDomain_RequireApplicationName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to ApplicationDirectory.
        /// </summary>
        public static string ApplicationDirectory_ToString
        {
            get { return Resource.ApplicationDirectory_ToString; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Absolute path information is required..
        /// </summary>
        public static string Argument_AbsolutePathRequired
        {
            get { return Resource.Argument_AbsolutePathRequired; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot access member..
        /// </summary>
        public static string Argument_AccessException
        {
            get { return Resource.Argument_AccessException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attempted to read or write protected memory. This is often an indication that other memory is corrupt..
        /// </summary>
        public static string Argument_AccessViolationException
        {
            get { return Resource.Argument_AccessViolationException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to An item with the same key has already been added..
        /// </summary>
        public static string Argument_AddingDuplicate
        {
            get { return Resource.Argument_AddingDuplicate; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Item has already been added. Key in dictionary: &apos;{0}&apos;  Key being added: &apos;{1}&apos;.
        /// </summary>
        public static string Argument_AddingDuplicate__
        {
            get { return Resource.Argument_AddingDuplicate__; }
        }

        /// <summary>
        ///   Looks up a localized string similar to An item with the same key has already been added. Key: {0}.
        /// </summary>
        public static string Argument_AddingDuplicateWithKey
        {
            get { return Resource.Argument_AddingDuplicateWithKey; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The elements of the AdjustmentRule array must not contain ambiguous time periods that extend beyond the DateStart or DateEnd properties of the element..
        /// </summary>
        public static string Argument_AdjustmentRulesAmbiguousOverlap
        {
            get { return Resource.Argument_AdjustmentRulesAmbiguousOverlap; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The elements of the AdjustmentRule array must not contain invalid time periods that extend beyond the DateStart or DateEnd properties of the element. .
        /// </summary>
        public static string Argument_AdjustmentRulesInvalidOverlap
        {
            get { return Resource.Argument_AdjustmentRulesInvalidOverlap; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The AdjustmentRule array cannot contain null elements..
        /// </summary>
        public static string Argument_AdjustmentRulesNoNulls
        {
            get { return Resource.Argument_AdjustmentRulesNoNulls; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The elements of the AdjustmentRule array must be in chronological order and must not overlap..
        /// </summary>
        public static string Argument_AdjustmentRulesOutOfOrder
        {
            get { return Resource.Argument_AdjustmentRulesOutOfOrder; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The elements of the AdjustmentRule array must not contain Daylight Saving Time periods that overlap adjacent elements in such a way as to cause invalid or ambiguous time periods..
        /// </summary>
        public static string Argument_AdjustmentRulesrDaylightSavingTimeOverlap
        {
            get { return Resource.Argument_AdjustmentRulesrDaylightSavingTimeOverlap; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The elements of the AdjustmentRule array must not contain Daylight Saving Time periods that overlap the DateStart or DateEnd properties in such a way as to cause invalid or ambiguous time periods..
        /// </summary>
        public static string Argument_AdjustmentRulesrDaylightSavingTimeOverlapNonRuleRange
        {
            get { return Resource.Argument_AdjustmentRulesrDaylightSavingTimeOverlapNonRuleRange; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The object already has a CCW associated with it..
        /// </summary>
        public static string Argument_AlreadyACCW
        {
            get { return Resource.Argument_AlreadyACCW; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Specified capacity must not be less than the current capacity..
        /// </summary>
        public static string Argument_ALSInvalidCapacity
        {
            get { return Resource.Argument_ALSInvalidCapacity; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Specified slot number was invalid..
        /// </summary>
        public static string Argument_ALSInvalidSlot
        {
            get { return Resource.Argument_ALSInvalidSlot; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Ambiguous match found..
        /// </summary>
        public static string Argument_AmbiguousMatchException
        {
            get { return Resource.Argument_AmbiguousMatchException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attempted to access an unloaded AppDomain..
        /// </summary>
        public static string Argument_AppDomainUnloadedException
        {
            get { return Resource.Argument_AppDomainUnloadedException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Error in the application..
        /// </summary>
        public static string Argument_ApplicationException
        {
            get { return Resource.Argument_ApplicationException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to An ApplicationTrust must have an application identity before it can be persisted..
        /// </summary>
        public static string Argument_ApplicationTrustShouldHaveIdentity
        {
            get { return Resource.Argument_ApplicationTrustShouldHaveIdentity; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Value does not fall within the expected range..
        /// </summary>
        public static string Argument_ArgumentException
        {
            get { return Resource.Argument_ArgumentException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Specified argument was out of the range of valid values..
        /// </summary>
        public static string Argument_ArgumentOutOfRangeException
        {
            get { return Resource.Argument_ArgumentOutOfRangeException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Argument cannot be zero..
        /// </summary>
        public static string Argument_ArgumentZero
        {
            get { return Resource.Argument_ArgumentZero; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Overflow or underflow in the arithmetic operation..
        /// </summary>
        public static string Argument_ArithmeticException
        {
            get { return Resource.Argument_ArithmeticException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Interface maps for generic interfaces on arrays cannot be retrieved..
        /// </summary>
        public static string Argument_ArrayGetInterfaceMap
        {
            get { return Resource.Argument_ArrayGetInterfaceMap; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Array lengths must be the same..
        /// </summary>
        public static string Argument_ArrayLengthsDiffer
        {
            get { return Resource.Argument_ArrayLengthsDiffer; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Destination array is not long enough to copy all the items in the collection. Check array index and length..
        /// </summary>
        public static string Argument_ArrayPlusOffTooSmall
        {
            get { return Resource.Argument_ArrayPlusOffTooSmall; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Array or pointer types are not valid..
        /// </summary>
        public static string Argument_ArraysInvalid
        {
            get { return Resource.Argument_ArraysInvalid; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The input array length must not exceed Int32.MaxValue / {0}. Otherwise BitArray.Length would exceed Int32.MaxValue..
        /// </summary>
        public static string Argument_ArrayTooLarge
        {
            get { return Resource.Argument_ArrayTooLarge; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attempted to access an element as a type incompatible with the array..
        /// </summary>
        public static string Argument_ArrayTypeMismatchException
        {
            get { return Resource.Argument_ArrayTypeMismatchException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Array must not be of length zero..
        /// </summary>
        public static string Argument_ArrayZeroError
        {
            get { return Resource.Argument_ArrayZeroError; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Assembly was already fully trusted..
        /// </summary>
        public static string Argument_AssemblyAlreadyFullTrust
        {
            get { return Resource.Argument_AssemblyAlreadyFullTrust; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Assembly was not fully trusted..
        /// </summary>
        public static string Argument_AssemblyNotFullTrust
        {
            get { return Resource.Argument_AssemblyNotFullTrust; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The manifest module of the assembly cannot be null..
        /// </summary>
        public static string Argument_AssemblyNullModule
        {
            get { return Resource.Argument_AssemblyNullModule; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Assembly must not be a Windows Runtime assembly..
        /// </summary>
        public static string Argument_AssemblyWinMD
        {
            get { return Resource.Argument_AssemblyWinMD; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attribute names must be unique..
        /// </summary>
        public static string Argument_AttributeNamesMustBeUnique
        {
            get { return Resource.Argument_AttributeNamesMustBeUnique; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Interface method must be abstract and virtual..
        /// </summary>
        public static string Argument_BadAttributeOnInterfaceMethod
        {
            get { return Resource.Argument_BadAttributeOnInterfaceMethod; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bad &apos;{0}&apos; while generating unmanaged resource information..
        /// </summary>
        public static string Argument_BadCAForUnmngRSC
        {
            get { return Resource.Argument_BadCAForUnmngRSC; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bad default value..
        /// </summary>
        public static string Argument_BadConstantValue
        {
            get { return Resource.Argument_BadConstantValue; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot have private or static constructor..
        /// </summary>
        public static string Argument_BadConstructor
        {
            get { return Resource.Argument_BadConstructor; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Constructor must have standard calling convention..
        /// </summary>
        public static string Argument_BadConstructorCallConv
        {
            get { return Resource.Argument_BadConstructorCallConv; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bad current local variable for setting symbol information..
        /// </summary>
        public static string Argument_BadCurrentLocalVariable
        {
            get { return Resource.Argument_BadCurrentLocalVariable; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Incorrect code generation for exception block..
        /// </summary>
        public static string Argument_BadExceptionCodeGen
        {
            get { return Resource.Argument_BadExceptionCodeGen; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Field must be on the same type of the given ConstructorInfo..
        /// </summary>
        public static string Argument_BadFieldForConstructorBuilder
        {
            get { return Resource.Argument_BadFieldForConstructorBuilder; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Field signatures do not have return types..
        /// </summary>
        public static string Argument_BadFieldSig
        {
            get { return Resource.Argument_BadFieldSig; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bad field type in defining field..
        /// </summary>
        public static string Argument_BadFieldType
        {
            get { return Resource.Argument_BadFieldType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Format specifier was invalid..
        /// </summary>
        public static string Argument_BadFormatSpecifier
        {
            get { return Resource.Argument_BadFormatSpecifier; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Format of the executable (.exe) or library (.dll) is invalid..
        /// </summary>
        public static string Argument_BadImageFormatException
        {
            get { return Resource.Argument_BadImageFormatException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to A BadImageFormatException has been thrown while parsing the signature. This is likely due to lack of a generic context. Ensure genericTypeArguments and genericMethodArguments are provided and contain enough context..
        /// </summary>
        public static string Argument_BadImageFormatExceptionResolve
        {
            get { return Resource.Argument_BadImageFormatExceptionResolve; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bad label in ILGenerator..
        /// </summary>
        public static string Argument_BadLabel
        {
            get { return Resource.Argument_BadLabel; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bad label content in ILGenerator..
        /// </summary>
        public static string Argument_BadLabelContent
        {
            get { return Resource.Argument_BadLabelContent; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Encountered an invalid type for a default value..
        /// </summary>
        public static string Argument_BadLiteralFormat
        {
            get { return Resource.Argument_BadLiteralFormat; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Visibility of interfaces must be one of the following: NestedAssembly, NestedFamANDAssem, NestedFamily, NestedFamORAssem, NestedPrivate or NestedPublic..
        /// </summary>
        public static string Argument_BadNestedTypeFlags
        {
            get { return Resource.Argument_BadNestedTypeFlags; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid ObjRef provided to &apos;{0}&apos;..
        /// </summary>
        public static string Argument_BadObjRef
        {
            get { return Resource.Argument_BadObjRef; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Parameter count does not match passed in argument value count..
        /// </summary>
        public static string Argument_BadParameterCountsForConstructor
        {
            get { return Resource.Argument_BadParameterCountsForConstructor; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot emit a CustomAttribute with argument of type {0}..
        /// </summary>
        public static string Argument_BadParameterTypeForCAB
        {
            get { return Resource.Argument_BadParameterTypeForCAB; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Passed in argument value at index {0} does not match the parameter type..
        /// </summary>
        public static string Argument_BadParameterTypeForConstructor
        {
            get { return Resource.Argument_BadParameterTypeForConstructor; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot have a persistable module in a transient assembly..
        /// </summary>
        public static string Argument_BadPersistableModuleInTransientAssembly
        {
            get { return Resource.Argument_BadPersistableModuleInTransientAssembly; }
        }

        /// <summary>
        ///   Looks up a localized string similar to PInvoke methods must be static and native and cannot be abstract..
        /// </summary>
        public static string Argument_BadPInvokeMethod
        {
            get { return Resource.Argument_BadPInvokeMethod; }
        }

        /// <summary>
        ///   Looks up a localized string similar to PInvoke methods cannot exist on interfaces..
        /// </summary>
        public static string Argument_BadPInvokeOnInterface
        {
            get { return Resource.Argument_BadPInvokeOnInterface; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Property must be on the same type of the given ConstructorInfo..
        /// </summary>
        public static string Argument_BadPropertyForConstructorBuilder
        {
            get { return Resource.Argument_BadPropertyForConstructorBuilder; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unknown value for the ResourceScope: {0}  Too many resource type bits may be set..
        /// </summary>
        public static string Argument_BadResourceScopeTypeBits
        {
            get { return Resource.Argument_BadResourceScopeTypeBits; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unknown value for the ResourceScope: {0}  Too many resource visibility bits may be set..
        /// </summary>
        public static string Argument_BadResourceScopeVisibilityBits
        {
            get { return Resource.Argument_BadResourceScopeVisibilityBits; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Incorrect signature format..
        /// </summary>
        public static string Argument_BadSigFormat
        {
            get { return Resource.Argument_BadSigFormat; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Data size must be &gt; 0 and &lt; 0x3f0000.
        /// </summary>
        public static string Argument_BadSizeForData
        {
            get { return Resource.Argument_BadSizeForData; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bad type attributes. A type cannot be both abstract and final..
        /// </summary>
        public static string Argument_BadTypeAttrAbstractNFinal
        {
            get { return Resource.Argument_BadTypeAttrAbstractNFinal; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bad type attributes. Invalid layout attribute specified..
        /// </summary>
        public static string Argument_BadTypeAttrInvalidLayout
        {
            get { return Resource.Argument_BadTypeAttrInvalidLayout; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bad type attributes. Nested visibility flag set on a non-nested type..
        /// </summary>
        public static string Argument_BadTypeAttrNestedVisibilityOnNonNestedType
        {
            get { return Resource.Argument_BadTypeAttrNestedVisibilityOnNonNestedType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bad type attributes. Non-nested visibility flag set on a nested type..
        /// </summary>
        public static string Argument_BadTypeAttrNonNestedVisibilityNestedType
        {
            get { return Resource.Argument_BadTypeAttrNonNestedVisibilityNestedType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bad type attributes. Reserved bits set on the type..
        /// </summary>
        public static string Argument_BadTypeAttrReservedBitsSet
        {
            get { return Resource.Argument_BadTypeAttrReservedBitsSet; }
        }

        /// <summary>
        ///   Looks up a localized string similar to An invalid type was used as a custom attribute constructor argument, field or property..
        /// </summary>
        public static string Argument_BadTypeInCustomAttribute
        {
            get { return Resource.Argument_BadTypeInCustomAttribute; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Only supported array types for CopyTo on BitArrays are Boolean[], Int32[] and Byte[]..
        /// </summary>
        public static string Argument_BitArrayTypeUnsupported
        {
            get { return Resource.Argument_BitArrayTypeUnsupported; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Public key must be specified..
        /// </summary>
        public static string Argument_BlobCannotBeNull
        {
            get { return Resource.Argument_BlobCannotBeNull; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to sort because the IComparer.Compare() method returns inconsistent results. Either a value does not compare equal to itself, or one value repeatedly compared to another value yields different results. IComparer: &apos;{0}&apos;..
        /// </summary>
        public static string Argument_BogusIComparer
        {
            get { return Resource.Argument_BogusIComparer; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Not enough space available in the buffer..
        /// </summary>
        public static string Argument_BufferTooSmall
        {
            get { return Resource.Argument_BufferTooSmall; }
        }

        /// <summary>
        ///   Looks up a localized string similar to TimeSpan does not accept floating point Not-a-Number values..
        /// </summary>
        public static string Argument_CannotBeNaN
        {
            get { return Resource.Argument_CannotBeNaN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot use function evaluation to create a TypedReference object..
        /// </summary>
        public static string Argument_CannotCreateTypedReference
        {
            get { return Resource.Argument_CannotCreateTypedReference; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot get TypeToken for a ByRef type..
        /// </summary>
        public static string Argument_CannotGetTypeTokenForByRef
        {
            get { return Resource.Argument_CannotGetTypeTokenForByRef; }
        }

        /// <summary>
        ///   Looks up a localized string similar to String cannot contain a minus sign if the base is not 10..
        /// </summary>
        public static string Argument_CannotHaveNegativeValue
        {
            get { return Resource.Argument_CannotHaveNegativeValue; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The usage of IKeyComparer and IHashCodeProvider/IComparer interfaces cannot be mixed; use one or the other..
        /// </summary>
        public static string Argument_CannotMixComparisonInfrastructure
        {
            get { return Resource.Argument_CannotMixComparisonInfrastructure; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Abstract methods cannot be prepared..
        /// </summary>
        public static string Argument_CannotPrepareAbstract
        {
            get { return Resource.Argument_CannotPrepareAbstract; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot set parent to an interface..
        /// </summary>
        public static string Argument_CannotSetParentToInterface
        {
            get { return Resource.Argument_CannotSetParentToInterface; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attempt to unload the AppDomain unsuccessfully..
        /// </summary>
        public static string Argument_CannotUnloadAppDomainException
        {
            get { return Resource.Argument_CannotUnloadAppDomainException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot evaluate a security function..
        /// </summary>
        public static string Argument_CantCallSecObjFunc
        {
            get { return Resource.Argument_CantCallSecObjFunc; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Failed to resolve type from string &quot;{0}&quot; which was embedded in custom attribute blob..
        /// </summary>
        public static string Argument_CATypeResolutionFailed
        {
            get { return Resource.Argument_CATypeResolutionFailed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to All objects in the input list must have a parent type of &apos;CodeGroup&apos;..
        /// </summary>
        public static string Argument_CodeGroupChildrenMustBeCodeGroups
        {
            get { return Resource.Argument_CodeGroupChildrenMustBeCodeGroups; }
        }

        /// <summary>
        ///   Looks up a localized string similar to {0} is not a supported code page..
        /// </summary>
        public static string Argument_CodepageNotSupported
        {
            get { return Resource.Argument_CodepageNotSupported; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Must specify property Set or Get or method call for a COM Object..
        /// </summary>
        public static string Argument_COMAccess
        {
            get { return Resource.Argument_COMAccess; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Error HRESULT E_FAIL has been returned from a call to a COM component..
        /// </summary>
        public static string Argument_COMException
        {
            get { return Resource.Argument_COMException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to CompareOption.Ordinal cannot be used with other options..
        /// </summary>
        public static string Argument_CompareOptionOrdinal
        {
            get { return Resource.Argument_CompareOptionOrdinal; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Only one of the following binding flags can be set: BindingFlags.SetProperty, BindingFlags.PutDispProperty,  BindingFlags.PutRefDispProperty..
        /// </summary>
        public static string Argument_COMPropSetPut
        {
            get { return Resource.Argument_COMPropSetPut; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The DateTimeStyles value RoundtripKind cannot be used with the values AssumeLocal, AssumeUniversal or AdjustToUniversal..
        /// </summary>
        public static string Argument_ConflictingDateTimeRoundtripStyles
        {
            get { return Resource.Argument_ConflictingDateTimeRoundtripStyles; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The DateTimeStyles values AssumeLocal and AssumeUniversal cannot be used together..
        /// </summary>
        public static string Argument_ConflictingDateTimeStyles
        {
            get { return Resource.Argument_ConflictingDateTimeStyles; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Constant does not match the defined type..
        /// </summary>
        public static string Argument_ConstantDoesntMatch
        {
            get { return Resource.Argument_ConstantDoesntMatch; }
        }

        /// <summary>
        ///   Looks up a localized string similar to {0} is not a supported constant type..
        /// </summary>
        public static string Argument_ConstantNotSupported
        {
            get { return Resource.Argument_ConstantNotSupported; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Null is not a valid constant value for this type..
        /// </summary>
        public static string Argument_ConstantNull
        {
            get { return Resource.Argument_ConstantNull; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified constructor must be declared on a generic type definition..
        /// </summary>
        public static string Argument_ConstructorNeedGenericDeclaringType
        {
            get { return Resource.Argument_ConstructorNeedGenericDeclaringType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attempted to marshal an object across a context boundary..
        /// </summary>
        public static string Argument_ContextMarshalException
        {
            get { return Resource.Argument_ContextMarshalException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Conversion buffer overflow..
        /// </summary>
        public static string Argument_ConversionOverflow
        {
            get { return Resource.Argument_ConversionOverflow; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The conversion could not be completed because the supplied DateTime did not have the Kind property set correctly.  For example, when the Kind property is DateTimeKind.Local, the source time zone must be TimeZoneInfo.Local..
        /// </summary>
        public static string Argument_ConvertMismatch
        {
            get { return Resource.Argument_ConvertMismatch; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot find the method on the object instance..
        /// </summary>
        public static string Argument_CORDBBadMethod
        {
            get { return Resource.Argument_CORDBBadMethod; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot evaluate a VarArgs function..
        /// </summary>
        public static string Argument_CORDBBadVarArgCallConv
        {
            get { return Resource.Argument_CORDBBadVarArgCallConv; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The file of the custom culture {0} is corrupt. Try to unregister this culture..
        /// </summary>
        public static string Argument_CorruptedCustomCultureFile
        {
            get { return Resource.Argument_CorruptedCustomCultureFile; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot specify both CreateInstance and another access type..
        /// </summary>
        public static string Argument_CreatInstAccess
        {
            get { return Resource.Argument_CreatInstAccess; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Error occurred during a cryptographic operation..
        /// </summary>
        public static string Argument_CryptographyException
        {
            get { return Resource.Argument_CryptographyException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Culture IETF Name {0} is not a recognized IETF name..
        /// </summary>
        public static string Argument_CultureIetfNotSupported
        {
            get { return Resource.Argument_CultureIetfNotSupported; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Culture &apos;{0}&apos; is a neutral culture. It cannot be used in formatting and parsing and therefore cannot be set as the thread&apos;s current culture..
        /// </summary>
        public static string Argument_CultureInvalidFormat
        {
            get { return Resource.Argument_CultureInvalidFormat; }
        }

        /// <summary>
        ///   Looks up a localized string similar to {0} is an invalid culture identifier..
        /// </summary>
        public static string Argument_CultureInvalidIdentifier
        {
            get { return Resource.Argument_CultureInvalidIdentifier; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Culture ID {0} (0x{0:X4}) is a neutral culture; a region cannot be created from it..
        /// </summary>
        public static string Argument_CultureIsNeutral
        {
            get { return Resource.Argument_CultureIsNeutral; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Culture is not supported..
        /// </summary>
        public static string Argument_CultureNotSupported
        {
            get { return Resource.Argument_CultureNotSupported; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Resolved assembly&apos;s simple name should be the same as of the requested assembly..
        /// </summary>
        public static string Argument_CustomAssemblyLoadContextRequestedNameMismatch
        {
            get { return Resource.Argument_CustomAssemblyLoadContextRequestedNameMismatch; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Binary format of the specified custom attribute was invalid..
        /// </summary>
        public static string Argument_CustomAttributeFormatException
        {
            get { return Resource.Argument_CustomAttributeFormatException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Customized cultures cannot be passed by LCID, only by name..
        /// </summary>
        public static string Argument_CustomCultureCannotBePassedByNumber
        {
            get { return Resource.Argument_CustomCultureCannotBePassedByNumber; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot find cvtres.exe.
        /// </summary>
        public static string Argument_cvtres_NotFound
        {
            get { return Resource.Argument_cvtres_NotFound; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Parameters &apos;members&apos; and &apos;data&apos; must have the same length..
        /// </summary>
        public static string Argument_DataLengthDifferent
        {
            get { return Resource.Argument_DataLengthDifferent; }
        }

        /// <summary>
        ///   Looks up a localized string similar to A datatype misalignment was detected in a load or store instruction..
        /// </summary>
        public static string Argument_DataMisalignedException
        {
            get { return Resource.Argument_DataMisalignedException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The binary data must result in a DateTime with ticks between DateTime.MinValue.Ticks and DateTime.MaxValue.Ticks..
        /// </summary>
        public static string Argument_DateTimeBadBinaryData
        {
            get { return Resource.Argument_DateTimeBadBinaryData; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The supplied DateTime must have the Year, Month, and Day properties set to 1.  The time cannot be specified more precisely than whole milliseconds..
        /// </summary>
        public static string Argument_DateTimeHasTicks
        {
            get { return Resource.Argument_DateTimeHasTicks; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The supplied DateTime includes a TimeOfDay setting.   This is not supported..
        /// </summary>
        public static string Argument_DateTimeHasTimeOfDay
        {
            get { return Resource.Argument_DateTimeHasTimeOfDay; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The supplied DateTime represents an invalid time.  For example, when the clock is adjusted forward, any time in the period that is skipped is invalid..
        /// </summary>
        public static string Argument_DateTimeIsInvalid
        {
            get { return Resource.Argument_DateTimeIsInvalid; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The supplied DateTime is not in an ambiguous time range..
        /// </summary>
        public static string Argument_DateTimeIsNotAmbiguous
        {
            get { return Resource.Argument_DateTimeIsNotAmbiguous; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The supplied DateTime must have the Kind property set to DateTimeKind.Unspecified or DateTimeKind.Utc..
        /// </summary>
        public static string Argument_DateTimeKindMustBeUnspecifiedOrUtc
        {
            get { return Resource.Argument_DateTimeKindMustBeUnspecifiedOrUtc; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The DateTimeStyles value &apos;NoCurrentDateDefault&apos; is not allowed when parsing DateTimeOffset..
        /// </summary>
        public static string Argument_DateTimeOffsetInvalidDateTimeStyles
        {
            get { return Resource.Argument_DateTimeOffsetInvalidDateTimeStyles; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The supplied DateTimeOffset is not in an ambiguous time range..
        /// </summary>
        public static string Argument_DateTimeOffsetIsNotAmbiguous
        {
            get { return Resource.Argument_DateTimeOffsetIsNotAmbiguous; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Combination of arguments to the DateTime constructor is out of the legal range..
        /// </summary>
        public static string Argument_DateTimeRange
        {
            get { return Resource.Argument_DateTimeRange; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Decimal byte array constructor requires an array of length four containing valid decimal bytes..
        /// </summary>
        public static string Argument_DecBitCtor
        {
            get { return Resource.Argument_DecBitCtor; }
        }

        /// <summary>
        ///   Looks up a localized string similar to FileStream will not open Win32 devices such as disk partitions and tape drives. Avoid use of &quot;\\\\.\\&quot; in the path..
        /// </summary>
        public static string Argument_DevicesNotSupported
        {
            get { return Resource.Argument_DevicesNotSupported; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attempted to access a path that is not on the disk..
        /// </summary>
        public static string Argument_DirectoryNotFoundException
        {
            get { return Resource.Argument_DirectoryNotFoundException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attempted to divide by zero..
        /// </summary>
        public static string Argument_DivideByZero
        {
            get { return Resource.Argument_DivideByZero; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Delegate to an instance method cannot have null &apos;this&apos;..
        /// </summary>
        public static string Argument_DlgtNullInst
        {
            get { return Resource.Argument_DlgtNullInst; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot bind to the target method because its signature or security transparency is not compatible with that of the delegate type..
        /// </summary>
        public static string Argument_DlgtTargMeth
        {
            get { return Resource.Argument_DlgtTargMeth; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Delegates must be of the same type..
        /// </summary>
        public static string Argument_DlgtTypeMis
        {
            get { return Resource.Argument_DlgtTypeMis; }
        }

        /// <summary>
        ///   Looks up a localized string similar to One machine may not have remote administration enabled, or both machines may not be running the remote registry service..
        /// </summary>
        public static string Argument_DllInitFailure
        {
            get { return Resource.Argument_DllInitFailure; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Dll was not found..
        /// </summary>
        public static string Argument_DllNotFoundException
        {
            get { return Resource.Argument_DllNotFoundException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attempted to access a drive that is not available..
        /// </summary>
        public static string Argument_DriveNotFoundException
        {
            get { return Resource.Argument_DriveNotFoundException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Duplicate file names..
        /// </summary>
        public static string Argument_DuplicatedFileName
        {
            get { return Resource.Argument_DuplicatedFileName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Duplicate dynamic module name within an assembly..
        /// </summary>
        public static string Argument_DuplicateModuleName
        {
            get { return Resource.Argument_DuplicateModuleName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tried to add NamedPermissionSet with non-unique name..
        /// </summary>
        public static string Argument_DuplicateName
        {
            get { return Resource.Argument_DuplicateName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Duplicate resource name within an assembly..
        /// </summary>
        public static string Argument_DuplicateResourceName
        {
            get { return Resource.Argument_DuplicateResourceName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Duplicate type name within an assembly..
        /// </summary>
        public static string Argument_DuplicateTypeName
        {
            get { return Resource.Argument_DuplicateTypeName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Duplicate objects in argument..
        /// </summary>
        public static string Argument_DuplicateWaitObjectException
        {
            get { return Resource.Argument_DuplicateWaitObjectException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to This ExceptionHandlingClause is not a clause..
        /// </summary>
        public static string Argument_EHClauseNotClause
        {
            get { return Resource.Argument_EHClauseNotClause; }
        }

        /// <summary>
        ///   Looks up a localized string similar to This ExceptionHandlingClause is not a filter..
        /// </summary>
        public static string Argument_EHClauseNotFilter
        {
            get { return Resource.Argument_EHClauseNotFilter; }
        }

        /// <summary>
        ///   Looks up a localized string similar to EmitWriteLine does not support this field or local type..
        /// </summary>
        public static string Argument_EmitWriteLineType
        {
            get { return Resource.Argument_EmitWriteLineType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to ApplicationId cannot have an empty string for the name..
        /// </summary>
        public static string Argument_EmptyApplicationName
        {
            get { return Resource.Argument_EmptyApplicationName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Array may not be empty..
        /// </summary>
        public static string Argument_EmptyArray
        {
            get { return Resource.Argument_EmptyArray; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Collection must not be empty..
        /// </summary>
        public static string Argument_EmptyCollection
        {
            get { return Resource.Argument_EmptyCollection; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Decimal separator cannot be the empty string..
        /// </summary>
        public static string Argument_EmptyDecString
        {
            get { return Resource.Argument_EmptyDecString; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Empty file name is not legal..
        /// </summary>
        public static string Argument_EmptyFileName
        {
            get { return Resource.Argument_EmptyFileName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Empty name is not legal..
        /// </summary>
        public static string Argument_EmptyName
        {
            get { return Resource.Argument_EmptyName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Array may not be empty or null..
        /// </summary>
        public static string Argument_EmptyOrNullArray
        {
            get { return Resource.Argument_EmptyOrNullArray; }
        }

        /// <summary>
        ///   Looks up a localized string similar to String can not be empty or null..
        /// </summary>
        public static string Argument_EmptyOrNullString
        {
            get { return Resource.Argument_EmptyOrNullString; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Empty path name is not legal..
        /// </summary>
        public static string Argument_EmptyPath
        {
            get { return Resource.Argument_EmptyPath; }
        }

        /// <summary>
        ///   Looks up a localized string similar to StrongName cannot have an empty string for the assembly name..
        /// </summary>
        public static string Argument_EmptyStrongName
        {
            get { return Resource.Argument_EmptyStrongName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Waithandle array may not be empty..
        /// </summary>
        public static string Argument_EmptyWaithandleArray
        {
            get { return Resource.Argument_EmptyWaithandleArray; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Must complete Convert() operation or call Encoder.Reset() before calling GetBytes() or GetByteCount(). Encoder &apos;{0}&apos; fallback &apos;{1}&apos;..
        /// </summary>
        public static string Argument_EncoderFallbackNotEmpty
        {
            get { return Resource.Argument_EncoderFallbackNotEmpty; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The output byte buffer is too small to contain the encoded data, encoding &apos;{0}&apos; fallback &apos;{1}&apos;..
        /// </summary>
        public static string Argument_EncodingConversionOverflowBytes
        {
            get { return Resource.Argument_EncodingConversionOverflowBytes; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The output char buffer is too small to contain the decoded characters, encoding &apos;{0}&apos; fallback &apos;{1}&apos;..
        /// </summary>
        public static string Argument_EncodingConversionOverflowChars
        {
            get { return Resource.Argument_EncodingConversionOverflowChars; }
        }

        /// <summary>
        ///   Looks up a localized string similar to &apos;{0}&apos; is not a supported encoding name. For information on defining a custom encoding, see the documentation for the Encoding.RegisterProvider method..
        /// </summary>
        public static string Argument_EncodingNotSupported
        {
            get { return Resource.Argument_EncodingNotSupported; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attempted to read past the end of the stream..
        /// </summary>
        public static string Argument_EndOfStreamException
        {
            get { return Resource.Argument_EndOfStreamException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Entry point was not found..
        /// </summary>
        public static string Argument_EntryPointNotFoundException
        {
            get { return Resource.Argument_EntryPointNotFoundException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object must be the same type as the enum. The type passed in was &apos;{0}&apos;; the enum type was &apos;{1}&apos;..
        /// </summary>
        public static string Argument_EnumAndObjectMustBeSameType
        {
            get { return Resource.Argument_EnumAndObjectMustBeSameType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Must set at least one flag..
        /// </summary>
        public static string Argument_EnumAtLeastOneFlag
        {
            get { return Resource.Argument_EnumAtLeastOneFlag; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Enum underlying type and the object must be same type or object. Type passed in was &apos;{0}&apos;; the enum underlying type was &apos;{1}&apos;..
        /// </summary>
        public static string Argument_EnumFormatUnderlyingTypeAndObjectMustBeSameType
        {
            get { return Resource.Argument_EnumFormatUnderlyingTypeAndObjectMustBeSameType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Illegal enum value: {0}..
        /// </summary>
        public static string Argument_EnumIllegalVal
        {
            get { return Resource.Argument_EnumIllegalVal; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The underlying type of enum argument must be Int32 or Int16..
        /// </summary>
        public static string Argument_EnumIsNotIntOrShort
        {
            get { return Resource.Argument_EnumIsNotIntOrShort; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Literal value was not found..
        /// </summary>
        public static string Argument_EnumLitValueNotFound
        {
            get { return Resource.Argument_EnumLitValueNotFound; }
        }

        /// <summary>
        ///   Looks up a localized string similar to All enums must have an underlying value__ field..
        /// </summary>
        public static string Argument_EnumMustHaveUnderlyingValueField
        {
            get { return Resource.Argument_EnumMustHaveUnderlyingValueField; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Must set exactly one flag..
        /// </summary>
        public static string Argument_EnumNotSingleFlag
        {
            get { return Resource.Argument_EnumNotSingleFlag; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The argument type, &apos;{0}&apos;, is not the same as the enum type &apos;{1}&apos;..
        /// </summary>
        public static string Argument_EnumTypeDoesNotMatch
        {
            get { return Resource.Argument_EnumTypeDoesNotMatch; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Enum underlying type and the object must be same type or object must be a String. Type passed in was &apos;{0}&apos;; the enum underlying type was &apos;{1}&apos;..
        /// </summary>
        public static string Argument_EnumUnderlyingTypeAndObjectMustBeSameType
        {
            get { return Resource.Argument_EnumUnderlyingTypeAndObjectMustBeSameType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Requested value &apos;{0}&apos; was not found..
        /// </summary>
        public static string Argument_EnumValueNotFound
        {
            get { return Resource.Argument_EnumValueNotFound; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Internal error in the runtime..
        /// </summary>
        public static string Argument_ExecutionEngineException
        {
            get { return Resource.Argument_ExecutionEngineException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to External component has thrown an exception..
        /// </summary>
        public static string Argument_ExternalException
        {
            get { return Resource.Argument_ExternalException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Failed to create a code group of type &apos;{0}&apos;..
        /// </summary>
        public static string Argument_FailedCodeGroup
        {
            get { return Resource.Argument_FailedCodeGroup; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot change fallback when buffer is not empty. Previous Convert() call left data in the fallback buffer..
        /// </summary>
        public static string Argument_FallbackBufferNotEmpty
        {
            get { return Resource.Argument_FallbackBufferNotEmpty; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attempted to access a field that is not accessible by the caller..
        /// </summary>
        public static string Argument_FieldAccessException
        {
            get { return Resource.Argument_FieldAccessException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot resolve field {0} because the declaring type of the field handle {1} is generic. Explicitly provide the declaring type to GetFieldFromHandle..
        /// </summary>
        public static string Argument_FieldDeclaringTypeGeneric
        {
            get { return Resource.Argument_FieldDeclaringTypeGeneric; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Field &apos;{0}&apos; defined on type &apos;{1}&apos; is not a field on the target object which is of type &apos;{2}&apos;..
        /// </summary>
        public static string Argument_FieldDeclTarget
        {
            get { return Resource.Argument_FieldDeclTarget; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified field must be declared on a generic type definition..
        /// </summary>
        public static string Argument_FieldNeedGenericDeclaringType
        {
            get { return Resource.Argument_FieldNeedGenericDeclaringType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The target file &quot;{0}&quot; is a directory, not a file..
        /// </summary>
        public static string Argument_FileIsDirectory_Name
        {
            get { return Resource.Argument_FileIsDirectory_Name; }
        }

        /// <summary>
        ///   Looks up a localized string similar to One or more flags are not supported..
        /// </summary>
        public static string Argument_FlagNotSupported
        {
            get { return Resource.Argument_FlagNotSupported; }
        }

        /// <summary>
        ///   Looks up a localized string similar to No arguments can be provided to Get a field value..
        /// </summary>
        public static string Argument_FldGetArgErr
        {
            get { return Resource.Argument_FldGetArgErr; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot specify both GetField and SetProperty..
        /// </summary>
        public static string Argument_FldGetPropSet
        {
            get { return Resource.Argument_FldGetPropSet; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Only the field value can be specified to set a field value..
        /// </summary>
        public static string Argument_FldSetArgErr
        {
            get { return Resource.Argument_FldSetArgErr; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot specify both Get and Set on a field..
        /// </summary>
        public static string Argument_FldSetGet
        {
            get { return Resource.Argument_FldSetGet; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot specify Set on a Field and Invoke on a method..
        /// </summary>
        public static string Argument_FldSetInvoke
        {
            get { return Resource.Argument_FldSetInvoke; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot specify both SetField and GetProperty..
        /// </summary>
        public static string Argument_FldSetPropGet
        {
            get { return Resource.Argument_FldSetPropGet; }
        }

        /// <summary>
        ///   Looks up a localized string similar to One of the identified items was in an invalid format..
        /// </summary>
        public static string Argument_FormatException
        {
            get { return Resource.Argument_FormatException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to FrameworkName is invalid..
        /// </summary>
        public static string Argument_FrameworkNameInvalid
        {
            get { return Resource.Argument_FrameworkNameInvalid; }
        }

        /// <summary>
        ///   Looks up a localized string similar to FrameworkName version component is missing..
        /// </summary>
        public static string Argument_FrameworkNameMissingVersion
        {
            get { return Resource.Argument_FrameworkNameMissingVersion; }
        }

        /// <summary>
        ///   Looks up a localized string similar to FrameworkName cannot have less than two components or more than three components..
        /// </summary>
        public static string Argument_FrameworkNameTooShort
        {
            get { return Resource.Argument_FrameworkNameTooShort; }
        }

        /// <summary>
        ///   Looks up a localized string similar to GenericArguments[{0}], &apos;{1}&apos;, on &apos;{2}&apos; violates the constraint of type &apos;{3}&apos;..
        /// </summary>
        public static string Argument_GenConstraintViolation
        {
            get { return Resource.Argument_GenConstraintViolation; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The number of generic arguments provided doesn&apos;t equal the arity of the generic type definition..
        /// </summary>
        public static string Argument_GenericArgsCount
        {
            get { return Resource.Argument_GenericArgsCount; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Method must be called on a Type for which Type.IsGenericParameter is false..
        /// </summary>
        public static string Argument_GenericParameter
        {
            get { return Resource.Argument_GenericParameter; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Generic types are not valid..
        /// </summary>
        public static string Argument_GenericsInvalid
        {
            get { return Resource.Argument_GenericsInvalid; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Property Get method was not found..
        /// </summary>
        public static string Argument_GetMethNotFnd
        {
            get { return Resource.Argument_GetMethNotFnd; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Global members must be static..
        /// </summary>
        public static string Argument_GlobalFunctionHasToBeStatic
        {
            get { return Resource.Argument_GlobalFunctionHasToBeStatic; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Byte array for GUID must be exactly {0} bytes long..
        /// </summary>
        public static string Argument_GuidArrayCtor
        {
            get { return Resource.Argument_GuidArrayCtor; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot pass a GCHandle across AppDomains..
        /// </summary>
        public static string Argument_HandleLeak
        {
            get { return Resource.Argument_HandleLeak; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Handle does not support asynchronous operations. The parameters to the FileStream constructor may need to be changed to indicate that the handle was opened synchronously (that is, it was not opened for overlapped I/O)..
        /// </summary>
        public static string Argument_HandleNotAsync
        {
            get { return Resource.Argument_HandleNotAsync; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Handle does not support synchronous operations. The parameters to the FileStream constructor may need to be changed to indicate that the handle was opened asynchronously (that is, it was opened explicitly for overlapped I/O)..
        /// </summary>
        public static string Argument_HandleNotSync
        {
            get { return Resource.Argument_HandleNotSync; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Must be an array type..
        /// </summary>
        public static string Argument_HasToBeArrayClass
        {
            get { return Resource.Argument_HasToBeArrayClass; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The number style AllowHexSpecifier is not supported on floating point data types..
        /// </summary>
        public static string Argument_HexStyleNotSupported
        {
            get { return Resource.Argument_HexStyleNotSupported; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Hashtable&apos;s capacity overflowed and went negative. Check load factor, capacity and the current size of the table..
        /// </summary>
        public static string Argument_HTCapacityOverflow
        {
            get { return Resource.Argument_HTCapacityOverflow; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Left to right characters may not be mixed with right to left characters in IDN labels..
        /// </summary>
        public static string Argument_IdnBadBidi
        {
            get { return Resource.Argument_IdnBadBidi; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IDN labels must be between 1 and 63 characters long..
        /// </summary>
        public static string Argument_IdnBadLabelSize
        {
            get { return Resource.Argument_IdnBadLabelSize; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IDN names must be between 1 and {0} characters long..
        /// </summary>
        public static string Argument_IdnBadNameSize
        {
            get { return Resource.Argument_IdnBadNameSize; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid IDN encoded string..
        /// </summary>
        public static string Argument_IdnBadPunycode
        {
            get { return Resource.Argument_IdnBadPunycode; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Label contains character &apos;{0}&apos; not allowed with UseStd3AsciiRules.
        /// </summary>
        public static string Argument_IdnBadStd3
        {
            get { return Resource.Argument_IdnBadStd3; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Decoded string is not a valid IDN name..
        /// </summary>
        public static string Argument_IdnIllegalName
        {
            get { return Resource.Argument_IdnIllegalName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The application base specified is not valid..
        /// </summary>
        public static string Argument_IllegalAppBase
        {
            get { return Resource.Argument_IllegalAppBase; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Application identity does not have same number of components as manifest paths..
        /// </summary>
        public static string Argument_IllegalAppId
        {
            get { return Resource.Argument_IllegalAppId; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Application identity does not match identities in manifests..
        /// </summary>
        public static string Argument_IllegalAppIdMismatch
        {
            get { return Resource.Argument_IllegalAppIdMismatch; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Environment variable name cannot contain equal character..
        /// </summary>
        public static string Argument_IllegalEnvVarName
        {
            get { return Resource.Argument_IllegalEnvVarName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Illegal name..
        /// </summary>
        public static string Argument_IllegalName
        {
            get { return Resource.Argument_IllegalName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Illegal security permission zone specified..
        /// </summary>
        public static string Argument_IllegalZone
        {
            get { return Resource.Argument_IllegalZone; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to impersonate user..
        /// </summary>
        public static string Argument_ImpersonateUser
        {
            get { return Resource.Argument_ImpersonateUser; }
        }

        /// <summary>
        ///   Looks up a localized string similar to At least one object must implement IComparable..
        /// </summary>
        public static string Argument_ImplementIComparable
        {
            get { return Resource.Argument_ImplementIComparable; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The type library importer encountered an error during type verification. Try importing without class members..
        /// </summary>
        public static string Argument_ImporterLoadFailure
        {
            get { return Resource.Argument_ImporterLoadFailure; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Improper types in collection..
        /// </summary>
        public static string Argument_ImproperType
        {
            get { return Resource.Argument_ImproperType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to All indexes must be of type Int32..
        /// </summary>
        public static string Argument_IndexMustBeInt
        {
            get { return Resource.Argument_IndexMustBeInt; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified index is out of bounds of the specified array..
        /// </summary>
        public static string Argument_IndexOutOfArrayBounds
        {
            get { return Resource.Argument_IndexOutOfArrayBounds; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Index was outside the bounds of the array..
        /// </summary>
        public static string Argument_IndexOutOfRangeException
        {
            get { return Resource.Argument_IndexOutOfRangeException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Insufficient stack to continue executing the program safely. This can happen from having too many functions on the call stack or function on the stack using too much stack space..
        /// </summary>
        public static string Argument_InsufficientExecutionStackException
        {
            get { return Resource.Argument_InsufficientExecutionStackException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified space is not sufficient to copy the elements from this Collection..
        /// </summary>
        public static string Argument_InsufficientSpaceToCopyCollection
        {
            get { return Resource.Argument_InsufficientSpaceToCopyCollection; }
        }

        /// <summary>
        ///   Looks up a localized string similar to &apos;this&apos; type cannot be an interface itself..
        /// </summary>
        public static string Argument_InterfaceMap
        {
            get { return Resource.Argument_InterfaceMap; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Specified access entry is invalid because it is unrestricted. The global flags should be specified instead..
        /// </summary>
        public static string Argument_InvalidAccessEntry
        {
            get { return Resource.Argument_InvalidAccessEntry; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The ANSI string passed in could not be converted from the default ANSI code page to Unicode..
        /// </summary>
        public static string Argument_InvalidANSIString
        {
            get { return Resource.Argument_InvalidANSIString; }
        }

        /// <summary>
        ///   Looks up a localized string similar to No flags can be set..
        /// </summary>
        public static string Argument_InvalidAnyFlag
        {
            get { return Resource.Argument_InvalidAnyFlag; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Append access can be requested only in write-only mode..
        /// </summary>
        public static string Argument_InvalidAppendMode
        {
            get { return Resource.Argument_InvalidAppendMode; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid identity: no deployment or application identity specified..
        /// </summary>
        public static string Argument_InvalidAppId
        {
            get { return Resource.Argument_InvalidAppId; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type of argument is not compatible with the generic comparer..
        /// </summary>
        public static string Argument_InvalidArgumentForComparison
        {
            get { return Resource.Argument_InvalidArgumentForComparison; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Length of the array must be {0}..
        /// </summary>
        public static string Argument_InvalidArrayLength
        {
            get { return Resource.Argument_InvalidArrayLength; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Target array type is not compatible with the type of items in the collection..
        /// </summary>
        public static string Argument_InvalidArrayType
        {
            get { return Resource.Argument_InvalidArrayType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Assembly names may not begin with whitespace or contain the characters &apos;/&apos;, or &apos;\\&apos; or &apos;:&apos;..
        /// </summary>
        public static string Argument_InvalidAssemblyName
        {
            get { return Resource.Argument_InvalidAssemblyName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid Base..
        /// </summary>
        public static string Argument_InvalidBase
        {
            get { return Resource.Argument_InvalidBase; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Not a valid calendar for the given culture..
        /// </summary>
        public static string Argument_InvalidCalendar
        {
            get { return Resource.Argument_InvalidCalendar; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Specified cast is not valid..
        /// </summary>
        public static string Argument_InvalidCastException
        {
            get { return Resource.Argument_InvalidCastException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid char {0} found in the string {1}..
        /// </summary>
        public static string Argument_InvalidCharInString
        {
            get { return Resource.Argument_InvalidCharInString; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid Unicode code point found at index {0}..
        /// </summary>
        public static string Argument_InvalidCharSequence
        {
            get { return Resource.Argument_InvalidCharSequence; }
        }

        /// <summary>
        ///   Looks up a localized string similar to String contains invalid Unicode code points..
        /// </summary>
        public static string Argument_InvalidCharSequenceNoIndex
        {
            get { return Resource.Argument_InvalidCharSequenceNoIndex; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to translate bytes {0} at index {1} from specified code page to Unicode..
        /// </summary>
        public static string Argument_InvalidCodePageBytesIndex
        {
            get { return Resource.Argument_InvalidCodePageBytesIndex; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to translate Unicode character \\u{0:X4} at index {1} to specified code page..
        /// </summary>
        public static string Argument_InvalidCodePageConversionIndex
        {
            get { return Resource.Argument_InvalidCodePageConversionIndex; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attempt has been made to use a COM object that does not have a backing class factory..
        /// </summary>
        public static string Argument_InvalidComObjectException
        {
            get { return Resource.Argument_InvalidComObjectException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The ConsoleColor enum value was not defined on that enum. Please use a defined color from the enum..
        /// </summary>
        public static string Argument_InvalidConsoleColor
        {
            get { return Resource.Argument_InvalidConsoleColor; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified constructor must be declared on the generic type definition of the specified type..
        /// </summary>
        public static string Argument_InvalidConstructorDeclaringType
        {
            get { return Resource.Argument_InvalidConstructorDeclaringType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The ConstructorInfo object is not valid..
        /// </summary>
        public static string Argument_InvalidConstructorInfo
        {
            get { return Resource.Argument_InvalidConstructorInfo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Culture name &apos;{0}&apos; is not supported..
        /// </summary>
        public static string Argument_InvalidCultureName
        {
            get { return Resource.Argument_InvalidCultureName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid DateTimeKind value..
        /// </summary>
        public static string Argument_InvalidDateTimeKind
        {
            get { return Resource.Argument_InvalidDateTimeKind; }
        }

        /// <summary>
        ///   Looks up a localized string similar to An undefined DateTimeStyles value is being used..
        /// </summary>
        public static string Argument_InvalidDateTimeStyles
        {
            get { return Resource.Argument_InvalidDateTimeStyles; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The DigitSubstitution property must be of a valid member of the DigitShapes enumeration. Valid entries include Context, NativeNational or None..
        /// </summary>
        public static string Argument_InvalidDigitSubstitution
        {
            get { return Resource.Argument_InvalidDigitSubstitution; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid directory, &apos;{0}&apos;..
        /// </summary>
        public static string Argument_InvalidDirectory
        {
            get { return Resource.Argument_InvalidDirectory; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid directory on URL..
        /// </summary>
        public static string Argument_InvalidDirectoryOnUrl
        {
            get { return Resource.Argument_InvalidDirectoryOnUrl; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid element name &apos;{0}&apos;..
        /// </summary>
        public static string Argument_InvalidElementName
        {
            get { return Resource.Argument_InvalidElementName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid element tag &apos;{0}&apos;..
        /// </summary>
        public static string Argument_InvalidElementTag
        {
            get { return Resource.Argument_InvalidElementTag; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid element text &apos;{0}&apos;..
        /// </summary>
        public static string Argument_InvalidElementText
        {
            get { return Resource.Argument_InvalidElementText; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid element value &apos;{0}&apos;..
        /// </summary>
        public static string Argument_InvalidElementValue
        {
            get { return Resource.Argument_InvalidElementValue; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The Enum type should contain one and only one instance field..
        /// </summary>
        public static string Argument_InvalidEnum
        {
            get { return Resource.Argument_InvalidEnum; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The value &apos;{0}&apos; is not valid for this usage of the type {1}..
        /// </summary>
        public static string Argument_InvalidEnumValue
        {
            get { return Resource.Argument_InvalidEnumValue; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified field must be declared on the generic type definition of the specified type..
        /// </summary>
        public static string Argument_InvalidFieldDeclaringType
        {
            get { return Resource.Argument_InvalidFieldDeclaringType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The FieldInfo object is not valid..
        /// </summary>
        public static string Argument_InvalidFieldInfo
        {
            get { return Resource.Argument_InvalidFieldInfo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid File or Directory attributes value..
        /// </summary>
        public static string Argument_InvalidFileAttrs
        {
            get { return Resource.Argument_InvalidFileAttrs; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Specified file extension was not a valid extension..
        /// </summary>
        public static string Argument_InvalidFileExtension
        {
            get { return Resource.Argument_InvalidFileExtension; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Combining FileMode: {0} with FileAccess: {1} is invalid..
        /// </summary>
        public static string Argument_InvalidFileMode_AccessCombo
        {
            get { return Resource.Argument_InvalidFileMode_AccessCombo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Combining FileMode: {0} with FileSystemRights: {1} is invalid..
        /// </summary>
        public static string Argument_InvalidFileMode_RightsCombo
        {
            get { return Resource.Argument_InvalidFileMode_RightsCombo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Combining FileMode: {0} with FileSystemRights: {1} is invalid. FileMode.Truncate is valid only when used with FileSystemRights.Write..
        /// </summary>
        public static string Argument_InvalidFileModeTruncate_RightsCombo
        {
            get { return Resource.Argument_InvalidFileModeTruncate_RightsCombo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Specified file name was invalid..
        /// </summary>
        public static string Argument_InvalidFileName
        {
            get { return Resource.Argument_InvalidFileName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Specified filter criteria was invalid..
        /// </summary>
        public static string Argument_InvalidFilterCriteriaException
        {
            get { return Resource.Argument_InvalidFilterCriteriaException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Value of flags is invalid..
        /// </summary>
        public static string Argument_InvalidFlag
        {
            get { return Resource.Argument_InvalidFlag; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The generic type parameter was not valid.
        /// </summary>
        public static string Argument_InvalidGenericArg
        {
            get { return Resource.Argument_InvalidGenericArg; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The given generic instantiation was invalid..
        /// </summary>
        public static string Argument_InvalidGenericInstantiation
        {
            get { return Resource.Argument_InvalidGenericInstantiation; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Generic arguments must be provided for each generic parameter and each generic argument must be a RuntimeType..
        /// </summary>
        public static string Argument_InvalidGenericInstArray
        {
            get { return Resource.Argument_InvalidGenericInstArray; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Every element in the value array should be between one and nine, except for the last element, which can be zero..
        /// </summary>
        public static string Argument_InvalidGroupSize
        {
            get { return Resource.Argument_InvalidGroupSize; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid handle..
        /// </summary>
        public static string Argument_InvalidHandle
        {
            get { return Resource.Argument_InvalidHandle; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Improperly formatted hex string..
        /// </summary>
        public static string Argument_InvalidHexFormat
        {
            get { return Resource.Argument_InvalidHexFormat; }
        }

        /// <summary>
        ///   Looks up a localized string similar to With the AllowHexSpecifier bit set in the enum bit field, the only other valid bits that can be combined into the enum value must be a subset of those in HexNumber..
        /// </summary>
        public static string Argument_InvalidHexStyle
        {
            get { return Resource.Argument_InvalidHexStyle; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Found a high surrogate char without a following low surrogate at index: {0}. The input may not be in this encoding, or may not contain valid Unicode (UTF-16) characters..
        /// </summary>
        public static string Argument_InvalidHighSurrogate
        {
            get { return Resource.Argument_InvalidHighSurrogate; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified ID parameter &apos;{0}&apos; is not supported..
        /// </summary>
        public static string Argument_InvalidId
        {
            get { return Resource.Argument_InvalidId; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid token for impersonation - it cannot be duplicated..
        /// </summary>
        public static string Argument_InvalidImpersonationToken
        {
            get { return Resource.Argument_InvalidImpersonationToken; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Key was invalid..
        /// </summary>
        public static string Argument_InvalidKey
        {
            get { return Resource.Argument_InvalidKey; }
        }

        /// <summary>
        ///   Looks up a localized string similar to &apos;{0}&apos; is not a valid KeyStore name. .
        /// </summary>
        public static string Argument_InvalidKeyStore
        {
            get { return Resource.Argument_InvalidKeyStore; }
        }

        /// <summary>
        ///   Looks up a localized string similar to This type cannot be represented as a custom attribute..
        /// </summary>
        public static string Argument_InvalidKindOfTypeForCA
        {
            get { return Resource.Argument_InvalidKindOfTypeForCA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid Label..
        /// </summary>
        public static string Argument_InvalidLabel
        {
            get { return Resource.Argument_InvalidLabel; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Found a low surrogate char without a preceding high surrogate at index: {0}. The input may not be in this encoding, or may not contain valid Unicode (UTF-16) characters..
        /// </summary>
        public static string Argument_InvalidLowSurrogate
        {
            get { return Resource.Argument_InvalidLowSurrogate; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The MarshalByRefObject is not valid..
        /// </summary>
        public static string Argument_InvalidMarshalByRefObject
        {
            get { return Resource.Argument_InvalidMarshalByRefObject; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The member must be either a field or a property..
        /// </summary>
        public static string Argument_InvalidMemberForNamedArgument
        {
            get { return Resource.Argument_InvalidMemberForNamedArgument; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified method must be declared on the generic type definition of the specified type..
        /// </summary>
        public static string Argument_InvalidMethodDeclaringType
        {
            get { return Resource.Argument_InvalidMethodDeclaringType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid name..
        /// </summary>
        public static string Argument_InvalidName
        {
            get { return Resource.Argument_InvalidName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The NativeDigits array must contain exactly ten members..
        /// </summary>
        public static string Argument_InvalidNativeDigitCount
        {
            get { return Resource.Argument_InvalidNativeDigitCount; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Each member of the NativeDigits array must be a single text element (one or more UTF16 code points) with a Unicode Nd (Number, Decimal Digit) property indicating it is a digit..
        /// </summary>
        public static string Argument_InvalidNativeDigitValue
        {
            get { return Resource.Argument_InvalidNativeDigitValue; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The region name {0} should not correspond to neutral culture; a specific culture name is required..
        /// </summary>
        public static string Argument_InvalidNeutralRegionName
        {
            get { return Resource.Argument_InvalidNeutralRegionName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The NeutralResourcesLanguageAttribute on the assembly &quot;{0}&quot; specifies an invalid culture name: &quot;{1}&quot;..
        /// </summary>
        public static string Argument_InvalidNeutralResourcesLanguage_Asm_Culture
        {
            get { return Resource.Argument_InvalidNeutralResourcesLanguage_Asm_Culture; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The NeutralResourcesLanguageAttribute specifies an invalid or unrecognized ultimate resource fallback location: &quot;{0}&quot;..
        /// </summary>
        public static string Argument_InvalidNeutralResourcesLanguage_FallbackLoc
        {
            get { return Resource.Argument_InvalidNeutralResourcesLanguage_FallbackLoc; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid or unsupported normalization form..
        /// </summary>
        public static string Argument_InvalidNormalizationForm
        {
            get { return Resource.Argument_InvalidNormalizationForm; }
        }

        /// <summary>
        ///   Looks up a localized string similar to MemberData contains an invalid number of members..
        /// </summary>
        public static string Argument_InvalidNumberOfMembers
        {
            get { return Resource.Argument_InvalidNumberOfMembers; }
        }

        /// <summary>
        ///   Looks up a localized string similar to An undefined NumberStyles value is being used..
        /// </summary>
        public static string Argument_InvalidNumberStyles
        {
            get { return Resource.Argument_InvalidNumberStyles; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Offset and length were out of bounds for the array or count is greater than the number of elements from index to the end of the source collection..
        /// </summary>
        public static string Argument_InvalidOffLen
        {
            get { return Resource.Argument_InvalidOffLen; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Specified OLE variant was invalid..
        /// </summary>
        public static string Argument_InvalidOleVariantTypeException
        {
            get { return Resource.Argument_InvalidOleVariantTypeException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Ldtoken, Ldftn and Ldvirtftn OpCodes cannot target DynamicMethods..
        /// </summary>
        public static string Argument_InvalidOpCodeOnDynamicMethod
        {
            get { return Resource.Argument_InvalidOpCodeOnDynamicMethod; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Operation is not valid due to the current state of the object..
        /// </summary>
        public static string Argument_InvalidOperationException
        {
            get { return Resource.Argument_InvalidOperationException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The ParameterInfo object is not valid..
        /// </summary>
        public static string Argument_InvalidParameterInfo
        {
            get { return Resource.Argument_InvalidParameterInfo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid type for ParameterInfo member in Attribute class..
        /// </summary>
        public static string Argument_InvalidParamInfo
        {
            get { return Resource.Argument_InvalidParamInfo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Illegal characters in path..
        /// </summary>
        public static string Argument_InvalidPathChars
        {
            get { return Resource.Argument_InvalidPathChars; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid permission state..
        /// </summary>
        public static string Argument_InvalidPermissionState
        {
            get { return Resource.Argument_InvalidPermissionState; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Privilege &apos;{0}&apos; is not valid on this system..
        /// </summary>
        public static string Argument_InvalidPrivilegeName
        {
            get { return Resource.Argument_InvalidPrivilegeName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The REG_TZI_FORMAT structure is corrupt..
        /// </summary>
        public static string Argument_InvalidREG_TZI_FORMAT
        {
            get { return Resource.Argument_InvalidREG_TZI_FORMAT; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Region name &apos;{0}&apos; is not supported..
        /// </summary>
        public static string Argument_InvalidRegionName
        {
            get { return Resource.Argument_InvalidRegionName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified RegistryKeyPermissionCheck value is invalid..
        /// </summary>
        public static string Argument_InvalidRegistryKeyPermissionCheck
        {
            get { return Resource.Argument_InvalidRegistryKeyPermissionCheck; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified RegistryOptions value is invalid..
        /// </summary>
        public static string Argument_InvalidRegistryOptionsCheck
        {
            get { return Resource.Argument_InvalidRegistryOptionsCheck; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified RegistryView value is invalid..
        /// </summary>
        public static string Argument_InvalidRegistryViewCheck
        {
            get { return Resource.Argument_InvalidRegistryViewCheck; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The given culture name &apos;{0}&apos; cannot be used to locate a resource file. Resource filenames must consist of only letters, numbers, hyphens or underscores..
        /// </summary>
        public static string Argument_InvalidResourceCultureName
        {
            get { return Resource.Argument_InvalidResourceCultureName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Offset and length were greater than the size of the SafeBuffer..
        /// </summary>
        public static string Argument_InvalidSafeBufferOffLen
        {
            get { return Resource.Argument_InvalidSafeBufferOffLen; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The SafeHandle is invalid..
        /// </summary>
        public static string Argument_InvalidSafeHandle
        {
            get { return Resource.Argument_InvalidSafeHandle; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Satellite contract version attribute on the assembly &apos;{0}&apos; specifies an invalid version: {1}..
        /// </summary>
        public static string Argument_InvalidSatelliteContract_Asm_Ver
        {
            get { return Resource.Argument_InvalidSatelliteContract_Asm_Ver; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Search pattern cannot contain &quot;..&quot; to move up directories and can be contained only internally in file/directory names, as in &quot;a..b&quot;..
        /// </summary>
        public static string Argument_InvalidSearchPattern
        {
            get { return Resource.Argument_InvalidSearchPattern; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid seek origin..
        /// </summary>
        public static string Argument_InvalidSeekOrigin
        {
            get { return Resource.Argument_InvalidSeekOrigin; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified serialized string &apos;{0}&apos; is not supported..
        /// </summary>
        public static string Argument_InvalidSerializedString
        {
            get { return Resource.Argument_InvalidSerializedString; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid site..
        /// </summary>
        public static string Argument_InvalidSite
        {
            get { return Resource.Argument_InvalidSite; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The directory specified, &apos;{0}&apos;, is not a subdirectory of &apos;{1}&apos;..
        /// </summary>
        public static string Argument_InvalidSubPath
        {
            get { return Resource.Argument_InvalidSubPath; }
        }

        /// <summary>
        ///   Looks up a localized string similar to An undefined TimeSpanStyles value is being used..
        /// </summary>
        public static string Argument_InvalidTimeSpanStyles
        {
            get { return Resource.Argument_InvalidTimeSpanStyles; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Token {0:x} is not valid in the scope of module {1}..
        /// </summary>
        public static string Argument_InvalidToken
        {
            get { return Resource.Argument_InvalidToken; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The type of arguments passed into generic comparer methods is invalid..
        /// </summary>
        public static string Argument_InvalidType
        {
            get { return Resource.Argument_InvalidType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot build type parameter for custom attribute with a type that does not support the AssemblyQualifiedName property. The type instance supplied was of type &apos;{0}&apos;..
        /// </summary>
        public static string Argument_InvalidTypeForCA
        {
            get { return Resource.Argument_InvalidTypeForCA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid type owner for DynamicMethod..
        /// </summary>
        public static string Argument_InvalidTypeForDynamicMethod
        {
            get { return Resource.Argument_InvalidTypeForDynamicMethod; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The return Type contains some invalid type (i.e. null, ByRef).
        /// </summary>
        public static string Argument_InvalidTypeInRetType
        {
            get { return Resource.Argument_InvalidTypeInRetType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The signature Type array contains some invalid type (i.e. null, void).
        /// </summary>
        public static string Argument_InvalidTypeInSignature
        {
            get { return Resource.Argument_InvalidTypeInSignature; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The name of the type is invalid..
        /// </summary>
        public static string Argument_InvalidTypeName
        {
            get { return Resource.Argument_InvalidTypeName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Token {0:x} is not a valid Type token..
        /// </summary>
        public static string Argument_InvalidTypeToken
        {
            get { return Resource.Argument_InvalidTypeToken; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid Unity type..
        /// </summary>
        public static string Argument_InvalidUnity
        {
            get { return Resource.Argument_InvalidUnity; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid URL..
        /// </summary>
        public static string Argument_InvalidUrl
        {
            get { return Resource.Argument_InvalidUrl; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The UTF8 string passed in could not be converted to Unicode..
        /// </summary>
        public static string Argument_InvalidUTF8String
        {
            get { return Resource.Argument_InvalidUTF8String; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Value was invalid..
        /// </summary>
        public static string Argument_InvalidValue
        {
            get { return Resource.Argument_InvalidValue; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid Xml..
        /// </summary>
        public static string Argument_InvalidXML
        {
            get { return Resource.Argument_InvalidXML; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid Xml - can only parse elements of version one..
        /// </summary>
        public static string Argument_InvalidXMLBadVersion
        {
            get { return Resource.Argument_InvalidXMLBadVersion; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid XML. Missing required tag &lt;{0}&gt; for type &apos;{1}&apos;..
        /// </summary>
        public static string Argument_InvalidXMLElement
        {
            get { return Resource.Argument_InvalidXMLElement; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid XML. Missing required attribute &apos;{0}&apos;..
        /// </summary>
        public static string Argument_InvalidXMLMissingAttr
        {
            get { return Resource.Argument_InvalidXMLMissingAttr; }
        }

        /// <summary>
        ///   Looks up a localized string similar to InvokeMember can be used only for COM objects..
        /// </summary>
        public static string Argument_InvokeMember
        {
            get { return Resource.Argument_InvokeMember; }
        }

        /// <summary>
        ///   Looks up a localized string similar to I/O error occurred..
        /// </summary>
        public static string Argument_IOException
        {
            get { return Resource.Argument_IOException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified item does not exist in this KeyedCollection..
        /// </summary>
        public static string Argument_ItemNotExist
        {
            get { return Resource.Argument_ItemNotExist; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The given key was not present in the dictionary..
        /// </summary>
        public static string Argument_KeyNotFound
        {
            get { return Resource.Argument_KeyNotFound; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Integer or token was too large to be encoded..
        /// </summary>
        public static string Argument_LargeInteger
        {
            get { return Resource.Argument_LargeInteger; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Environment variable name cannot contain 1024 or more characters..
        /// </summary>
        public static string Argument_LongEnvVarName
        {
            get { return Resource.Argument_LongEnvVarName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Environment variable name or value is too long..
        /// </summary>
        public static string Argument_LongEnvVarValue
        {
            get { return Resource.Argument_LongEnvVarValue; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Destination array was not long enough. Check destIndex and length, and the array&apos;s lower bounds..
        /// </summary>
        public static string Argument_LongerThanDestArray
        {
            get { return Resource.Argument_LongerThanDestArray; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Source array was not long enough. Check srcIndex and length, and the array&apos;s lower bounds..
        /// </summary>
        public static string Argument_LongerThanSrcArray
        {
            get { return Resource.Argument_LongerThanSrcArray; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Source string was not long enough. Check sourceIndex and count..
        /// </summary>
        public static string Argument_LongerThanSrcString
        {
            get { return Resource.Argument_LongerThanSrcString; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The arrays&apos; lower bounds must be identical..
        /// </summary>
        public static string Argument_LowerBoundsMustMatch
        {
            get { return Resource.Argument_LowerBoundsMustMatch; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified manifest file does not exist..
        /// </summary>
        public static string Argument_ManifestFileDoesNotExist
        {
            get { return Resource.Argument_ManifestFileDoesNotExist; }
        }

        /// <summary>
        ///   Looks up a localized string similar to AsAny cannot be used on return types, ByRef parameters, ArrayWithOffset, or parameters passed from unmanaged to managed..
        /// </summary>
        public static string Argument_MarshalAsAnyRestriction
        {
            get { return Resource.Argument_MarshalAsAnyRestriction; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Marshaling directives are invalid..
        /// </summary>
        public static string Argument_MarshalDirectiveException
        {
            get { return Resource.Argument_MarshalDirectiveException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot supply both a MemberInfo and an Array to indicate the parent of a value type..
        /// </summary>
        public static string Argument_MemberAndArray
        {
            get { return Resource.Argument_MemberAndArray; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The Module object containing the member cannot be null..
        /// </summary>
        public static string Argument_MemberInfoNullModule
        {
            get { return Resource.Argument_MemberInfoNullModule; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Element must be a &lt;IMembershipCondition&gt; element..
        /// </summary>
        public static string Argument_MembershipConditionElement
        {
            get { return Resource.Argument_MembershipConditionElement; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attempt to access the method unsuccessfully..
        /// </summary>
        public static string Argument_MethodAccessException
        {
            get { return Resource.Argument_MethodAccessException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attempt by security transparent method &apos;{0}&apos; to access security critical method &apos;{1}&apos; unsuccessfully..
        /// </summary>
        public static string Argument_MethodAccessException_WithCaller
        {
            get { return Resource.Argument_MethodAccessException_WithCaller; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attempt to access the method &quot;{0}&quot; on type &quot;{1}&quot; unsuccessfully..
        /// </summary>
        public static string Argument_MethodAccessException_WithMethodName
        {
            get { return Resource.Argument_MethodAccessException_WithMethodName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot resolve method {0} because the declaring type of the method handle {1} is generic. Explicitly provide the declaring type to GetMethodFromHandle. .
        /// </summary>
        public static string Argument_MethodDeclaringTypeGeneric
        {
            get { return Resource.Argument_MethodDeclaringTypeGeneric; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Method &apos;{0}&apos; has a generic declaring type &apos;{1}&apos;. Explicitly provide the declaring type to GetTokenFor. .
        /// </summary>
        public static string Argument_MethodDeclaringTypeGenericLcg
        {
            get { return Resource.Argument_MethodDeclaringTypeGenericLcg; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified method cannot be dynamic or global and must be declared on a generic type definition..
        /// </summary>
        public static string Argument_MethodNeedGenericDeclaringType
        {
            get { return Resource.Argument_MethodNeedGenericDeclaringType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Method has been already defined..
        /// </summary>
        public static string Argument_MethodRedefined
        {
            get { return Resource.Argument_MethodRedefined; }
        }

        /// <summary>
        ///   Looks up a localized string similar to &apos;{0}&apos; cannot be greater than {1}..
        /// </summary>
        public static string Argument_MinMaxValue
        {
            get { return Resource.Argument_MinMaxValue; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Two arrays, {0} and {1}, must be of  the same size..
        /// </summary>
        public static string Argument_MismatchedArrays
        {
            get { return Resource.Argument_MismatchedArrays; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The AppDomainSetup must specify the activation arguments for this call..
        /// </summary>
        public static string Argument_MissingActivationArguments
        {
            get { return Resource.Argument_MissingActivationArguments; }
        }

        /// <summary>
        ///   Looks up a localized string similar to was missing default constructor..
        /// </summary>
        public static string Argument_MissingDefaultConstructor
        {
            get { return Resource.Argument_MissingDefaultConstructor; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attempted to access a non-existing field..
        /// </summary>
        public static string Argument_MissingFieldException
        {
            get { return Resource.Argument_MissingFieldException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to find manifest resource..
        /// </summary>
        public static string Argument_MissingManifestResourceException
        {
            get { return Resource.Argument_MissingManifestResourceException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attempted to access a missing member..
        /// </summary>
        public static string Argument_MissingMemberException
        {
            get { return Resource.Argument_MissingMemberException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attempted to access a missing method..
        /// </summary>
        public static string Argument_MissingMethodException
        {
            get { return Resource.Argument_MissingMethodException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified module has already been loaded..
        /// </summary>
        public static string Argument_ModuleAlreadyLoaded
        {
            get { return Resource.Argument_ModuleAlreadyLoaded; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attempted to add multiple callbacks to a delegate that does not support multicast..
        /// </summary>
        public static string Argument_MulticastNotSupportedException
        {
            get { return Resource.Argument_MulticastNotSupportedException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to At least one type argument is not a runtime type..
        /// </summary>
        public static string Argument_MustAllBeRuntimeType
        {
            get { return Resource.Argument_MustAllBeRuntimeType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object must be of type Boolean..
        /// </summary>
        public static string Argument_MustBeBoolean
        {
            get { return Resource.Argument_MustBeBoolean; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object must be of type Byte..
        /// </summary>
        public static string Argument_MustBeByte
        {
            get { return Resource.Argument_MustBeByte; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object must be of type Char..
        /// </summary>
        public static string Argument_MustBeChar
        {
            get { return Resource.Argument_MustBeChar; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object must be of type DateTime..
        /// </summary>
        public static string Argument_MustBeDateTime
        {
            get { return Resource.Argument_MustBeDateTime; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object must be of type DateTimeOffset..
        /// </summary>
        public static string Argument_MustBeDateTimeOffset
        {
            get { return Resource.Argument_MustBeDateTimeOffset; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object must be of type Decimal..
        /// </summary>
        public static string Argument_MustBeDecimal
        {
            get { return Resource.Argument_MustBeDecimal; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type must derive from Delegate..
        /// </summary>
        public static string Argument_MustBeDelegate
        {
            get { return Resource.Argument_MustBeDelegate; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object must be of type Double..
        /// </summary>
        public static string Argument_MustBeDouble
        {
            get { return Resource.Argument_MustBeDouble; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object must be a root directory (&quot;C:\\&quot;) or a drive letter (&quot;C&quot;)..
        /// </summary>
        public static string Argument_MustBeDriveLetterOrRootDir
        {
            get { return Resource.Argument_MustBeDriveLetterOrRootDir; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type provided must be an Enum..
        /// </summary>
        public static string Argument_MustBeEnum
        {
            get { return Resource.Argument_MustBeEnum; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The value passed in must be an enum base or an underlying type for an enum, such as an Int32..
        /// </summary>
        public static string Argument_MustBeEnumBaseTypeOrEnum
        {
            get { return Resource.Argument_MustBeEnumBaseTypeOrEnum; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Argument must be initialized to false.
        /// </summary>
        public static string Argument_MustBeFalse
        {
            get { return Resource.Argument_MustBeFalse; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object must be of type GUID..
        /// </summary>
        public static string Argument_MustBeGuid
        {
            get { return Resource.Argument_MustBeGuid; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type must be an IdentityReference, such as NTAccount or SecurityIdentifier..
        /// </summary>
        public static string Argument_MustBeIdentityReferenceType
        {
            get { return Resource.Argument_MustBeIdentityReferenceType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object must be of type Int16..
        /// </summary>
        public static string Argument_MustBeInt16
        {
            get { return Resource.Argument_MustBeInt16; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object must be of type Int32..
        /// </summary>
        public static string Argument_MustBeInt32
        {
            get { return Resource.Argument_MustBeInt32; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object must be of type Int64..
        /// </summary>
        public static string Argument_MustBeInt64
        {
            get { return Resource.Argument_MustBeInt64; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type passed must be an interface..
        /// </summary>
        public static string Argument_MustBeInterface
        {
            get { return Resource.Argument_MustBeInterface; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The MemberInfo must be an interface method..
        /// </summary>
        public static string Argument_MustBeInterfaceMethod
        {
            get { return Resource.Argument_MustBeInterfaceMethod; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type must be a Pointer..
        /// </summary>
        public static string Argument_MustBePointer
        {
            get { return Resource.Argument_MustBePointer; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object must be an array of primitives..
        /// </summary>
        public static string Argument_MustBePrimArray
        {
            get { return Resource.Argument_MustBePrimArray; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Assembly must be a runtime Assembly object..
        /// </summary>
        public static string Argument_MustBeRuntimeAssembly
        {
            get { return Resource.Argument_MustBeRuntimeAssembly; }
        }

        /// <summary>
        ///   Looks up a localized string similar to FieldInfo must be a runtime FieldInfo object..
        /// </summary>
        public static string Argument_MustBeRuntimeFieldInfo
        {
            get { return Resource.Argument_MustBeRuntimeFieldInfo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to MethodInfo must be a runtime MethodInfo object..
        /// </summary>
        public static string Argument_MustBeRuntimeMethodInfo
        {
            get { return Resource.Argument_MustBeRuntimeMethodInfo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Module must be a runtime Module object..
        /// </summary>
        public static string Argument_MustBeRuntimeModule
        {
            get { return Resource.Argument_MustBeRuntimeModule; }
        }

        /// <summary>
        ///   Looks up a localized string similar to ParameterInfo must be a runtime ParameterInfo object..
        /// </summary>
        public static string Argument_MustBeRuntimeParameterInfo
        {
            get { return Resource.Argument_MustBeRuntimeParameterInfo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The object must be a runtime Reflection object..
        /// </summary>
        public static string Argument_MustBeRuntimeReflectionObject
        {
            get { return Resource.Argument_MustBeRuntimeReflectionObject; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type must be a runtime Type object..
        /// </summary>
        public static string Argument_MustBeRuntimeType
        {
            get { return Resource.Argument_MustBeRuntimeType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object must be of type SByte..
        /// </summary>
        public static string Argument_MustBeSByte
        {
            get { return Resource.Argument_MustBeSByte; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object must be of type Single..
        /// </summary>
        public static string Argument_MustBeSingle
        {
            get { return Resource.Argument_MustBeSingle; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Method must be a static method..
        /// </summary>
        public static string Argument_MustBeStatic
        {
            get { return Resource.Argument_MustBeStatic; }
        }

        /// <summary>
        ///   Looks up a localized string similar to String is too long or has invalid contents..
        /// </summary>
        public static string Argument_MustBeString
        {
            get { return Resource.Argument_MustBeString; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The pointer passed in as a String must not be in the bottom 64K of the process&apos;s address space..
        /// </summary>
        public static string Argument_MustBeStringPtrNotAtom
        {
            get { return Resource.Argument_MustBeStringPtrNotAtom; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object must be of type TimeSpan..
        /// </summary>
        public static string Argument_MustBeTimeSpan
        {
            get { return Resource.Argument_MustBeTimeSpan; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Argument must be true..
        /// </summary>
        public static string Argument_MustBeTrue
        {
            get { return Resource.Argument_MustBeTrue; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type must be a type provided by the runtime..
        /// </summary>
        public static string Argument_MustBeType
        {
            get { return Resource.Argument_MustBeType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to &apos;type&apos; must contain a TypeBuilder as a generic argument..
        /// </summary>
        public static string Argument_MustBeTypeBuilder
        {
            get { return Resource.Argument_MustBeTypeBuilder; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object must be of type UInt16..
        /// </summary>
        public static string Argument_MustBeUInt16
        {
            get { return Resource.Argument_MustBeUInt16; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object must be of type UInt32..
        /// </summary>
        public static string Argument_MustBeUInt32
        {
            get { return Resource.Argument_MustBeUInt32; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object must be of type UInt64..
        /// </summary>
        public static string Argument_MustBeUInt64
        {
            get { return Resource.Argument_MustBeUInt64; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object must be of type Version..
        /// </summary>
        public static string Argument_MustBeVersion
        {
            get { return Resource.Argument_MustBeVersion; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Must specify valid information for parsing in the string..
        /// </summary>
        public static string Argument_MustContainEnumInfo
        {
            get { return Resource.Argument_MustContainEnumInfo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type passed in must be derived from System.Attribute or System.Attribute itself..
        /// </summary>
        public static string Argument_MustHaveAttributeBaseClass
        {
            get { return Resource.Argument_MustHaveAttributeBaseClass; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified structure must be blittable or have layout information..
        /// </summary>
        public static string Argument_MustHaveLayoutOrBeBlittable
        {
            get { return Resource.Argument_MustHaveLayoutOrBeBlittable; }
        }

        /// <summary>
        ///   Looks up a localized string similar to When supplying a FieldInfo for fixing up a nested type, a valid ID for that containing object must also be supplied..
        /// </summary>
        public static string Argument_MustSupplyContainer
        {
            get { return Resource.Argument_MustSupplyContainer; }
        }

        /// <summary>
        ///   Looks up a localized string similar to When supplying the ID of a containing object, the FieldInfo that identifies the current field within that object must also be supplied..
        /// </summary>
        public static string Argument_MustSupplyParent
        {
            get { return Resource.Argument_MustSupplyParent; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The name &apos;{0}&apos; contains characters that are not valid for a Culture or Region..
        /// </summary>
        public static string Argument_NameContainsInvalidCharacters
        {
            get { return Resource.Argument_NameContainsInvalidCharacters; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Named parameter value must not be null..
        /// </summary>
        public static string Argument_NamedParamNull
        {
            get { return Resource.Argument_NamedParamNull; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Named parameter array cannot be bigger than argument array..
        /// </summary>
        public static string Argument_NamedParamTooBig
        {
            get { return Resource.Argument_NamedParamTooBig; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The name &apos;{0}&apos; is too long to be a Culture or Region name, which is limited to {1} characters..
        /// </summary>
        public static string Argument_NameTooLong
        {
            get { return Resource.Argument_NameTooLong; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Native resource has already been defined..
        /// </summary>
        public static string Argument_NativeResourceAlreadyDefined
        {
            get { return Resource.Argument_NativeResourceAlreadyDefined; }
        }

        /// <summary>
        ///   Looks up a localized string similar to No PInvoke conversion exists for value passed to Object-typed parameter..
        /// </summary>
        public static string Argument_NDirectBadObject
        {
            get { return Resource.Argument_NDirectBadObject; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Array was not a one-dimensional array..
        /// </summary>
        public static string Argument_Need1DArray
        {
            get { return Resource.Argument_Need1DArray; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Array was not a two-dimensional array..
        /// </summary>
        public static string Argument_Need2DArray
        {
            get { return Resource.Argument_Need2DArray; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Array was not a three-dimensional array..
        /// </summary>
        public static string Argument_Need3DArray
        {
            get { return Resource.Argument_Need3DArray; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Must provide at least one rank..
        /// </summary>
        public static string Argument_NeedAtLeast1Rank
        {
            get { return Resource.Argument_NeedAtLeast1Rank; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Method must represent a generic method definition on a generic type definition..
        /// </summary>
        public static string Argument_NeedGenericMethodDefinition
        {
            get { return Resource.Argument_NeedGenericMethodDefinition; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified object must not be an instance of a generic type..
        /// </summary>
        public static string Argument_NeedNonGenericObject
        {
            get { return Resource.Argument_NeedNonGenericObject; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified Type must not be a generic type definition..
        /// </summary>
        public static string Argument_NeedNonGenericType
        {
            get { return Resource.Argument_NeedNonGenericType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified Type must be a struct containing no references..
        /// </summary>
        public static string Argument_NeedStructWithNoRefs
        {
            get { return Resource.Argument_NeedStructWithNoRefs; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Argument count must not be negative..
        /// </summary>
        public static string Argument_NegativeArgCount
        {
            get { return Resource.Argument_NegativeArgCount; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The type &apos;{0}&apos; may not be used as a type argument..
        /// </summary>
        public static string Argument_NeverValidGenericArgument
        {
            get { return Resource.Argument_NeverValidGenericArgument; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Must specify binding flags describing the invoke operation required (BindingFlags.InvokeMethod CreateInstance GetField SetField GetProperty SetProperty)..
        /// </summary>
        public static string Argument_NoAccessSpec
        {
            get { return Resource.Argument_NoAccessSpec; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Element does not specify a class..
        /// </summary>
        public static string Argument_NoClass
        {
            get { return Resource.Argument_NoClass; }
        }

        /// <summary>
        ///   Looks up a localized string similar to No parameterless constructor defined for this object..
        /// </summary>
        public static string Argument_NoDefCTor
        {
            get { return Resource.Argument_NoDefCTor; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The domain manager specified by the host could not be instantiated..
        /// </summary>
        public static string Argument_NoDomainManager
        {
            get { return Resource.Argument_NoDomainManager; }
        }

        /// <summary>
        ///   Looks up a localized string similar to No Era was supplied..
        /// </summary>
        public static string Argument_NoEra
        {
            get { return Resource.Argument_NoEra; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Specified type library importer callback was invalid because it did not support the ITypeLibImporterNotifySink interface..
        /// </summary>
        public static string Argument_NoImporterCallback
        {
            get { return Resource.Argument_NoImporterCallback; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Specified TypeInfo was invalid because it did not support the ITypeInfo interface..
        /// </summary>
        public static string Argument_NoITypeInfo
        {
            get { return Resource.Argument_NoITypeInfo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Specified TypeLib was invalid because it did not support the ITypeLib interface..
        /// </summary>
        public static string Argument_NoITypeLib
        {
            get { return Resource.Argument_NoITypeLib; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Main entry point not defined..
        /// </summary>
        public static string Argument_NoMain
        {
            get { return Resource.Argument_NoMain; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Module file name &apos;{0}&apos; must have file extension..
        /// </summary>
        public static string Argument_NoModuleFileExtension
        {
            get { return Resource.Argument_NoModuleFileExtension; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Only LPArray or SafeArray has nested unmanaged marshal..
        /// </summary>
        public static string Argument_NoNestedMarshal
        {
            get { return Resource.Argument_NoNestedMarshal; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Either obj or ctx must be null..
        /// </summary>
        public static string Argument_NonNullObjAndCtx
        {
            get { return Resource.Argument_NonNullObjAndCtx; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to find a permission set with the provided name..
        /// </summary>
        public static string Argument_NoNPMS
        {
            get { return Resource.Argument_NoNPMS; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The lower bound of target array must be zero..
        /// </summary>
        public static string Argument_NonZeroLowerBound
        {
            get { return Resource.Argument_NonZeroLowerBound; }
        }

        /// <summary>
        ///   Looks up a localized string similar to There is no region associated with the Invariant Culture (Culture ID: 0x7F)..
        /// </summary>
        public static string Argument_NoRegionInvariantCulture
        {
            get { return Resource.Argument_NoRegionInvariantCulture; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Please select a specific culture, such as zh-CN, zh-HK, zh-TW, zh-MO, zh-SG..
        /// </summary>
        public static string Argument_NoSpecificCulture
        {
            get { return Resource.Argument_NoSpecificCulture; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Method cannot be both static and virtual..
        /// </summary>
        public static string Argument_NoStaticVirtual
        {
            get { return Resource.Argument_NoStaticVirtual; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The type does not inherit from CodeGroup.
        /// </summary>
        public static string Argument_NotACodeGroupType
        {
            get { return Resource.Argument_NotACodeGroupType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Not a custom marshal..
        /// </summary>
        public static string Argument_NotACustomMarshaler
        {
            get { return Resource.Argument_NotACustomMarshaler; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The type does not implement IMembershipCondition.
        /// </summary>
        public static string Argument_NotAMembershipCondition
        {
            get { return Resource.Argument_NotAMembershipCondition; }
        }

        /// <summary>
        ///   Looks up a localized string similar to &apos;elem&apos; was not a permission element..
        /// </summary>
        public static string Argument_NotAPermissionElement
        {
            get { return Resource.Argument_NotAPermissionElement; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The type does not implement IPermission.
        /// </summary>
        public static string Argument_NotAPermissionType
        {
            get { return Resource.Argument_NotAPermissionType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The UnmanagedType passed to DefineUnmanagedMarshal is not a simple type. None of the following values may be used: UnmanagedType.ByValTStr, UnmanagedType.SafeArray, UnmanagedType.ByValArray, UnmanagedType.LPArray, UnmanagedType.CustomMarshaler..
        /// </summary>
        public static string Argument_NotASimpleNativeType
        {
            get { return Resource.Argument_NotASimpleNativeType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type must be a TransparentProxy.
        /// </summary>
        public static string Argument_NotATP
        {
            get { return Resource.Argument_NotATP; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Not a writable property..
        /// </summary>
        public static string Argument_NotAWritableProperty
        {
            get { return Resource.Argument_NotAWritableProperty; }
        }

        /// <summary>
        ///   Looks up a localized string similar to There are not enough bytes remaining in the accessor to read at this position..
        /// </summary>
        public static string Argument_NotEnoughBytesToRead
        {
            get { return Resource.Argument_NotEnoughBytesToRead; }
        }

        /// <summary>
        ///   Looks up a localized string similar to There are not enough bytes remaining in the accessor to write at this position..
        /// </summary>
        public static string Argument_NotEnoughBytesToWrite
        {
            get { return Resource.Argument_NotEnoughBytesToWrite; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The type or method has {1} generic parameter(s), but {0} generic argument(s) were provided. A generic argument must be provided for each generic parameter..
        /// </summary>
        public static string Argument_NotEnoughGenArguments
        {
            get { return Resource.Argument_NotEnoughGenArguments; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Does not extend Exception..
        /// </summary>
        public static string Argument_NotExceptionType
        {
            get { return Resource.Argument_NotExceptionType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Number encountered was not a finite quantity..
        /// </summary>
        public static string Argument_NotFiniteNumberException
        {
            get { return Resource.Argument_NotFiniteNumberException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Interface not found..
        /// </summary>
        public static string Argument_NotFoundIFace
        {
            get { return Resource.Argument_NotFoundIFace; }
        }

        /// <summary>
        ///   Looks up a localized string similar to {0} is not a GenericMethodDefinition. MakeGenericMethod may only be called on a method for which MethodBase.IsGenericMethodDefinition is true..
        /// </summary>
        public static string Argument_NotGenericMethodDefinition
        {
            get { return Resource.Argument_NotGenericMethodDefinition; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Method may only be called on a Type for which Type.IsGenericParameter is true..
        /// </summary>
        public static string Argument_NotGenericParameter
        {
            get { return Resource.Argument_NotGenericParameter; }
        }

        /// <summary>
        ///   Looks up a localized string similar to {0} is not a GenericTypeDefinition. MakeGenericType may only be called on a type for which Type.IsGenericTypeDefinition is true..
        /// </summary>
        public static string Argument_NotGenericTypeDefinition
        {
            get { return Resource.Argument_NotGenericTypeDefinition; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The method or operation is not implemented..
        /// </summary>
        public static string Argument_NotImplementedException
        {
            get { return Resource.Argument_NotImplementedException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Not currently in an exception block..
        /// </summary>
        public static string Argument_NotInExceptionBlock
        {
            get { return Resource.Argument_NotInExceptionBlock; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The argument passed in was not from the same ModuleBuilder..
        /// </summary>
        public static string Argument_NotInTheSameModuleBuilder
        {
            get { return Resource.Argument_NotInTheSameModuleBuilder; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified opcode cannot be passed to EmitCall..
        /// </summary>
        public static string Argument_NotMethodCallOpcode
        {
            get { return Resource.Argument_NotMethodCallOpcode; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Argument passed in is not serializable..
        /// </summary>
        public static string Argument_NotSerializable
        {
            get { return Resource.Argument_NotSerializable; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The filename must not include a path specification..
        /// </summary>
        public static string Argument_NotSimpleFileName
        {
            get { return Resource.Argument_NotSimpleFileName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Specified method is not supported..
        /// </summary>
        public static string Argument_NotSupportedException
        {
            get { return Resource.Argument_NotSupportedException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The object has no underlying COM data associated with it..
        /// </summary>
        public static string Argument_NoUnderlyingCCW
        {
            get { return Resource.Argument_NoUnderlyingCCW; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Uninitialized Strings cannot be created..
        /// </summary>
        public static string Argument_NoUninitializedStrings
        {
            get { return Resource.Argument_NoUninitializedStrings; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unmanaged marshal does not have ElementCount..
        /// </summary>
        public static string Argument_NoUnmanagedElementCount
        {
            get { return Resource.Argument_NoUnmanagedElementCount; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Permission set &apos;{0}&apos; was in use and could not be deleted..
        /// </summary>
        public static string Argument_NPMSInUse
        {
            get { return Resource.Argument_NPMSInUse; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Name can be neither null nor empty..
        /// </summary>
        public static string Argument_NPMSInvalidName
        {
            get { return Resource.Argument_NPMSInvalidName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to A null StrongName was found in the full trust assembly list..
        /// </summary>
        public static string Argument_NullFullTrustAssembly
        {
            get { return Resource.Argument_NullFullTrustAssembly; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arrays indexes must be set to an object instance..
        /// </summary>
        public static string Argument_NullIndex
        {
            get { return Resource.Argument_NullIndex; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object reference not set to an instance of an object..
        /// </summary>
        public static string Argument_NullReferenceException
        {
            get { return Resource.Argument_NullReferenceException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The object&apos;s type must not be a Windows Runtime type..
        /// </summary>
        public static string Argument_ObjIsWinRTObject
        {
            get { return Resource.Argument_ObjIsWinRTObject; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The object&apos;s type must be __ComObject or derived from __ComObject..
        /// </summary>
        public static string Argument_ObjNotComObject
        {
            get { return Resource.Argument_ObjNotComObject; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object type cannot be converted to target type..
        /// </summary>
        public static string Argument_ObjObj
        {
            get { return Resource.Argument_ObjObj; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object of type &apos;{0}&apos; cannot be converted to type &apos;{1}&apos;..
        /// </summary>
        public static string Argument_ObjObjEx
        {
            get { return Resource.Argument_ObjObjEx; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Offset and capacity were greater than the size of the view..
        /// </summary>
        public static string Argument_OffsetAndCapacityOutOfBounds
        {
            get { return Resource.Argument_OffsetAndCapacityOutOfBounds; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Offset and length were out of bounds for the array or count is greater than the number of elements from index to the end of the source collection..
        /// </summary>
        public static string Argument_OffsetAndLengthOutOfBounds
        {
            get { return Resource.Argument_OffsetAndLengthOutOfBounds; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The UTC Offset of the local dateTime parameter does not match the offset argument..
        /// </summary>
        public static string Argument_OffsetLocalMismatch
        {
            get { return Resource.Argument_OffsetLocalMismatch; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Field passed in is not a marshaled member of the type &apos;{0}&apos;..
        /// </summary>
        public static string Argument_OffsetOfFieldNotFound
        {
            get { return Resource.Argument_OffsetOfFieldNotFound; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Offset must be within plus or minus 14 hours..
        /// </summary>
        public static string Argument_OffsetOutOfRange
        {
            get { return Resource.Argument_OffsetOutOfRange; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Offset must be specified in whole minutes..
        /// </summary>
        public static string Argument_OffsetPrecision
        {
            get { return Resource.Argument_OffsetPrecision; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The UTC Offset for Utc DateTime instances must be 0..
        /// </summary>
        public static string Argument_OffsetUtcMismatch
        {
            get { return Resource.Argument_OffsetUtcMismatch; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Not a legal OleAut date..
        /// </summary>
        public static string Argument_OleAutDateInvalid
        {
            get { return Resource.Argument_OleAutDateInvalid; }
        }

        /// <summary>
        ///   Looks up a localized string similar to OleAut date did not convert to a DateTime correctly..
        /// </summary>
        public static string Argument_OleAutDateScale
        {
            get { return Resource.Argument_OleAutDateScale; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Culture name {0} or {1} is not supported..
        /// </summary>
        public static string Argument_OneOfCulturesNotSupported
        {
            get { return Resource.Argument_OneOfCulturesNotSupported; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Only mscorlib&apos;s assembly is valid..
        /// </summary>
        public static string Argument_OnlyMscorlib
        {
            get { return Resource.Argument_OnlyMscorlib; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The DateStart property must come before the DateEnd property..
        /// </summary>
        public static string Argument_OutOfOrderDateTimes
        {
            get { return Resource.Argument_OutOfOrderDateTimes; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arithmetic operation resulted in an overflow..
        /// </summary>
        public static string Argument_OverflowException
        {
            get { return Resource.Argument_OverflowException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The MemberInfo object defining the parameter cannot be null..
        /// </summary>
        public static string Argument_ParameterInfoNullMember
        {
            get { return Resource.Argument_ParameterInfoNullMember; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The Module object containing the parameter cannot be null..
        /// </summary>
        public static string Argument_ParameterInfoNullModule
        {
            get { return Resource.Argument_ParameterInfoNullModule; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Parameter name: {0}.
        /// </summary>
        public static string Argument_ParamName_Name
        {
            get { return Resource.Argument_ParamName_Name; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Must specify one or more parameters..
        /// </summary>
        public static string Argument_ParmArraySize
        {
            get { return Resource.Argument_ParmArraySize; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Parameter count mismatch..
        /// </summary>
        public static string Argument_ParmCnt
        {
            get { return Resource.Argument_ParmCnt; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Second path fragment must not be a drive or UNC name..
        /// </summary>
        public static string Argument_Path2IsRooted
        {
            get { return Resource.Argument_Path2IsRooted; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Path cannot be the empty string or all whitespace..
        /// </summary>
        public static string Argument_PathEmpty
        {
            get { return Resource.Argument_PathEmpty; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The given path&apos;s format is not supported..
        /// </summary>
        public static string Argument_PathFormatNotSupported
        {
            get { return Resource.Argument_PathFormatNotSupported; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Paths that begin with \\\\?\\GlobalRoot are internal to the kernel and should not be opened by managed applications..
        /// </summary>
        public static string Argument_PathGlobalRoot
        {
            get { return Resource.Argument_PathGlobalRoot; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The path is not of a legal form..
        /// </summary>
        public static string Argument_PathIllegal
        {
            get { return Resource.Argument_PathIllegal; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The UNC path should be of the form \\\\server\\share..
        /// </summary>
        public static string Argument_PathIllegalUNC
        {
            get { return Resource.Argument_PathIllegalUNC; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Path must not be a drive..
        /// </summary>
        public static string Argument_PathIsVolume
        {
            get { return Resource.Argument_PathIsVolume; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Uri formats are not supported..
        /// </summary>
        public static string Argument_PathUriFormatNotSupported
        {
            get { return Resource.Argument_PathUriFormatNotSupported; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Operation is not supported on this platform..
        /// </summary>
        public static string Argument_PlatformNotSupported
        {
            get { return Resource.Argument_PlatformNotSupported; }
        }

        /// <summary>
        ///   Looks up a localized string similar to SecureString is only supported on Windows 2000 SP3 and higher platforms..
        /// </summary>
        public static string Argument_PlatformSecureString
        {
            get { return Resource.Argument_PlatformSecureString; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The requested policy file does not exist..
        /// </summary>
        public static string Argument_PolicyFileDoesNotExist
        {
            get { return Resource.Argument_PolicyFileDoesNotExist; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot widen from source type to target type either because the source type is a not a primitive type or the conversion cannot be accomplished..
        /// </summary>
        public static string Argument_PrimWiden
        {
            get { return Resource.Argument_PrimWiden; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Could not find the specified property..
        /// </summary>
        public static string Argument_PropNotFound
        {
            get { return Resource.Argument_PropNotFound; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot specify both Get and Set on a property..
        /// </summary>
        public static string Argument_PropSetGet
        {
            get { return Resource.Argument_PropSetGet; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot specify Set on a property and Invoke on a method..
        /// </summary>
        public static string Argument_PropSetInvoke
        {
            get { return Resource.Argument_PropSetInvoke; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attempted to operate on an array with the incorrect number of dimensions..
        /// </summary>
        public static string Argument_RankException
        {
            get { return Resource.Argument_RankException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Indices length does not match the array rank..
        /// </summary>
        public static string Argument_RankIndices
        {
            get { return Resource.Argument_RankIndices; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Only single dimensional arrays are supported for the requested action..
        /// </summary>
        public static string Argument_RankMultiDimNotSupported
        {
            get { return Resource.Argument_RankMultiDimNotSupported; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Number of lengths and lowerBounds must match..
        /// </summary>
        public static string Argument_RanksAndBounds
        {
            get { return Resource.Argument_RanksAndBounds; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Recursive fallback not allowed for character \\u{0:X4}..
        /// </summary>
        public static string Argument_RecursiveFallback
        {
            get { return Resource.Argument_RecursiveFallback; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Recursive fallback not allowed for bytes {0}..
        /// </summary>
        public static string Argument_RecursiveFallbackBytes
        {
            get { return Resource.Argument_RecursiveFallbackBytes; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Label multiply defined..
        /// </summary>
        public static string Argument_RedefinedLabel
        {
            get { return Resource.Argument_RedefinedLabel; }
        }

        /// <summary>
        ///   Looks up a localized string similar to It is illegal to reflect on the custom attributes of a Type loaded via ReflectionOnlyGetType (see Assembly.ReflectionOnly) -- use CustomAttributeData instead..
        /// </summary>
        public static string Argument_ReflectionOnlyCA
        {
            get { return Resource.Argument_ReflectionOnlyCA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to It is illegal to get or set the value on a field on a Type loaded via ReflectionOnlyGetType..
        /// </summary>
        public static string Argument_ReflectionOnlyField
        {
            get { return Resource.Argument_ReflectionOnlyField; }
        }

        /// <summary>
        ///   Looks up a localized string similar to It is illegal to invoke a method on a Type loaded via ReflectionOnlyGetType..
        /// </summary>
        public static string Argument_ReflectionOnlyInvoke
        {
            get { return Resource.Argument_ReflectionOnlyInvoke; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified RegistryValueKind is an invalid value..
        /// </summary>
        public static string Argument_RegBadKeyKind
        {
            get { return Resource.Argument_RegBadKeyKind; }
        }

        /// <summary>
        ///   Looks up a localized string similar to RegistryKey.GetValue does not allow a String that has a length greater than Int32.MaxValue..
        /// </summary>
        public static string Argument_RegGetOverflowBug
        {
            get { return Resource.Argument_RegGetOverflowBug; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Registry key name must start with a valid base key name..
        /// </summary>
        public static string Argument_RegInvalidKeyName
        {
            get { return Resource.Argument_RegInvalidKeyName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot delete a registry hive&apos;s subtree..
        /// </summary>
        public static string Argument_RegKeyDelHive
        {
            get { return Resource.Argument_RegKeyDelHive; }
        }

        /// <summary>
        ///   Looks up a localized string similar to No remote connection to &apos;{0}&apos; while trying to read the registry..
        /// </summary>
        public static string Argument_RegKeyNoRemoteConnect
        {
            get { return Resource.Argument_RegKeyNoRemoteConnect; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified registry key does not exist..
        /// </summary>
        public static string Argument_RegKeyNotFound
        {
            get { return Resource.Argument_RegKeyNotFound; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Registry HKEY was out of the legal range..
        /// </summary>
        public static string Argument_RegKeyOutOfRange
        {
            get { return Resource.Argument_RegKeyOutOfRange; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Registry key names should not be greater than 255 characters..
        /// </summary>
        public static string Argument_RegKeyStrLenBug
        {
            get { return Resource.Argument_RegKeyStrLenBug; }
        }

        /// <summary>
        ///   Looks up a localized string similar to RegistryKey.SetValue does not support arrays of type &apos;{0}&apos;. Only Byte[] and String[] are supported..
        /// </summary>
        public static string Argument_RegSetBadArrType
        {
            get { return Resource.Argument_RegSetBadArrType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The type of the value object did not match the specified RegistryValueKind or the object could not be properly converted..
        /// </summary>
        public static string Argument_RegSetMismatchedKind
        {
            get { return Resource.Argument_RegSetMismatchedKind; }
        }

        /// <summary>
        ///   Looks up a localized string similar to RegistryKey.SetValue does not allow a String[] that contains a null String reference..
        /// </summary>
        public static string Argument_RegSetStrArrNull
        {
            get { return Resource.Argument_RegSetStrArrNull; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot delete a subkey tree because the subkey does not exist..
        /// </summary>
        public static string Argument_RegSubKeyAbsent
        {
            get { return Resource.Argument_RegSubKeyAbsent; }
        }

        /// <summary>
        ///   Looks up a localized string similar to No value exists with that name..
        /// </summary>
        public static string Argument_RegSubKeyValueAbsent
        {
            get { return Resource.Argument_RegSubKeyValueAbsent; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Registry value names should not be greater than 16,383 characters..
        /// </summary>
        public static string Argument_RegValStrLenBug
        {
            get { return Resource.Argument_RegValStrLenBug; }
        }

        /// <summary>
        ///   Looks up a localized string similar to UrlMembershipCondition requires an absolute URL..
        /// </summary>
        public static string Argument_RelativeUrlMembershipCondition
        {
            get { return Resource.Argument_RelativeUrlMembershipCondition; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot remove the specified item because it was not found in the specified Collection..
        /// </summary>
        public static string Argument_RemoveArgNotFound
        {
            get { return Resource.Argument_RemoveArgNotFound; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot remove or modify reserved permissions set &apos;{0}&apos;..
        /// </summary>
        public static string Argument_ReservedNPMS
        {
            get { return Resource.Argument_ReservedNPMS; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type parameter must refer to a subclass of ResourceSet..
        /// </summary>
        public static string Argument_ResMgrNotResSet
        {
            get { return Resource.Argument_ResMgrNotResSet; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Token {0:x} is not a valid FieldInfo token in the scope of module {1}..
        /// </summary>
        public static string Argument_ResolveField
        {
            get { return Resource.Argument_ResolveField; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type handle &apos;{0}&apos; and field handle with declaring type &apos;{1}&apos; are incompatible. Get RuntimeFieldHandle and declaring RuntimeTypeHandle off the same FieldInfo..
        /// </summary>
        public static string Argument_ResolveFieldHandle
        {
            get { return Resource.Argument_ResolveFieldHandle; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Token {0:x} is not a valid MemberInfo token in the scope of module {1}..
        /// </summary>
        public static string Argument_ResolveMember
        {
            get { return Resource.Argument_ResolveMember; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Token {0:x} is not a valid MethodBase token in the scope of module {1}..
        /// </summary>
        public static string Argument_ResolveMethod
        {
            get { return Resource.Argument_ResolveMethod; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type handle &apos;{0}&apos; and method handle with declaring type &apos;{1}&apos; are incompatible. Get RuntimeMethodHandle and declaring RuntimeTypeHandle off the same MethodBase..
        /// </summary>
        public static string Argument_ResolveMethodHandle
        {
            get { return Resource.Argument_ResolveMethodHandle; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Token {0} resolves to the special module type representing this module..
        /// </summary>
        public static string Argument_ResolveModuleType
        {
            get { return Resource.Argument_ResolveModuleType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Token {0:x} is not a valid string token in the scope of module {1}..
        /// </summary>
        public static string Argument_ResolveString
        {
            get { return Resource.Argument_ResolveString; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Token {0:x} is not a valid Type token in the scope of module {1}..
        /// </summary>
        public static string Argument_ResolveType
        {
            get { return Resource.Argument_ResolveType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The ResourceReader class does not know how to read this version of .resources files. Expected version: {0}  This file: {1}.
        /// </summary>
        public static string Argument_ResourceFileUnsupportedVersion
        {
            get { return Resource.Argument_ResourceFileUnsupportedVersion; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified resource name &quot;{0}&quot; does not exist in the resource file..
        /// </summary>
        public static string Argument_ResourceNameNotExist
        {
            get { return Resource.Argument_ResourceNameNotExist; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Resource type in the ResourceScope enum is going from a more restrictive resource type to a more general one.  From: &quot;{0}&quot;  To: &quot;{1}&quot;.
        /// </summary>
        public static string Argument_ResourceScopeWrongDirection
        {
            get { return Resource.Argument_ResourceScopeWrongDirection; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The result is out of the supported range for this calendar. The result should be between {0} (Gregorian date) and {1} (Gregorian date), inclusive..
        /// </summary>
        public static string Argument_ResultCalendarRange
        {
            get { return Resource.Argument_ResultCalendarRange; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The date is out of the supported range for the Islamic calendar. The date should be greater than July 18th, 622 AD (Gregorian date)..
        /// </summary>
        public static string Argument_ResultIslamicCalendarRange
        {
            get { return Resource.Argument_ResultIslamicCalendarRange; }
        }

        /// <summary>
        ///   Looks up a localized string similar to ReaderWriterLock.RestoreLock was called without releasing all locks acquired since the call to ReleaseLock..
        /// </summary>
        public static string Argument_RWLockRestoreException
        {
            get { return Resource.Argument_RWLockRestoreException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Specified array was not of the expected rank..
        /// </summary>
        public static string Argument_SafeArrayRankMismatchException
        {
            get { return Resource.Argument_SafeArrayRankMismatchException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Specified array was not of the expected type..
        /// </summary>
        public static string Argument_SafeArrayTypeMismatchException
        {
            get { return Resource.Argument_SafeArrayTypeMismatchException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Security error..
        /// </summary>
        public static string Argument_SecurityException
        {
            get { return Resource.Argument_SecurityException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified seek offset &apos;{0}&apos; would result in a negative Stream position..
        /// </summary>
        public static string Argument_SeekOverflow
        {
            get { return Resource.Argument_SeekOverflow; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The initial count for the semaphore must be greater than or equal to zero and less than the maximum count..
        /// </summary>
        public static string Argument_SemaphoreInitialMaximum
        {
            get { return Resource.Argument_SemaphoreInitialMaximum; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Serialization error..
        /// </summary>
        public static string Argument_SerializationException
        {
            get { return Resource.Argument_SerializationException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Property set method not found..
        /// </summary>
        public static string Argument_SetMethNotFnd
        {
            get { return Resource.Argument_SetMethNotFnd; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Should not specify exception type for catch clause for filter block..
        /// </summary>
        public static string Argument_ShouldNotSpecifyExceptionType
        {
            get { return Resource.Argument_ShouldNotSpecifyExceptionType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Should only set visibility flags when creating EnumBuilder..
        /// </summary>
        public static string Argument_ShouldOnlySetVisibilityFlags
        {
            get { return Resource.Argument_ShouldOnlySetVisibilityFlags; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Completed signature cannot be modified..
        /// </summary>
        public static string Argument_SigIsFinalized
        {
            get { return Resource.Argument_SigIsFinalized; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Site name must be specified..
        /// </summary>
        public static string Argument_SiteCannotBeNull
        {
            get { return Resource.Argument_SiteCannotBeNull; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Operation caused a stack overflow..
        /// </summary>
        public static string Argument_StackOverflowException
        {
            get { return Resource.Argument_StackOverflowException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Stream was not readable..
        /// </summary>
        public static string Argument_StreamNotReadable
        {
            get { return Resource.Argument_StreamNotReadable; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Stream was not writable..
        /// </summary>
        public static string Argument_StreamNotWritable
        {
            get { return Resource.Argument_StreamNotWritable; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The first char in the string is the null character..
        /// </summary>
        public static string Argument_StringFirstCharIsZero
        {
            get { return Resource.Argument_StringFirstCharIsZero; }
        }

        /// <summary>
        ///   Looks up a localized string similar to String cannot be of zero length..
        /// </summary>
        public static string Argument_StringZeroLength
        {
            get { return Resource.Argument_StringZeroLength; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to obtain public key for StrongNameKeyPair..
        /// </summary>
        public static string Argument_StrongNameGetPublicKey
        {
            get { return Resource.Argument_StrongNameGetPublicKey; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The structure must not be a value class..
        /// </summary>
        public static string Argument_StructMustNotBeValueClass
        {
            get { return Resource.Argument_StructMustNotBeValueClass; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unicode surrogate characters must be written out as pairs together in the same call, not individually. Consider passing in a character array instead..
        /// </summary>
        public static string Argument_SurrogatesNotAllowedAsSingleChar
        {
            get { return Resource.Argument_SurrogatesNotAllowedAsSingleChar; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object synchronization method was called from an unsynchronized block of code..
        /// </summary>
        public static string Argument_SynchronizationLockException
        {
            get { return Resource.Argument_SynchronizationLockException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to System error..
        /// </summary>
        public static string Argument_SystemException
        {
            get { return Resource.Argument_SystemException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Exception has been thrown by the target of an invocation..
        /// </summary>
        public static string Argument_TargetInvocationException
        {
            get { return Resource.Argument_TargetInvocationException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Number of parameters specified does not match the expected number..
        /// </summary>
        public static string Argument_TargetParameterCountException
        {
            get { return Resource.Argument_TargetParameterCountException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Thread unsuccessfully to start..
        /// </summary>
        public static string Argument_ThreadStartException
        {
            get { return Resource.Argument_ThreadStartException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Thread was in an invalid state for the operation being executed..
        /// </summary>
        public static string Argument_ThreadStateException
        {
            get { return Resource.Argument_ThreadStateException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The operation has timed out..
        /// </summary>
        public static string Argument_TimeoutException
        {
            get { return Resource.Argument_TimeoutException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The TimeSpan parameter cannot be specified more precisely than whole minutes..
        /// </summary>
        public static string Argument_TimeSpanHasSeconds
        {
            get { return Resource.Argument_TimeSpanHasSeconds; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The tzfile does not begin with the magic characters &apos;TZif&apos;.  Please verify that the file is not corrupt..
        /// </summary>
        public static string Argument_TimeZoneInfoBadTZif
        {
            get { return Resource.Argument_TimeZoneInfoBadTZif; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The TZif data structure is corrupt..
        /// </summary>
        public static string Argument_TimeZoneInfoInvalidTZif
        {
            get { return Resource.Argument_TimeZoneInfoInvalidTZif; }
        }

        /// <summary>
        ///   Looks up a localized string similar to fromInclusive must be less than or equal to toExclusive..
        /// </summary>
        public static string Argument_ToExclusiveLessThanFromExclusive
        {
            get { return Resource.Argument_ToExclusiveLessThanFromExclusive; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Token cannot be zero..
        /// </summary>
        public static string Argument_TokenZero
        {
            get { return Resource.Argument_TokenZero; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Exception blocks may have at most one finally clause..
        /// </summary>
        public static string Argument_TooManyFinallyClause
        {
            get { return Resource.Argument_TooManyFinallyClause; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The DaylightTransitionStart property must not equal the DaylightTransitionEnd property..
        /// </summary>
        public static string Argument_TransitionTimesAreIdentical
        {
            get { return Resource.Argument_TransitionTimesAreIdentical; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attempt to access the type unsuccessfully..
        /// </summary>
        public static string Argument_TypeAccessException
        {
            get { return Resource.Argument_TypeAccessException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type does not contain the given method..
        /// </summary>
        public static string Argument_TypeDoesNotContainMethod
        {
            get { return Resource.Argument_TypeDoesNotContainMethod; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The TypedReference must be initialized..
        /// </summary>
        public static string Argument_TypedReference_Null
        {
            get { return Resource.Argument_TypedReference_Null; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Field in TypedReferences cannot be static or init only..
        /// </summary>
        public static string Argument_TypedReferenceInvalidField
        {
            get { return Resource.Argument_TypedReferenceInvalidField; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The type must not be a Windows Runtime type..
        /// </summary>
        public static string Argument_TypeIsWinRTType
        {
            get { return Resource.Argument_TypeIsWinRTType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Failure has occurred while loading a type..
        /// </summary>
        public static string Argument_TypeLoadException
        {
            get { return Resource.Argument_TypeLoadException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to A null or zero length string does not represent a valid Type..
        /// </summary>
        public static string Argument_TypeLoadNullStr
        {
            get { return Resource.Argument_TypeLoadNullStr; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The type must be creatable from COM..
        /// </summary>
        public static string Argument_TypeMustBeComCreatable
        {
            get { return Resource.Argument_TypeMustBeComCreatable; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified type must be visible from COM..
        /// </summary>
        public static string Argument_TypeMustBeVisibleFromCom
        {
            get { return Resource.Argument_TypeMustBeVisibleFromCom; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The type must not be imported from COM..
        /// </summary>
        public static string Argument_TypeMustNotBeComImport
        {
            get { return Resource.Argument_TypeMustNotBeComImport; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type name was too long. The fully qualified type name must be less than 1,024 characters..
        /// </summary>
        public static string Argument_TypeNameTooLong
        {
            get { return Resource.Argument_TypeNameTooLong; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type &apos;{0}&apos; does not have an activation factory because it is not activatable by Windows Runtime..
        /// </summary>
        public static string Argument_TypeNotActivatableViaWindowsRuntime
        {
            get { return Resource.Argument_TypeNotActivatableViaWindowsRuntime; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The type must be __ComObject or be derived from __ComObject..
        /// </summary>
        public static string Argument_TypeNotComObject
        {
            get { return Resource.Argument_TypeNotComObject; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The Type object is not valid..
        /// </summary>
        public static string Argument_TypeNotValid
        {
            get { return Resource.Argument_TypeNotValid; }
        }

        /// <summary>
        ///   Looks up a localized string similar to TypedReferences cannot be redefined as primitives..
        /// </summary>
        public static string Argument_TypeRefPrimitve
        {
            get { return Resource.Argument_TypeRefPrimitve; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type had been unloaded..
        /// </summary>
        public static string Argument_TypeUnloadedException
        {
            get { return Resource.Argument_TypeUnloadedException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to generate permission set; input XML may be malformed..
        /// </summary>
        public static string Argument_UnableToGeneratePermissionSet
        {
            get { return Resource.Argument_UnableToGeneratePermissionSet; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unexpected error while parsing the specified manifest..
        /// </summary>
        public static string Argument_UnableToParseManifest
        {
            get { return Resource.Argument_UnableToParseManifest; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attempted to perform an unauthorized operation..
        /// </summary>
        public static string Argument_UnauthorizedAccessException
        {
            get { return Resource.Argument_UnauthorizedAccessException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Late bound operations cannot be performed on fields with types for which Type.ContainsGenericParameters is true..
        /// </summary>
        public static string Argument_UnboundGenField
        {
            get { return Resource.Argument_UnboundGenField; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Late bound operations cannot be performed on types or methods for which ContainsGenericParameters is true..
        /// </summary>
        public static string Argument_UnboundGenParam
        {
            get { return Resource.Argument_UnboundGenParam; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The IL Generator cannot be used while there are unclosed exceptions..
        /// </summary>
        public static string Argument_UnclosedExceptionBlock
        {
            get { return Resource.Argument_UnclosedExceptionBlock; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Supplied MemberInfo does not match the expected type..
        /// </summary>
        public static string Argument_UnequalMembers
        {
            get { return Resource.Argument_UnequalMembers; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unexpected TypeKind when marshaling Windows.Foundation.TypeName. .
        /// </summary>
        public static string Argument_Unexpected_TypeSource
        {
            get { return Resource.Argument_Unexpected_TypeSource; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Uninitialized certificate object..
        /// </summary>
        public static string Argument_UninitializedCertificate
        {
            get { return Resource.Argument_UninitializedCertificate; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unknown TypeCode value..
        /// </summary>
        public static string Argument_UnknownTypeCode
        {
            get { return Resource.Argument_UnknownTypeCode; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unknown unmanaged calling convention for function signature..
        /// </summary>
        public static string Argument_UnknownUnmanagedCallConv
        {
            get { return Resource.Argument_UnknownUnmanagedCallConv; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The UnmanagedMemoryAccessor capacity and offset would wrap around the high end of the address space..
        /// </summary>
        public static string Argument_UnmanagedMemAccessorWrapAround
        {
            get { return Resource.Argument_UnmanagedMemAccessorWrapAround; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Local passed in does not belong to this ILGenerator..
        /// </summary>
        public static string Argument_UnmatchedMethodForLocal
        {
            get { return Resource.Argument_UnmatchedMethodForLocal; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Non-matching symbol scope..
        /// </summary>
        public static string Argument_UnmatchingSymScope
        {
            get { return Resource.Argument_UnmatchingSymScope; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unrecognized LOADER_OPTIMIZATION property value.  Supported values may include &quot;SingleDomain&quot;, &quot;MultiDomain&quot;, &quot;MultiDomainHost&quot;, and &quot;NotSpecified&quot;..
        /// </summary>
        public static string Argument_UnrecognizedLoaderOptimization
        {
            get { return Resource.Argument_UnrecognizedLoaderOptimization; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Identity permissions cannot be unrestricted..
        /// </summary>
        public static string Argument_UnrestrictedIdentityPermission
        {
            get { return Resource.Argument_UnrestrictedIdentityPermission; }
        }

        /// <summary>
        ///   Looks up a localized string similar to URL must be specified..
        /// </summary>
        public static string Argument_UrlCannotBeNull
        {
            get { return Resource.Argument_UrlCannotBeNull; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The UTC time represented when the offset is applied must be between year 0 and 10,000..
        /// </summary>
        public static string Argument_UTCOutOfRange
        {
            get { return Resource.Argument_UTCOutOfRange; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Missing parameter does not have a default value..
        /// </summary>
        public static string Argument_VarMissNull
        {
            get { return Resource.Argument_VarMissNull; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Version string portion was too short or too long..
        /// </summary>
        public static string Argument_VersionString
        {
            get { return Resource.Argument_VersionString; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The unmanaged Version information is too large to persist..
        /// </summary>
        public static string Argument_VerStringTooLong
        {
            get { return Resource.Argument_VerStringTooLong; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attempted to make an early bound call on a COM dispatch-only interface..
        /// </summary>
        public static string Argument_VTableCallsNotSupportedException
        {
            get { return Resource.Argument_VTableCallsNotSupportedException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The name can be no more than {0} characters in length..
        /// </summary>
        public static string Argument_WaitHandleNameTooLong
        {
            get { return Resource.Argument_WaitHandleNameTooLong; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot marshal type &apos;{0}&apos; to Windows Runtime. Only &apos;System.RuntimeType&apos; is supported..
        /// </summary>
        public static string Argument_WinRTSystemRuntimeType
        {
            get { return Resource.Argument_WinRTSystemRuntimeType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IAsyncResult object did not come from the corresponding async method on this type..
        /// </summary>
        public static string Argument_WrongAsyncResult
        {
            get { return Resource.Argument_WrongAsyncResult; }
        }

        /// <summary>
        ///   Looks up a localized string similar to &apos;{0}&apos; element required..
        /// </summary>
        public static string Argument_WrongElementType
        {
            get { return Resource.Argument_WrongElementType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Operation on type &apos;{0}&apos; attempted with target of incorrect type..
        /// </summary>
        public static string Argument_WrongType
        {
            get { return Resource.Argument_WrongType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Zone must be specified..
        /// </summary>
        public static string Argument_ZoneCannotBeNull
        {
            get { return Resource.Argument_ZoneCannotBeNull; }
        }

        /// <summary>
        ///   Looks up a localized string similar to MethodOverride&apos;s body must be from this type..
        /// </summary>
        public static string ArgumentException_BadMethodImplBody
        {
            get { return Resource.ArgumentException_BadMethodImplBody; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The binary form of an ACE object is invalid..
        /// </summary>
        public static string ArgumentException_InvalidAceBinaryForm
        {
            get { return Resource.ArgumentException_InvalidAceBinaryForm; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The binary form of an ACL object is invalid..
        /// </summary>
        public static string ArgumentException_InvalidAclBinaryForm
        {
            get { return Resource.ArgumentException_InvalidAclBinaryForm; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The SDDL form of a security descriptor object is invalid..
        /// </summary>
        public static string ArgumentException_InvalidSDSddlForm
        {
            get { return Resource.ArgumentException_InvalidSDSddlForm; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The runtime does not support a version of &quot;{0}&quot; less than {1}..
        /// </summary>
        public static string ArgumentException_MinSortingVersion
        {
            get { return Resource.ArgumentException_MinSortingVersion; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Implementations of all the NLS functions must be provided..
        /// </summary>
        public static string ArgumentException_NotAllCustomSortingFuncsDefined
        {
            get { return Resource.ArgumentException_NotAllCustomSortingFuncsDefined; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object is not a array with the same number of elements as the array to compare it to..
        /// </summary>
        public static string ArgumentException_OtherNotArrayOfCorrectLength
        {
            get { return Resource.ArgumentException_OtherNotArrayOfCorrectLength; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Argument must be of type {0}..
        /// </summary>
        public static string ArgumentException_TupleIncorrectType
        {
            get { return Resource.ArgumentException_TupleIncorrectType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The last element of an eight element tuple must be a Tuple..
        /// </summary>
        public static string ArgumentException_TupleLastArgumentNotATuple
        {
            get { return Resource.ArgumentException_TupleLastArgumentNotATuple; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The tuple contains an element of type {0} which does not implement the IComparable interface..
        /// </summary>
        public static string ArgumentException_TupleNonIComparableElement
        {
            get { return Resource.ArgumentException_TupleNonIComparableElement; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The application trust cannot be null..
        /// </summary>
        public static string ArgumentNull_ApplicationTrust
        {
            get { return Resource.ArgumentNull_ApplicationTrust; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Array cannot be null..
        /// </summary>
        public static string ArgumentNull_Array
        {
            get { return Resource.ArgumentNull_Array; }
        }

        /// <summary>
        ///   Looks up a localized string similar to At least one element in the specified array was null..
        /// </summary>
        public static string ArgumentNull_ArrayElement
        {
            get { return Resource.ArgumentNull_ArrayElement; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Found a null value within an array..
        /// </summary>
        public static string ArgumentNull_ArrayValue
        {
            get { return Resource.ArgumentNull_ArrayValue; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Assembly cannot be null..
        /// </summary>
        public static string ArgumentNull_Assembly
        {
            get { return Resource.ArgumentNull_Assembly; }
        }

        /// <summary>
        ///   Looks up a localized string similar to AssemblyName cannot be null..
        /// </summary>
        public static string ArgumentNull_AssemblyName
        {
            get { return Resource.ArgumentNull_AssemblyName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to AssemblyName.Name cannot be null or an empty string..
        /// </summary>
        public static string ArgumentNull_AssemblyNameName
        {
            get { return Resource.ArgumentNull_AssemblyNameName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Buffer cannot be null..
        /// </summary>
        public static string ArgumentNull_Buffer
        {
            get { return Resource.ArgumentNull_Buffer; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot have a null child..
        /// </summary>
        public static string ArgumentNull_Child
        {
            get { return Resource.ArgumentNull_Child; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Collection cannot be null..
        /// </summary>
        public static string ArgumentNull_Collection
        {
            get { return Resource.ArgumentNull_Collection; }
        }

        /// <summary>
        ///   Looks up a localized string similar to CriticalHandle cannot be null..
        /// </summary>
        public static string ArgumentNull_CriticalHandle
        {
            get { return Resource.ArgumentNull_CriticalHandle; }
        }

        /// <summary>
        ///   Looks up a localized string similar to CultureInfo cannot be null..
        /// </summary>
        public static string ArgumentNull_CultureInfo
        {
            get { return Resource.ArgumentNull_CultureInfo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Dictionary cannot be null..
        /// </summary>
        public static string ArgumentNull_Dictionary
        {
            get { return Resource.ArgumentNull_Dictionary; }
        }

        /// <summary>
        ///   Looks up a localized string similar to File name cannot be null..
        /// </summary>
        public static string ArgumentNull_FileName
        {
            get { return Resource.ArgumentNull_FileName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Value cannot be null..
        /// </summary>
        public static string ArgumentNull_Generic
        {
            get { return Resource.ArgumentNull_Generic; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object Graph cannot be null..
        /// </summary>
        public static string ArgumentNull_Graph
        {
            get { return Resource.ArgumentNull_Graph; }
        }

        /// <summary>
        ///   Looks up a localized string similar to GUID cannot be null..
        /// </summary>
        public static string ArgumentNull_GUID
        {
            get { return Resource.ArgumentNull_GUID; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Key cannot be null..
        /// </summary>
        public static string ArgumentNull_Key
        {
            get { return Resource.ArgumentNull_Key; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Member at position {0} was null..
        /// </summary>
        public static string ArgumentNull_NullMember
        {
            get { return Resource.ArgumentNull_NullMember; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object cannot be null..
        /// </summary>
        public static string ArgumentNull_Obj
        {
            get { return Resource.ArgumentNull_Obj; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Path cannot be null..
        /// </summary>
        public static string ArgumentNull_Path
        {
            get { return Resource.ArgumentNull_Path; }
        }

        /// <summary>
        ///   Looks up a localized string similar to SafeHandle cannot be null..
        /// </summary>
        public static string ArgumentNull_SafeHandle
        {
            get { return Resource.ArgumentNull_SafeHandle; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Stream cannot be null..
        /// </summary>
        public static string ArgumentNull_Stream
        {
            get { return Resource.ArgumentNull_Stream; }
        }

        /// <summary>
        ///   Looks up a localized string similar to String reference not set to an instance of a String..
        /// </summary>
        public static string ArgumentNull_String
        {
            get { return Resource.ArgumentNull_String; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type cannot be null..
        /// </summary>
        public static string ArgumentNull_Type
        {
            get { return Resource.ArgumentNull_Type; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type in TypedReference cannot be null..
        /// </summary>
        public static string ArgumentNull_TypedRefType
        {
            get { return Resource.ArgumentNull_TypedRefType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The type parameter cannot be null when scoping the resource&apos;s visibility to Private or Assembly..
        /// </summary>
        public static string ArgumentNull_TypeRequiredByResourceScope
        {
            get { return Resource.ArgumentNull_TypeRequiredByResourceScope; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The waitHandles parameter cannot be null..
        /// </summary>
        public static string ArgumentNull_Waithandles
        {
            get { return Resource.ArgumentNull_Waithandles; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Parameter &apos;{0}&apos; cannot be null..
        /// </summary>
        public static string ArgumentNull_WithParamName
        {
            get { return Resource.ArgumentNull_WithParamName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Actual value was {0}..
        /// </summary>
        public static string ArgumentOutOfRange_ActualValue
        {
            get { return Resource.ArgumentOutOfRange_ActualValue; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The number of bytes cannot exceed the virtual address space on a 32 bit machine..
        /// </summary>
        public static string ArgumentOutOfRange_AddressSpace
        {
            get { return Resource.ArgumentOutOfRange_AddressSpace; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Value to add was out of range..
        /// </summary>
        public static string ArgumentOutOfRange_AddValue
        {
            get { return Resource.ArgumentOutOfRange_AddValue; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Number was less than the array&apos;s lower bound in the first dimension..
        /// </summary>
        public static string ArgumentOutOfRange_ArrayLB
        {
            get { return Resource.ArgumentOutOfRange_ArrayLB; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Higher indices will exceed Int32.MaxValue because of large lower bound and/or length..
        /// </summary>
        public static string ArgumentOutOfRange_ArrayLBAndLength
        {
            get { return Resource.ArgumentOutOfRange_ArrayLBAndLength; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The length of the array must be between {0} and {1}, inclusive..
        /// </summary>
        public static string ArgumentOutOfRange_ArrayLength
        {
            get { return Resource.ArgumentOutOfRange_ArrayLength; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The length of the array must be a multiple of {0}..
        /// </summary>
        public static string ArgumentOutOfRange_ArrayLengthMultiple
        {
            get { return Resource.ArgumentOutOfRange_ArrayLengthMultiple; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Insertion index was out of range. Must be non-negative and less than or equal to size..
        /// </summary>
        public static string ArgumentOutOfRange_ArrayListInsert
        {
            get { return Resource.ArgumentOutOfRange_ArrayListInsert; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Destination array is not long enough to copy all the required data. Check array length and offset..
        /// </summary>
        public static string ArgumentOutOfRange_ArrayTooSmall
        {
            get { return Resource.ArgumentOutOfRange_ArrayTooSmall; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Hour, Minute, and Second parameters describe an un-representable DateTime..
        /// </summary>
        public static string ArgumentOutOfRange_BadHourMinuteSecond
        {
            get { return Resource.ArgumentOutOfRange_BadHourMinuteSecond; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Year, Month, and Day parameters describe an un-representable DateTime..
        /// </summary>
        public static string ArgumentOutOfRange_BadYearMonthDay
        {
            get { return Resource.ArgumentOutOfRange_BadYearMonthDay; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Console.Beep&apos;s frequency must be between {0} and {1}..
        /// </summary>
        public static string ArgumentOutOfRange_BeepFrequency
        {
            get { return Resource.ArgumentOutOfRange_BeepFrequency; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Larger than collection size..
        /// </summary>
        public static string ArgumentOutOfRange_BiggerThanCollection
        {
            get { return Resource.ArgumentOutOfRange_BiggerThanCollection; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The number of bytes requested does not fit into BinaryReader&apos;s internal buffer..
        /// </summary>
        public static string ArgumentOutOfRange_BinaryReaderFillBuffer
        {
            get { return Resource.ArgumentOutOfRange_BinaryReaderFillBuffer; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Argument must be between {0} and {1}..
        /// </summary>
        public static string ArgumentOutOfRange_Bounds_Lower_Upper
        {
            get { return Resource.ArgumentOutOfRange_Bounds_Lower_Upper; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Specified time is not supported in this calendar. It should be between {0} (Gregorian date) and {1} (Gregorian date), inclusive..
        /// </summary>
        public static string ArgumentOutOfRange_CalendarRange
        {
            get { return Resource.ArgumentOutOfRange_CalendarRange; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Capacity exceeds maximum capacity..
        /// </summary>
        public static string ArgumentOutOfRange_Capacity
        {
            get { return Resource.ArgumentOutOfRange_Capacity; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The value must be greater than or equal to zero and less than the console&apos;s buffer size in that dimension..
        /// </summary>
        public static string ArgumentOutOfRange_ConsoleBufferBoundaries
        {
            get { return Resource.ArgumentOutOfRange_ConsoleBufferBoundaries; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The console buffer size must not be less than the current size and position of the console window, nor greater than or equal to Int16.MaxValue..
        /// </summary>
        public static string ArgumentOutOfRange_ConsoleBufferLessThanWindowSize
        {
            get { return Resource.ArgumentOutOfRange_ConsoleBufferLessThanWindowSize; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Console key values must be between 0 and 255..
        /// </summary>
        public static string ArgumentOutOfRange_ConsoleKey
        {
            get { return Resource.ArgumentOutOfRange_ConsoleKey; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The console title is too long..
        /// </summary>
        public static string ArgumentOutOfRange_ConsoleTitleTooLong
        {
            get { return Resource.ArgumentOutOfRange_ConsoleTitleTooLong; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The new console window size would force the console buffer size to be too large..
        /// </summary>
        public static string ArgumentOutOfRange_ConsoleWindowBufferSize
        {
            get { return Resource.ArgumentOutOfRange_ConsoleWindowBufferSize; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The window position must be set such that the current window size fits within the console&apos;s buffer, and the numbers must not be negative..
        /// </summary>
        public static string ArgumentOutOfRange_ConsoleWindowPos
        {
            get { return Resource.ArgumentOutOfRange_ConsoleWindowPos; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The value must be less than the console&apos;s current maximum window size of {0} in that dimension. Note that this value depends on screen resolution and the console font..
        /// </summary>
        public static string ArgumentOutOfRange_ConsoleWindowSize_Size
        {
            get { return Resource.ArgumentOutOfRange_ConsoleWindowSize_Size; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Count must be positive and count must refer to a location within the string/array/collection..
        /// </summary>
        public static string ArgumentOutOfRange_Count
        {
            get { return Resource.ArgumentOutOfRange_Count; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The cursor size is invalid. It must be a percentage between 1 and 100..
        /// </summary>
        public static string ArgumentOutOfRange_CursorSize
        {
            get { return Resource.ArgumentOutOfRange_CursorSize; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The added or subtracted value results in an un-representable DateTime..
        /// </summary>
        public static string ArgumentOutOfRange_DateArithmetic
        {
            get { return Resource.ArgumentOutOfRange_DateArithmetic; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Months value must be between +/-120000..
        /// </summary>
        public static string ArgumentOutOfRange_DateTimeBadMonths
        {
            get { return Resource.ArgumentOutOfRange_DateTimeBadMonths; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Ticks must be between DateTime.MinValue.Ticks and DateTime.MaxValue.Ticks..
        /// </summary>
        public static string ArgumentOutOfRange_DateTimeBadTicks
        {
            get { return Resource.ArgumentOutOfRange_DateTimeBadTicks; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Years value must be between +/-10000..
        /// </summary>
        public static string ArgumentOutOfRange_DateTimeBadYears
        {
            get { return Resource.ArgumentOutOfRange_DateTimeBadYears; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Day must be between 1 and {0} for month {1}..
        /// </summary>
        public static string ArgumentOutOfRange_Day
        {
            get { return Resource.ArgumentOutOfRange_Day; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The DayOfWeek enumeration must be in the range 0 through 6..
        /// </summary>
        public static string ArgumentOutOfRange_DayOfWeek
        {
            get { return Resource.ArgumentOutOfRange_DayOfWeek; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The Day parameter must be in the range 1 through 31..
        /// </summary>
        public static string ArgumentOutOfRange_DayParam
        {
            get { return Resource.ArgumentOutOfRange_DayParam; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Decimal can only round to between 0 and 28 digits of precision..
        /// </summary>
        public static string ArgumentOutOfRange_DecimalRound
        {
            get { return Resource.ArgumentOutOfRange_DecimalRound; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Decimal&apos;s scale value must be between 0 and 28, inclusive..
        /// </summary>
        public static string ArgumentOutOfRange_DecimalScale
        {
            get { return Resource.ArgumentOutOfRange_DecimalScale; }
        }

        /// <summary>
        ///   Looks up a localized string similar to endIndex cannot be greater than startIndex..
        /// </summary>
        public static string ArgumentOutOfRange_EndIndexStartIndex
        {
            get { return Resource.ArgumentOutOfRange_EndIndexStartIndex; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Enum value was out of legal range..
        /// </summary>
        public static string ArgumentOutOfRange_Enum
        {
            get { return Resource.ArgumentOutOfRange_Enum; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Time value was out of era range..
        /// </summary>
        public static string ArgumentOutOfRange_Era
        {
            get { return Resource.ArgumentOutOfRange_Era; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Specified file length was too large for the file system..
        /// </summary>
        public static string ArgumentOutOfRange_FileLengthTooBig
        {
            get { return Resource.ArgumentOutOfRange_FileLengthTooBig; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Not a valid Win32 FileTime..
        /// </summary>
        public static string ArgumentOutOfRange_FileTimeInvalid
        {
            get { return Resource.ArgumentOutOfRange_FileTimeInvalid; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Value must be positive..
        /// </summary>
        public static string ArgumentOutOfRange_GenericPositive
        {
            get { return Resource.ArgumentOutOfRange_GenericPositive; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Too many characters. The resulting number of bytes is larger than what can be returned as an int..
        /// </summary>
        public static string ArgumentOutOfRange_GetByteCountOverflow
        {
            get { return Resource.ArgumentOutOfRange_GetByteCountOverflow; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Too many bytes. The resulting number of chars is larger than what can be returned as an int..
        /// </summary>
        public static string ArgumentOutOfRange_GetCharCountOverflow
        {
            get { return Resource.ArgumentOutOfRange_GetCharCountOverflow; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Load factor needs to be between 0.1 and 1.0..
        /// </summary>
        public static string ArgumentOutOfRange_HashtableLoadFactor
        {
            get { return Resource.ArgumentOutOfRange_HashtableLoadFactor; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arrays larger than 2GB are not supported..
        /// </summary>
        public static string ArgumentOutOfRange_HugeArrayNotSupported
        {
            get { return Resource.ArgumentOutOfRange_HugeArrayNotSupported; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Index was out of range. Must be non-negative and less than the size of the collection..
        /// </summary>
        public static string ArgumentOutOfRange_Index
        {
            get { return Resource.ArgumentOutOfRange_Index; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Index and count must refer to a location within the string..
        /// </summary>
        public static string ArgumentOutOfRange_IndexCount
        {
            get { return Resource.ArgumentOutOfRange_IndexCount; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Index and count must refer to a location within the buffer..
        /// </summary>
        public static string ArgumentOutOfRange_IndexCountBuffer
        {
            get { return Resource.ArgumentOutOfRange_IndexCountBuffer; }
        }

        /// <summary>
        ///   Looks up a localized string similar to This collection cannot work with indices larger than Int32.MaxValue - 1 (0x7FFFFFFF - 1)..
        /// </summary>
        public static string ArgumentOutOfRange_IndexLargerThanMaxValue
        {
            get { return Resource.ArgumentOutOfRange_IndexLargerThanMaxValue; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Index and length must refer to a location within the string..
        /// </summary>
        public static string ArgumentOutOfRange_IndexLength
        {
            get { return Resource.ArgumentOutOfRange_IndexLength; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified index is outside the current index range of this collection..
        /// </summary>
        public static string ArgumentOutOfRange_IndexOutOfRange
        {
            get { return Resource.ArgumentOutOfRange_IndexOutOfRange; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Index was out of range. Must be non-negative and less than the length of the string..
        /// </summary>
        public static string ArgumentOutOfRange_IndexString
        {
            get { return Resource.ArgumentOutOfRange_IndexString; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Era value was not valid..
        /// </summary>
        public static string ArgumentOutOfRange_InvalidEraValue
        {
            get { return Resource.ArgumentOutOfRange_InvalidEraValue; }
        }

        /// <summary>
        ///   Looks up a localized string similar to A valid high surrogate character is between 0xd800 and 0xdbff, inclusive..
        /// </summary>
        public static string ArgumentOutOfRange_InvalidHighSurrogate
        {
            get { return Resource.ArgumentOutOfRange_InvalidHighSurrogate; }
        }

        /// <summary>
        ///   Looks up a localized string similar to A valid low surrogate character is between 0xdc00 and 0xdfff, inclusive..
        /// </summary>
        public static string ArgumentOutOfRange_InvalidLowSurrogate
        {
            get { return Resource.ArgumentOutOfRange_InvalidLowSurrogate; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified threshold for creating dictionary is out of range..
        /// </summary>
        public static string ArgumentOutOfRange_InvalidThreshold
        {
            get { return Resource.ArgumentOutOfRange_InvalidThreshold; }
        }

        /// <summary>
        ///   Looks up a localized string similar to User-defined ACEs must not have a well-known ACE type..
        /// </summary>
        public static string ArgumentOutOfRange_InvalidUserDefinedAceType
        {
            get { return Resource.ArgumentOutOfRange_InvalidUserDefinedAceType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to A valid UTF32 value is between 0x000000 and 0x10ffff, inclusive, and should not include surrogate codepoint values (0x00d800 ~ 0x00dfff)..
        /// </summary>
        public static string ArgumentOutOfRange_InvalidUTF32
        {
            get { return Resource.ArgumentOutOfRange_InvalidUTF32; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified length exceeds maximum capacity of SecureString..
        /// </summary>
        public static string ArgumentOutOfRange_Length
        {
            get { return Resource.ArgumentOutOfRange_Length; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The length cannot be greater than the capacity..
        /// </summary>
        public static string ArgumentOutOfRange_LengthGreaterThanCapacity
        {
            get { return Resource.ArgumentOutOfRange_LengthGreaterThanCapacity; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified length exceeds the maximum value of {0}..
        /// </summary>
        public static string ArgumentOutOfRange_LengthTooLarge
        {
            get { return Resource.ArgumentOutOfRange_LengthTooLarge; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Argument must be less than or equal to 2^31 - 1 milliseconds..
        /// </summary>
        public static string ArgumentOutOfRange_LessEqualToIntegerMaxVal
        {
            get { return Resource.ArgumentOutOfRange_LessEqualToIntegerMaxVal; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Index must be within the bounds of the List..
        /// </summary>
        public static string ArgumentOutOfRange_ListInsert
        {
            get { return Resource.ArgumentOutOfRange_ListInsert; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The total number of parameters must not exceed {0}..
        /// </summary>
        public static string ArgumentOutOfRange_MaxArgExceeded
        {
            get { return Resource.ArgumentOutOfRange_MaxArgExceeded; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The number of String parameters must not exceed {0}..
        /// </summary>
        public static string ArgumentOutOfRange_MaxStringsExceeded
        {
            get { return Resource.ArgumentOutOfRange_MaxStringsExceeded; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Month must be between one and twelve..
        /// </summary>
        public static string ArgumentOutOfRange_Month
        {
            get { return Resource.ArgumentOutOfRange_Month; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The Month parameter must be in the range 1 through 12..
        /// </summary>
        public static string ArgumentOutOfRange_MonthParam
        {
            get { return Resource.ArgumentOutOfRange_MonthParam; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Value must be non-negative and less than or equal to Int32.MaxValue..
        /// </summary>
        public static string ArgumentOutOfRange_MustBeNonNegInt32
        {
            get { return Resource.ArgumentOutOfRange_MustBeNonNegInt32; }
        }

        /// <summary>
        ///   Looks up a localized string similar to &apos;{0}&apos; must be non-negative..
        /// </summary>
        public static string ArgumentOutOfRange_MustBeNonNegNum
        {
            get { return Resource.ArgumentOutOfRange_MustBeNonNegNum; }
        }

        /// <summary>
        ///   Looks up a localized string similar to &apos;{0}&apos; must be greater than zero..
        /// </summary>
        public static string ArgumentOutOfRange_MustBePositive
        {
            get { return Resource.ArgumentOutOfRange_MustBePositive; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Non-negative number required..
        /// </summary>
        public static string ArgumentOutOfRange_NeedNonNegNum
        {
            get { return Resource.ArgumentOutOfRange_NeedNonNegNum; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Number must be either non-negative and less than or equal to Int32.MaxValue or -1..
        /// </summary>
        public static string ArgumentOutOfRange_NeedNonNegOrNegative1
        {
            get { return Resource.ArgumentOutOfRange_NeedNonNegOrNegative1; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Positive number required..
        /// </summary>
        public static string ArgumentOutOfRange_NeedPosNum
        {
            get { return Resource.ArgumentOutOfRange_NeedPosNum; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The ID parameter must be in the range {0} through {1}..
        /// </summary>
        public static string ArgumentOutOfRange_NeedValidId
        {
            get { return Resource.ArgumentOutOfRange_NeedValidId; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Capacity must be positive..
        /// </summary>
        public static string ArgumentOutOfRange_NegativeCapacity
        {
            get { return Resource.ArgumentOutOfRange_NegativeCapacity; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Count cannot be less than zero..
        /// </summary>
        public static string ArgumentOutOfRange_NegativeCount
        {
            get { return Resource.ArgumentOutOfRange_NegativeCount; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Length cannot be less than zero..
        /// </summary>
        public static string ArgumentOutOfRange_NegativeLength
        {
            get { return Resource.ArgumentOutOfRange_NegativeLength; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Length must be non-negative..
        /// </summary>
        public static string ArgumentOutOfRange_NegFileSize
        {
            get { return Resource.ArgumentOutOfRange_NegFileSize; }
        }

        /// <summary>
        ///   Looks up a localized string similar to objectID cannot be less than or equal to zero..
        /// </summary>
        public static string ArgumentOutOfRange_ObjectID
        {
            get { return Resource.ArgumentOutOfRange_ObjectID; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Offset and length must refer to a position in the string..
        /// </summary>
        public static string ArgumentOutOfRange_OffsetLength
        {
            get { return Resource.ArgumentOutOfRange_OffsetLength; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Either offset did not refer to a position in the string, or there is an insufficient length of destination character array..
        /// </summary>
        public static string ArgumentOutOfRange_OffsetOut
        {
            get { return Resource.ArgumentOutOfRange_OffsetOut; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified parameter index is not in range..
        /// </summary>
        public static string ArgumentOutOfRange_ParamSequence
        {
            get { return Resource.ArgumentOutOfRange_ParamSequence; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Pointer startIndex and length do not refer to a valid string..
        /// </summary>
        public static string ArgumentOutOfRange_PartialWCHAR
        {
            get { return Resource.ArgumentOutOfRange_PartialWCHAR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Period must be less than 2^32-2..
        /// </summary>
        public static string ArgumentOutOfRange_PeriodTooLarge
        {
            get { return Resource.ArgumentOutOfRange_PeriodTooLarge; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The position may not be greater or equal to the capacity of the accessor..
        /// </summary>
        public static string ArgumentOutOfRange_PositionLessThanCapacityRequired
        {
            get { return Resource.ArgumentOutOfRange_PositionLessThanCapacityRequired; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Queue grow factor must be between {0} and {1}..
        /// </summary>
        public static string ArgumentOutOfRange_QueueGrowFactor
        {
            get { return Resource.ArgumentOutOfRange_QueueGrowFactor; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Valid values are between {0} and {1}, inclusive..
        /// </summary>
        public static string ArgumentOutOfRange_Range
        {
            get { return Resource.ArgumentOutOfRange_Range; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Rounding digits must be between 0 and 15, inclusive..
        /// </summary>
        public static string ArgumentOutOfRange_RoundingDigits
        {
            get { return Resource.ArgumentOutOfRange_RoundingDigits; }
        }

        /// <summary>
        ///   Looks up a localized string similar to capacity was less than the current size..
        /// </summary>
        public static string ArgumentOutOfRange_SmallCapacity
        {
            get { return Resource.ArgumentOutOfRange_SmallCapacity; }
        }

        /// <summary>
        ///   Looks up a localized string similar to MaxCapacity must be one or greater..
        /// </summary>
        public static string ArgumentOutOfRange_SmallMaxCapacity
        {
            get { return Resource.ArgumentOutOfRange_SmallMaxCapacity; }
        }

        /// <summary>
        ///   Looks up a localized string similar to StartIndex cannot be less than zero..
        /// </summary>
        public static string ArgumentOutOfRange_StartIndex
        {
            get { return Resource.ArgumentOutOfRange_StartIndex; }
        }

        /// <summary>
        ///   Looks up a localized string similar to startIndex cannot be larger than length of string..
        /// </summary>
        public static string ArgumentOutOfRange_StartIndexLargerThanLength
        {
            get { return Resource.ArgumentOutOfRange_StartIndexLargerThanLength; }
        }

        /// <summary>
        ///   Looks up a localized string similar to startIndex must be less than length of string..
        /// </summary>
        public static string ArgumentOutOfRange_StartIndexLessThanLength
        {
            get { return Resource.ArgumentOutOfRange_StartIndexLessThanLength; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Stream length must be non-negative and less than 2^31 - 1 - origin..
        /// </summary>
        public static string ArgumentOutOfRange_StreamLength
        {
            get { return Resource.ArgumentOutOfRange_StreamLength; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Time-out interval must be less than 2^32-2..
        /// </summary>
        public static string ArgumentOutOfRange_TimeoutTooLarge
        {
            get { return Resource.ArgumentOutOfRange_TimeoutTooLarge; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The length of the buffer must be less than the maximum UIntPtr value for your platform..
        /// </summary>
        public static string ArgumentOutOfRange_UIntPtrMax_1
        {
            get { return Resource.ArgumentOutOfRange_UIntPtrMax_1; }
        }

        /// <summary>
        ///   Looks up a localized string similar to UnmanagedMemoryStream length must be non-negative and less than 2^63 - 1 - baseAddress..
        /// </summary>
        public static string ArgumentOutOfRange_UnmanagedMemStreamLength
        {
            get { return Resource.ArgumentOutOfRange_UnmanagedMemStreamLength; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The UnmanagedMemoryStream capacity would wrap around the high end of the address space..
        /// </summary>
        public static string ArgumentOutOfRange_UnmanagedMemStreamWrapAround
        {
            get { return Resource.ArgumentOutOfRange_UnmanagedMemStreamWrapAround; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The TimeSpan parameter must be within plus or minus 14.0 hours..
        /// </summary>
        public static string ArgumentOutOfRange_UtcOffset
        {
            get { return Resource.ArgumentOutOfRange_UtcOffset; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The sum of the BaseUtcOffset and DaylightDelta properties must within plus or minus 14.0 hours..
        /// </summary>
        public static string ArgumentOutOfRange_UtcOffsetAndDaylightDelta
        {
            get { return Resource.ArgumentOutOfRange_UtcOffsetAndDaylightDelta; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Version&apos;s parameters must be greater than or equal to zero..
        /// </summary>
        public static string ArgumentOutOfRange_Version
        {
            get { return Resource.ArgumentOutOfRange_Version; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The Week parameter must be in the range 1 through 5..
        /// </summary>
        public static string ArgumentOutOfRange_Week
        {
            get { return Resource.ArgumentOutOfRange_Week; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Year must be between 1 and 9999..
        /// </summary>
        public static string ArgumentOutOfRange_Year
        {
            get { return Resource.ArgumentOutOfRange_Year; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Function does not accept floating point Not-a-Number values..
        /// </summary>
        public static string Arithmetic_NaN
        {
            get { return Resource.Arithmetic_NaN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Source array type cannot be assigned to destination array type..
        /// </summary>
        public static string ArrayTypeMismatch_CantAssignType
        {
            get { return Resource.ArrayTypeMismatch_CantAssignType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Array.ConstrainedCopy will only work on array types that are provably compatible, without any form of boxing, unboxing, widening, or casting of each array element.  Change the array types (i.e., copy a Derived[] to a Base[]), or use a mitigation strategy in the CER for Array.Copy&apos;s less powerful reliability contract, such as cloning the array or throwing away the potentially corrupt destination array..
        /// </summary>
        public static string ArrayTypeMismatch_ConstrainedCopy
        {
            get { return Resource.ArrayTypeMismatch_ConstrainedCopy; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type &apos;{0}&apos; was loaded in the ReflectionOnly context but the AssemblyBuilder was not created as AssemblyBuilderAccess.ReflectionOnly..
        /// </summary>
        public static string Arugment_EmitMixedContext1
        {
            get { return Resource.Arugment_EmitMixedContext1; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type &apos;{0}&apos; was not loaded in the ReflectionOnly context but the AssemblyBuilder was created as AssemblyBuilderAccess.ReflectionOnly..
        /// </summary>
        public static string Arugment_EmitMixedContext2
        {
            get { return Resource.Arugment_EmitMixedContext2; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Assertion unsuccessfully..
        /// </summary>
        public static string AssertionFailed
        {
            get { return Resource.AssertionFailed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Assertion unsuccessfully: {0}.
        /// </summary>
        public static string AssertionFailed_Cnd
        {
            get { return Resource.AssertionFailed_Cnd; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Assumption unsuccessfully..
        /// </summary>
        public static string AssumptionFailed
        {
            get { return Resource.AssumptionFailed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Assumption unsuccessfully: {0}.
        /// </summary>
        public static string AssumptionFailed_Cnd
        {
            get { return Resource.AssumptionFailed_Cnd; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The builder was not properly initialized..
        /// </summary>
        public static string AsyncMethodBuilder_InstanceNotInitialized
        {
            get { return Resource.AsyncMethodBuilder_InstanceNotInitialized; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The awaitable or awaiter was not properly initialized..
        /// </summary>
        public static string AwaitableAwaiter_InstanceNotInitialized
        {
            get { return Resource.AwaitableAwaiter_InstanceNotInitialized; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Corrupt .resources file.  The specified type doesn&apos;t exist..
        /// </summary>
        public static string BadImageFormat_InvalidType
        {
            get { return Resource.BadImageFormat_InvalidType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Corrupt .resources file. String length must be non-negative..
        /// </summary>
        public static string BadImageFormat_NegativeStringLength
        {
            get { return Resource.BadImageFormat_NegativeStringLength; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The parameters and the signature of the method don&apos;t match..
        /// </summary>
        public static string BadImageFormat_ParameterSignatureMismatch
        {
            get { return Resource.BadImageFormat_ParameterSignatureMismatch; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Corrupt .resources file.  The specified data length &apos;{0}&apos; is not a valid position in the stream..
        /// </summary>
        public static string BadImageFormat_ResourceDataLengthInvalid
        {
            get { return Resource.BadImageFormat_ResourceDataLengthInvalid; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Corrupt .resources file. A resource name extends past the end of the stream..
        /// </summary>
        public static string BadImageFormat_ResourceNameCorrupted
        {
            get { return Resource.BadImageFormat_ResourceNameCorrupted; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Corrupt .resources file. The resource name for name index {0} extends past the end of the stream..
        /// </summary>
        public static string BadImageFormat_ResourceNameCorrupted_NameIndex
        {
            get { return Resource.BadImageFormat_ResourceNameCorrupted_NameIndex; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Corrupt .resources file. Invalid offset &apos;{0}&apos; into data section..
        /// </summary>
        public static string BadImageFormat_ResourcesDataInvalidOffset
        {
            get { return Resource.BadImageFormat_ResourcesDataInvalidOffset; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Corrupt .resources file. Unable to read resources from this file because of invalid header information. Try regenerating the .resources file..
        /// </summary>
        public static string BadImageFormat_ResourcesHeaderCorrupted
        {
            get { return Resource.BadImageFormat_ResourcesHeaderCorrupted; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Corrupt .resources file. The resource index &apos;{0}&apos; is outside the valid range..
        /// </summary>
        public static string BadImageFormat_ResourcesIndexInvalid
        {
            get { return Resource.BadImageFormat_ResourcesIndexInvalid; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Corrupt .resources file. String for name index &apos;{0}&apos; extends past the end of the file..
        /// </summary>
        public static string BadImageFormat_ResourcesIndexTooLong
        {
            get { return Resource.BadImageFormat_ResourcesIndexTooLong; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Corrupt .resources file. Invalid offset &apos;{0}&apos; into name section..
        /// </summary>
        public static string BadImageFormat_ResourcesNameInvalidOffset
        {
            get { return Resource.BadImageFormat_ResourcesNameInvalidOffset; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Corrupt .resources file. Resource name extends past the end of the file..
        /// </summary>
        public static string BadImageFormat_ResourcesNameTooLong
        {
            get { return Resource.BadImageFormat_ResourcesNameTooLong; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The type serialized in the .resources file was not the same type that the .resources file said it contained. Expected &apos;{0}&apos; but read &apos;{1}&apos;..
        /// </summary>
        public static string BadImageFormat_ResType_SerBlobMismatch
        {
            get { return Resource.BadImageFormat_ResType_SerBlobMismatch; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Corrupt .resources file.  The specified position &apos;{0}&apos; is not a valid position in the stream..
        /// </summary>
        public static string BadImageFormat_StreamPositionInvalid
        {
            get { return Resource.BadImageFormat_StreamPositionInvalid; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Corrupt .resources file.  The specified type doesn&apos;t match the available data in the stream..
        /// </summary>
        public static string BadImageFormat_TypeMismatch
        {
            get { return Resource.BadImageFormat_TypeMismatch; }
        }

        /// <summary>
        ///   Looks up a localized string similar to No tokens were supplied..
        /// </summary>
        public static string CancellationToken_CreateLinkedToken_TokensIsEmpty
        {
            get { return Resource.CancellationToken_CreateLinkedToken_TokensIsEmpty; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The CancellationTokenSource associated with this CancellationToken has been disposed..
        /// </summary>
        public static string CancellationToken_SourceDisposed
        {
            get { return Resource.CancellationToken_SourceDisposed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The CancellationTokenSource has been disposed..
        /// </summary>
        public static string CancellationTokenSource_Disposed
        {
            get { return Resource.CancellationTokenSource_Disposed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The SyncRoot property may not be used for the synchronization of concurrent collections..
        /// </summary>
        public static string ConcurrentCollection_SyncRoot_NotSupported
        {
            get { return Resource.ConcurrentCollection_SyncRoot_NotSupported; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The array is multidimensional, or the type parameter for the set cannot be cast automatically to the type of the destination array..
        /// </summary>
        public static string ConcurrentDictionary_ArrayIncorrectType
        {
            get { return Resource.ConcurrentDictionary_ArrayIncorrectType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The index is equal to or greater than the length of the array, or the number of elements in the dictionary is greater than the available space from index to the end of the destination array..
        /// </summary>
        public static string ConcurrentDictionary_ArrayNotLargeEnough
        {
            get { return Resource.ConcurrentDictionary_ArrayNotLargeEnough; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The capacity argument must be greater than or equal to zero..
        /// </summary>
        public static string ConcurrentDictionary_CapacityMustNotBeNegative
        {
            get { return Resource.ConcurrentDictionary_CapacityMustNotBeNegative; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The concurrencyLevel argument must be positive..
        /// </summary>
        public static string ConcurrentDictionary_ConcurrencyLevelMustBePositive
        {
            get { return Resource.ConcurrentDictionary_ConcurrencyLevelMustBePositive; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The index argument is less than zero..
        /// </summary>
        public static string ConcurrentDictionary_IndexIsNegative
        {
            get { return Resource.ConcurrentDictionary_IndexIsNegative; }
        }

        /// <summary>
        ///   Looks up a localized string similar to TKey is a reference type and item.Key is null..
        /// </summary>
        public static string ConcurrentDictionary_ItemKeyIsNull
        {
            get { return Resource.ConcurrentDictionary_ItemKeyIsNull; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The key already existed in the dictionary..
        /// </summary>
        public static string ConcurrentDictionary_KeyAlreadyExisted
        {
            get { return Resource.ConcurrentDictionary_KeyAlreadyExisted; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The source argument contains duplicate keys..
        /// </summary>
        public static string ConcurrentDictionary_SourceContainsDuplicateKeys
        {
            get { return Resource.ConcurrentDictionary_SourceContainsDuplicateKeys; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The key was of an incorrect type for this dictionary..
        /// </summary>
        public static string ConcurrentDictionary_TypeOfKeyIncorrect
        {
            get { return Resource.ConcurrentDictionary_TypeOfKeyIncorrect; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The value was of an incorrect type for this dictionary..
        /// </summary>
        public static string ConcurrentDictionary_TypeOfValueIncorrect
        {
            get { return Resource.ConcurrentDictionary_TypeOfValueIncorrect; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The count argument must be greater than or equal to zero..
        /// </summary>
        public static string ConcurrentStack_PushPopRange_CountOutOfRange
        {
            get { return Resource.ConcurrentStack_PushPopRange_CountOutOfRange; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The sum of the startIndex and count arguments must be less than or equal to the collection&apos;s Count..
        /// </summary>
        public static string ConcurrentStack_PushPopRange_InvalidCount
        {
            get { return Resource.ConcurrentStack_PushPopRange_InvalidCount; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The startIndex argument must be greater than or equal to zero..
        /// </summary>
        public static string ConcurrentStack_PushPopRange_StartOutOfRange
        {
            get { return Resource.ConcurrentStack_PushPopRange_StartOutOfRange; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The serialization stream contains no elements..
        /// </summary>
        public static string ConcurrentStackQueue_OnDeserialization_NoData
        {
            get { return Resource.ConcurrentStackQueue_OnDeserialization_NoData; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid attempt made to decrement the event&apos;s count below zero..
        /// </summary>
        public static string CountdownEvent_Decrement_BelowZero
        {
            get { return Resource.CountdownEvent_Decrement_BelowZero; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The increment operation would cause the CurrentCount to overflow..
        /// </summary>
        public static string CountdownEvent_Increment_AlreadyMax
        {
            get { return Resource.CountdownEvent_Increment_AlreadyMax; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The event is already signaled and cannot be incremented..
        /// </summary>
        public static string CountdownEvent_Increment_AlreadyZero
        {
            get { return Resource.CountdownEvent_Increment_AlreadyZero; }
        }

        /// <summary>
        ///   Looks up a localized string similar to CryptoConfig cannot add a mapping for a null or empty name..
        /// </summary>
        public static string Cryptography_AddNullOrEmptyName
        {
            get { return Resource.Cryptography_AddNullOrEmptyName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Algorithms added to CryptoConfig must be accessable from outside their assembly..
        /// </summary>
        public static string Cryptography_AlgorithmTypesMustBeVisible
        {
            get { return Resource.Cryptography_AlgorithmTypesMustBeVisible; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Encoded OID length is too large (greater than 0x7f bytes)..
        /// </summary>
        public static string Cryptography_Config_EncodedOIDError
        {
            get { return Resource.Cryptography_Config_EncodedOIDError; }
        }

        /// <summary>
        ///   Looks up a localized string similar to FlushFinalBlock() method was called twice on a CryptoStream. It can only be called once..
        /// </summary>
        public static string Cryptography_CryptoStream_FlushFinalBlockTwice
        {
            get { return Resource.Cryptography_CryptoStream_FlushFinalBlockTwice; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Algorithm implementation does not support a key size of {0}..
        /// </summary>
        public static string Cryptography_CSP_AlgKeySizeNotAvailable
        {
            get { return Resource.Cryptography_CSP_AlgKeySizeNotAvailable; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cryptographic service provider (CSP) could not be found for this algorithm..
        /// </summary>
        public static string Cryptography_CSP_AlgorithmNotAvailable
        {
            get { return Resource.Cryptography_CSP_AlgorithmNotAvailable; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Feedback size for the cipher feedback mode (CFB) must be 8 bits..
        /// </summary>
        public static string Cryptography_CSP_CFBSizeNotSupported
        {
            get { return Resource.Cryptography_CSP_CFBSizeNotSupported; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object contains only the public half of a key pair. A private key must also be provided..
        /// </summary>
        public static string Cryptography_CSP_NoPrivateKey
        {
            get { return Resource.Cryptography_CSP_NoPrivateKey; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The requested key container was not found..
        /// </summary>
        public static string Cryptography_CSP_NotFound
        {
            get { return Resource.Cryptography_CSP_NotFound; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Output feedback mode (OFB) is not supported by this implementation..
        /// </summary>
        public static string Cryptography_CSP_OFBNotSupported
        {
            get { return Resource.Cryptography_CSP_OFBNotSupported; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified cryptographic service provider (CSP) does not support this key algorithm..
        /// </summary>
        public static string Cryptography_CSP_WrongKeySpec
        {
            get { return Resource.Cryptography_CSP_WrongKeySpec; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Error 0x{0} from the operating system security framework: &apos;{1}&apos;..
        /// </summary>
        public static string Cryptography_CSSM_Error
        {
            get { return Resource.Cryptography_CSSM_Error; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Error 0x{0} from the operating system security framework..
        /// </summary>
        public static string Cryptography_CSSM_Error_Unknown
        {
            get { return Resource.Cryptography_CSSM_Error_Unknown; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The hash algorithm name cannot be null or empty..
        /// </summary>
        public static string Cryptography_HashAlgorithmNameNullOrEmpty
        {
            get { return Resource.Cryptography_HashAlgorithmNameNullOrEmpty; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Hash key cannot be changed after the first write to the stream..
        /// </summary>
        public static string Cryptography_HashKeySet
        {
            get { return Resource.Cryptography_HashKeySet; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Hash name cannot be changed after the first write to the stream..
        /// </summary>
        public static string Cryptography_HashNameSet
        {
            get { return Resource.Cryptography_HashNameSet; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Hash must be finalized before the hash value is retrieved..
        /// </summary>
        public static string Cryptography_HashNotYetFinalized
        {
            get { return Resource.Cryptography_HashNotYetFinalized; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Input buffer contains insufficient data..
        /// </summary>
        public static string Cryptography_InsufficientBuffer
        {
            get { return Resource.Cryptography_InsufficientBuffer; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Specified block size is not valid for this algorithm..
        /// </summary>
        public static string Cryptography_InvalidBlockSize
        {
            get { return Resource.Cryptography_InvalidBlockSize; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Specified cipher mode is not valid for this algorithm..
        /// </summary>
        public static string Cryptography_InvalidCipherMode
        {
            get { return Resource.Cryptography_InvalidCipherMode; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Length of the DSA signature was not 40 bytes..
        /// </summary>
        public static string Cryptography_InvalidDSASignatureSize
        {
            get { return Resource.Cryptography_InvalidDSASignatureSize; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Specified feedback size is invalid..
        /// </summary>
        public static string Cryptography_InvalidFeedbackSize
        {
            get { return Resource.Cryptography_InvalidFeedbackSize; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Input string does not contain a valid encoding of the &apos;{0}&apos; &apos;{1}&apos; parameter..
        /// </summary>
        public static string Cryptography_InvalidFromXmlString
        {
            get { return Resource.Cryptography_InvalidFromXmlString; }
        }

        /// <summary>
        ///   Looks up a localized string similar to {0} is an invalid handle..
        /// </summary>
        public static string Cryptography_InvalidHandle
        {
            get { return Resource.Cryptography_InvalidHandle; }
        }

        /// <summary>
        ///   Looks up a localized string similar to {0} algorithm hash size is {1} bytes..
        /// </summary>
        public static string Cryptography_InvalidHashSize
        {
            get { return Resource.Cryptography_InvalidHashSize; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Specified initialization vector (IV) does not match the block size for this algorithm..
        /// </summary>
        public static string Cryptography_InvalidIVSize
        {
            get { return Resource.Cryptography_InvalidIVSize; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Specified key is a known semi-weak key for &apos;{0}&apos; and cannot be used..
        /// </summary>
        public static string Cryptography_InvalidKey_SemiWeak
        {
            get { return Resource.Cryptography_InvalidKey_SemiWeak; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Specified key is a known weak key for &apos;{0}&apos; and cannot be used..
        /// </summary>
        public static string Cryptography_InvalidKey_Weak
        {
            get { return Resource.Cryptography_InvalidKey_Weak; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Parameter &apos;{0}&apos; is not a valid key parameter..
        /// </summary>
        public static string Cryptography_InvalidKeyParameter
        {
            get { return Resource.Cryptography_InvalidKeyParameter; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Specified key is not a valid size for this algorithm..
        /// </summary>
        public static string Cryptography_InvalidKeySize
        {
            get { return Resource.Cryptography_InvalidKeySize; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object identifier (OID) is unknown..
        /// </summary>
        public static string Cryptography_InvalidOID
        {
            get { return Resource.Cryptography_InvalidOID; }
        }

        /// <summary>
        ///   Looks up a localized string similar to This operation is not supported for this class..
        /// </summary>
        public static string Cryptography_InvalidOperation
        {
            get { return Resource.Cryptography_InvalidOperation; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Specified padding mode is not valid for this algorithm..
        /// </summary>
        public static string Cryptography_InvalidPaddingMode
        {
            get { return Resource.Cryptography_InvalidPaddingMode; }
        }

        /// <summary>
        ///   Looks up a localized string similar to No asymmetric key object has been associated with this formatter object..
        /// </summary>
        public static string Cryptography_MissingKey
        {
            get { return Resource.Cryptography_MissingKey; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Required object identifier (OID) cannot be found..
        /// </summary>
        public static string Cryptography_MissingOID
        {
            get { return Resource.Cryptography_MissingOID; }
        }

        /// <summary>
        ///   Looks up a localized string similar to This implementation is not part of the Windows Platform FIPS validated cryptographic algorithms..
        /// </summary>
        public static string Cryptography_NonCompliantFIPSAlgorithm
        {
            get { return Resource.Cryptography_NonCompliantFIPSAlgorithm; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The current session is not interactive..
        /// </summary>
        public static string Cryptography_NotInteractive
        {
            get { return Resource.Cryptography_NotInteractive; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Error occurred while decoding OAEP padding..
        /// </summary>
        public static string Cryptography_OAEPDecoding
        {
            get { return Resource.Cryptography_OAEPDecoding; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The data to be decrypted exceeds the maximum for this modulus of {0} bytes..
        /// </summary>
        public static string Cryptography_Padding_DecDataTooBig
        {
            get { return Resource.Cryptography_Padding_DecDataTooBig; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The data to be encrypted exceeds the maximum for this modulus of {0} bytes..
        /// </summary>
        public static string Cryptography_Padding_EncDataTooBig
        {
            get { return Resource.Cryptography_Padding_EncDataTooBig; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Direct Encryption and decryption using RSA are not available on this platform..
        /// </summary>
        public static string Cryptography_Padding_Win2KEnhOnly
        {
            get { return Resource.Cryptography_Padding_Win2KEnhOnly; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Salt is not at least eight bytes..
        /// </summary>
        public static string Cryptography_PasswordDerivedBytes_FewBytesSalt
        {
            get { return Resource.Cryptography_PasswordDerivedBytes_FewBytesSalt; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Algorithm is unavailable or is not supported for this operation..
        /// </summary>
        public static string Cryptography_PasswordDerivedBytes_InvalidAlgorithm
        {
            get { return Resource.Cryptography_PasswordDerivedBytes_InvalidAlgorithm; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The Initialization vector should have the same length as the algorithm block size in bytes..
        /// </summary>
        public static string Cryptography_PasswordDerivedBytes_InvalidIV
        {
            get { return Resource.Cryptography_PasswordDerivedBytes_InvalidIV; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Requested number of bytes exceeds the maximum..
        /// </summary>
        public static string Cryptography_PasswordDerivedBytes_TooManyBytes
        {
            get { return Resource.Cryptography_PasswordDerivedBytes_TooManyBytes; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Value of &apos;{0}&apos; cannot be changed after the bytes have been retrieved..
        /// </summary>
        public static string Cryptography_PasswordDerivedBytes_ValuesFixed
        {
            get { return Resource.Cryptography_PasswordDerivedBytes_ValuesFixed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Error occurred while decoding PKCS1 padding..
        /// </summary>
        public static string Cryptography_PKCS1Decoding
        {
            get { return Resource.Cryptography_PKCS1Decoding; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Padding is invalid and cannot be removed..
        /// </summary>
        public static string Cryptography_PKCS7_InvalidPadding
        {
            get { return Resource.Cryptography_PKCS7_InvalidPadding; }
        }

        /// <summary>
        ///   Looks up a localized string similar to EffectiveKeySize value must be at least 40 bits..
        /// </summary>
        public static string Cryptography_RC2_EKS40
        {
            get { return Resource.Cryptography_RC2_EKS40; }
        }

        /// <summary>
        ///   Looks up a localized string similar to EffectiveKeySize value must be at least as large as the KeySize value..
        /// </summary>
        public static string Cryptography_RC2_EKSKS
        {
            get { return Resource.Cryptography_RC2_EKSKS; }
        }

        /// <summary>
        ///   Looks up a localized string similar to EffectiveKeySize must be the same as KeySize in this implementation..
        /// </summary>
        public static string Cryptography_RC2_EKSKS2
        {
            get { return Resource.Cryptography_RC2_EKSKS2; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Length of the data to decrypt is invalid..
        /// </summary>
        public static string Cryptography_SSD_InvalidDataSize
        {
            get { return Resource.Cryptography_SSD_InvalidDataSize; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Length of the data to encrypt is invalid..
        /// </summary>
        public static string Cryptography_SSE_InvalidDataSize
        {
            get { return Resource.Cryptography_SSE_InvalidDataSize; }
        }

        /// <summary>
        ///   Looks up a localized string similar to &apos;{0}&apos; is not a known hash algorithm..
        /// </summary>
        public static string Cryptography_UnknownHashAlgorithm
        {
            get { return Resource.Cryptography_UnknownHashAlgorithm; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The certificate export operation unsuccessfully..
        /// </summary>
        public static string Cryptography_X509_ExportFailed
        {
            get { return Resource.Cryptography_X509_ExportFailed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid content type..
        /// </summary>
        public static string Cryptography_X509_InvalidContentType
        {
            get { return Resource.Cryptography_X509_InvalidContentType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Error occurred while parsing the &apos;{0}&apos; policy level. The default policy level was used instead..
        /// </summary>
        public static string Error_SecurityPolicyFileParse
        {
            get { return Resource.Error_SecurityPolicyFileParse; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Error &apos;{1}&apos; occurred while parsing the &apos;{0}&apos; policy level. The default policy level was used instead..
        /// </summary>
        public static string Error_SecurityPolicyFileParseEx
        {
            get { return Resource.Error_SecurityPolicyFileParseEx; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Barrier finishing phase {1}..
        /// </summary>
        public static string event_Barrier_PhaseFinished
        {
            get { return Resource.event_Barrier_PhaseFinished; }
        }

        /// <summary>
        ///   Looks up a localized string similar to ConcurrentBag stealing in TryPeek..
        /// </summary>
        public static string event_ConcurrentBag_TryPeekSteals
        {
            get { return Resource.event_ConcurrentBag_TryPeekSteals; }
        }

        /// <summary>
        ///   Looks up a localized string similar to ConcurrentBag stealing in TryTake..
        /// </summary>
        public static string event_ConcurrentBag_TryTakeSteals
        {
            get { return Resource.event_ConcurrentBag_TryTakeSteals; }
        }

        /// <summary>
        ///   Looks up a localized string similar to ConcurrentDictionary acquiring all locks on {0} bucket(s)..
        /// </summary>
        public static string event_ConcurrentDictionary_AcquiringAllLocks
        {
            get { return Resource.event_ConcurrentDictionary_AcquiringAllLocks; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Pop from ConcurrentStack spun {0} time(s)..
        /// </summary>
        public static string event_ConcurrentStack_FastPopFailed
        {
            get { return Resource.event_ConcurrentStack_FastPopFailed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Push to ConcurrentStack spun {0} time(s)..
        /// </summary>
        public static string event_ConcurrentStack_FastPushFailed
        {
            get { return Resource.event_ConcurrentStack_FastPushFailed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Task {1} entering fork/join {2}..
        /// </summary>
        public static string event_ParallelFork
        {
            get { return Resource.event_ParallelFork; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Beginning ParallelInvoke {2} from Task {1} for {4} actions..
        /// </summary>
        public static string event_ParallelInvokeBegin
        {
            get { return Resource.event_ParallelInvokeBegin; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Ending ParallelInvoke {2}..
        /// </summary>
        public static string event_ParallelInvokeEnd
        {
            get { return Resource.event_ParallelInvokeEnd; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Task {1} leaving fork/join {2}..
        /// </summary>
        public static string event_ParallelJoin
        {
            get { return Resource.event_ParallelJoin; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Beginning {3} loop {2} from Task {1}..
        /// </summary>
        public static string event_ParallelLoopBegin
        {
            get { return Resource.event_ParallelLoopBegin; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Ending loop {2} after {3} iterations..
        /// </summary>
        public static string event_ParallelLoopEnd
        {
            get { return Resource.event_ParallelLoopEnd; }
        }

        /// <summary>
        ///   Looks up a localized string similar to SpinLock beginning to spin..
        /// </summary>
        public static string event_SpinLock_FastPathFailed
        {
            get { return Resource.event_SpinLock_FastPathFailed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Next spin will yield..
        /// </summary>
        public static string event_SpinWait_NextSpinWillYield
        {
            get { return Resource.event_SpinWait_NextSpinWillYield; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Task {2} completed..
        /// </summary>
        public static string event_TaskCompleted
        {
            get { return Resource.event_TaskCompleted; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Task {2} scheduled to TaskScheduler {0}..
        /// </summary>
        public static string event_TaskScheduled
        {
            get { return Resource.event_TaskScheduled; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Task {2} executing..
        /// </summary>
        public static string event_TaskStarted
        {
            get { return Resource.event_TaskStarted; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Beginning wait ({3}) on Task {2}..
        /// </summary>
        public static string event_TaskWaitBegin
        {
            get { return Resource.event_TaskWaitBegin; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Ending wait on Task {2}..
        /// </summary>
        public static string event_TaskWaitEnd
        {
            get { return Resource.event_TaskWaitEnd; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Abstract event source must not declare event methods ({0} with ID {1})..
        /// </summary>
        public static string EventSource_AbstractMustNotDeclareEventMethods
        {
            get { return Resource.EventSource_AbstractMustNotDeclareEventMethods; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Abstract event source must not declare {0} nested type..
        /// </summary>
        public static string EventSource_AbstractMustNotDeclareKTOC
        {
            get { return Resource.EventSource_AbstractMustNotDeclareKTOC; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Getting out of bounds during scalar addition. .
        /// </summary>
        public static string EventSource_AddScalarOutOfRange
        {
            get { return Resource.EventSource_AddScalarOutOfRange; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Event attribute placed on method {0} which does not return &apos;void&apos;..
        /// </summary>
        public static string EventSource_AttributeOnNonVoid
        {
            get { return Resource.EventSource_AttributeOnNonVoid; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Channel {0} does not match event channel value {1}..
        /// </summary>
        public static string EventSource_ChannelTypeDoesNotMatchEventChannelValue
        {
            get { return Resource.EventSource_ChannelTypeDoesNotMatchEventChannelValue; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Data descriptors are out of range..
        /// </summary>
        public static string EventSource_DataDescriptorsOutOfRange
        {
            get { return Resource.EventSource_DataDescriptorsOutOfRange; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Multiple definitions for string &quot;{0}&quot;..
        /// </summary>
        public static string EventSource_DuplicateStringKey
        {
            get { return Resource.EventSource_DuplicateStringKey; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The type of {0} is not expected in {1}..
        /// </summary>
        public static string EventSource_EnumKindMismatch
        {
            get { return Resource.EventSource_EnumKindMismatch; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The provider has already been registered with the operating system..
        /// </summary>
        public static string EventSource_EtwAlreadyRegistered
        {
            get { return Resource.EventSource_EtwAlreadyRegistered; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Channel {0} has a value of {1} which is outside the legal range (16-254)..
        /// </summary>
        public static string EventSource_EventChannelOutOfRange
        {
            get { return Resource.EventSource_EventChannelOutOfRange; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Event {0} has ID {1} which is already in use..
        /// </summary>
        public static string EventSource_EventIdReused
        {
            get { return Resource.EventSource_EventIdReused; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Event {0} (with ID {1}) has a non-default opcode but not a task..
        /// </summary>
        public static string EventSource_EventMustHaveTaskIfNonDefaultOpcode
        {
            get { return Resource.EventSource_EventMustHaveTaskIfNonDefaultOpcode; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Event method {0} (with ID {1}) is an explicit interface method implementation. Re-write method as implicit implementation..
        /// </summary>
        public static string EventSource_EventMustNotBeExplicitImplementation
        {
            get { return Resource.EventSource_EventMustNotBeExplicitImplementation; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Event {0} (with ID {1}) has a name that is not the concatenation of its task name and opcode..
        /// </summary>
        public static string EventSource_EventNameDoesNotEqualTaskPlusOpcode
        {
            get { return Resource.EventSource_EventNameDoesNotEqualTaskPlusOpcode; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Event name {0} used more than once.  If you wish to overload a method, the overloaded method should have a NonEvent attribute..
        /// </summary>
        public static string EventSource_EventNameReused
        {
            get { return Resource.EventSource_EventNameReused; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Event {0} was called with {1} argument(s), but it is defined with {2} parameter(s)..
        /// </summary>
        public static string EventSource_EventParametersMismatch
        {
            get { return Resource.EventSource_EventParametersMismatch; }
        }

        /// <summary>
        ///   Looks up a localized string similar to An instance of EventSource with Guid {0} already exists..
        /// </summary>
        public static string EventSource_EventSourceGuidInUse
        {
            get { return Resource.EventSource_EventSourceGuidInUse; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Event {0} specifies an Admin channel {1}. It must specify a Message property..
        /// </summary>
        public static string EventSource_EventWithAdminChannelMustHaveMessage
        {
            get { return Resource.EventSource_EventWithAdminChannelMustHaveMessage; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Keyword {0} has a value of {1} which is outside the legal range (0-0x0000080000000000)..
        /// </summary>
        public static string EventSource_IllegalKeywordsValue
        {
            get { return Resource.EventSource_IllegalKeywordsValue; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Opcode {0} has a value of {1} which is outside the legal range (11-238)..
        /// </summary>
        public static string EventSource_IllegalOpcodeValue
        {
            get { return Resource.EventSource_IllegalOpcodeValue; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Task {0} has a value of {1} which is outside the legal range (1-65535)..
        /// </summary>
        public static string EventSource_IllegalTaskValue
        {
            get { return Resource.EventSource_IllegalTaskValue; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Incorrectly-authored TypeInfo - a type should be serialized as one field or as one group.
        /// </summary>
        public static string EventSource_IncorrentlyAuthoredTypeInfo
        {
            get { return Resource.EventSource_IncorrentlyAuthoredTypeInfo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid command value..
        /// </summary>
        public static string EventSource_InvalidCommand
        {
            get { return Resource.EventSource_InvalidCommand; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Can&apos;t specify both etw event format flags..
        /// </summary>
        public static string EventSource_InvalidEventFormat
        {
            get { return Resource.EventSource_InvalidEventFormat; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Keywords {0} and {1} are defined with the same value ({2})..
        /// </summary>
        public static string EventSource_KeywordCollision
        {
            get { return Resource.EventSource_KeywordCollision; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Value {0} for keyword {1} needs to be a power of 2..
        /// </summary>
        public static string EventSource_KeywordNeedPowerOfTwo
        {
            get { return Resource.EventSource_KeywordNeedPowerOfTwo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Creating an EventListener inside a EventListener callback..
        /// </summary>
        public static string EventSource_ListenerCreatedInsideCallback
        {
            get { return Resource.EventSource_ListenerCreatedInsideCallback; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Listener not found..
        /// </summary>
        public static string EventSource_ListenerNotFound
        {
            get { return Resource.EventSource_ListenerNotFound; }
        }

        /// <summary>
        ///   Looks up a localized string similar to An error occurred when writing to a listener..
        /// </summary>
        public static string EventSource_ListenerWriteFailure
        {
            get { return Resource.EventSource_ListenerWriteFailure; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attempt to define more than the maximum limit of 8 channels for a provider..
        /// </summary>
        public static string EventSource_MaxChannelExceeded
        {
            get { return Resource.EventSource_MaxChannelExceeded; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Event {0} is givien event ID {1} but {2} was passed to WriteEvent..
        /// </summary>
        public static string EventSource_MismatchIdToWriteEvent
        {
            get { return Resource.EventSource_MismatchIdToWriteEvent; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The Guid of an EventSource must be non zero..
        /// </summary>
        public static string EventSource_NeedGuid
        {
            get { return Resource.EventSource_NeedGuid; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The name of an EventSource must not be null..
        /// </summary>
        public static string EventSource_NeedName
        {
            get { return Resource.EventSource_NeedName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Event IDs must be positive integers..
        /// </summary>
        public static string EventSource_NeedPositiveId
        {
            get { return Resource.EventSource_NeedPositiveId; }
        }

        /// <summary>
        ///   Looks up a localized string similar to No Free Buffers available from the operating system (e.g. event rate too fast)..
        /// </summary>
        public static string EventSource_NoFreeBuffers
        {
            get { return Resource.EventSource_NoFreeBuffers; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The API supports only anonymous types or types decorated with the EventDataAttribute. Non-compliant type: {0} dataType..
        /// </summary>
        public static string EventSource_NonCompliantTypeError
        {
            get { return Resource.EventSource_NonCompliantTypeError; }
        }

        /// <summary>
        ///   Looks up a localized string similar to EventSource expects the first parameter of the Event method to be of type Guid and to be named &quot;relatedActivityId&quot; when calling WriteEventWithRelatedActivityId..
        /// </summary>
        public static string EventSource_NoRelatedActivityId
        {
            get { return Resource.EventSource_NoRelatedActivityId; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arrays of Binary are not supported..
        /// </summary>
        public static string EventSource_NotSupportedArrayOfBinary
        {
            get { return Resource.EventSource_NotSupportedArrayOfBinary; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arrays of Nil are not supported..
        /// </summary>
        public static string EventSource_NotSupportedArrayOfNil
        {
            get { return Resource.EventSource_NotSupportedArrayOfNil; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arrays of null-terminated string are not supported..
        /// </summary>
        public static string EventSource_NotSupportedArrayOfNullTerminatedString
        {
            get { return Resource.EventSource_NotSupportedArrayOfNullTerminatedString; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Enumerables of custom-serialized data are not supported.
        /// </summary>
        public static string EventSource_NotSupportedCustomSerializedData
        {
            get { return Resource.EventSource_NotSupportedCustomSerializedData; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Enum type {0} underlying type {1} is not supported for serialization..
        /// </summary>
        public static string EventSource_NotSupportedEnumType
        {
            get { return Resource.EventSource_NotSupportedEnumType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Nested arrays/enumerables are not supported..
        /// </summary>
        public static string EventSource_NotSupportedNestedArraysEnums
        {
            get { return Resource.EventSource_NotSupportedNestedArraysEnums; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Null passed as a event argument..
        /// </summary>
        public static string EventSource_NullInput
        {
            get { return Resource.EventSource_NullInput; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Opcodes {0} and {1} are defined with the same value ({2})..
        /// </summary>
        public static string EventSource_OpcodeCollision
        {
            get { return Resource.EventSource_OpcodeCollision; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The payload for a single event is too large..
        /// </summary>
        public static string EventSource_PayloadTooBig
        {
            get { return Resource.EventSource_PayloadTooBig; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Period character (&apos;.&apos;) is illegal in an ETW provider name ({0})..
        /// </summary>
        public static string EventSource_PeriodIllegalInProviderName
        {
            get { return Resource.EventSource_PeriodIllegalInProviderName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to  Pins are out of range..
        /// </summary>
        public static string EventSource_PinArrayOutOfRange
        {
            get { return Resource.EventSource_PinArrayOutOfRange; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Recursive type definition is not supported..
        /// </summary>
        public static string EventSource_RecursiveTypeDefinition
        {
            get { return Resource.EventSource_RecursiveTypeDefinition; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Keywords values larger than 0x0000100000000000 are reserved for system use.
        /// </summary>
        public static string EventSource_ReservedKeywords
        {
            get { return Resource.EventSource_ReservedKeywords; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Opcode values less than 11 are reserved for system use..
        /// </summary>
        public static string EventSource_ReservedOpcode
        {
            get { return Resource.EventSource_ReservedOpcode; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bit position in AllKeywords ({0}) must equal the command argument named &quot;EtwSessionKeyword&quot; ({1})..
        /// </summary>
        public static string EventSource_SessionIdError
        {
            get { return Resource.EventSource_SessionIdError; }
        }

        /// <summary>
        ///   Looks up a localized string similar to An event with stop suffix must follow a corresponding event with a start suffix..
        /// </summary>
        public static string EventSource_StopsFollowStarts
        {
            get { return Resource.EventSource_StopsFollowStarts; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tasks {0} and {1} are defined with the same value ({2})..
        /// </summary>
        public static string EventSource_TaskCollision
        {
            get { return Resource.EventSource_TaskCollision; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Event {0} (with ID {1}) has the same task/opcode pair as event {2} (with ID {3})..
        /// </summary>
        public static string EventSource_TaskOpcodePairReused
        {
            get { return Resource.EventSource_TaskOpcodePairReused; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Too many arguments..
        /// </summary>
        public static string EventSource_TooManyArgs
        {
            get { return Resource.EventSource_TooManyArgs; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Too many fields in structure..
        /// </summary>
        public static string EventSource_TooManyFields
        {
            get { return Resource.EventSource_TooManyFields; }
        }

        /// <summary>
        ///   Looks up a localized string similar to EventSource({0}, {1}).
        /// </summary>
        public static string EventSource_ToString
        {
            get { return Resource.EventSource_ToString; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Event source types must be sealed or abstract..
        /// </summary>
        public static string EventSource_TypeMustBeSealedOrAbstract
        {
            get { return Resource.EventSource_TypeMustBeSealedOrAbstract; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Event source types must derive from EventSource..
        /// </summary>
        public static string EventSource_TypeMustDeriveFromEventSource
        {
            get { return Resource.EventSource_TypeMustDeriveFromEventSource; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Use of undefined channel value {0} for event {1}..
        /// </summary>
        public static string EventSource_UndefinedChannel
        {
            get { return Resource.EventSource_UndefinedChannel; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Use of undefined keyword value {0} for event {1}..
        /// </summary>
        public static string EventSource_UndefinedKeyword
        {
            get { return Resource.EventSource_UndefinedKeyword; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Use of undefined opcode value {0} for event {1}..
        /// </summary>
        public static string EventSource_UndefinedOpcode
        {
            get { return Resource.EventSource_UndefinedOpcode; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unsupported type {0} in event source..
        /// </summary>
        public static string EventSource_UnsupportedEventTypeInManifest
        {
            get { return Resource.EventSource_UnsupportedEventTypeInManifest; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Event {0} specifies an illegal or unsupported formatting message (&quot;{1}&quot;)..
        /// </summary>
        public static string EventSource_UnsupportedMessageProperty
        {
            get { return Resource.EventSource_UnsupportedMessageProperty; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The parameters to the Event method do not match the parameters to the WriteEvent method. This may cause the event to be displayed incorrectly..
        /// </summary>
        public static string EventSource_VarArgsParameterMismatch
        {
            get { return Resource.EventSource_VarArgsParameterMismatch; }
        }

        /// <summary>
        ///   Looks up a localized string similar to --- End of inner exception stack trace ---.
        /// </summary>
        public static string Exception_EndOfInnerExceptionStack
        {
            get { return Resource.Exception_EndOfInnerExceptionStack; }
        }

        /// <summary>
        ///   Looks up a localized string similar to --- End of stack trace from previous location where exception was thrown ---.
        /// </summary>
        public static string Exception_EndStackTraceFromPreviousThrow
        {
            get { return Resource.Exception_EndStackTraceFromPreviousThrow; }
        }

        /// <summary>
        ///    Looks up a localized string similar to The session cannot be established after the response has started..
        /// </summary>
        public static string Exception_InvalidSessionEstablishment
        {
            get { return Resource.Exception_InvalidSessionEstablishment; }
        }

        /// <summary>
        ///    Looks up a localized string similar to The value cannot be serialized in two bytes..
        /// </summary>
        public static string Exception_InvalidToSerializeIn2Bytes
        {
            get { return Resource.Exception_InvalidToSerializeIn2Bytes; }
        }

        /// <summary>
        ///    Looks up a localized string similar to The value cannot be serialized in three bytes..
        /// </summary>
        public static string Exception_InvalidToSerializeIn3Bytes
        {
            get { return Resource.Exception_InvalidToSerializeIn3Bytes; }
        }

        /// <summary>
        ///    Looks up a localized string similar to The key cannot be longer than &apos;{0}&apos; when encoded with UTF-8..
        /// </summary>
        public static string Exception_KeyLengthIsExceeded
        {
            get { return Resource.Exception_KeyLengthIsExceeded; }
        }

        /// <summary>
        ///    Looks up a localized string similar to The value cannot be negative..
        /// </summary>
        public static string Exception_NumberShouldNotBeNegative
        {
            get { return Resource.Exception_NumberShouldNotBeNegative; }
        }


        /// <summary>
        ///   Looks up a localized string similar to Exception of type &apos;{0}&apos; was thrown..
        /// </summary>
        public static string Exception_WasThrown
        {
            get { return Resource.Exception_WasThrown; }
        }

        /// <summary>
        ///   Looks up a localized string similar to An exception was not handled in an AsyncLocal&lt;T&gt; notification callback..
        /// </summary>
        public static string ExecutionContext_ExceptionInAsyncLocalNotification
        {
            get { return Resource.ExecutionContext_ExceptionInAsyncLocalNotification; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Undo operation on a component context threw an exception..
        /// </summary>
        public static string ExecutionContext_UndoFailed
        {
            get { return Resource.ExecutionContext_UndoFailed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attribute cannot have multiple definitions..
        /// </summary>
        public static string ExecutionEngine_InvalidAttribute
        {
            get { return Resource.ExecutionEngine_InvalidAttribute; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to retrieve security descriptor for this frame..
        /// </summary>
        public static string ExecutionEngine_MissingSecurityDescriptor
        {
            get { return Resource.ExecutionEngine_MissingSecurityDescriptor; }
        }

        /// <summary>
        ///   Looks up a localized string similar to InitOnly (aka ReadOnly) fields can only be initialized in the type/instance constructor..
        /// </summary>
        public static string FieldAccess_InitOnly
        {
            get { return Resource.FieldAccess_InitOnly; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Same directory FileIO - &apos;{0}&apos;.
        /// </summary>
        public static string FileCodeGroup_PermissionSet
        {
            get { return Resource.FileCodeGroup_PermissionSet; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Could not resolve assembly &apos;{0}&apos;..
        /// </summary>
        public static string FileNotFound_ResolveAssembly
        {
            get { return Resource.FileNotFound_ResolveAssembly; }
        }

        /// <summary>
        ///   Looks up a localized string similar to File operation not permitted. Access to path &apos;{0}&apos; is denied..
        /// </summary>
        public static string FileSecurityState_OperationNotPermitted
        {
            get { return Resource.FileSecurityState_OperationNotPermitted; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Duplicate AttributeUsageAttribute found on attribute type {0}..
        /// </summary>
        public static string Format_AttributeUsage
        {
            get { return Resource.Format_AttributeUsage; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Too many bytes in what should have been a 7 bit encoded Int32..
        /// </summary>
        public static string Format_Bad7BitInt32
        {
            get { return Resource.Format_Bad7BitInt32; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid digits for the specified base..
        /// </summary>
        public static string Format_BadBase
        {
            get { return Resource.Format_BadBase; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The input is not a valid Base-64 string as it contains a non-base 64 character, more than two padding characters, or an illegal character among the padding characters. .
        /// </summary>
        public static string Format_BadBase64Char
        {
            get { return Resource.Format_BadBase64Char; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid length for a Base-64 char array or string..
        /// </summary>
        public static string Format_BadBase64CharArrayLength
        {
            get { return Resource.Format_BadBase64CharArrayLength; }
        }

        /// <summary>
        ///   Looks up a localized string similar to String was not recognized as a valid Boolean..
        /// </summary>
        public static string Format_BadBoolean
        {
            get { return Resource.Format_BadBoolean; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Could not determine the order of year, month, and date from &apos;{0}&apos;..
        /// </summary>
        public static string Format_BadDatePattern
        {
            get { return Resource.Format_BadDatePattern; }
        }

        /// <summary>
        ///   Looks up a localized string similar to String was not recognized as a valid DateTime..
        /// </summary>
        public static string Format_BadDateTime
        {
            get { return Resource.Format_BadDateTime; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The DateTime represented by the string is not supported in calendar {0}..
        /// </summary>
        public static string Format_BadDateTimeCalendar
        {
            get { return Resource.Format_BadDateTimeCalendar; }
        }

        /// <summary>
        ///   Looks up a localized string similar to String was not recognized as a valid DateTime because the day of week was incorrect..
        /// </summary>
        public static string Format_BadDayOfWeek
        {
            get { return Resource.Format_BadDayOfWeek; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Format specifier was invalid..
        /// </summary>
        public static string Format_BadFormatSpecifier
        {
            get { return Resource.Format_BadFormatSpecifier; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot find a matching quote character for the character &apos;{0}&apos;..
        /// </summary>
        public static string Format_BadQuote
        {
            get { return Resource.Format_BadQuote; }
        }

        /// <summary>
        ///   Looks up a localized string similar to String was not recognized as a valid TimeSpan..
        /// </summary>
        public static string Format_BadTimeSpan
        {
            get { return Resource.Format_BadTimeSpan; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The DateTime represented by the string is out of range..
        /// </summary>
        public static string Format_DateOutOfRange
        {
            get { return Resource.Format_DateOutOfRange; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Input string was either empty or contained only whitespace..
        /// </summary>
        public static string Format_EmptyInputString
        {
            get { return Resource.Format_EmptyInputString; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Additional non-parsable characters are at the end of the string..
        /// </summary>
        public static string Format_ExtraJunkAtEnd
        {
            get { return Resource.Format_ExtraJunkAtEnd; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Expected {0xdddddddd, etc}..
        /// </summary>
        public static string Format_GuidBrace
        {
            get { return Resource.Format_GuidBrace; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Could not find a brace, or the length between the previous token and the brace was zero (i.e., &apos;0x,&apos;etc.)..
        /// </summary>
        public static string Format_GuidBraceAfterLastNumber
        {
            get { return Resource.Format_GuidBraceAfterLastNumber; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Could not find a comma, or the length between the previous token and the comma was zero (i.e., &apos;0x,&apos;etc.)..
        /// </summary>
        public static string Format_GuidComma
        {
            get { return Resource.Format_GuidComma; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Dashes are in the wrong position for GUID parsing..
        /// </summary>
        public static string Format_GuidDashes
        {
            get { return Resource.Format_GuidDashes; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Could not find the ending brace..
        /// </summary>
        public static string Format_GuidEndBrace
        {
            get { return Resource.Format_GuidEndBrace; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Expected hex 0x in &apos;{0}&apos;..
        /// </summary>
        public static string Format_GuidHexPrefix
        {
            get { return Resource.Format_GuidHexPrefix; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Guid string should only contain hexadecimal characters..
        /// </summary>
        public static string Format_GuidInvalidChar
        {
            get { return Resource.Format_GuidInvalidChar; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Guid should contain 32 digits with 4 dashes (xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx)..
        /// </summary>
        public static string Format_GuidInvLen
        {
            get { return Resource.Format_GuidInvLen; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unrecognized Guid format..
        /// </summary>
        public static string Format_GuidUnrecognized
        {
            get { return Resource.Format_GuidUnrecognized; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Index (zero based) must be greater than or equal to zero and less than the size of the argument list..
        /// </summary>
        public static string Format_IndexOutOfRange
        {
            get { return Resource.Format_IndexOutOfRange; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Format String can be only &quot;G&quot;, &quot;g&quot;, &quot;X&quot;, &quot;x&quot;, &quot;F&quot;, &quot;f&quot;, &quot;D&quot; or &quot;d&quot;..
        /// </summary>
        public static string Format_InvalidEnumFormatSpecification
        {
            get { return Resource.Format_InvalidEnumFormatSpecification; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Format String can be only &quot;D&quot;, &quot;d&quot;, &quot;N&quot;, &quot;n&quot;, &quot;P&quot;, &quot;p&quot;, &quot;B&quot;, &quot;b&quot;, &quot;X&quot; or &quot;x&quot;..
        /// </summary>
        public static string Format_InvalidGuidFormatSpecification
        {
            get { return Resource.Format_InvalidGuidFormatSpecification; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Input string was not in a correct format..
        /// </summary>
        public static string Format_InvalidString
        {
            get { return Resource.Format_InvalidString; }
        }

        /// <summary>
        ///   Looks up a localized string similar to There must be at least a partial date with a year present in the input..
        /// </summary>
        public static string Format_MissingIncompleteDate
        {
            get { return Resource.Format_MissingIncompleteDate; }
        }

        /// <summary>
        ///   Looks up a localized string similar to String must be exactly one character long..
        /// </summary>
        public static string Format_NeedSingleChar
        {
            get { return Resource.Format_NeedSingleChar; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Could not find any recognizable digits..
        /// </summary>
        public static string Format_NoParsibleDigits
        {
            get { return Resource.Format_NoParsibleDigits; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The time zone offset must be within plus or minus 14 hours..
        /// </summary>
        public static string Format_OffsetOutOfRange
        {
            get { return Resource.Format_OffsetOutOfRange; }
        }

        /// <summary>
        ///   Looks up a localized string similar to DateTime pattern &apos;{0}&apos; appears more than once with different values..
        /// </summary>
        public static string Format_RepeatDateTimePattern
        {
            get { return Resource.Format_RepeatDateTimePattern; }
        }

        /// <summary>
        ///   Looks up a localized string similar to String cannot have zero length..
        /// </summary>
        public static string Format_StringZeroLength
        {
            get { return Resource.Format_StringZeroLength; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The String being parsed cannot contain two TimeZone specifiers..
        /// </summary>
        public static string Format_TwoTimeZoneSpecifiers
        {
            get { return Resource.Format_TwoTimeZoneSpecifiers; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The string was not recognized as a valid DateTime. There is an unknown word starting at index {0}..
        /// </summary>
        public static string Format_UnknowDateTimeWord
        {
            get { return Resource.Format_UnknowDateTimeWord; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The UTC representation of the date falls outside the year range 1-9999..
        /// </summary>
        public static string Format_UTCOutOfRange
        {
            get { return Resource.Format_UTCOutOfRange; }
        }

        /// <summary>
        ///   Looks up a localized string similar to GAC.
        /// </summary>
        public static string GAC_ToString
        {
            get { return Resource.GAC_ToString; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invariant Language (Invariant Country).
        /// </summary>
        public static string Globalization_ci
        {
            get { return Resource.Globalization_ci; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Afar.
        /// </summary>
        public static string Globalization_ci_aa
        {
            get { return Resource.Globalization_ci_aa; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Afar (Djibouti).
        /// </summary>
        public static string Globalization_ci_aa_DJ
        {
            get { return Resource.Globalization_ci_aa_DJ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Afar (Eritrea).
        /// </summary>
        public static string Globalization_ci_aa_ER
        {
            get { return Resource.Globalization_ci_aa_ER; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Afar (Ethiopia).
        /// </summary>
        public static string Globalization_ci_aa_ET
        {
            get { return Resource.Globalization_ci_aa_ET; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Afrikaans.
        /// </summary>
        public static string Globalization_ci_af
        {
            get { return Resource.Globalization_ci_af; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Afrikaans (Namibia).
        /// </summary>
        public static string Globalization_ci_af_NA
        {
            get { return Resource.Globalization_ci_af_NA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Afrikaans (South Africa).
        /// </summary>
        public static string Globalization_ci_af_ZA
        {
            get { return Resource.Globalization_ci_af_ZA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Aghem.
        /// </summary>
        public static string Globalization_ci_agq
        {
            get { return Resource.Globalization_ci_agq; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Aghem (Cameroon).
        /// </summary>
        public static string Globalization_ci_agq_CM
        {
            get { return Resource.Globalization_ci_agq_CM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Akan.
        /// </summary>
        public static string Globalization_ci_ak
        {
            get { return Resource.Globalization_ci_ak; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Akan (Ghana).
        /// </summary>
        public static string Globalization_ci_ak_GH
        {
            get { return Resource.Globalization_ci_ak_GH; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Amharic.
        /// </summary>
        public static string Globalization_ci_am
        {
            get { return Resource.Globalization_ci_am; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Amharic (Ethiopia).
        /// </summary>
        public static string Globalization_ci_am_ET
        {
            get { return Resource.Globalization_ci_am_ET; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic.
        /// </summary>
        public static string Globalization_ci_ar
        {
            get { return Resource.Globalization_ci_ar; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic (World).
        /// </summary>
        public static string Globalization_ci_ar_001
        {
            get { return Resource.Globalization_ci_ar_001; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic (U.A.E.).
        /// </summary>
        public static string Globalization_ci_ar_AE
        {
            get { return Resource.Globalization_ci_ar_AE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic (Bahrain).
        /// </summary>
        public static string Globalization_ci_ar_BH
        {
            get { return Resource.Globalization_ci_ar_BH; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic (Djibouti).
        /// </summary>
        public static string Globalization_ci_ar_DJ
        {
            get { return Resource.Globalization_ci_ar_DJ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic (Algeria).
        /// </summary>
        public static string Globalization_ci_ar_DZ
        {
            get { return Resource.Globalization_ci_ar_DZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic (Egypt).
        /// </summary>
        public static string Globalization_ci_ar_EG
        {
            get { return Resource.Globalization_ci_ar_EG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic (Eritrea).
        /// </summary>
        public static string Globalization_ci_ar_ER
        {
            get { return Resource.Globalization_ci_ar_ER; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic (Israel).
        /// </summary>
        public static string Globalization_ci_ar_IL
        {
            get { return Resource.Globalization_ci_ar_IL; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic (Iraq).
        /// </summary>
        public static string Globalization_ci_ar_IQ
        {
            get { return Resource.Globalization_ci_ar_IQ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic (Jordan).
        /// </summary>
        public static string Globalization_ci_ar_JO
        {
            get { return Resource.Globalization_ci_ar_JO; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic (Comoros).
        /// </summary>
        public static string Globalization_ci_ar_KM
        {
            get { return Resource.Globalization_ci_ar_KM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic (Kuwait).
        /// </summary>
        public static string Globalization_ci_ar_KW
        {
            get { return Resource.Globalization_ci_ar_KW; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic (Lebanon).
        /// </summary>
        public static string Globalization_ci_ar_LB
        {
            get { return Resource.Globalization_ci_ar_LB; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic (Libya).
        /// </summary>
        public static string Globalization_ci_ar_LY
        {
            get { return Resource.Globalization_ci_ar_LY; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic (Morocco).
        /// </summary>
        public static string Globalization_ci_ar_MA
        {
            get { return Resource.Globalization_ci_ar_MA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic (Mauritania).
        /// </summary>
        public static string Globalization_ci_ar_MR
        {
            get { return Resource.Globalization_ci_ar_MR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic (Oman).
        /// </summary>
        public static string Globalization_ci_ar_OM
        {
            get { return Resource.Globalization_ci_ar_OM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic (Palestinian Authority).
        /// </summary>
        public static string Globalization_ci_ar_PS
        {
            get { return Resource.Globalization_ci_ar_PS; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic (Qatar).
        /// </summary>
        public static string Globalization_ci_ar_QA
        {
            get { return Resource.Globalization_ci_ar_QA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic (Saudi Arabia).
        /// </summary>
        public static string Globalization_ci_ar_SA
        {
            get { return Resource.Globalization_ci_ar_SA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic (Sudan).
        /// </summary>
        public static string Globalization_ci_ar_SD
        {
            get { return Resource.Globalization_ci_ar_SD; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic (Somalia).
        /// </summary>
        public static string Globalization_ci_ar_SO
        {
            get { return Resource.Globalization_ci_ar_SO; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic (South Sudan).
        /// </summary>
        public static string Globalization_ci_ar_SS
        {
            get { return Resource.Globalization_ci_ar_SS; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic (Syria).
        /// </summary>
        public static string Globalization_ci_ar_SY
        {
            get { return Resource.Globalization_ci_ar_SY; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic (Chad).
        /// </summary>
        public static string Globalization_ci_ar_TD
        {
            get { return Resource.Globalization_ci_ar_TD; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic (Tunisia).
        /// </summary>
        public static string Globalization_ci_ar_TN
        {
            get { return Resource.Globalization_ci_ar_TN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic (Yemen).
        /// </summary>
        public static string Globalization_ci_ar_YE
        {
            get { return Resource.Globalization_ci_ar_YE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Mapudungun.
        /// </summary>
        public static string Globalization_ci_arn
        {
            get { return Resource.Globalization_ci_arn; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Mapudungun (Chile).
        /// </summary>
        public static string Globalization_ci_arn_CL
        {
            get { return Resource.Globalization_ci_arn_CL; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Assamese.
        /// </summary>
        public static string Globalization_ci_as
        {
            get { return Resource.Globalization_ci_as; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Assamese (India).
        /// </summary>
        public static string Globalization_ci_as_IN
        {
            get { return Resource.Globalization_ci_as_IN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Asu.
        /// </summary>
        public static string Globalization_ci_asa
        {
            get { return Resource.Globalization_ci_asa; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Asu (Tanzania).
        /// </summary>
        public static string Globalization_ci_asa_TZ
        {
            get { return Resource.Globalization_ci_asa_TZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Asturian.
        /// </summary>
        public static string Globalization_ci_ast
        {
            get { return Resource.Globalization_ci_ast; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Asturian (Spain).
        /// </summary>
        public static string Globalization_ci_ast_ES
        {
            get { return Resource.Globalization_ci_ast_ES; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Azerbaijani.
        /// </summary>
        public static string Globalization_ci_az
        {
            get { return Resource.Globalization_ci_az; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Azerbaijani (Cyrillic).
        /// </summary>
        public static string Globalization_ci_az_Cyrl
        {
            get { return Resource.Globalization_ci_az_Cyrl; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Azerbaijani (Cyrillic, Azerbaijan).
        /// </summary>
        public static string Globalization_ci_az_Cyrl_AZ
        {
            get { return Resource.Globalization_ci_az_Cyrl_AZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Azerbaijani (Latin).
        /// </summary>
        public static string Globalization_ci_az_Latn
        {
            get { return Resource.Globalization_ci_az_Latn; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Azerbaijani (Latin, Azerbaijan).
        /// </summary>
        public static string Globalization_ci_az_Latn_AZ
        {
            get { return Resource.Globalization_ci_az_Latn_AZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bashkir.
        /// </summary>
        public static string Globalization_ci_ba
        {
            get { return Resource.Globalization_ci_ba; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bashkir (Russia).
        /// </summary>
        public static string Globalization_ci_ba_RU
        {
            get { return Resource.Globalization_ci_ba_RU; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Basaa.
        /// </summary>
        public static string Globalization_ci_bas
        {
            get { return Resource.Globalization_ci_bas; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Basaa (Cameroon).
        /// </summary>
        public static string Globalization_ci_bas_CM
        {
            get { return Resource.Globalization_ci_bas_CM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Belarusian.
        /// </summary>
        public static string Globalization_ci_be
        {
            get { return Resource.Globalization_ci_be; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Belarusian (Belarus).
        /// </summary>
        public static string Globalization_ci_be_BY
        {
            get { return Resource.Globalization_ci_be_BY; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bemba.
        /// </summary>
        public static string Globalization_ci_bem
        {
            get { return Resource.Globalization_ci_bem; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bemba (Zambia).
        /// </summary>
        public static string Globalization_ci_bem_ZM
        {
            get { return Resource.Globalization_ci_bem_ZM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bena.
        /// </summary>
        public static string Globalization_ci_bez
        {
            get { return Resource.Globalization_ci_bez; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bena (Tanzania).
        /// </summary>
        public static string Globalization_ci_bez_TZ
        {
            get { return Resource.Globalization_ci_bez_TZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bulgarian.
        /// </summary>
        public static string Globalization_ci_bg
        {
            get { return Resource.Globalization_ci_bg; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bulgarian (Bulgaria).
        /// </summary>
        public static string Globalization_ci_bg_BG
        {
            get { return Resource.Globalization_ci_bg_BG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bambara.
        /// </summary>
        public static string Globalization_ci_bm
        {
            get { return Resource.Globalization_ci_bm; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bambara (Latin).
        /// </summary>
        public static string Globalization_ci_bm_Latn
        {
            get { return Resource.Globalization_ci_bm_Latn; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bambara (Latin, Mali).
        /// </summary>
        public static string Globalization_ci_bm_Latn_ML
        {
            get { return Resource.Globalization_ci_bm_Latn_ML; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bamanankan (Latin, Mali).
        /// </summary>
        public static string Globalization_ci_bm_ML
        {
            get { return Resource.Globalization_ci_bm_ML; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bangla.
        /// </summary>
        public static string Globalization_ci_bn
        {
            get { return Resource.Globalization_ci_bn; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bangla (Bangladesh).
        /// </summary>
        public static string Globalization_ci_bn_BD
        {
            get { return Resource.Globalization_ci_bn_BD; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bangla (India).
        /// </summary>
        public static string Globalization_ci_bn_IN
        {
            get { return Resource.Globalization_ci_bn_IN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tibetan.
        /// </summary>
        public static string Globalization_ci_bo
        {
            get { return Resource.Globalization_ci_bo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tibetan (PRC).
        /// </summary>
        public static string Globalization_ci_bo_CN
        {
            get { return Resource.Globalization_ci_bo_CN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tibetan (India).
        /// </summary>
        public static string Globalization_ci_bo_IN
        {
            get { return Resource.Globalization_ci_bo_IN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Breton.
        /// </summary>
        public static string Globalization_ci_br
        {
            get { return Resource.Globalization_ci_br; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Breton (France).
        /// </summary>
        public static string Globalization_ci_br_FR
        {
            get { return Resource.Globalization_ci_br_FR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bodo.
        /// </summary>
        public static string Globalization_ci_brx
        {
            get { return Resource.Globalization_ci_brx; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bodo (India).
        /// </summary>
        public static string Globalization_ci_brx_IN
        {
            get { return Resource.Globalization_ci_brx_IN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bosnian.
        /// </summary>
        public static string Globalization_ci_bs
        {
            get { return Resource.Globalization_ci_bs; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bosnian (Cyrillic).
        /// </summary>
        public static string Globalization_ci_bs_Cyrl
        {
            get { return Resource.Globalization_ci_bs_Cyrl; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bosnian (Cyrillic, Bosnia and Herzegovina).
        /// </summary>
        public static string Globalization_ci_bs_Cyrl_BA
        {
            get { return Resource.Globalization_ci_bs_Cyrl_BA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bosnian (Latin).
        /// </summary>
        public static string Globalization_ci_bs_Latn
        {
            get { return Resource.Globalization_ci_bs_Latn; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bosnian (Latin, Bosnia and Herzegovina).
        /// </summary>
        public static string Globalization_ci_bs_Latn_BA
        {
            get { return Resource.Globalization_ci_bs_Latn_BA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Blin.
        /// </summary>
        public static string Globalization_ci_byn
        {
            get { return Resource.Globalization_ci_byn; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Blin (Eritrea).
        /// </summary>
        public static string Globalization_ci_byn_ER
        {
            get { return Resource.Globalization_ci_byn_ER; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Catalan.
        /// </summary>
        public static string Globalization_ci_ca
        {
            get { return Resource.Globalization_ci_ca; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Catalan (Andorra).
        /// </summary>
        public static string Globalization_ci_ca_AD
        {
            get { return Resource.Globalization_ci_ca_AD; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Catalan (Catalan).
        /// </summary>
        public static string Globalization_ci_ca_ES
        {
            get { return Resource.Globalization_ci_ca_ES; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Valencian (Spain).
        /// </summary>
        public static string Globalization_ci_ca_ES_valencia
        {
            get { return Resource.Globalization_ci_ca_ES_valencia; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Catalan (France).
        /// </summary>
        public static string Globalization_ci_ca_FR
        {
            get { return Resource.Globalization_ci_ca_FR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Catalan (Italy).
        /// </summary>
        public static string Globalization_ci_ca_IT
        {
            get { return Resource.Globalization_ci_ca_IT; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Chiga.
        /// </summary>
        public static string Globalization_ci_cgg
        {
            get { return Resource.Globalization_ci_cgg; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Chiga (Uganda).
        /// </summary>
        public static string Globalization_ci_cgg_UG
        {
            get { return Resource.Globalization_ci_cgg_UG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cherokee.
        /// </summary>
        public static string Globalization_ci_chr
        {
            get { return Resource.Globalization_ci_chr; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cherokee (Cherokee).
        /// </summary>
        public static string Globalization_ci_chr_Cher
        {
            get { return Resource.Globalization_ci_chr_Cher; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cherokee (Cherokee).
        /// </summary>
        public static string Globalization_ci_chr_Cher_US
        {
            get { return Resource.Globalization_ci_chr_Cher_US; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Corsican.
        /// </summary>
        public static string Globalization_ci_co
        {
            get { return Resource.Globalization_ci_co; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Corsican (France).
        /// </summary>
        public static string Globalization_ci_co_FR
        {
            get { return Resource.Globalization_ci_co_FR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Czech.
        /// </summary>
        public static string Globalization_ci_cs
        {
            get { return Resource.Globalization_ci_cs; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Czech (Czech Republic).
        /// </summary>
        public static string Globalization_ci_cs_CZ
        {
            get { return Resource.Globalization_ci_cs_CZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Welsh.
        /// </summary>
        public static string Globalization_ci_cy
        {
            get { return Resource.Globalization_ci_cy; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Welsh (United Kingdom).
        /// </summary>
        public static string Globalization_ci_cy_GB
        {
            get { return Resource.Globalization_ci_cy_GB; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Danish.
        /// </summary>
        public static string Globalization_ci_da
        {
            get { return Resource.Globalization_ci_da; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Danish (Denmark).
        /// </summary>
        public static string Globalization_ci_da_DK
        {
            get { return Resource.Globalization_ci_da_DK; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Danish (Greenland).
        /// </summary>
        public static string Globalization_ci_da_GL
        {
            get { return Resource.Globalization_ci_da_GL; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Taita.
        /// </summary>
        public static string Globalization_ci_dav
        {
            get { return Resource.Globalization_ci_dav; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Taita (Kenya).
        /// </summary>
        public static string Globalization_ci_dav_KE
        {
            get { return Resource.Globalization_ci_dav_KE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to German.
        /// </summary>
        public static string Globalization_ci_de
        {
            get { return Resource.Globalization_ci_de; }
        }

        /// <summary>
        ///   Looks up a localized string similar to German (Austria).
        /// </summary>
        public static string Globalization_ci_de_AT
        {
            get { return Resource.Globalization_ci_de_AT; }
        }

        /// <summary>
        ///   Looks up a localized string similar to German (Belgium).
        /// </summary>
        public static string Globalization_ci_de_BE
        {
            get { return Resource.Globalization_ci_de_BE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to German (Switzerland).
        /// </summary>
        public static string Globalization_ci_de_CH
        {
            get { return Resource.Globalization_ci_de_CH; }
        }

        /// <summary>
        ///   Looks up a localized string similar to German (Germany).
        /// </summary>
        public static string Globalization_ci_de_DE
        {
            get { return Resource.Globalization_ci_de_DE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to German (Germany).
        /// </summary>
        public static string Globalization_ci_de_DE_phoneb
        {
            get { return Resource.Globalization_ci_de_DE_phoneb; }
        }

        /// <summary>
        ///   Looks up a localized string similar to German (Liechtenstein).
        /// </summary>
        public static string Globalization_ci_de_LI
        {
            get { return Resource.Globalization_ci_de_LI; }
        }

        /// <summary>
        ///   Looks up a localized string similar to German (Luxembourg).
        /// </summary>
        public static string Globalization_ci_de_LU
        {
            get { return Resource.Globalization_ci_de_LU; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Zarma.
        /// </summary>
        public static string Globalization_ci_dje
        {
            get { return Resource.Globalization_ci_dje; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Zarma (Niger).
        /// </summary>
        public static string Globalization_ci_dje_NE
        {
            get { return Resource.Globalization_ci_dje_NE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Lower Sorbian.
        /// </summary>
        public static string Globalization_ci_dsb
        {
            get { return Resource.Globalization_ci_dsb; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Lower Sorbian (Germany).
        /// </summary>
        public static string Globalization_ci_dsb_DE
        {
            get { return Resource.Globalization_ci_dsb_DE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Duala.
        /// </summary>
        public static string Globalization_ci_dua
        {
            get { return Resource.Globalization_ci_dua; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Duala (Cameroon).
        /// </summary>
        public static string Globalization_ci_dua_CM
        {
            get { return Resource.Globalization_ci_dua_CM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Divehi.
        /// </summary>
        public static string Globalization_ci_dv
        {
            get { return Resource.Globalization_ci_dv; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Divehi (Maldives).
        /// </summary>
        public static string Globalization_ci_dv_MV
        {
            get { return Resource.Globalization_ci_dv_MV; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Jola-Fonyi.
        /// </summary>
        public static string Globalization_ci_dyo
        {
            get { return Resource.Globalization_ci_dyo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Jola-Fonyi (Senegal).
        /// </summary>
        public static string Globalization_ci_dyo_SN
        {
            get { return Resource.Globalization_ci_dyo_SN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Dzongkha.
        /// </summary>
        public static string Globalization_ci_dz
        {
            get { return Resource.Globalization_ci_dz; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Dzongkha (Bhutan).
        /// </summary>
        public static string Globalization_ci_dz_BT
        {
            get { return Resource.Globalization_ci_dz_BT; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Embu.
        /// </summary>
        public static string Globalization_ci_ebu
        {
            get { return Resource.Globalization_ci_ebu; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Embu (Kenya).
        /// </summary>
        public static string Globalization_ci_ebu_KE
        {
            get { return Resource.Globalization_ci_ebu_KE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Ewe.
        /// </summary>
        public static string Globalization_ci_ee
        {
            get { return Resource.Globalization_ci_ee; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Ewe (Ghana).
        /// </summary>
        public static string Globalization_ci_ee_GH
        {
            get { return Resource.Globalization_ci_ee_GH; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Ewe (Togo).
        /// </summary>
        public static string Globalization_ci_ee_TG
        {
            get { return Resource.Globalization_ci_ee_TG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Greek.
        /// </summary>
        public static string Globalization_ci_el
        {
            get { return Resource.Globalization_ci_el; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Greek (Cyprus).
        /// </summary>
        public static string Globalization_ci_el_CY
        {
            get { return Resource.Globalization_ci_el_CY; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Greek (Greece).
        /// </summary>
        public static string Globalization_ci_el_GR
        {
            get { return Resource.Globalization_ci_el_GR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English.
        /// </summary>
        public static string Globalization_ci_en
        {
            get { return Resource.Globalization_ci_en; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (World).
        /// </summary>
        public static string Globalization_ci_en_001
        {
            get { return Resource.Globalization_ci_en_001; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Caribbean).
        /// </summary>
        public static string Globalization_ci_en_029
        {
            get { return Resource.Globalization_ci_en_029; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Europe).
        /// </summary>
        public static string Globalization_ci_en_150
        {
            get { return Resource.Globalization_ci_en_150; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Antigua and Barbuda).
        /// </summary>
        public static string Globalization_ci_en_AG
        {
            get { return Resource.Globalization_ci_en_AG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Anguilla).
        /// </summary>
        public static string Globalization_ci_en_AI
        {
            get { return Resource.Globalization_ci_en_AI; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (American Samoa).
        /// </summary>
        public static string Globalization_ci_en_AS
        {
            get { return Resource.Globalization_ci_en_AS; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Australia).
        /// </summary>
        public static string Globalization_ci_en_AU
        {
            get { return Resource.Globalization_ci_en_AU; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Barbados).
        /// </summary>
        public static string Globalization_ci_en_BB
        {
            get { return Resource.Globalization_ci_en_BB; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Belgium).
        /// </summary>
        public static string Globalization_ci_en_BE
        {
            get { return Resource.Globalization_ci_en_BE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Bermuda).
        /// </summary>
        public static string Globalization_ci_en_BM
        {
            get { return Resource.Globalization_ci_en_BM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Bahamas).
        /// </summary>
        public static string Globalization_ci_en_BS
        {
            get { return Resource.Globalization_ci_en_BS; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Botswana).
        /// </summary>
        public static string Globalization_ci_en_BW
        {
            get { return Resource.Globalization_ci_en_BW; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Belize).
        /// </summary>
        public static string Globalization_ci_en_BZ
        {
            get { return Resource.Globalization_ci_en_BZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Canada).
        /// </summary>
        public static string Globalization_ci_en_CA
        {
            get { return Resource.Globalization_ci_en_CA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Cocos [Keeling] Islands).
        /// </summary>
        public static string Globalization_ci_en_CC
        {
            get { return Resource.Globalization_ci_en_CC; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Cook Islands).
        /// </summary>
        public static string Globalization_ci_en_CK
        {
            get { return Resource.Globalization_ci_en_CK; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Cameroon).
        /// </summary>
        public static string Globalization_ci_en_CM
        {
            get { return Resource.Globalization_ci_en_CM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Christmas Island).
        /// </summary>
        public static string Globalization_ci_en_CX
        {
            get { return Resource.Globalization_ci_en_CX; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Dominica).
        /// </summary>
        public static string Globalization_ci_en_DM
        {
            get { return Resource.Globalization_ci_en_DM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Eritrea).
        /// </summary>
        public static string Globalization_ci_en_ER
        {
            get { return Resource.Globalization_ci_en_ER; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Fiji).
        /// </summary>
        public static string Globalization_ci_en_FJ
        {
            get { return Resource.Globalization_ci_en_FJ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Falkland Islands).
        /// </summary>
        public static string Globalization_ci_en_FK
        {
            get { return Resource.Globalization_ci_en_FK; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Micronesia).
        /// </summary>
        public static string Globalization_ci_en_FM
        {
            get { return Resource.Globalization_ci_en_FM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (United Kingdom).
        /// </summary>
        public static string Globalization_ci_en_GB
        {
            get { return Resource.Globalization_ci_en_GB; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Grenada).
        /// </summary>
        public static string Globalization_ci_en_GD
        {
            get { return Resource.Globalization_ci_en_GD; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Guernsey).
        /// </summary>
        public static string Globalization_ci_en_GG
        {
            get { return Resource.Globalization_ci_en_GG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Ghana).
        /// </summary>
        public static string Globalization_ci_en_GH
        {
            get { return Resource.Globalization_ci_en_GH; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Gibraltar).
        /// </summary>
        public static string Globalization_ci_en_GI
        {
            get { return Resource.Globalization_ci_en_GI; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Gambia).
        /// </summary>
        public static string Globalization_ci_en_GM
        {
            get { return Resource.Globalization_ci_en_GM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Guam).
        /// </summary>
        public static string Globalization_ci_en_GU
        {
            get { return Resource.Globalization_ci_en_GU; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Guyana).
        /// </summary>
        public static string Globalization_ci_en_GY
        {
            get { return Resource.Globalization_ci_en_GY; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Hong Kong SAR).
        /// </summary>
        public static string Globalization_ci_en_HK
        {
            get { return Resource.Globalization_ci_en_HK; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Ireland).
        /// </summary>
        public static string Globalization_ci_en_IE
        {
            get { return Resource.Globalization_ci_en_IE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Isle of Man).
        /// </summary>
        public static string Globalization_ci_en_IM
        {
            get { return Resource.Globalization_ci_en_IM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (India).
        /// </summary>
        public static string Globalization_ci_en_IN
        {
            get { return Resource.Globalization_ci_en_IN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (British Indian Ocean Territory).
        /// </summary>
        public static string Globalization_ci_en_IO
        {
            get { return Resource.Globalization_ci_en_IO; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Jersey).
        /// </summary>
        public static string Globalization_ci_en_JE
        {
            get { return Resource.Globalization_ci_en_JE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Jamaica).
        /// </summary>
        public static string Globalization_ci_en_JM
        {
            get { return Resource.Globalization_ci_en_JM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Kenya).
        /// </summary>
        public static string Globalization_ci_en_KE
        {
            get { return Resource.Globalization_ci_en_KE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Kiribati).
        /// </summary>
        public static string Globalization_ci_en_KI
        {
            get { return Resource.Globalization_ci_en_KI; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Saint Kitts and Nevis).
        /// </summary>
        public static string Globalization_ci_en_KN
        {
            get { return Resource.Globalization_ci_en_KN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Cayman Islands).
        /// </summary>
        public static string Globalization_ci_en_KY
        {
            get { return Resource.Globalization_ci_en_KY; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Saint Lucia).
        /// </summary>
        public static string Globalization_ci_en_LC
        {
            get { return Resource.Globalization_ci_en_LC; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Liberia).
        /// </summary>
        public static string Globalization_ci_en_LR
        {
            get { return Resource.Globalization_ci_en_LR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Lesotho).
        /// </summary>
        public static string Globalization_ci_en_LS
        {
            get { return Resource.Globalization_ci_en_LS; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Madagascar).
        /// </summary>
        public static string Globalization_ci_en_MG
        {
            get { return Resource.Globalization_ci_en_MG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Marshall Islands).
        /// </summary>
        public static string Globalization_ci_en_MH
        {
            get { return Resource.Globalization_ci_en_MH; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Macao SAR).
        /// </summary>
        public static string Globalization_ci_en_MO
        {
            get { return Resource.Globalization_ci_en_MO; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Northern Mariana Islands).
        /// </summary>
        public static string Globalization_ci_en_MP
        {
            get { return Resource.Globalization_ci_en_MP; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Montserrat).
        /// </summary>
        public static string Globalization_ci_en_MS
        {
            get { return Resource.Globalization_ci_en_MS; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Malta).
        /// </summary>
        public static string Globalization_ci_en_MT
        {
            get { return Resource.Globalization_ci_en_MT; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Mauritius).
        /// </summary>
        public static string Globalization_ci_en_MU
        {
            get { return Resource.Globalization_ci_en_MU; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Malawi).
        /// </summary>
        public static string Globalization_ci_en_MW
        {
            get { return Resource.Globalization_ci_en_MW; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Malaysia).
        /// </summary>
        public static string Globalization_ci_en_MY
        {
            get { return Resource.Globalization_ci_en_MY; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Namibia).
        /// </summary>
        public static string Globalization_ci_en_NA
        {
            get { return Resource.Globalization_ci_en_NA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Norfolk Island).
        /// </summary>
        public static string Globalization_ci_en_NF
        {
            get { return Resource.Globalization_ci_en_NF; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Nigeria).
        /// </summary>
        public static string Globalization_ci_en_NG
        {
            get { return Resource.Globalization_ci_en_NG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Nauru).
        /// </summary>
        public static string Globalization_ci_en_NR
        {
            get { return Resource.Globalization_ci_en_NR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Niue).
        /// </summary>
        public static string Globalization_ci_en_NU
        {
            get { return Resource.Globalization_ci_en_NU; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (New Zealand).
        /// </summary>
        public static string Globalization_ci_en_NZ
        {
            get { return Resource.Globalization_ci_en_NZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Papua New Guinea).
        /// </summary>
        public static string Globalization_ci_en_PG
        {
            get { return Resource.Globalization_ci_en_PG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Republic of the Philippines).
        /// </summary>
        public static string Globalization_ci_en_PH
        {
            get { return Resource.Globalization_ci_en_PH; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Pakistan).
        /// </summary>
        public static string Globalization_ci_en_PK
        {
            get { return Resource.Globalization_ci_en_PK; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Pitcairn Islands).
        /// </summary>
        public static string Globalization_ci_en_PN
        {
            get { return Resource.Globalization_ci_en_PN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Puerto Rico).
        /// </summary>
        public static string Globalization_ci_en_PR
        {
            get { return Resource.Globalization_ci_en_PR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Palau).
        /// </summary>
        public static string Globalization_ci_en_PW
        {
            get { return Resource.Globalization_ci_en_PW; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Rwanda).
        /// </summary>
        public static string Globalization_ci_en_RW
        {
            get { return Resource.Globalization_ci_en_RW; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Solomon Islands).
        /// </summary>
        public static string Globalization_ci_en_SB
        {
            get { return Resource.Globalization_ci_en_SB; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Seychelles).
        /// </summary>
        public static string Globalization_ci_en_SC
        {
            get { return Resource.Globalization_ci_en_SC; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Sudan).
        /// </summary>
        public static string Globalization_ci_en_SD
        {
            get { return Resource.Globalization_ci_en_SD; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Singapore).
        /// </summary>
        public static string Globalization_ci_en_SG
        {
            get { return Resource.Globalization_ci_en_SG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (St Helena, Ascension, Tristan da Cunha).
        /// </summary>
        public static string Globalization_ci_en_SH
        {
            get { return Resource.Globalization_ci_en_SH; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Sierra Leone).
        /// </summary>
        public static string Globalization_ci_en_SL
        {
            get { return Resource.Globalization_ci_en_SL; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (South Sudan).
        /// </summary>
        public static string Globalization_ci_en_SS
        {
            get { return Resource.Globalization_ci_en_SS; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Sint Maarten).
        /// </summary>
        public static string Globalization_ci_en_SX
        {
            get { return Resource.Globalization_ci_en_SX; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Swaziland).
        /// </summary>
        public static string Globalization_ci_en_SZ
        {
            get { return Resource.Globalization_ci_en_SZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Turks and Caicos Islands).
        /// </summary>
        public static string Globalization_ci_en_TC
        {
            get { return Resource.Globalization_ci_en_TC; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Tokelau).
        /// </summary>
        public static string Globalization_ci_en_TK
        {
            get { return Resource.Globalization_ci_en_TK; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Tonga).
        /// </summary>
        public static string Globalization_ci_en_TO
        {
            get { return Resource.Globalization_ci_en_TO; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Trinidad and Tobago).
        /// </summary>
        public static string Globalization_ci_en_TT
        {
            get { return Resource.Globalization_ci_en_TT; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Tuvalu).
        /// </summary>
        public static string Globalization_ci_en_TV
        {
            get { return Resource.Globalization_ci_en_TV; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Tanzania).
        /// </summary>
        public static string Globalization_ci_en_TZ
        {
            get { return Resource.Globalization_ci_en_TZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Uganda).
        /// </summary>
        public static string Globalization_ci_en_UG
        {
            get { return Resource.Globalization_ci_en_UG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (US Minor Outlying Islands).
        /// </summary>
        public static string Globalization_ci_en_UM
        {
            get { return Resource.Globalization_ci_en_UM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (United States).
        /// </summary>
        public static string Globalization_ci_en_US
        {
            get { return Resource.Globalization_ci_en_US; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Saint Vincent and the Grenadines).
        /// </summary>
        public static string Globalization_ci_en_VC
        {
            get { return Resource.Globalization_ci_en_VC; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (British Virgin Islands).
        /// </summary>
        public static string Globalization_ci_en_VG
        {
            get { return Resource.Globalization_ci_en_VG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (US Virgin Islands).
        /// </summary>
        public static string Globalization_ci_en_VI
        {
            get { return Resource.Globalization_ci_en_VI; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Vanuatu).
        /// </summary>
        public static string Globalization_ci_en_VU
        {
            get { return Resource.Globalization_ci_en_VU; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Samoa).
        /// </summary>
        public static string Globalization_ci_en_WS
        {
            get { return Resource.Globalization_ci_en_WS; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (South Africa).
        /// </summary>
        public static string Globalization_ci_en_ZA
        {
            get { return Resource.Globalization_ci_en_ZA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Zambia).
        /// </summary>
        public static string Globalization_ci_en_ZM
        {
            get { return Resource.Globalization_ci_en_ZM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to English (Zimbabwe).
        /// </summary>
        public static string Globalization_ci_en_ZW
        {
            get { return Resource.Globalization_ci_en_ZW; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Esperanto.
        /// </summary>
        public static string Globalization_ci_eo
        {
            get { return Resource.Globalization_ci_eo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Esperanto (World).
        /// </summary>
        public static string Globalization_ci_eo_001
        {
            get { return Resource.Globalization_ci_eo_001; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Spanish.
        /// </summary>
        public static string Globalization_ci_es
        {
            get { return Resource.Globalization_ci_es; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Spanish (Latin America).
        /// </summary>
        public static string Globalization_ci_es_419
        {
            get { return Resource.Globalization_ci_es_419; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Spanish (Argentina).
        /// </summary>
        public static string Globalization_ci_es_AR
        {
            get { return Resource.Globalization_ci_es_AR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Spanish (Bolivia).
        /// </summary>
        public static string Globalization_ci_es_BO
        {
            get { return Resource.Globalization_ci_es_BO; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Spanish (Chile).
        /// </summary>
        public static string Globalization_ci_es_CL
        {
            get { return Resource.Globalization_ci_es_CL; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Spanish (Colombia).
        /// </summary>
        public static string Globalization_ci_es_CO
        {
            get { return Resource.Globalization_ci_es_CO; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Spanish (Costa Rica).
        /// </summary>
        public static string Globalization_ci_es_CR
        {
            get { return Resource.Globalization_ci_es_CR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Spanish (Cuba).
        /// </summary>
        public static string Globalization_ci_es_CU
        {
            get { return Resource.Globalization_ci_es_CU; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Spanish (Dominican Republic).
        /// </summary>
        public static string Globalization_ci_es_DO
        {
            get { return Resource.Globalization_ci_es_DO; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Spanish (Ecuador).
        /// </summary>
        public static string Globalization_ci_es_EC
        {
            get { return Resource.Globalization_ci_es_EC; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Spanish (Spain).
        /// </summary>
        public static string Globalization_ci_es_ES
        {
            get { return Resource.Globalization_ci_es_ES; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Spanish (Spain).
        /// </summary>
        public static string Globalization_ci_es_ES_tradnl
        {
            get { return Resource.Globalization_ci_es_ES_tradnl; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Spanish (Equatorial Guinea).
        /// </summary>
        public static string Globalization_ci_es_GQ
        {
            get { return Resource.Globalization_ci_es_GQ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Spanish (Guatemala).
        /// </summary>
        public static string Globalization_ci_es_GT
        {
            get { return Resource.Globalization_ci_es_GT; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Spanish (Honduras).
        /// </summary>
        public static string Globalization_ci_es_HN
        {
            get { return Resource.Globalization_ci_es_HN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Spanish (Mexico).
        /// </summary>
        public static string Globalization_ci_es_MX
        {
            get { return Resource.Globalization_ci_es_MX; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Spanish (Nicaragua).
        /// </summary>
        public static string Globalization_ci_es_NI
        {
            get { return Resource.Globalization_ci_es_NI; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Spanish (Panama).
        /// </summary>
        public static string Globalization_ci_es_PA
        {
            get { return Resource.Globalization_ci_es_PA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Spanish (Peru).
        /// </summary>
        public static string Globalization_ci_es_PE
        {
            get { return Resource.Globalization_ci_es_PE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Spanish (Philippines).
        /// </summary>
        public static string Globalization_ci_es_PH
        {
            get { return Resource.Globalization_ci_es_PH; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Spanish (Puerto Rico).
        /// </summary>
        public static string Globalization_ci_es_PR
        {
            get { return Resource.Globalization_ci_es_PR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Spanish (Paraguay).
        /// </summary>
        public static string Globalization_ci_es_PY
        {
            get { return Resource.Globalization_ci_es_PY; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Spanish (El Salvador).
        /// </summary>
        public static string Globalization_ci_es_SV
        {
            get { return Resource.Globalization_ci_es_SV; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Spanish (United States).
        /// </summary>
        public static string Globalization_ci_es_US
        {
            get { return Resource.Globalization_ci_es_US; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Spanish (Uruguay).
        /// </summary>
        public static string Globalization_ci_es_UY
        {
            get { return Resource.Globalization_ci_es_UY; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Spanish (Bolivarian Republic of Venezuela).
        /// </summary>
        public static string Globalization_ci_es_VE
        {
            get { return Resource.Globalization_ci_es_VE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Estonian.
        /// </summary>
        public static string Globalization_ci_et
        {
            get { return Resource.Globalization_ci_et; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Estonian (Estonia).
        /// </summary>
        public static string Globalization_ci_et_EE
        {
            get { return Resource.Globalization_ci_et_EE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Basque.
        /// </summary>
        public static string Globalization_ci_eu
        {
            get { return Resource.Globalization_ci_eu; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Basque (Basque).
        /// </summary>
        public static string Globalization_ci_eu_ES
        {
            get { return Resource.Globalization_ci_eu_ES; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Ewondo.
        /// </summary>
        public static string Globalization_ci_ewo
        {
            get { return Resource.Globalization_ci_ewo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Ewondo (Cameroon).
        /// </summary>
        public static string Globalization_ci_ewo_CM
        {
            get { return Resource.Globalization_ci_ewo_CM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Persian.
        /// </summary>
        public static string Globalization_ci_fa
        {
            get { return Resource.Globalization_ci_fa; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Persian (Afghanistan).
        /// </summary>
        public static string Globalization_ci_fa_AF
        {
            get { return Resource.Globalization_ci_fa_AF; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Persian (Iran).
        /// </summary>
        public static string Globalization_ci_fa_IR
        {
            get { return Resource.Globalization_ci_fa_IR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Fulah.
        /// </summary>
        public static string Globalization_ci_ff
        {
            get { return Resource.Globalization_ci_ff; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Fulah (Cameroon).
        /// </summary>
        public static string Globalization_ci_ff_CM
        {
            get { return Resource.Globalization_ci_ff_CM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Fulah (Guinea).
        /// </summary>
        public static string Globalization_ci_ff_GN
        {
            get { return Resource.Globalization_ci_ff_GN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Fulah (Latin).
        /// </summary>
        public static string Globalization_ci_ff_Latn
        {
            get { return Resource.Globalization_ci_ff_Latn; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Fulah (Latin, Senegal).
        /// </summary>
        public static string Globalization_ci_ff_Latn_SN
        {
            get { return Resource.Globalization_ci_ff_Latn_SN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Fulah (Mauritania).
        /// </summary>
        public static string Globalization_ci_ff_MR
        {
            get { return Resource.Globalization_ci_ff_MR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Finnish.
        /// </summary>
        public static string Globalization_ci_fi
        {
            get { return Resource.Globalization_ci_fi; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Finnish (Finland).
        /// </summary>
        public static string Globalization_ci_fi_FI
        {
            get { return Resource.Globalization_ci_fi_FI; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Filipino.
        /// </summary>
        public static string Globalization_ci_fil
        {
            get { return Resource.Globalization_ci_fil; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Filipino (Philippines).
        /// </summary>
        public static string Globalization_ci_fil_PH
        {
            get { return Resource.Globalization_ci_fil_PH; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Faroese.
        /// </summary>
        public static string Globalization_ci_fo
        {
            get { return Resource.Globalization_ci_fo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Faroese (Faroe Islands).
        /// </summary>
        public static string Globalization_ci_fo_FO
        {
            get { return Resource.Globalization_ci_fo_FO; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French.
        /// </summary>
        public static string Globalization_ci_fr
        {
            get { return Resource.Globalization_ci_fr; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Belgium).
        /// </summary>
        public static string Globalization_ci_fr_BE
        {
            get { return Resource.Globalization_ci_fr_BE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Burkina Faso).
        /// </summary>
        public static string Globalization_ci_fr_BF
        {
            get { return Resource.Globalization_ci_fr_BF; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Burundi).
        /// </summary>
        public static string Globalization_ci_fr_BI
        {
            get { return Resource.Globalization_ci_fr_BI; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Benin).
        /// </summary>
        public static string Globalization_ci_fr_BJ
        {
            get { return Resource.Globalization_ci_fr_BJ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Saint Barthélemy).
        /// </summary>
        public static string Globalization_ci_fr_BL
        {
            get { return Resource.Globalization_ci_fr_BL; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Canada).
        /// </summary>
        public static string Globalization_ci_fr_CA
        {
            get { return Resource.Globalization_ci_fr_CA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Congo DRC).
        /// </summary>
        public static string Globalization_ci_fr_CD
        {
            get { return Resource.Globalization_ci_fr_CD; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Central African Republic).
        /// </summary>
        public static string Globalization_ci_fr_CF
        {
            get { return Resource.Globalization_ci_fr_CF; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Congo).
        /// </summary>
        public static string Globalization_ci_fr_CG
        {
            get { return Resource.Globalization_ci_fr_CG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Switzerland).
        /// </summary>
        public static string Globalization_ci_fr_CH
        {
            get { return Resource.Globalization_ci_fr_CH; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Côte d’Ivoire).
        /// </summary>
        public static string Globalization_ci_fr_CI
        {
            get { return Resource.Globalization_ci_fr_CI; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Cameroon).
        /// </summary>
        public static string Globalization_ci_fr_CM
        {
            get { return Resource.Globalization_ci_fr_CM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Djibouti).
        /// </summary>
        public static string Globalization_ci_fr_DJ
        {
            get { return Resource.Globalization_ci_fr_DJ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Algeria).
        /// </summary>
        public static string Globalization_ci_fr_DZ
        {
            get { return Resource.Globalization_ci_fr_DZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (France).
        /// </summary>
        public static string Globalization_ci_fr_FR
        {
            get { return Resource.Globalization_ci_fr_FR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Gabon).
        /// </summary>
        public static string Globalization_ci_fr_GA
        {
            get { return Resource.Globalization_ci_fr_GA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (French Guiana).
        /// </summary>
        public static string Globalization_ci_fr_GF
        {
            get { return Resource.Globalization_ci_fr_GF; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Guinea).
        /// </summary>
        public static string Globalization_ci_fr_GN
        {
            get { return Resource.Globalization_ci_fr_GN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Guadeloupe).
        /// </summary>
        public static string Globalization_ci_fr_GP
        {
            get { return Resource.Globalization_ci_fr_GP; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Equatorial Guinea).
        /// </summary>
        public static string Globalization_ci_fr_GQ
        {
            get { return Resource.Globalization_ci_fr_GQ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Haiti).
        /// </summary>
        public static string Globalization_ci_fr_HT
        {
            get { return Resource.Globalization_ci_fr_HT; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Comoros).
        /// </summary>
        public static string Globalization_ci_fr_KM
        {
            get { return Resource.Globalization_ci_fr_KM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Luxembourg).
        /// </summary>
        public static string Globalization_ci_fr_LU
        {
            get { return Resource.Globalization_ci_fr_LU; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Morocco).
        /// </summary>
        public static string Globalization_ci_fr_MA
        {
            get { return Resource.Globalization_ci_fr_MA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Monaco).
        /// </summary>
        public static string Globalization_ci_fr_MC
        {
            get { return Resource.Globalization_ci_fr_MC; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Saint Martin).
        /// </summary>
        public static string Globalization_ci_fr_MF
        {
            get { return Resource.Globalization_ci_fr_MF; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Madagascar).
        /// </summary>
        public static string Globalization_ci_fr_MG
        {
            get { return Resource.Globalization_ci_fr_MG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Mali).
        /// </summary>
        public static string Globalization_ci_fr_ML
        {
            get { return Resource.Globalization_ci_fr_ML; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Martinique).
        /// </summary>
        public static string Globalization_ci_fr_MQ
        {
            get { return Resource.Globalization_ci_fr_MQ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Mauritania).
        /// </summary>
        public static string Globalization_ci_fr_MR
        {
            get { return Resource.Globalization_ci_fr_MR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Mauritius).
        /// </summary>
        public static string Globalization_ci_fr_MU
        {
            get { return Resource.Globalization_ci_fr_MU; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (New Caledonia).
        /// </summary>
        public static string Globalization_ci_fr_NC
        {
            get { return Resource.Globalization_ci_fr_NC; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Niger).
        /// </summary>
        public static string Globalization_ci_fr_NE
        {
            get { return Resource.Globalization_ci_fr_NE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (French Polynesia).
        /// </summary>
        public static string Globalization_ci_fr_PF
        {
            get { return Resource.Globalization_ci_fr_PF; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Saint Pierre and Miquelon).
        /// </summary>
        public static string Globalization_ci_fr_PM
        {
            get { return Resource.Globalization_ci_fr_PM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Reunion).
        /// </summary>
        public static string Globalization_ci_fr_RE
        {
            get { return Resource.Globalization_ci_fr_RE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Rwanda).
        /// </summary>
        public static string Globalization_ci_fr_RW
        {
            get { return Resource.Globalization_ci_fr_RW; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Seychelles).
        /// </summary>
        public static string Globalization_ci_fr_SC
        {
            get { return Resource.Globalization_ci_fr_SC; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Senegal).
        /// </summary>
        public static string Globalization_ci_fr_SN
        {
            get { return Resource.Globalization_ci_fr_SN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Syria).
        /// </summary>
        public static string Globalization_ci_fr_SY
        {
            get { return Resource.Globalization_ci_fr_SY; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Chad).
        /// </summary>
        public static string Globalization_ci_fr_TD
        {
            get { return Resource.Globalization_ci_fr_TD; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Togo).
        /// </summary>
        public static string Globalization_ci_fr_TG
        {
            get { return Resource.Globalization_ci_fr_TG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Tunisia).
        /// </summary>
        public static string Globalization_ci_fr_TN
        {
            get { return Resource.Globalization_ci_fr_TN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Vanuatu).
        /// </summary>
        public static string Globalization_ci_fr_VU
        {
            get { return Resource.Globalization_ci_fr_VU; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Wallis and Futuna).
        /// </summary>
        public static string Globalization_ci_fr_WF
        {
            get { return Resource.Globalization_ci_fr_WF; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French (Mayotte).
        /// </summary>
        public static string Globalization_ci_fr_YT
        {
            get { return Resource.Globalization_ci_fr_YT; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Friulian.
        /// </summary>
        public static string Globalization_ci_fur
        {
            get { return Resource.Globalization_ci_fur; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Friulian (Italy).
        /// </summary>
        public static string Globalization_ci_fur_IT
        {
            get { return Resource.Globalization_ci_fur_IT; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Frisian.
        /// </summary>
        public static string Globalization_ci_fy
        {
            get { return Resource.Globalization_ci_fy; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Frisian (Netherlands).
        /// </summary>
        public static string Globalization_ci_fy_NL
        {
            get { return Resource.Globalization_ci_fy_NL; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Irish.
        /// </summary>
        public static string Globalization_ci_ga
        {
            get { return Resource.Globalization_ci_ga; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Irish (Ireland).
        /// </summary>
        public static string Globalization_ci_ga_IE
        {
            get { return Resource.Globalization_ci_ga_IE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Scottish Gaelic.
        /// </summary>
        public static string Globalization_ci_gd
        {
            get { return Resource.Globalization_ci_gd; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Scottish Gaelic (United Kingdom).
        /// </summary>
        public static string Globalization_ci_gd_GB
        {
            get { return Resource.Globalization_ci_gd_GB; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Galician.
        /// </summary>
        public static string Globalization_ci_gl
        {
            get { return Resource.Globalization_ci_gl; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Galician (Galician).
        /// </summary>
        public static string Globalization_ci_gl_ES
        {
            get { return Resource.Globalization_ci_gl_ES; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Guarani.
        /// </summary>
        public static string Globalization_ci_gn
        {
            get { return Resource.Globalization_ci_gn; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Guarani (Paraguay).
        /// </summary>
        public static string Globalization_ci_gn_PY
        {
            get { return Resource.Globalization_ci_gn_PY; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Alsatian.
        /// </summary>
        public static string Globalization_ci_gsw
        {
            get { return Resource.Globalization_ci_gsw; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Alsatian (Switzerland).
        /// </summary>
        public static string Globalization_ci_gsw_CH
        {
            get { return Resource.Globalization_ci_gsw_CH; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Alsatian (France).
        /// </summary>
        public static string Globalization_ci_gsw_FR
        {
            get { return Resource.Globalization_ci_gsw_FR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Alsatian (Liechtenstein).
        /// </summary>
        public static string Globalization_ci_gsw_LI
        {
            get { return Resource.Globalization_ci_gsw_LI; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Gujarati.
        /// </summary>
        public static string Globalization_ci_gu
        {
            get { return Resource.Globalization_ci_gu; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Gujarati (India).
        /// </summary>
        public static string Globalization_ci_gu_IN
        {
            get { return Resource.Globalization_ci_gu_IN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Gusii.
        /// </summary>
        public static string Globalization_ci_guz
        {
            get { return Resource.Globalization_ci_guz; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Gusii (Kenya).
        /// </summary>
        public static string Globalization_ci_guz_KE
        {
            get { return Resource.Globalization_ci_guz_KE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Manx.
        /// </summary>
        public static string Globalization_ci_gv
        {
            get { return Resource.Globalization_ci_gv; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Manx (Isle of Man).
        /// </summary>
        public static string Globalization_ci_gv_IM
        {
            get { return Resource.Globalization_ci_gv_IM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Hausa.
        /// </summary>
        public static string Globalization_ci_ha
        {
            get { return Resource.Globalization_ci_ha; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Hausa (Latin).
        /// </summary>
        public static string Globalization_ci_ha_Latn
        {
            get { return Resource.Globalization_ci_ha_Latn; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Hausa (Latin, Ghana).
        /// </summary>
        public static string Globalization_ci_ha_Latn_GH
        {
            get { return Resource.Globalization_ci_ha_Latn_GH; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Hausa (Latin, Niger).
        /// </summary>
        public static string Globalization_ci_ha_Latn_NE
        {
            get { return Resource.Globalization_ci_ha_Latn_NE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Hausa (Latin, Nigeria).
        /// </summary>
        public static string Globalization_ci_ha_Latn_NG
        {
            get { return Resource.Globalization_ci_ha_Latn_NG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Hawaiian.
        /// </summary>
        public static string Globalization_ci_haw
        {
            get { return Resource.Globalization_ci_haw; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Hawaiian (United States).
        /// </summary>
        public static string Globalization_ci_haw_US
        {
            get { return Resource.Globalization_ci_haw_US; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Hebrew.
        /// </summary>
        public static string Globalization_ci_he
        {
            get { return Resource.Globalization_ci_he; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Hebrew (Israel).
        /// </summary>
        public static string Globalization_ci_he_IL
        {
            get { return Resource.Globalization_ci_he_IL; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Hindi.
        /// </summary>
        public static string Globalization_ci_hi
        {
            get { return Resource.Globalization_ci_hi; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Hindi (India).
        /// </summary>
        public static string Globalization_ci_hi_IN
        {
            get { return Resource.Globalization_ci_hi_IN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Croatian.
        /// </summary>
        public static string Globalization_ci_hr
        {
            get { return Resource.Globalization_ci_hr; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Croatian (Latin, Bosnia and Herzegovina).
        /// </summary>
        public static string Globalization_ci_hr_BA
        {
            get { return Resource.Globalization_ci_hr_BA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Croatian (Croatia).
        /// </summary>
        public static string Globalization_ci_hr_HR
        {
            get { return Resource.Globalization_ci_hr_HR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Upper Sorbian.
        /// </summary>
        public static string Globalization_ci_hsb
        {
            get { return Resource.Globalization_ci_hsb; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Upper Sorbian (Germany).
        /// </summary>
        public static string Globalization_ci_hsb_DE
        {
            get { return Resource.Globalization_ci_hsb_DE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Hungarian.
        /// </summary>
        public static string Globalization_ci_hu
        {
            get { return Resource.Globalization_ci_hu; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Hungarian (Hungary).
        /// </summary>
        public static string Globalization_ci_hu_HU
        {
            get { return Resource.Globalization_ci_hu_HU; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Hungarian (Hungary).
        /// </summary>
        public static string Globalization_ci_hu_HU_technl
        {
            get { return Resource.Globalization_ci_hu_HU_technl; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Armenian.
        /// </summary>
        public static string Globalization_ci_hy
        {
            get { return Resource.Globalization_ci_hy; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Armenian (Armenia).
        /// </summary>
        public static string Globalization_ci_hy_AM
        {
            get { return Resource.Globalization_ci_hy_AM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Interlingua.
        /// </summary>
        public static string Globalization_ci_ia
        {
            get { return Resource.Globalization_ci_ia; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Interlingua (World).
        /// </summary>
        public static string Globalization_ci_ia_001
        {
            get { return Resource.Globalization_ci_ia_001; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Interlingua (France).
        /// </summary>
        public static string Globalization_ci_ia_FR
        {
            get { return Resource.Globalization_ci_ia_FR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Indonesian.
        /// </summary>
        public static string Globalization_ci_id
        {
            get { return Resource.Globalization_ci_id; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Indonesian (Indonesia).
        /// </summary>
        public static string Globalization_ci_id_ID
        {
            get { return Resource.Globalization_ci_id_ID; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Igbo.
        /// </summary>
        public static string Globalization_ci_ig
        {
            get { return Resource.Globalization_ci_ig; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Igbo (Nigeria).
        /// </summary>
        public static string Globalization_ci_ig_NG
        {
            get { return Resource.Globalization_ci_ig_NG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Yi.
        /// </summary>
        public static string Globalization_ci_ii
        {
            get { return Resource.Globalization_ci_ii; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Yi (PRC).
        /// </summary>
        public static string Globalization_ci_ii_CN
        {
            get { return Resource.Globalization_ci_ii_CN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Icelandic.
        /// </summary>
        public static string Globalization_ci_is
        {
            get { return Resource.Globalization_ci_is; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Icelandic (Iceland).
        /// </summary>
        public static string Globalization_ci_is_IS
        {
            get { return Resource.Globalization_ci_is_IS; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Italian.
        /// </summary>
        public static string Globalization_ci_it
        {
            get { return Resource.Globalization_ci_it; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Italian (Switzerland).
        /// </summary>
        public static string Globalization_ci_it_CH
        {
            get { return Resource.Globalization_ci_it_CH; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Italian (Italy).
        /// </summary>
        public static string Globalization_ci_it_IT
        {
            get { return Resource.Globalization_ci_it_IT; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Italian (San Marino).
        /// </summary>
        public static string Globalization_ci_it_SM
        {
            get { return Resource.Globalization_ci_it_SM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Inuktitut.
        /// </summary>
        public static string Globalization_ci_iu
        {
            get { return Resource.Globalization_ci_iu; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Inuktitut (Syllabics).
        /// </summary>
        public static string Globalization_ci_iu_Cans
        {
            get { return Resource.Globalization_ci_iu_Cans; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Inuktitut (Syllabics, Canada).
        /// </summary>
        public static string Globalization_ci_iu_Cans_CA
        {
            get { return Resource.Globalization_ci_iu_Cans_CA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Inuktitut (Latin).
        /// </summary>
        public static string Globalization_ci_iu_Latn
        {
            get { return Resource.Globalization_ci_iu_Latn; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Inuktitut (Latin, Canada).
        /// </summary>
        public static string Globalization_ci_iu_Latn_CA
        {
            get { return Resource.Globalization_ci_iu_Latn_CA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Japanese.
        /// </summary>
        public static string Globalization_ci_ja
        {
            get { return Resource.Globalization_ci_ja; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Japanese (Japan).
        /// </summary>
        public static string Globalization_ci_ja_JP
        {
            get { return Resource.Globalization_ci_ja_JP; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Japanese (Japan).
        /// </summary>
        public static string Globalization_ci_ja_JP_radstr
        {
            get { return Resource.Globalization_ci_ja_JP_radstr; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Ngomba.
        /// </summary>
        public static string Globalization_ci_jgo
        {
            get { return Resource.Globalization_ci_jgo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Ngomba (Cameroon).
        /// </summary>
        public static string Globalization_ci_jgo_CM
        {
            get { return Resource.Globalization_ci_jgo_CM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Machame.
        /// </summary>
        public static string Globalization_ci_jmc
        {
            get { return Resource.Globalization_ci_jmc; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Machame (Tanzania).
        /// </summary>
        public static string Globalization_ci_jmc_TZ
        {
            get { return Resource.Globalization_ci_jmc_TZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Javanese.
        /// </summary>
        public static string Globalization_ci_jv
        {
            get { return Resource.Globalization_ci_jv; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Javanese.
        /// </summary>
        public static string Globalization_ci_jv_Latn
        {
            get { return Resource.Globalization_ci_jv_Latn; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Javanese (Indonesia).
        /// </summary>
        public static string Globalization_ci_jv_Latn_ID
        {
            get { return Resource.Globalization_ci_jv_Latn_ID; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Georgian.
        /// </summary>
        public static string Globalization_ci_ka
        {
            get { return Resource.Globalization_ci_ka; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Georgian (Georgia).
        /// </summary>
        public static string Globalization_ci_ka_GE
        {
            get { return Resource.Globalization_ci_ka_GE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Georgian (Georgia).
        /// </summary>
        public static string Globalization_ci_ka_GE_modern
        {
            get { return Resource.Globalization_ci_ka_GE_modern; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Kabyle.
        /// </summary>
        public static string Globalization_ci_kab
        {
            get { return Resource.Globalization_ci_kab; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Kabyle (Algeria).
        /// </summary>
        public static string Globalization_ci_kab_DZ
        {
            get { return Resource.Globalization_ci_kab_DZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Kamba.
        /// </summary>
        public static string Globalization_ci_kam
        {
            get { return Resource.Globalization_ci_kam; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Kamba (Kenya).
        /// </summary>
        public static string Globalization_ci_kam_KE
        {
            get { return Resource.Globalization_ci_kam_KE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Makonde.
        /// </summary>
        public static string Globalization_ci_kde
        {
            get { return Resource.Globalization_ci_kde; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Makonde (Tanzania).
        /// </summary>
        public static string Globalization_ci_kde_TZ
        {
            get { return Resource.Globalization_ci_kde_TZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Kabuverdianu.
        /// </summary>
        public static string Globalization_ci_kea
        {
            get { return Resource.Globalization_ci_kea; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Kabuverdianu (Cabo Verde).
        /// </summary>
        public static string Globalization_ci_kea_CV
        {
            get { return Resource.Globalization_ci_kea_CV; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Koyra Chiini.
        /// </summary>
        public static string Globalization_ci_khq
        {
            get { return Resource.Globalization_ci_khq; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Koyra Chiini (Mali).
        /// </summary>
        public static string Globalization_ci_khq_ML
        {
            get { return Resource.Globalization_ci_khq_ML; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Kikuyu.
        /// </summary>
        public static string Globalization_ci_ki
        {
            get { return Resource.Globalization_ci_ki; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Kikuyu (Kenya).
        /// </summary>
        public static string Globalization_ci_ki_KE
        {
            get { return Resource.Globalization_ci_ki_KE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Kazakh.
        /// </summary>
        public static string Globalization_ci_kk
        {
            get { return Resource.Globalization_ci_kk; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Kazakh (Kazakhstan).
        /// </summary>
        public static string Globalization_ci_kk_KZ
        {
            get { return Resource.Globalization_ci_kk_KZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Kako.
        /// </summary>
        public static string Globalization_ci_kkj
        {
            get { return Resource.Globalization_ci_kkj; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Kako (Cameroon).
        /// </summary>
        public static string Globalization_ci_kkj_CM
        {
            get { return Resource.Globalization_ci_kkj_CM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Greenlandic.
        /// </summary>
        public static string Globalization_ci_kl
        {
            get { return Resource.Globalization_ci_kl; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Greenlandic (Greenland).
        /// </summary>
        public static string Globalization_ci_kl_GL
        {
            get { return Resource.Globalization_ci_kl_GL; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Kalenjin.
        /// </summary>
        public static string Globalization_ci_kln
        {
            get { return Resource.Globalization_ci_kln; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Kalenjin (Kenya).
        /// </summary>
        public static string Globalization_ci_kln_KE
        {
            get { return Resource.Globalization_ci_kln_KE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Khmer.
        /// </summary>
        public static string Globalization_ci_km
        {
            get { return Resource.Globalization_ci_km; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Khmer (Cambodia).
        /// </summary>
        public static string Globalization_ci_km_KH
        {
            get { return Resource.Globalization_ci_km_KH; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Kannada.
        /// </summary>
        public static string Globalization_ci_kn
        {
            get { return Resource.Globalization_ci_kn; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Kannada (India).
        /// </summary>
        public static string Globalization_ci_kn_IN
        {
            get { return Resource.Globalization_ci_kn_IN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Korean.
        /// </summary>
        public static string Globalization_ci_ko
        {
            get { return Resource.Globalization_ci_ko; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Korean (Korea).
        /// </summary>
        public static string Globalization_ci_ko_KR
        {
            get { return Resource.Globalization_ci_ko_KR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Konkani.
        /// </summary>
        public static string Globalization_ci_kok
        {
            get { return Resource.Globalization_ci_kok; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Konkani (India).
        /// </summary>
        public static string Globalization_ci_kok_IN
        {
            get { return Resource.Globalization_ci_kok_IN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Kashmiri.
        /// </summary>
        public static string Globalization_ci_ks
        {
            get { return Resource.Globalization_ci_ks; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Kashmiri (Perso-Arabic).
        /// </summary>
        public static string Globalization_ci_ks_Arab
        {
            get { return Resource.Globalization_ci_ks_Arab; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Kashmiri (Perso-Arabic).
        /// </summary>
        public static string Globalization_ci_ks_Arab_IN
        {
            get { return Resource.Globalization_ci_ks_Arab_IN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Shambala.
        /// </summary>
        public static string Globalization_ci_ksb
        {
            get { return Resource.Globalization_ci_ksb; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Shambala (Tanzania).
        /// </summary>
        public static string Globalization_ci_ksb_TZ
        {
            get { return Resource.Globalization_ci_ksb_TZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bafia.
        /// </summary>
        public static string Globalization_ci_ksf
        {
            get { return Resource.Globalization_ci_ksf; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bafia (Cameroon).
        /// </summary>
        public static string Globalization_ci_ksf_CM
        {
            get { return Resource.Globalization_ci_ksf_CM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Colognian.
        /// </summary>
        public static string Globalization_ci_ksh
        {
            get { return Resource.Globalization_ci_ksh; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Ripuarian (Germany).
        /// </summary>
        public static string Globalization_ci_ksh_DE
        {
            get { return Resource.Globalization_ci_ksh_DE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Central Kurdish.
        /// </summary>
        public static string Globalization_ci_ku
        {
            get { return Resource.Globalization_ci_ku; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Central Kurdish (Arabic).
        /// </summary>
        public static string Globalization_ci_ku_Arab
        {
            get { return Resource.Globalization_ci_ku_Arab; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Central Kurdish (Iraq).
        /// </summary>
        public static string Globalization_ci_ku_Arab_IQ
        {
            get { return Resource.Globalization_ci_ku_Arab_IQ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cornish.
        /// </summary>
        public static string Globalization_ci_kw
        {
            get { return Resource.Globalization_ci_kw; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cornish (United Kingdom).
        /// </summary>
        public static string Globalization_ci_kw_GB
        {
            get { return Resource.Globalization_ci_kw_GB; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Kyrgyz.
        /// </summary>
        public static string Globalization_ci_ky
        {
            get { return Resource.Globalization_ci_ky; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Kyrgyz (Kyrgyzstan).
        /// </summary>
        public static string Globalization_ci_ky_KG
        {
            get { return Resource.Globalization_ci_ky_KG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Langi.
        /// </summary>
        public static string Globalization_ci_lag
        {
            get { return Resource.Globalization_ci_lag; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Langi (Tanzania).
        /// </summary>
        public static string Globalization_ci_lag_TZ
        {
            get { return Resource.Globalization_ci_lag_TZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Luxembourgish.
        /// </summary>
        public static string Globalization_ci_lb
        {
            get { return Resource.Globalization_ci_lb; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Luxembourgish (Luxembourg).
        /// </summary>
        public static string Globalization_ci_lb_LU
        {
            get { return Resource.Globalization_ci_lb_LU; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Ganda.
        /// </summary>
        public static string Globalization_ci_lg
        {
            get { return Resource.Globalization_ci_lg; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Ganda (Uganda).
        /// </summary>
        public static string Globalization_ci_lg_UG
        {
            get { return Resource.Globalization_ci_lg_UG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Lakota.
        /// </summary>
        public static string Globalization_ci_lkt
        {
            get { return Resource.Globalization_ci_lkt; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Lakota (United States).
        /// </summary>
        public static string Globalization_ci_lkt_US
        {
            get { return Resource.Globalization_ci_lkt_US; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Lingala.
        /// </summary>
        public static string Globalization_ci_ln
        {
            get { return Resource.Globalization_ci_ln; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Lingala (Angola).
        /// </summary>
        public static string Globalization_ci_ln_AO
        {
            get { return Resource.Globalization_ci_ln_AO; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Lingala (Congo DRC).
        /// </summary>
        public static string Globalization_ci_ln_CD
        {
            get { return Resource.Globalization_ci_ln_CD; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Lingala (Central African Republic).
        /// </summary>
        public static string Globalization_ci_ln_CF
        {
            get { return Resource.Globalization_ci_ln_CF; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Lingala (Congo).
        /// </summary>
        public static string Globalization_ci_ln_CG
        {
            get { return Resource.Globalization_ci_ln_CG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Lao.
        /// </summary>
        public static string Globalization_ci_lo
        {
            get { return Resource.Globalization_ci_lo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Lao (Lao P.D.R.).
        /// </summary>
        public static string Globalization_ci_lo_LA
        {
            get { return Resource.Globalization_ci_lo_LA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Lithuanian.
        /// </summary>
        public static string Globalization_ci_lt
        {
            get { return Resource.Globalization_ci_lt; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Lithuanian (Lithuania).
        /// </summary>
        public static string Globalization_ci_lt_LT
        {
            get { return Resource.Globalization_ci_lt_LT; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Luba-Katanga.
        /// </summary>
        public static string Globalization_ci_lu
        {
            get { return Resource.Globalization_ci_lu; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Luba-Katanga (Congo DRC).
        /// </summary>
        public static string Globalization_ci_lu_CD
        {
            get { return Resource.Globalization_ci_lu_CD; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Luo.
        /// </summary>
        public static string Globalization_ci_luo
        {
            get { return Resource.Globalization_ci_luo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Luo (Kenya).
        /// </summary>
        public static string Globalization_ci_luo_KE
        {
            get { return Resource.Globalization_ci_luo_KE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Luyia.
        /// </summary>
        public static string Globalization_ci_luy
        {
            get { return Resource.Globalization_ci_luy; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Luyia (Kenya).
        /// </summary>
        public static string Globalization_ci_luy_KE
        {
            get { return Resource.Globalization_ci_luy_KE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Latvian.
        /// </summary>
        public static string Globalization_ci_lv
        {
            get { return Resource.Globalization_ci_lv; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Latvian (Latvia).
        /// </summary>
        public static string Globalization_ci_lv_LV
        {
            get { return Resource.Globalization_ci_lv_LV; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Masai.
        /// </summary>
        public static string Globalization_ci_mas
        {
            get { return Resource.Globalization_ci_mas; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Masai (Kenya).
        /// </summary>
        public static string Globalization_ci_mas_KE
        {
            get { return Resource.Globalization_ci_mas_KE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Masai (Tanzania).
        /// </summary>
        public static string Globalization_ci_mas_TZ
        {
            get { return Resource.Globalization_ci_mas_TZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Meru.
        /// </summary>
        public static string Globalization_ci_mer
        {
            get { return Resource.Globalization_ci_mer; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Meru (Kenya).
        /// </summary>
        public static string Globalization_ci_mer_KE
        {
            get { return Resource.Globalization_ci_mer_KE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Morisyen.
        /// </summary>
        public static string Globalization_ci_mfe
        {
            get { return Resource.Globalization_ci_mfe; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Morisyen (Mauritius).
        /// </summary>
        public static string Globalization_ci_mfe_MU
        {
            get { return Resource.Globalization_ci_mfe_MU; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Malagasy.
        /// </summary>
        public static string Globalization_ci_mg
        {
            get { return Resource.Globalization_ci_mg; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Malagasy (Madagascar).
        /// </summary>
        public static string Globalization_ci_mg_MG
        {
            get { return Resource.Globalization_ci_mg_MG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Makhuwa_Meetto.
        /// </summary>
        public static string Globalization_ci_mgh
        {
            get { return Resource.Globalization_ci_mgh; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Makhuwa_Meetto (Mozambique).
        /// </summary>
        public static string Globalization_ci_mgh_MZ
        {
            get { return Resource.Globalization_ci_mgh_MZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Meta&apos;.
        /// </summary>
        public static string Globalization_ci_mgo
        {
            get { return Resource.Globalization_ci_mgo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Meta&apos; (Cameroon).
        /// </summary>
        public static string Globalization_ci_mgo_CM
        {
            get { return Resource.Globalization_ci_mgo_CM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Maori.
        /// </summary>
        public static string Globalization_ci_mi
        {
            get { return Resource.Globalization_ci_mi; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Maori (New Zealand).
        /// </summary>
        public static string Globalization_ci_mi_NZ
        {
            get { return Resource.Globalization_ci_mi_NZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Macedonian (FYROM).
        /// </summary>
        public static string Globalization_ci_mk
        {
            get { return Resource.Globalization_ci_mk; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Macedonian (Former Yugoslav Republic of Macedonia).
        /// </summary>
        public static string Globalization_ci_mk_MK
        {
            get { return Resource.Globalization_ci_mk_MK; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Malayalam.
        /// </summary>
        public static string Globalization_ci_ml
        {
            get { return Resource.Globalization_ci_ml; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Malayalam (India).
        /// </summary>
        public static string Globalization_ci_ml_IN
        {
            get { return Resource.Globalization_ci_ml_IN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Mongolian.
        /// </summary>
        public static string Globalization_ci_mn
        {
            get { return Resource.Globalization_ci_mn; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Mongolian (Cyrillic).
        /// </summary>
        public static string Globalization_ci_mn_Cyrl
        {
            get { return Resource.Globalization_ci_mn_Cyrl; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Mongolian (Cyrillic, Mongolia).
        /// </summary>
        public static string Globalization_ci_mn_MN
        {
            get { return Resource.Globalization_ci_mn_MN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Mongolian (Traditional Mongolian).
        /// </summary>
        public static string Globalization_ci_mn_Mong
        {
            get { return Resource.Globalization_ci_mn_Mong; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Mongolian (Traditional Mongolian, PRC).
        /// </summary>
        public static string Globalization_ci_mn_Mong_CN
        {
            get { return Resource.Globalization_ci_mn_Mong_CN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Mongolian (Traditional Mongolian, Mongolia).
        /// </summary>
        public static string Globalization_ci_mn_Mong_MN
        {
            get { return Resource.Globalization_ci_mn_Mong_MN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Mohawk.
        /// </summary>
        public static string Globalization_ci_moh
        {
            get { return Resource.Globalization_ci_moh; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Mohawk (Mohawk).
        /// </summary>
        public static string Globalization_ci_moh_CA
        {
            get { return Resource.Globalization_ci_moh_CA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Marathi.
        /// </summary>
        public static string Globalization_ci_mr
        {
            get { return Resource.Globalization_ci_mr; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Marathi (India).
        /// </summary>
        public static string Globalization_ci_mr_IN
        {
            get { return Resource.Globalization_ci_mr_IN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Malay.
        /// </summary>
        public static string Globalization_ci_ms
        {
            get { return Resource.Globalization_ci_ms; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Malay (Brunei Darussalam).
        /// </summary>
        public static string Globalization_ci_ms_BN
        {
            get { return Resource.Globalization_ci_ms_BN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Malay (Malaysia).
        /// </summary>
        public static string Globalization_ci_ms_MY
        {
            get { return Resource.Globalization_ci_ms_MY; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Malay (Latin, Singapore).
        /// </summary>
        public static string Globalization_ci_ms_SG
        {
            get { return Resource.Globalization_ci_ms_SG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Maltese.
        /// </summary>
        public static string Globalization_ci_mt
        {
            get { return Resource.Globalization_ci_mt; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Maltese (Malta).
        /// </summary>
        public static string Globalization_ci_mt_MT
        {
            get { return Resource.Globalization_ci_mt_MT; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Mundang.
        /// </summary>
        public static string Globalization_ci_mua
        {
            get { return Resource.Globalization_ci_mua; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Mundang (Cameroon).
        /// </summary>
        public static string Globalization_ci_mua_CM
        {
            get { return Resource.Globalization_ci_mua_CM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Burmese.
        /// </summary>
        public static string Globalization_ci_my
        {
            get { return Resource.Globalization_ci_my; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Burmese (Myanmar).
        /// </summary>
        public static string Globalization_ci_my_MM
        {
            get { return Resource.Globalization_ci_my_MM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Nama.
        /// </summary>
        public static string Globalization_ci_naq
        {
            get { return Resource.Globalization_ci_naq; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Nama (Namibia).
        /// </summary>
        public static string Globalization_ci_naq_NA
        {
            get { return Resource.Globalization_ci_naq_NA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Norwegian (Bokmål).
        /// </summary>
        public static string Globalization_ci_nb
        {
            get { return Resource.Globalization_ci_nb; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Norwegian, Bokmål (Norway).
        /// </summary>
        public static string Globalization_ci_nb_NO
        {
            get { return Resource.Globalization_ci_nb_NO; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Norwegian, Bokmål (Svalbard and Jan Mayen).
        /// </summary>
        public static string Globalization_ci_nb_SJ
        {
            get { return Resource.Globalization_ci_nb_SJ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to North Ndebele.
        /// </summary>
        public static string Globalization_ci_nd
        {
            get { return Resource.Globalization_ci_nd; }
        }

        /// <summary>
        ///   Looks up a localized string similar to North Ndebele (Zimbabwe).
        /// </summary>
        public static string Globalization_ci_nd_ZW
        {
            get { return Resource.Globalization_ci_nd_ZW; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Nepali.
        /// </summary>
        public static string Globalization_ci_ne
        {
            get { return Resource.Globalization_ci_ne; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Nepali (India).
        /// </summary>
        public static string Globalization_ci_ne_IN
        {
            get { return Resource.Globalization_ci_ne_IN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Nepali (Nepal).
        /// </summary>
        public static string Globalization_ci_ne_NP
        {
            get { return Resource.Globalization_ci_ne_NP; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Dutch.
        /// </summary>
        public static string Globalization_ci_nl
        {
            get { return Resource.Globalization_ci_nl; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Dutch (Aruba).
        /// </summary>
        public static string Globalization_ci_nl_AW
        {
            get { return Resource.Globalization_ci_nl_AW; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Dutch (Belgium).
        /// </summary>
        public static string Globalization_ci_nl_BE
        {
            get { return Resource.Globalization_ci_nl_BE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Dutch (Bonaire, Sint Eustatius and Saba).
        /// </summary>
        public static string Globalization_ci_nl_BQ
        {
            get { return Resource.Globalization_ci_nl_BQ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Dutch (Curaçao).
        /// </summary>
        public static string Globalization_ci_nl_CW
        {
            get { return Resource.Globalization_ci_nl_CW; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Dutch (Netherlands).
        /// </summary>
        public static string Globalization_ci_nl_NL
        {
            get { return Resource.Globalization_ci_nl_NL; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Dutch (Suriname).
        /// </summary>
        public static string Globalization_ci_nl_SR
        {
            get { return Resource.Globalization_ci_nl_SR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Dutch (Sint Maarten).
        /// </summary>
        public static string Globalization_ci_nl_SX
        {
            get { return Resource.Globalization_ci_nl_SX; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Kwasio.
        /// </summary>
        public static string Globalization_ci_nmg
        {
            get { return Resource.Globalization_ci_nmg; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Kwasio (Cameroon).
        /// </summary>
        public static string Globalization_ci_nmg_CM
        {
            get { return Resource.Globalization_ci_nmg_CM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Norwegian (Nynorsk).
        /// </summary>
        public static string Globalization_ci_nn
        {
            get { return Resource.Globalization_ci_nn; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Norwegian, Nynorsk (Norway).
        /// </summary>
        public static string Globalization_ci_nn_NO
        {
            get { return Resource.Globalization_ci_nn_NO; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Ngiemboon.
        /// </summary>
        public static string Globalization_ci_nnh
        {
            get { return Resource.Globalization_ci_nnh; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Ngiemboon (Cameroon).
        /// </summary>
        public static string Globalization_ci_nnh_CM
        {
            get { return Resource.Globalization_ci_nnh_CM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Norwegian.
        /// </summary>
        public static string Globalization_ci_no
        {
            get { return Resource.Globalization_ci_no; }
        }

        /// <summary>
        ///   Looks up a localized string similar to N&apos;ko.
        /// </summary>
        public static string Globalization_ci_nqo
        {
            get { return Resource.Globalization_ci_nqo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to N&apos;ko (Guinea).
        /// </summary>
        public static string Globalization_ci_nqo_GN
        {
            get { return Resource.Globalization_ci_nqo_GN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to South Ndebele.
        /// </summary>
        public static string Globalization_ci_nr
        {
            get { return Resource.Globalization_ci_nr; }
        }

        /// <summary>
        ///   Looks up a localized string similar to South Ndebele (South Africa).
        /// </summary>
        public static string Globalization_ci_nr_ZA
        {
            get { return Resource.Globalization_ci_nr_ZA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sesotho sa Leboa.
        /// </summary>
        public static string Globalization_ci_nso
        {
            get { return Resource.Globalization_ci_nso; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sesotho sa Leboa (South Africa).
        /// </summary>
        public static string Globalization_ci_nso_ZA
        {
            get { return Resource.Globalization_ci_nso_ZA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Nuer.
        /// </summary>
        public static string Globalization_ci_nus
        {
            get { return Resource.Globalization_ci_nus; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Nuer (Sudan).
        /// </summary>
        public static string Globalization_ci_nus_SD
        {
            get { return Resource.Globalization_ci_nus_SD; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Nyankole.
        /// </summary>
        public static string Globalization_ci_nyn
        {
            get { return Resource.Globalization_ci_nyn; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Nyankole (Uganda).
        /// </summary>
        public static string Globalization_ci_nyn_UG
        {
            get { return Resource.Globalization_ci_nyn_UG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Occitan.
        /// </summary>
        public static string Globalization_ci_oc
        {
            get { return Resource.Globalization_ci_oc; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Occitan (France).
        /// </summary>
        public static string Globalization_ci_oc_FR
        {
            get { return Resource.Globalization_ci_oc_FR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Oromo.
        /// </summary>
        public static string Globalization_ci_om
        {
            get { return Resource.Globalization_ci_om; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Oromo (Ethiopia).
        /// </summary>
        public static string Globalization_ci_om_ET
        {
            get { return Resource.Globalization_ci_om_ET; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Oromo (Kenya).
        /// </summary>
        public static string Globalization_ci_om_KE
        {
            get { return Resource.Globalization_ci_om_KE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Odia.
        /// </summary>
        public static string Globalization_ci_or
        {
            get { return Resource.Globalization_ci_or; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Odia (India).
        /// </summary>
        public static string Globalization_ci_or_IN
        {
            get { return Resource.Globalization_ci_or_IN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Ossetic.
        /// </summary>
        public static string Globalization_ci_os
        {
            get { return Resource.Globalization_ci_os; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Ossetian (Cyrillic, Georgia).
        /// </summary>
        public static string Globalization_ci_os_GE
        {
            get { return Resource.Globalization_ci_os_GE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Ossetian (Cyrillic, Russia).
        /// </summary>
        public static string Globalization_ci_os_RU
        {
            get { return Resource.Globalization_ci_os_RU; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Punjabi.
        /// </summary>
        public static string Globalization_ci_pa
        {
            get { return Resource.Globalization_ci_pa; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Punjabi (Arabic).
        /// </summary>
        public static string Globalization_ci_pa_Arab
        {
            get { return Resource.Globalization_ci_pa_Arab; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Punjabi (Islamic Republic of Pakistan).
        /// </summary>
        public static string Globalization_ci_pa_Arab_PK
        {
            get { return Resource.Globalization_ci_pa_Arab_PK; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Punjabi (India).
        /// </summary>
        public static string Globalization_ci_pa_IN
        {
            get { return Resource.Globalization_ci_pa_IN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Polish.
        /// </summary>
        public static string Globalization_ci_pl
        {
            get { return Resource.Globalization_ci_pl; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Polish (Poland).
        /// </summary>
        public static string Globalization_ci_pl_PL
        {
            get { return Resource.Globalization_ci_pl_PL; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Dari.
        /// </summary>
        public static string Globalization_ci_prs
        {
            get { return Resource.Globalization_ci_prs; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Dari (Afghanistan).
        /// </summary>
        public static string Globalization_ci_prs_AF
        {
            get { return Resource.Globalization_ci_prs_AF; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Pashto.
        /// </summary>
        public static string Globalization_ci_ps
        {
            get { return Resource.Globalization_ci_ps; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Pashto (Afghanistan).
        /// </summary>
        public static string Globalization_ci_ps_AF
        {
            get { return Resource.Globalization_ci_ps_AF; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Portuguese.
        /// </summary>
        public static string Globalization_ci_pt
        {
            get { return Resource.Globalization_ci_pt; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Portuguese (Angola).
        /// </summary>
        public static string Globalization_ci_pt_AO
        {
            get { return Resource.Globalization_ci_pt_AO; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Portuguese (Brazil).
        /// </summary>
        public static string Globalization_ci_pt_BR
        {
            get { return Resource.Globalization_ci_pt_BR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Portuguese (Cabo Verde).
        /// </summary>
        public static string Globalization_ci_pt_CV
        {
            get { return Resource.Globalization_ci_pt_CV; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Portuguese (Guinea-Bissau).
        /// </summary>
        public static string Globalization_ci_pt_GW
        {
            get { return Resource.Globalization_ci_pt_GW; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Portuguese (Macao SAR).
        /// </summary>
        public static string Globalization_ci_pt_MO
        {
            get { return Resource.Globalization_ci_pt_MO; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Portuguese (Mozambique).
        /// </summary>
        public static string Globalization_ci_pt_MZ
        {
            get { return Resource.Globalization_ci_pt_MZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Portuguese (Portugal).
        /// </summary>
        public static string Globalization_ci_pt_PT
        {
            get { return Resource.Globalization_ci_pt_PT; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Portuguese (São Tomé and Príncipe).
        /// </summary>
        public static string Globalization_ci_pt_ST
        {
            get { return Resource.Globalization_ci_pt_ST; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Portuguese (Timor-Leste).
        /// </summary>
        public static string Globalization_ci_pt_TL
        {
            get { return Resource.Globalization_ci_pt_TL; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Pseudo Language (Pseudo).
        /// </summary>
        public static string Globalization_ci_qps_ploc
        {
            get { return Resource.Globalization_ci_qps_ploc; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Pseudo Language (Pseudo Asia).
        /// </summary>
        public static string Globalization_ci_qps_ploca
        {
            get { return Resource.Globalization_ci_qps_ploca; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Pseudo Language (Pseudo Mirrored).
        /// </summary>
        public static string Globalization_ci_qps_plocm
        {
            get { return Resource.Globalization_ci_qps_plocm; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Quechua.
        /// </summary>
        public static string Globalization_ci_qu
        {
            get { return Resource.Globalization_ci_qu; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Quechua (Bolivia).
        /// </summary>
        public static string Globalization_ci_qu_BO
        {
            get { return Resource.Globalization_ci_qu_BO; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Quechua (Ecuador).
        /// </summary>
        public static string Globalization_ci_qu_EC
        {
            get { return Resource.Globalization_ci_qu_EC; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Quechua (Peru).
        /// </summary>
        public static string Globalization_ci_qu_PE
        {
            get { return Resource.Globalization_ci_qu_PE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to K&apos;iche&apos;.
        /// </summary>
        public static string Globalization_ci_quc
        {
            get { return Resource.Globalization_ci_quc; }
        }

        /// <summary>
        ///   Looks up a localized string similar to K&apos;iche&apos;.
        /// </summary>
        public static string Globalization_ci_quc_Latn
        {
            get { return Resource.Globalization_ci_quc_Latn; }
        }

        /// <summary>
        ///   Looks up a localized string similar to K&apos;iche&apos; (Guatemala).
        /// </summary>
        public static string Globalization_ci_quc_Latn_GT
        {
            get { return Resource.Globalization_ci_quc_Latn_GT; }
        }

        /// <summary>
        ///   Looks up a localized string similar to K&apos;iche.
        /// </summary>
        public static string Globalization_ci_qut
        {
            get { return Resource.Globalization_ci_qut; }
        }

        /// <summary>
        ///   Looks up a localized string similar to K&apos;iche (Guatemala).
        /// </summary>
        public static string Globalization_ci_qut_GT
        {
            get { return Resource.Globalization_ci_qut_GT; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Quechua.
        /// </summary>
        public static string Globalization_ci_quz
        {
            get { return Resource.Globalization_ci_quz; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Quechua (Bolivia).
        /// </summary>
        public static string Globalization_ci_quz_BO
        {
            get { return Resource.Globalization_ci_quz_BO; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Quechua (Ecuador).
        /// </summary>
        public static string Globalization_ci_quz_EC
        {
            get { return Resource.Globalization_ci_quz_EC; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Quechua (Peru).
        /// </summary>
        public static string Globalization_ci_quz_PE
        {
            get { return Resource.Globalization_ci_quz_PE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Romansh.
        /// </summary>
        public static string Globalization_ci_rm
        {
            get { return Resource.Globalization_ci_rm; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Romansh (Switzerland).
        /// </summary>
        public static string Globalization_ci_rm_CH
        {
            get { return Resource.Globalization_ci_rm_CH; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Rundi.
        /// </summary>
        public static string Globalization_ci_rn
        {
            get { return Resource.Globalization_ci_rn; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Rundi (Burundi).
        /// </summary>
        public static string Globalization_ci_rn_BI
        {
            get { return Resource.Globalization_ci_rn_BI; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Romanian.
        /// </summary>
        public static string Globalization_ci_ro
        {
            get { return Resource.Globalization_ci_ro; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Romanian (Moldova).
        /// </summary>
        public static string Globalization_ci_ro_MD
        {
            get { return Resource.Globalization_ci_ro_MD; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Romanian (Romania).
        /// </summary>
        public static string Globalization_ci_ro_RO
        {
            get { return Resource.Globalization_ci_ro_RO; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Rombo.
        /// </summary>
        public static string Globalization_ci_rof
        {
            get { return Resource.Globalization_ci_rof; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Rombo (Tanzania).
        /// </summary>
        public static string Globalization_ci_rof_TZ
        {
            get { return Resource.Globalization_ci_rof_TZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Russian.
        /// </summary>
        public static string Globalization_ci_ru
        {
            get { return Resource.Globalization_ci_ru; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Russian (Belarus).
        /// </summary>
        public static string Globalization_ci_ru_BY
        {
            get { return Resource.Globalization_ci_ru_BY; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Russian (Kyrgyzstan).
        /// </summary>
        public static string Globalization_ci_ru_KG
        {
            get { return Resource.Globalization_ci_ru_KG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Russian (Kazakhstan).
        /// </summary>
        public static string Globalization_ci_ru_KZ
        {
            get { return Resource.Globalization_ci_ru_KZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Russian (Moldova).
        /// </summary>
        public static string Globalization_ci_ru_MD
        {
            get { return Resource.Globalization_ci_ru_MD; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Russian (Russia).
        /// </summary>
        public static string Globalization_ci_ru_RU
        {
            get { return Resource.Globalization_ci_ru_RU; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Russian (Ukraine).
        /// </summary>
        public static string Globalization_ci_ru_UA
        {
            get { return Resource.Globalization_ci_ru_UA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Kinyarwanda.
        /// </summary>
        public static string Globalization_ci_rw
        {
            get { return Resource.Globalization_ci_rw; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Kinyarwanda (Rwanda).
        /// </summary>
        public static string Globalization_ci_rw_RW
        {
            get { return Resource.Globalization_ci_rw_RW; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Rwa.
        /// </summary>
        public static string Globalization_ci_rwk
        {
            get { return Resource.Globalization_ci_rwk; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Rwa (Tanzania).
        /// </summary>
        public static string Globalization_ci_rwk_TZ
        {
            get { return Resource.Globalization_ci_rwk_TZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sanskrit.
        /// </summary>
        public static string Globalization_ci_sa
        {
            get { return Resource.Globalization_ci_sa; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sanskrit (India).
        /// </summary>
        public static string Globalization_ci_sa_IN
        {
            get { return Resource.Globalization_ci_sa_IN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sakha.
        /// </summary>
        public static string Globalization_ci_sah
        {
            get { return Resource.Globalization_ci_sah; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sakha (Russia).
        /// </summary>
        public static string Globalization_ci_sah_RU
        {
            get { return Resource.Globalization_ci_sah_RU; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Samburu.
        /// </summary>
        public static string Globalization_ci_saq
        {
            get { return Resource.Globalization_ci_saq; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Samburu (Kenya).
        /// </summary>
        public static string Globalization_ci_saq_KE
        {
            get { return Resource.Globalization_ci_saq_KE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sangu.
        /// </summary>
        public static string Globalization_ci_sbp
        {
            get { return Resource.Globalization_ci_sbp; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sangu (Tanzania).
        /// </summary>
        public static string Globalization_ci_sbp_TZ
        {
            get { return Resource.Globalization_ci_sbp_TZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sindhi.
        /// </summary>
        public static string Globalization_ci_sd
        {
            get { return Resource.Globalization_ci_sd; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sindhi (Arabic).
        /// </summary>
        public static string Globalization_ci_sd_Arab
        {
            get { return Resource.Globalization_ci_sd_Arab; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sindhi (Islamic Republic of Pakistan).
        /// </summary>
        public static string Globalization_ci_sd_Arab_PK
        {
            get { return Resource.Globalization_ci_sd_Arab_PK; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sami (Northern).
        /// </summary>
        public static string Globalization_ci_se
        {
            get { return Resource.Globalization_ci_se; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sami, Northern (Finland).
        /// </summary>
        public static string Globalization_ci_se_FI
        {
            get { return Resource.Globalization_ci_se_FI; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sami, Northern (Norway).
        /// </summary>
        public static string Globalization_ci_se_NO
        {
            get { return Resource.Globalization_ci_se_NO; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sami, Northern (Sweden).
        /// </summary>
        public static string Globalization_ci_se_SE
        {
            get { return Resource.Globalization_ci_se_SE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sena.
        /// </summary>
        public static string Globalization_ci_seh
        {
            get { return Resource.Globalization_ci_seh; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sena (Mozambique).
        /// </summary>
        public static string Globalization_ci_seh_MZ
        {
            get { return Resource.Globalization_ci_seh_MZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Koyraboro Senni.
        /// </summary>
        public static string Globalization_ci_ses
        {
            get { return Resource.Globalization_ci_ses; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Koyraboro Senni (Mali).
        /// </summary>
        public static string Globalization_ci_ses_ML
        {
            get { return Resource.Globalization_ci_ses_ML; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sango.
        /// </summary>
        public static string Globalization_ci_sg
        {
            get { return Resource.Globalization_ci_sg; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sango (Central African Republic).
        /// </summary>
        public static string Globalization_ci_sg_CF
        {
            get { return Resource.Globalization_ci_sg_CF; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tachelhit.
        /// </summary>
        public static string Globalization_ci_shi
        {
            get { return Resource.Globalization_ci_shi; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tachelhit (Latin).
        /// </summary>
        public static string Globalization_ci_shi_Latn
        {
            get { return Resource.Globalization_ci_shi_Latn; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tachelhit (Latin, Morocco).
        /// </summary>
        public static string Globalization_ci_shi_Latn_MA
        {
            get { return Resource.Globalization_ci_shi_Latn_MA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tachelhit (Tifinagh).
        /// </summary>
        public static string Globalization_ci_shi_Tfng
        {
            get { return Resource.Globalization_ci_shi_Tfng; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tachelhit (Tifinagh, Morocco).
        /// </summary>
        public static string Globalization_ci_shi_Tfng_MA
        {
            get { return Resource.Globalization_ci_shi_Tfng_MA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sinhala.
        /// </summary>
        public static string Globalization_ci_si
        {
            get { return Resource.Globalization_ci_si; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sinhala (Sri Lanka).
        /// </summary>
        public static string Globalization_ci_si_LK
        {
            get { return Resource.Globalization_ci_si_LK; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Slovak.
        /// </summary>
        public static string Globalization_ci_sk
        {
            get { return Resource.Globalization_ci_sk; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Slovak (Slovakia).
        /// </summary>
        public static string Globalization_ci_sk_SK
        {
            get { return Resource.Globalization_ci_sk_SK; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Slovenian.
        /// </summary>
        public static string Globalization_ci_sl
        {
            get { return Resource.Globalization_ci_sl; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Slovenian (Slovenia).
        /// </summary>
        public static string Globalization_ci_sl_SI
        {
            get { return Resource.Globalization_ci_sl_SI; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sami (Southern).
        /// </summary>
        public static string Globalization_ci_sma
        {
            get { return Resource.Globalization_ci_sma; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sami, Southern (Norway).
        /// </summary>
        public static string Globalization_ci_sma_NO
        {
            get { return Resource.Globalization_ci_sma_NO; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sami, Southern (Sweden).
        /// </summary>
        public static string Globalization_ci_sma_SE
        {
            get { return Resource.Globalization_ci_sma_SE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sami (Lule).
        /// </summary>
        public static string Globalization_ci_smj
        {
            get { return Resource.Globalization_ci_smj; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sami, Lule (Norway).
        /// </summary>
        public static string Globalization_ci_smj_NO
        {
            get { return Resource.Globalization_ci_smj_NO; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sami, Lule (Sweden).
        /// </summary>
        public static string Globalization_ci_smj_SE
        {
            get { return Resource.Globalization_ci_smj_SE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sami (Inari).
        /// </summary>
        public static string Globalization_ci_smn
        {
            get { return Resource.Globalization_ci_smn; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sami, Inari (Finland).
        /// </summary>
        public static string Globalization_ci_smn_FI
        {
            get { return Resource.Globalization_ci_smn_FI; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sami (Skolt).
        /// </summary>
        public static string Globalization_ci_sms
        {
            get { return Resource.Globalization_ci_sms; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sami, Skolt (Finland).
        /// </summary>
        public static string Globalization_ci_sms_FI
        {
            get { return Resource.Globalization_ci_sms_FI; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Shona.
        /// </summary>
        public static string Globalization_ci_sn
        {
            get { return Resource.Globalization_ci_sn; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Shona (Latin).
        /// </summary>
        public static string Globalization_ci_sn_Latn
        {
            get { return Resource.Globalization_ci_sn_Latn; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Shona (Latin, Zimbabwe).
        /// </summary>
        public static string Globalization_ci_sn_Latn_ZW
        {
            get { return Resource.Globalization_ci_sn_Latn_ZW; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Somali.
        /// </summary>
        public static string Globalization_ci_so
        {
            get { return Resource.Globalization_ci_so; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Somali (Djibouti).
        /// </summary>
        public static string Globalization_ci_so_DJ
        {
            get { return Resource.Globalization_ci_so_DJ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Somali (Ethiopia).
        /// </summary>
        public static string Globalization_ci_so_ET
        {
            get { return Resource.Globalization_ci_so_ET; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Somali (Kenya).
        /// </summary>
        public static string Globalization_ci_so_KE
        {
            get { return Resource.Globalization_ci_so_KE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Somali (Somalia).
        /// </summary>
        public static string Globalization_ci_so_SO
        {
            get { return Resource.Globalization_ci_so_SO; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Albanian.
        /// </summary>
        public static string Globalization_ci_sq
        {
            get { return Resource.Globalization_ci_sq; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Albanian (Albania).
        /// </summary>
        public static string Globalization_ci_sq_AL
        {
            get { return Resource.Globalization_ci_sq_AL; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Albanian (Macedonia, FYRO).
        /// </summary>
        public static string Globalization_ci_sq_MK
        {
            get { return Resource.Globalization_ci_sq_MK; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Serbian.
        /// </summary>
        public static string Globalization_ci_sr
        {
            get { return Resource.Globalization_ci_sr; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Serbian (Cyrillic).
        /// </summary>
        public static string Globalization_ci_sr_Cyrl
        {
            get { return Resource.Globalization_ci_sr_Cyrl; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Serbian (Cyrillic, Bosnia and Herzegovina).
        /// </summary>
        public static string Globalization_ci_sr_Cyrl_BA
        {
            get { return Resource.Globalization_ci_sr_Cyrl_BA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Serbian (Cyrillic, Serbia and Montenegro (Former)).
        /// </summary>
        public static string Globalization_ci_sr_Cyrl_CS
        {
            get { return Resource.Globalization_ci_sr_Cyrl_CS; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Serbian (Cyrillic, Montenegro).
        /// </summary>
        public static string Globalization_ci_sr_Cyrl_ME
        {
            get { return Resource.Globalization_ci_sr_Cyrl_ME; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Serbian (Cyrillic, Serbia).
        /// </summary>
        public static string Globalization_ci_sr_Cyrl_RS
        {
            get { return Resource.Globalization_ci_sr_Cyrl_RS; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Serbian (Latin).
        /// </summary>
        public static string Globalization_ci_sr_Latn
        {
            get { return Resource.Globalization_ci_sr_Latn; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Serbian (Latin, Bosnia and Herzegovina).
        /// </summary>
        public static string Globalization_ci_sr_Latn_BA
        {
            get { return Resource.Globalization_ci_sr_Latn_BA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Serbian (Latin, Serbia and Montenegro (Former)).
        /// </summary>
        public static string Globalization_ci_sr_Latn_CS
        {
            get { return Resource.Globalization_ci_sr_Latn_CS; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Serbian (Latin, Montenegro).
        /// </summary>
        public static string Globalization_ci_sr_Latn_ME
        {
            get { return Resource.Globalization_ci_sr_Latn_ME; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Serbian (Latin, Serbia).
        /// </summary>
        public static string Globalization_ci_sr_Latn_RS
        {
            get { return Resource.Globalization_ci_sr_Latn_RS; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Swati.
        /// </summary>
        public static string Globalization_ci_ss
        {
            get { return Resource.Globalization_ci_ss; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Swati (Swaziland).
        /// </summary>
        public static string Globalization_ci_ss_SZ
        {
            get { return Resource.Globalization_ci_ss_SZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Swati (South Africa).
        /// </summary>
        public static string Globalization_ci_ss_ZA
        {
            get { return Resource.Globalization_ci_ss_ZA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Saho.
        /// </summary>
        public static string Globalization_ci_ssy
        {
            get { return Resource.Globalization_ci_ssy; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Saho (Eritrea).
        /// </summary>
        public static string Globalization_ci_ssy_ER
        {
            get { return Resource.Globalization_ci_ssy_ER; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Southern Sotho.
        /// </summary>
        public static string Globalization_ci_st
        {
            get { return Resource.Globalization_ci_st; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sesotho (Lesotho).
        /// </summary>
        public static string Globalization_ci_st_LS
        {
            get { return Resource.Globalization_ci_st_LS; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Southern Sotho (South Africa).
        /// </summary>
        public static string Globalization_ci_st_ZA
        {
            get { return Resource.Globalization_ci_st_ZA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Swedish.
        /// </summary>
        public static string Globalization_ci_sv
        {
            get { return Resource.Globalization_ci_sv; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Swedish (Åland Islands).
        /// </summary>
        public static string Globalization_ci_sv_AX
        {
            get { return Resource.Globalization_ci_sv_AX; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Swedish (Finland).
        /// </summary>
        public static string Globalization_ci_sv_FI
        {
            get { return Resource.Globalization_ci_sv_FI; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Swedish (Sweden).
        /// </summary>
        public static string Globalization_ci_sv_SE
        {
            get { return Resource.Globalization_ci_sv_SE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Kiswahili.
        /// </summary>
        public static string Globalization_ci_sw
        {
            get { return Resource.Globalization_ci_sw; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Kiswahili (Kenya).
        /// </summary>
        public static string Globalization_ci_sw_KE
        {
            get { return Resource.Globalization_ci_sw_KE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Kiswahili (Tanzania).
        /// </summary>
        public static string Globalization_ci_sw_TZ
        {
            get { return Resource.Globalization_ci_sw_TZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Kiswahili (Uganda).
        /// </summary>
        public static string Globalization_ci_sw_UG
        {
            get { return Resource.Globalization_ci_sw_UG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Congo Swahili.
        /// </summary>
        public static string Globalization_ci_swc
        {
            get { return Resource.Globalization_ci_swc; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Congo Swahili (Congo DRC).
        /// </summary>
        public static string Globalization_ci_swc_CD
        {
            get { return Resource.Globalization_ci_swc_CD; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Syriac.
        /// </summary>
        public static string Globalization_ci_syr
        {
            get { return Resource.Globalization_ci_syr; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Syriac (Syria).
        /// </summary>
        public static string Globalization_ci_syr_SY
        {
            get { return Resource.Globalization_ci_syr_SY; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tamil.
        /// </summary>
        public static string Globalization_ci_ta
        {
            get { return Resource.Globalization_ci_ta; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tamil (India).
        /// </summary>
        public static string Globalization_ci_ta_IN
        {
            get { return Resource.Globalization_ci_ta_IN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tamil (Sri Lanka).
        /// </summary>
        public static string Globalization_ci_ta_LK
        {
            get { return Resource.Globalization_ci_ta_LK; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tamil (Malaysia).
        /// </summary>
        public static string Globalization_ci_ta_MY
        {
            get { return Resource.Globalization_ci_ta_MY; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tamil (Singapore).
        /// </summary>
        public static string Globalization_ci_ta_SG
        {
            get { return Resource.Globalization_ci_ta_SG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Telugu.
        /// </summary>
        public static string Globalization_ci_te
        {
            get { return Resource.Globalization_ci_te; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Telugu (India).
        /// </summary>
        public static string Globalization_ci_te_IN
        {
            get { return Resource.Globalization_ci_te_IN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Teso.
        /// </summary>
        public static string Globalization_ci_teo
        {
            get { return Resource.Globalization_ci_teo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Teso (Kenya).
        /// </summary>
        public static string Globalization_ci_teo_KE
        {
            get { return Resource.Globalization_ci_teo_KE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Teso (Uganda).
        /// </summary>
        public static string Globalization_ci_teo_UG
        {
            get { return Resource.Globalization_ci_teo_UG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tajik.
        /// </summary>
        public static string Globalization_ci_tg
        {
            get { return Resource.Globalization_ci_tg; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tajik (Cyrillic).
        /// </summary>
        public static string Globalization_ci_tg_Cyrl
        {
            get { return Resource.Globalization_ci_tg_Cyrl; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tajik (Cyrillic, Tajikistan).
        /// </summary>
        public static string Globalization_ci_tg_Cyrl_TJ
        {
            get { return Resource.Globalization_ci_tg_Cyrl_TJ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Thai.
        /// </summary>
        public static string Globalization_ci_th
        {
            get { return Resource.Globalization_ci_th; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Thai (Thailand).
        /// </summary>
        public static string Globalization_ci_th_TH
        {
            get { return Resource.Globalization_ci_th_TH; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tigrinya.
        /// </summary>
        public static string Globalization_ci_ti
        {
            get { return Resource.Globalization_ci_ti; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tigrinya (Eritrea).
        /// </summary>
        public static string Globalization_ci_ti_ER
        {
            get { return Resource.Globalization_ci_ti_ER; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tigrinya (Ethiopia).
        /// </summary>
        public static string Globalization_ci_ti_ET
        {
            get { return Resource.Globalization_ci_ti_ET; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tigre.
        /// </summary>
        public static string Globalization_ci_tig
        {
            get { return Resource.Globalization_ci_tig; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tigre (Eritrea).
        /// </summary>
        public static string Globalization_ci_tig_ER
        {
            get { return Resource.Globalization_ci_tig_ER; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Turkmen.
        /// </summary>
        public static string Globalization_ci_tk
        {
            get { return Resource.Globalization_ci_tk; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Turkmen (Turkmenistan).
        /// </summary>
        public static string Globalization_ci_tk_TM
        {
            get { return Resource.Globalization_ci_tk_TM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Setswana.
        /// </summary>
        public static string Globalization_ci_tn
        {
            get { return Resource.Globalization_ci_tn; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Setswana (Botswana).
        /// </summary>
        public static string Globalization_ci_tn_BW
        {
            get { return Resource.Globalization_ci_tn_BW; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Setswana (South Africa).
        /// </summary>
        public static string Globalization_ci_tn_ZA
        {
            get { return Resource.Globalization_ci_tn_ZA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tongan.
        /// </summary>
        public static string Globalization_ci_to
        {
            get { return Resource.Globalization_ci_to; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tongan (Tonga).
        /// </summary>
        public static string Globalization_ci_to_TO
        {
            get { return Resource.Globalization_ci_to_TO; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Turkish.
        /// </summary>
        public static string Globalization_ci_tr
        {
            get { return Resource.Globalization_ci_tr; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Turkish (Cyprus).
        /// </summary>
        public static string Globalization_ci_tr_CY
        {
            get { return Resource.Globalization_ci_tr_CY; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Turkish (Turkey).
        /// </summary>
        public static string Globalization_ci_tr_TR
        {
            get { return Resource.Globalization_ci_tr_TR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tsonga.
        /// </summary>
        public static string Globalization_ci_ts
        {
            get { return Resource.Globalization_ci_ts; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tsonga (South Africa).
        /// </summary>
        public static string Globalization_ci_ts_ZA
        {
            get { return Resource.Globalization_ci_ts_ZA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tatar.
        /// </summary>
        public static string Globalization_ci_tt
        {
            get { return Resource.Globalization_ci_tt; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tatar (Russia).
        /// </summary>
        public static string Globalization_ci_tt_RU
        {
            get { return Resource.Globalization_ci_tt_RU; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tasawaq.
        /// </summary>
        public static string Globalization_ci_twq
        {
            get { return Resource.Globalization_ci_twq; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tasawaq (Niger).
        /// </summary>
        public static string Globalization_ci_twq_NE
        {
            get { return Resource.Globalization_ci_twq_NE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tamazight.
        /// </summary>
        public static string Globalization_ci_tzm
        {
            get { return Resource.Globalization_ci_tzm; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tamazight (Latin).
        /// </summary>
        public static string Globalization_ci_tzm_Latn
        {
            get { return Resource.Globalization_ci_tzm_Latn; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tamazight (Latin, Algeria).
        /// </summary>
        public static string Globalization_ci_tzm_Latn_DZ
        {
            get { return Resource.Globalization_ci_tzm_Latn_DZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Central Atlas Tamazight (Latin, Morocco).
        /// </summary>
        public static string Globalization_ci_tzm_Latn_MA
        {
            get { return Resource.Globalization_ci_tzm_Latn_MA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tamazight (Tifinagh).
        /// </summary>
        public static string Globalization_ci_tzm_Tfng
        {
            get { return Resource.Globalization_ci_tzm_Tfng; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Central Atlas Tamazight (Tifinagh, Morocco).
        /// </summary>
        public static string Globalization_ci_tzm_Tfng_MA
        {
            get { return Resource.Globalization_ci_tzm_Tfng_MA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Uyghur.
        /// </summary>
        public static string Globalization_ci_ug
        {
            get { return Resource.Globalization_ci_ug; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Uyghur (PRC).
        /// </summary>
        public static string Globalization_ci_ug_CN
        {
            get { return Resource.Globalization_ci_ug_CN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Ukrainian.
        /// </summary>
        public static string Globalization_ci_uk
        {
            get { return Resource.Globalization_ci_uk; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Ukrainian (Ukraine).
        /// </summary>
        public static string Globalization_ci_uk_UA
        {
            get { return Resource.Globalization_ci_uk_UA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Urdu.
        /// </summary>
        public static string Globalization_ci_ur
        {
            get { return Resource.Globalization_ci_ur; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Urdu (India).
        /// </summary>
        public static string Globalization_ci_ur_IN
        {
            get { return Resource.Globalization_ci_ur_IN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Urdu (Islamic Republic of Pakistan).
        /// </summary>
        public static string Globalization_ci_ur_PK
        {
            get { return Resource.Globalization_ci_ur_PK; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Uzbek.
        /// </summary>
        public static string Globalization_ci_uz
        {
            get { return Resource.Globalization_ci_uz; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Uzbek (Perso-Arabic).
        /// </summary>
        public static string Globalization_ci_uz_Arab
        {
            get { return Resource.Globalization_ci_uz_Arab; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Uzbek (Perso-Arabic, Afghanistan).
        /// </summary>
        public static string Globalization_ci_uz_Arab_AF
        {
            get { return Resource.Globalization_ci_uz_Arab_AF; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Uzbek (Cyrillic).
        /// </summary>
        public static string Globalization_ci_uz_Cyrl
        {
            get { return Resource.Globalization_ci_uz_Cyrl; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Uzbek (Cyrillic, Uzbekistan).
        /// </summary>
        public static string Globalization_ci_uz_Cyrl_UZ
        {
            get { return Resource.Globalization_ci_uz_Cyrl_UZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Uzbek (Latin).
        /// </summary>
        public static string Globalization_ci_uz_Latn
        {
            get { return Resource.Globalization_ci_uz_Latn; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Uzbek (Latin, Uzbekistan).
        /// </summary>
        public static string Globalization_ci_uz_Latn_UZ
        {
            get { return Resource.Globalization_ci_uz_Latn_UZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Vai.
        /// </summary>
        public static string Globalization_ci_vai
        {
            get { return Resource.Globalization_ci_vai; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Vai (Latin).
        /// </summary>
        public static string Globalization_ci_vai_Latn
        {
            get { return Resource.Globalization_ci_vai_Latn; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Vai (Latin, Liberia).
        /// </summary>
        public static string Globalization_ci_vai_Latn_LR
        {
            get { return Resource.Globalization_ci_vai_Latn_LR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Vai (Vai).
        /// </summary>
        public static string Globalization_ci_vai_Vaii
        {
            get { return Resource.Globalization_ci_vai_Vaii; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Vai (Vai, Liberia).
        /// </summary>
        public static string Globalization_ci_vai_Vaii_LR
        {
            get { return Resource.Globalization_ci_vai_Vaii_LR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Venda.
        /// </summary>
        public static string Globalization_ci_ve
        {
            get { return Resource.Globalization_ci_ve; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Venda (South Africa).
        /// </summary>
        public static string Globalization_ci_ve_ZA
        {
            get { return Resource.Globalization_ci_ve_ZA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Vietnamese.
        /// </summary>
        public static string Globalization_ci_vi
        {
            get { return Resource.Globalization_ci_vi; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Vietnamese (Vietnam).
        /// </summary>
        public static string Globalization_ci_vi_VN
        {
            get { return Resource.Globalization_ci_vi_VN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Volapük.
        /// </summary>
        public static string Globalization_ci_vo
        {
            get { return Resource.Globalization_ci_vo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Volapük (World).
        /// </summary>
        public static string Globalization_ci_vo_001
        {
            get { return Resource.Globalization_ci_vo_001; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Vunjo.
        /// </summary>
        public static string Globalization_ci_vun
        {
            get { return Resource.Globalization_ci_vun; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Vunjo (Tanzania).
        /// </summary>
        public static string Globalization_ci_vun_TZ
        {
            get { return Resource.Globalization_ci_vun_TZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Walser.
        /// </summary>
        public static string Globalization_ci_wae
        {
            get { return Resource.Globalization_ci_wae; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Walser (Switzerland).
        /// </summary>
        public static string Globalization_ci_wae_CH
        {
            get { return Resource.Globalization_ci_wae_CH; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Wolaytta.
        /// </summary>
        public static string Globalization_ci_wal
        {
            get { return Resource.Globalization_ci_wal; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Wolaytta (Ethiopia).
        /// </summary>
        public static string Globalization_ci_wal_ET
        {
            get { return Resource.Globalization_ci_wal_ET; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Wolof.
        /// </summary>
        public static string Globalization_ci_wo
        {
            get { return Resource.Globalization_ci_wo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Wolof (Senegal).
        /// </summary>
        public static string Globalization_ci_wo_SN
        {
            get { return Resource.Globalization_ci_wo_SN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invariant Language (Invariant Country).
        /// </summary>
        public static string Globalization_ci_x_IV
        {
            get { return Resource.Globalization_ci_x_IV; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invariant Language (Invariant Country).
        /// </summary>
        public static string Globalization_ci_x_IV_mathan
        {
            get { return Resource.Globalization_ci_x_IV_mathan; }
        }

        /// <summary>
        ///   Looks up a localized string similar to isiXhosa.
        /// </summary>
        public static string Globalization_ci_xh
        {
            get { return Resource.Globalization_ci_xh; }
        }

        /// <summary>
        ///   Looks up a localized string similar to isiXhosa (South Africa).
        /// </summary>
        public static string Globalization_ci_xh_ZA
        {
            get { return Resource.Globalization_ci_xh_ZA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Soga.
        /// </summary>
        public static string Globalization_ci_xog
        {
            get { return Resource.Globalization_ci_xog; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Soga (Uganda).
        /// </summary>
        public static string Globalization_ci_xog_UG
        {
            get { return Resource.Globalization_ci_xog_UG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Yangben.
        /// </summary>
        public static string Globalization_ci_yav
        {
            get { return Resource.Globalization_ci_yav; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Yangben (Cameroon).
        /// </summary>
        public static string Globalization_ci_yav_CM
        {
            get { return Resource.Globalization_ci_yav_CM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Yiddish.
        /// </summary>
        public static string Globalization_ci_yi
        {
            get { return Resource.Globalization_ci_yi; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Yiddish (World).
        /// </summary>
        public static string Globalization_ci_yi_001
        {
            get { return Resource.Globalization_ci_yi_001; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Yoruba.
        /// </summary>
        public static string Globalization_ci_yo
        {
            get { return Resource.Globalization_ci_yo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Yoruba (Benin).
        /// </summary>
        public static string Globalization_ci_yo_BJ
        {
            get { return Resource.Globalization_ci_yo_BJ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Yoruba (Nigeria).
        /// </summary>
        public static string Globalization_ci_yo_NG
        {
            get { return Resource.Globalization_ci_yo_NG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Standard Moroccan Tamazight.
        /// </summary>
        public static string Globalization_ci_zgh
        {
            get { return Resource.Globalization_ci_zgh; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Standard Moroccan Tamazight (Tifinagh).
        /// </summary>
        public static string Globalization_ci_zgh_Tfng
        {
            get { return Resource.Globalization_ci_zgh_Tfng; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Standard Moroccan Tamazight (Tifinagh, Morocco).
        /// </summary>
        public static string Globalization_ci_zgh_Tfng_MA
        {
            get { return Resource.Globalization_ci_zgh_Tfng_MA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Chinese.
        /// </summary>
        public static string Globalization_ci_zh
        {
            get { return Resource.Globalization_ci_zh; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Chinese (Simplified) Legacy.
        /// </summary>
        public static string Globalization_ci_zh_CHS
        {
            get { return Resource.Globalization_ci_zh_CHS; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Chinese (Traditional) Legacy.
        /// </summary>
        public static string Globalization_ci_zh_CHT
        {
            get { return Resource.Globalization_ci_zh_CHT; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Chinese (Simplified, PRC).
        /// </summary>
        public static string Globalization_ci_zh_CN
        {
            get { return Resource.Globalization_ci_zh_CN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Chinese (Simplified, PRC).
        /// </summary>
        public static string Globalization_ci_zh_CN_stroke
        {
            get { return Resource.Globalization_ci_zh_CN_stroke; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Chinese (Simplified).
        /// </summary>
        public static string Globalization_ci_zh_Hans
        {
            get { return Resource.Globalization_ci_zh_Hans; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Chinese (Traditional).
        /// </summary>
        public static string Globalization_ci_zh_Hant
        {
            get { return Resource.Globalization_ci_zh_Hant; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Chinese (Traditional, Hong Kong S.A.R.).
        /// </summary>
        public static string Globalization_ci_zh_HK
        {
            get { return Resource.Globalization_ci_zh_HK; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Chinese (Traditional, Hong Kong S.A.R.).
        /// </summary>
        public static string Globalization_ci_zh_HK_radstr
        {
            get { return Resource.Globalization_ci_zh_HK_radstr; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Chinese (Traditional, Macao S.A.R.).
        /// </summary>
        public static string Globalization_ci_zh_MO
        {
            get { return Resource.Globalization_ci_zh_MO; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Chinese (Traditional, Macao S.A.R.).
        /// </summary>
        public static string Globalization_ci_zh_MO_radstr
        {
            get { return Resource.Globalization_ci_zh_MO_radstr; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Chinese (Traditional, Macao S.A.R.).
        /// </summary>
        public static string Globalization_ci_zh_MO_stroke
        {
            get { return Resource.Globalization_ci_zh_MO_stroke; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Chinese (Simplified, Singapore).
        /// </summary>
        public static string Globalization_ci_zh_SG
        {
            get { return Resource.Globalization_ci_zh_SG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Chinese (Simplified, Singapore).
        /// </summary>
        public static string Globalization_ci_zh_SG_stroke
        {
            get { return Resource.Globalization_ci_zh_SG_stroke; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Chinese (Traditional, Taiwan).
        /// </summary>
        public static string Globalization_ci_zh_TW
        {
            get { return Resource.Globalization_ci_zh_TW; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Chinese (Traditional, Taiwan).
        /// </summary>
        public static string Globalization_ci_zh_TW_pronun
        {
            get { return Resource.Globalization_ci_zh_TW_pronun; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Chinese (Traditional, Taiwan).
        /// </summary>
        public static string Globalization_ci_zh_TW_radstr
        {
            get { return Resource.Globalization_ci_zh_TW_radstr; }
        }

        /// <summary>
        ///   Looks up a localized string similar to isiZulu.
        /// </summary>
        public static string Globalization_ci_zu
        {
            get { return Resource.Globalization_ci_zu; }
        }

        /// <summary>
        ///   Looks up a localized string similar to isiZulu (South Africa).
        /// </summary>
        public static string Globalization_ci_zu_ZA
        {
            get { return Resource.Globalization_ci_zu_ZA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Western European (Mac).
        /// </summary>
        public static string Globalization_cp_10000
        {
            get { return Resource.Globalization_cp_10000; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Japanese (Mac).
        /// </summary>
        public static string Globalization_cp_10001
        {
            get { return Resource.Globalization_cp_10001; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Chinese Traditional (Mac).
        /// </summary>
        public static string Globalization_cp_10002
        {
            get { return Resource.Globalization_cp_10002; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Korean (Mac).
        /// </summary>
        public static string Globalization_cp_10003
        {
            get { return Resource.Globalization_cp_10003; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic (Mac).
        /// </summary>
        public static string Globalization_cp_10004
        {
            get { return Resource.Globalization_cp_10004; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Hebrew (Mac).
        /// </summary>
        public static string Globalization_cp_10005
        {
            get { return Resource.Globalization_cp_10005; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Greek (Mac).
        /// </summary>
        public static string Globalization_cp_10006
        {
            get { return Resource.Globalization_cp_10006; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cyrillic (Mac).
        /// </summary>
        public static string Globalization_cp_10007
        {
            get { return Resource.Globalization_cp_10007; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Chinese Simplified (Mac).
        /// </summary>
        public static string Globalization_cp_10008
        {
            get { return Resource.Globalization_cp_10008; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Romanian (Mac).
        /// </summary>
        public static string Globalization_cp_10010
        {
            get { return Resource.Globalization_cp_10010; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Ukrainian (Mac).
        /// </summary>
        public static string Globalization_cp_10017
        {
            get { return Resource.Globalization_cp_10017; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Thai (Mac).
        /// </summary>
        public static string Globalization_cp_10021
        {
            get { return Resource.Globalization_cp_10021; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Central European (Mac).
        /// </summary>
        public static string Globalization_cp_10029
        {
            get { return Resource.Globalization_cp_10029; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Icelandic (Mac).
        /// </summary>
        public static string Globalization_cp_10079
        {
            get { return Resource.Globalization_cp_10079; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Turkish (Mac).
        /// </summary>
        public static string Globalization_cp_10081
        {
            get { return Resource.Globalization_cp_10081; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Croatian (Mac).
        /// </summary>
        public static string Globalization_cp_10082
        {
            get { return Resource.Globalization_cp_10082; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (Turkish Latin-5).
        /// </summary>
        public static string Globalization_cp_1026
        {
            get { return Resource.Globalization_cp_1026; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM Latin-1.
        /// </summary>
        public static string Globalization_cp_1047
        {
            get { return Resource.Globalization_cp_1047; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (US-Canada-Euro).
        /// </summary>
        public static string Globalization_cp_1140
        {
            get { return Resource.Globalization_cp_1140; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (Germany-Euro).
        /// </summary>
        public static string Globalization_cp_1141
        {
            get { return Resource.Globalization_cp_1141; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (Denmark-Norway-Euro).
        /// </summary>
        public static string Globalization_cp_1142
        {
            get { return Resource.Globalization_cp_1142; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (Finland-Sweden-Euro).
        /// </summary>
        public static string Globalization_cp_1143
        {
            get { return Resource.Globalization_cp_1143; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (Italy-Euro).
        /// </summary>
        public static string Globalization_cp_1144
        {
            get { return Resource.Globalization_cp_1144; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (Spain-Euro).
        /// </summary>
        public static string Globalization_cp_1145
        {
            get { return Resource.Globalization_cp_1145; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (UK-Euro).
        /// </summary>
        public static string Globalization_cp_1146
        {
            get { return Resource.Globalization_cp_1146; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (France-Euro).
        /// </summary>
        public static string Globalization_cp_1147
        {
            get { return Resource.Globalization_cp_1147; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (International-Euro).
        /// </summary>
        public static string Globalization_cp_1148
        {
            get { return Resource.Globalization_cp_1148; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (Icelandic-Euro).
        /// </summary>
        public static string Globalization_cp_1149
        {
            get { return Resource.Globalization_cp_1149; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unicode.
        /// </summary>
        public static string Globalization_cp_1200
        {
            get { return Resource.Globalization_cp_1200; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unicode (UTF-32).
        /// </summary>
        public static string Globalization_cp_12000
        {
            get { return Resource.Globalization_cp_12000; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unicode (UTF-32 Big-Endian).
        /// </summary>
        public static string Globalization_cp_12001
        {
            get { return Resource.Globalization_cp_12001; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unicode (Big-Endian).
        /// </summary>
        public static string Globalization_cp_1201
        {
            get { return Resource.Globalization_cp_1201; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Central European (Windows).
        /// </summary>
        public static string Globalization_cp_1250
        {
            get { return Resource.Globalization_cp_1250; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cyrillic (Windows).
        /// </summary>
        public static string Globalization_cp_1251
        {
            get { return Resource.Globalization_cp_1251; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Western European (Windows).
        /// </summary>
        public static string Globalization_cp_1252
        {
            get { return Resource.Globalization_cp_1252; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Greek (Windows).
        /// </summary>
        public static string Globalization_cp_1253
        {
            get { return Resource.Globalization_cp_1253; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Turkish (Windows).
        /// </summary>
        public static string Globalization_cp_1254
        {
            get { return Resource.Globalization_cp_1254; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Hebrew (Windows).
        /// </summary>
        public static string Globalization_cp_1255
        {
            get { return Resource.Globalization_cp_1255; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic (Windows).
        /// </summary>
        public static string Globalization_cp_1256
        {
            get { return Resource.Globalization_cp_1256; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Baltic (Windows).
        /// </summary>
        public static string Globalization_cp_1257
        {
            get { return Resource.Globalization_cp_1257; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Vietnamese (Windows).
        /// </summary>
        public static string Globalization_cp_1258
        {
            get { return Resource.Globalization_cp_1258; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Korean (Johab).
        /// </summary>
        public static string Globalization_cp_1361
        {
            get { return Resource.Globalization_cp_1361; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Chinese Traditional (CNS).
        /// </summary>
        public static string Globalization_cp_20000
        {
            get { return Resource.Globalization_cp_20000; }
        }

        /// <summary>
        ///   Looks up a localized string similar to TCA Taiwan.
        /// </summary>
        public static string Globalization_cp_20001
        {
            get { return Resource.Globalization_cp_20001; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Chinese Traditional (Eten).
        /// </summary>
        public static string Globalization_cp_20002
        {
            get { return Resource.Globalization_cp_20002; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM5550 Taiwan.
        /// </summary>
        public static string Globalization_cp_20003
        {
            get { return Resource.Globalization_cp_20003; }
        }

        /// <summary>
        ///   Looks up a localized string similar to TeleText Taiwan.
        /// </summary>
        public static string Globalization_cp_20004
        {
            get { return Resource.Globalization_cp_20004; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Wang Taiwan.
        /// </summary>
        public static string Globalization_cp_20005
        {
            get { return Resource.Globalization_cp_20005; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Western European (IA5).
        /// </summary>
        public static string Globalization_cp_20105
        {
            get { return Resource.Globalization_cp_20105; }
        }

        /// <summary>
        ///   Looks up a localized string similar to German (IA5).
        /// </summary>
        public static string Globalization_cp_20106
        {
            get { return Resource.Globalization_cp_20106; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Swedish (IA5).
        /// </summary>
        public static string Globalization_cp_20107
        {
            get { return Resource.Globalization_cp_20107; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Norwegian (IA5).
        /// </summary>
        public static string Globalization_cp_20108
        {
            get { return Resource.Globalization_cp_20108; }
        }

        /// <summary>
        ///   Looks up a localized string similar to US-ASCII.
        /// </summary>
        public static string Globalization_cp_20127
        {
            get { return Resource.Globalization_cp_20127; }
        }

        /// <summary>
        ///   Looks up a localized string similar to T.61.
        /// </summary>
        public static string Globalization_cp_20261
        {
            get { return Resource.Globalization_cp_20261; }
        }

        /// <summary>
        ///   Looks up a localized string similar to ISO-6937.
        /// </summary>
        public static string Globalization_cp_20269
        {
            get { return Resource.Globalization_cp_20269; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (Germany).
        /// </summary>
        public static string Globalization_cp_20273
        {
            get { return Resource.Globalization_cp_20273; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (Denmark-Norway).
        /// </summary>
        public static string Globalization_cp_20277
        {
            get { return Resource.Globalization_cp_20277; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (Finland-Sweden).
        /// </summary>
        public static string Globalization_cp_20278
        {
            get { return Resource.Globalization_cp_20278; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (Italy).
        /// </summary>
        public static string Globalization_cp_20280
        {
            get { return Resource.Globalization_cp_20280; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (Spain).
        /// </summary>
        public static string Globalization_cp_20284
        {
            get { return Resource.Globalization_cp_20284; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (UK).
        /// </summary>
        public static string Globalization_cp_20285
        {
            get { return Resource.Globalization_cp_20285; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (Japanese katakana).
        /// </summary>
        public static string Globalization_cp_20290
        {
            get { return Resource.Globalization_cp_20290; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (France).
        /// </summary>
        public static string Globalization_cp_20297
        {
            get { return Resource.Globalization_cp_20297; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (Arabic).
        /// </summary>
        public static string Globalization_cp_20420
        {
            get { return Resource.Globalization_cp_20420; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (Greek).
        /// </summary>
        public static string Globalization_cp_20423
        {
            get { return Resource.Globalization_cp_20423; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (Hebrew).
        /// </summary>
        public static string Globalization_cp_20424
        {
            get { return Resource.Globalization_cp_20424; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (Korean Extended).
        /// </summary>
        public static string Globalization_cp_20833
        {
            get { return Resource.Globalization_cp_20833; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (Thai).
        /// </summary>
        public static string Globalization_cp_20838
        {
            get { return Resource.Globalization_cp_20838; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cyrillic (KOI8-R).
        /// </summary>
        public static string Globalization_cp_20866
        {
            get { return Resource.Globalization_cp_20866; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (Icelandic).
        /// </summary>
        public static string Globalization_cp_20871
        {
            get { return Resource.Globalization_cp_20871; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (Cyrillic Russian).
        /// </summary>
        public static string Globalization_cp_20880
        {
            get { return Resource.Globalization_cp_20880; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (Turkish).
        /// </summary>
        public static string Globalization_cp_20905
        {
            get { return Resource.Globalization_cp_20905; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM Latin-1.
        /// </summary>
        public static string Globalization_cp_20924
        {
            get { return Resource.Globalization_cp_20924; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Japanese (JIS 0208-1990 and 0212-1990).
        /// </summary>
        public static string Globalization_cp_20932
        {
            get { return Resource.Globalization_cp_20932; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Chinese Simplified (GB2312-80).
        /// </summary>
        public static string Globalization_cp_20936
        {
            get { return Resource.Globalization_cp_20936; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Korean Wansung.
        /// </summary>
        public static string Globalization_cp_20949
        {
            get { return Resource.Globalization_cp_20949; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (Cyrillic Serbian-Bulgarian).
        /// </summary>
        public static string Globalization_cp_21025
        {
            get { return Resource.Globalization_cp_21025; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Ext Alpha Lowercase.
        /// </summary>
        public static string Globalization_cp_21027
        {
            get { return Resource.Globalization_cp_21027; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cyrillic (KOI8-U).
        /// </summary>
        public static string Globalization_cp_21866
        {
            get { return Resource.Globalization_cp_21866; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Western European (ISO).
        /// </summary>
        public static string Globalization_cp_28591
        {
            get { return Resource.Globalization_cp_28591; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Central European (ISO).
        /// </summary>
        public static string Globalization_cp_28592
        {
            get { return Resource.Globalization_cp_28592; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Latin 3 (ISO).
        /// </summary>
        public static string Globalization_cp_28593
        {
            get { return Resource.Globalization_cp_28593; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Baltic (ISO).
        /// </summary>
        public static string Globalization_cp_28594
        {
            get { return Resource.Globalization_cp_28594; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cyrillic (ISO).
        /// </summary>
        public static string Globalization_cp_28595
        {
            get { return Resource.Globalization_cp_28595; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic (ISO).
        /// </summary>
        public static string Globalization_cp_28596
        {
            get { return Resource.Globalization_cp_28596; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Greek (ISO).
        /// </summary>
        public static string Globalization_cp_28597
        {
            get { return Resource.Globalization_cp_28597; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Hebrew (ISO-Visual).
        /// </summary>
        public static string Globalization_cp_28598
        {
            get { return Resource.Globalization_cp_28598; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Turkish (ISO).
        /// </summary>
        public static string Globalization_cp_28599
        {
            get { return Resource.Globalization_cp_28599; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Estonian (ISO).
        /// </summary>
        public static string Globalization_cp_28603
        {
            get { return Resource.Globalization_cp_28603; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Latin 9 (ISO).
        /// </summary>
        public static string Globalization_cp_28605
        {
            get { return Resource.Globalization_cp_28605; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Europa.
        /// </summary>
        public static string Globalization_cp_29001
        {
            get { return Resource.Globalization_cp_29001; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (US-Canada).
        /// </summary>
        public static string Globalization_cp_37
        {
            get { return Resource.Globalization_cp_37; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Hebrew (ISO-Logical).
        /// </summary>
        public static string Globalization_cp_38598
        {
            get { return Resource.Globalization_cp_38598; }
        }

        /// <summary>
        ///   Looks up a localized string similar to OEM United States.
        /// </summary>
        public static string Globalization_cp_437
        {
            get { return Resource.Globalization_cp_437; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (International).
        /// </summary>
        public static string Globalization_cp_500
        {
            get { return Resource.Globalization_cp_500; }
        }

        /// <summary>
        ///   Looks up a localized string similar to User Defined.
        /// </summary>
        public static string Globalization_cp_50000
        {
            get { return Resource.Globalization_cp_50000; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Japanese (JIS).
        /// </summary>
        public static string Globalization_cp_50220
        {
            get { return Resource.Globalization_cp_50220; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Japanese (JIS-Allow 1 byte Kana).
        /// </summary>
        public static string Globalization_cp_50221
        {
            get { return Resource.Globalization_cp_50221; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Japanese (JIS-Allow 1 byte Kana - SO/SI).
        /// </summary>
        public static string Globalization_cp_50222
        {
            get { return Resource.Globalization_cp_50222; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Korean (ISO).
        /// </summary>
        public static string Globalization_cp_50225
        {
            get { return Resource.Globalization_cp_50225; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Chinese Simplified (ISO-2022).
        /// </summary>
        public static string Globalization_cp_50227
        {
            get { return Resource.Globalization_cp_50227; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Chinese Traditional (ISO-2022).
        /// </summary>
        public static string Globalization_cp_50229
        {
            get { return Resource.Globalization_cp_50229; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (Japanese and Japanese Katakana).
        /// </summary>
        public static string Globalization_cp_50930
        {
            get { return Resource.Globalization_cp_50930; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (Japanese and US-Canada).
        /// </summary>
        public static string Globalization_cp_50931
        {
            get { return Resource.Globalization_cp_50931; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (Korean and Korean Extended).
        /// </summary>
        public static string Globalization_cp_50933
        {
            get { return Resource.Globalization_cp_50933; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (Simplified Chinese).
        /// </summary>
        public static string Globalization_cp_50935
        {
            get { return Resource.Globalization_cp_50935; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (Traditional Chinese).
        /// </summary>
        public static string Globalization_cp_50937
        {
            get { return Resource.Globalization_cp_50937; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (Japanese and Japanese-Latin).
        /// </summary>
        public static string Globalization_cp_50939
        {
            get { return Resource.Globalization_cp_50939; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Japanese (EUC).
        /// </summary>
        public static string Globalization_cp_51932
        {
            get { return Resource.Globalization_cp_51932; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Chinese Simplified (EUC).
        /// </summary>
        public static string Globalization_cp_51936
        {
            get { return Resource.Globalization_cp_51936; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Korean (EUC).
        /// </summary>
        public static string Globalization_cp_51949
        {
            get { return Resource.Globalization_cp_51949; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Chinese Simplified (HZ).
        /// </summary>
        public static string Globalization_cp_52936
        {
            get { return Resource.Globalization_cp_52936; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Chinese Simplified (GB18030).
        /// </summary>
        public static string Globalization_cp_54936
        {
            get { return Resource.Globalization_cp_54936; }
        }

        /// <summary>
        ///   Looks up a localized string similar to ISCII Devanagari.
        /// </summary>
        public static string Globalization_cp_57002
        {
            get { return Resource.Globalization_cp_57002; }
        }

        /// <summary>
        ///   Looks up a localized string similar to ISCII Bengali.
        /// </summary>
        public static string Globalization_cp_57003
        {
            get { return Resource.Globalization_cp_57003; }
        }

        /// <summary>
        ///   Looks up a localized string similar to ISCII Tamil.
        /// </summary>
        public static string Globalization_cp_57004
        {
            get { return Resource.Globalization_cp_57004; }
        }

        /// <summary>
        ///   Looks up a localized string similar to ISCII Telugu.
        /// </summary>
        public static string Globalization_cp_57005
        {
            get { return Resource.Globalization_cp_57005; }
        }

        /// <summary>
        ///   Looks up a localized string similar to ISCII Assamese.
        /// </summary>
        public static string Globalization_cp_57006
        {
            get { return Resource.Globalization_cp_57006; }
        }

        /// <summary>
        ///   Looks up a localized string similar to ISCII Oriya.
        /// </summary>
        public static string Globalization_cp_57007
        {
            get { return Resource.Globalization_cp_57007; }
        }

        /// <summary>
        ///   Looks up a localized string similar to ISCII Kannada.
        /// </summary>
        public static string Globalization_cp_57008
        {
            get { return Resource.Globalization_cp_57008; }
        }

        /// <summary>
        ///   Looks up a localized string similar to ISCII Malayalam.
        /// </summary>
        public static string Globalization_cp_57009
        {
            get { return Resource.Globalization_cp_57009; }
        }

        /// <summary>
        ///   Looks up a localized string similar to ISCII Gujarati.
        /// </summary>
        public static string Globalization_cp_57010
        {
            get { return Resource.Globalization_cp_57010; }
        }

        /// <summary>
        ///   Looks up a localized string similar to ISCII Punjabi.
        /// </summary>
        public static string Globalization_cp_57011
        {
            get { return Resource.Globalization_cp_57011; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unicode (UTF-7).
        /// </summary>
        public static string Globalization_cp_65000
        {
            get { return Resource.Globalization_cp_65000; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unicode (UTF-8).
        /// </summary>
        public static string Globalization_cp_65001
        {
            get { return Resource.Globalization_cp_65001; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic (ASMO 708).
        /// </summary>
        public static string Globalization_cp_708
        {
            get { return Resource.Globalization_cp_708; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic (DOS).
        /// </summary>
        public static string Globalization_cp_720
        {
            get { return Resource.Globalization_cp_720; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Greek (DOS).
        /// </summary>
        public static string Globalization_cp_737
        {
            get { return Resource.Globalization_cp_737; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Baltic (DOS).
        /// </summary>
        public static string Globalization_cp_775
        {
            get { return Resource.Globalization_cp_775; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Western European (DOS).
        /// </summary>
        public static string Globalization_cp_850
        {
            get { return Resource.Globalization_cp_850; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Central European (DOS).
        /// </summary>
        public static string Globalization_cp_852
        {
            get { return Resource.Globalization_cp_852; }
        }

        /// <summary>
        ///   Looks up a localized string similar to OEM Cyrillic.
        /// </summary>
        public static string Globalization_cp_855
        {
            get { return Resource.Globalization_cp_855; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Turkish (DOS).
        /// </summary>
        public static string Globalization_cp_857
        {
            get { return Resource.Globalization_cp_857; }
        }

        /// <summary>
        ///   Looks up a localized string similar to OEM Multilingual Latin I.
        /// </summary>
        public static string Globalization_cp_858
        {
            get { return Resource.Globalization_cp_858; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Portuguese (DOS).
        /// </summary>
        public static string Globalization_cp_860
        {
            get { return Resource.Globalization_cp_860; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Icelandic (DOS).
        /// </summary>
        public static string Globalization_cp_861
        {
            get { return Resource.Globalization_cp_861; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Hebrew (DOS).
        /// </summary>
        public static string Globalization_cp_862
        {
            get { return Resource.Globalization_cp_862; }
        }

        /// <summary>
        ///   Looks up a localized string similar to French Canadian (DOS).
        /// </summary>
        public static string Globalization_cp_863
        {
            get { return Resource.Globalization_cp_863; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arabic (864).
        /// </summary>
        public static string Globalization_cp_864
        {
            get { return Resource.Globalization_cp_864; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Nordic (DOS).
        /// </summary>
        public static string Globalization_cp_865
        {
            get { return Resource.Globalization_cp_865; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cyrillic (DOS).
        /// </summary>
        public static string Globalization_cp_866
        {
            get { return Resource.Globalization_cp_866; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Greek, Modern (DOS).
        /// </summary>
        public static string Globalization_cp_869
        {
            get { return Resource.Globalization_cp_869; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (Multilingual Latin-2).
        /// </summary>
        public static string Globalization_cp_870
        {
            get { return Resource.Globalization_cp_870; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Thai (Windows).
        /// </summary>
        public static string Globalization_cp_874
        {
            get { return Resource.Globalization_cp_874; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IBM EBCDIC (Greek Modern).
        /// </summary>
        public static string Globalization_cp_875
        {
            get { return Resource.Globalization_cp_875; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Japanese (Shift-JIS).
        /// </summary>
        public static string Globalization_cp_932
        {
            get { return Resource.Globalization_cp_932; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Chinese Simplified (GB2312).
        /// </summary>
        public static string Globalization_cp_936
        {
            get { return Resource.Globalization_cp_936; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Korean.
        /// </summary>
        public static string Globalization_cp_949
        {
            get { return Resource.Globalization_cp_949; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Chinese Traditional (Big5).
        /// </summary>
        public static string Globalization_cp_950
        {
            get { return Resource.Globalization_cp_950; }
        }

        /// <summary>
        ///   Looks up a localized string similar to  Legacy.
        /// </summary>
        public static string Globalization_LegacyModifier
        {
            get { return Resource.Globalization_LegacyModifier; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Caribbean.
        /// </summary>
        public static string Globalization_ri_029
        {
            get { return Resource.Globalization_ri_029; }
        }

        /// <summary>
        ///   Looks up a localized string similar to U.A.E..
        /// </summary>
        public static string Globalization_ri_AE
        {
            get { return Resource.Globalization_ri_AE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Afghanistan.
        /// </summary>
        public static string Globalization_ri_AF
        {
            get { return Resource.Globalization_ri_AF; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Albania.
        /// </summary>
        public static string Globalization_ri_AL
        {
            get { return Resource.Globalization_ri_AL; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Armenia.
        /// </summary>
        public static string Globalization_ri_AM
        {
            get { return Resource.Globalization_ri_AM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Argentina.
        /// </summary>
        public static string Globalization_ri_AR
        {
            get { return Resource.Globalization_ri_AR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Austria.
        /// </summary>
        public static string Globalization_ri_AT
        {
            get { return Resource.Globalization_ri_AT; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Australia.
        /// </summary>
        public static string Globalization_ri_AU
        {
            get { return Resource.Globalization_ri_AU; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Azerbaijan.
        /// </summary>
        public static string Globalization_ri_AZ
        {
            get { return Resource.Globalization_ri_AZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bosnia and Herzegovina.
        /// </summary>
        public static string Globalization_ri_BA
        {
            get { return Resource.Globalization_ri_BA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bangladesh.
        /// </summary>
        public static string Globalization_ri_BD
        {
            get { return Resource.Globalization_ri_BD; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Belgium.
        /// </summary>
        public static string Globalization_ri_BE
        {
            get { return Resource.Globalization_ri_BE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bulgaria.
        /// </summary>
        public static string Globalization_ri_BG
        {
            get { return Resource.Globalization_ri_BG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bahrain.
        /// </summary>
        public static string Globalization_ri_BH
        {
            get { return Resource.Globalization_ri_BH; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Brunei Darussalam.
        /// </summary>
        public static string Globalization_ri_BN
        {
            get { return Resource.Globalization_ri_BN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bolivia.
        /// </summary>
        public static string Globalization_ri_BO
        {
            get { return Resource.Globalization_ri_BO; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Brazil.
        /// </summary>
        public static string Globalization_ri_BR
        {
            get { return Resource.Globalization_ri_BR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Belarus.
        /// </summary>
        public static string Globalization_ri_BY
        {
            get { return Resource.Globalization_ri_BY; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Belize.
        /// </summary>
        public static string Globalization_ri_BZ
        {
            get { return Resource.Globalization_ri_BZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Canada.
        /// </summary>
        public static string Globalization_ri_CA
        {
            get { return Resource.Globalization_ri_CA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Switzerland.
        /// </summary>
        public static string Globalization_ri_CH
        {
            get { return Resource.Globalization_ri_CH; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Chile.
        /// </summary>
        public static string Globalization_ri_CL
        {
            get { return Resource.Globalization_ri_CL; }
        }

        /// <summary>
        ///   Looks up a localized string similar to People&apos;s Republic of China.
        /// </summary>
        public static string Globalization_ri_CN
        {
            get { return Resource.Globalization_ri_CN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Colombia.
        /// </summary>
        public static string Globalization_ri_CO
        {
            get { return Resource.Globalization_ri_CO; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Costa Rica.
        /// </summary>
        public static string Globalization_ri_CR
        {
            get { return Resource.Globalization_ri_CR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Serbia and Montenegro (Former).
        /// </summary>
        public static string Globalization_ri_CS
        {
            get { return Resource.Globalization_ri_CS; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Czech Republic.
        /// </summary>
        public static string Globalization_ri_CZ
        {
            get { return Resource.Globalization_ri_CZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Germany.
        /// </summary>
        public static string Globalization_ri_DE
        {
            get { return Resource.Globalization_ri_DE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Denmark.
        /// </summary>
        public static string Globalization_ri_DK
        {
            get { return Resource.Globalization_ri_DK; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Dominican Republic.
        /// </summary>
        public static string Globalization_ri_DO
        {
            get { return Resource.Globalization_ri_DO; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Algeria.
        /// </summary>
        public static string Globalization_ri_DZ
        {
            get { return Resource.Globalization_ri_DZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Ecuador.
        /// </summary>
        public static string Globalization_ri_EC
        {
            get { return Resource.Globalization_ri_EC; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Estonia.
        /// </summary>
        public static string Globalization_ri_EE
        {
            get { return Resource.Globalization_ri_EE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Egypt.
        /// </summary>
        public static string Globalization_ri_EG
        {
            get { return Resource.Globalization_ri_EG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Eritrea.
        /// </summary>
        public static string Globalization_ri_ER
        {
            get { return Resource.Globalization_ri_ER; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Spain.
        /// </summary>
        public static string Globalization_ri_ES
        {
            get { return Resource.Globalization_ri_ES; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Ethiopia.
        /// </summary>
        public static string Globalization_ri_ET
        {
            get { return Resource.Globalization_ri_ET; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Finland.
        /// </summary>
        public static string Globalization_ri_FI
        {
            get { return Resource.Globalization_ri_FI; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Faroe Islands.
        /// </summary>
        public static string Globalization_ri_FO
        {
            get { return Resource.Globalization_ri_FO; }
        }

        /// <summary>
        ///   Looks up a localized string similar to France.
        /// </summary>
        public static string Globalization_ri_FR
        {
            get { return Resource.Globalization_ri_FR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to United Kingdom.
        /// </summary>
        public static string Globalization_ri_GB
        {
            get { return Resource.Globalization_ri_GB; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Georgia.
        /// </summary>
        public static string Globalization_ri_GE
        {
            get { return Resource.Globalization_ri_GE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Greenland.
        /// </summary>
        public static string Globalization_ri_GL
        {
            get { return Resource.Globalization_ri_GL; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Greece.
        /// </summary>
        public static string Globalization_ri_GR
        {
            get { return Resource.Globalization_ri_GR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Guatemala.
        /// </summary>
        public static string Globalization_ri_GT
        {
            get { return Resource.Globalization_ri_GT; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Hong Kong S.A.R..
        /// </summary>
        public static string Globalization_ri_HK
        {
            get { return Resource.Globalization_ri_HK; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Honduras.
        /// </summary>
        public static string Globalization_ri_HN
        {
            get { return Resource.Globalization_ri_HN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Croatia.
        /// </summary>
        public static string Globalization_ri_HR
        {
            get { return Resource.Globalization_ri_HR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Hungary.
        /// </summary>
        public static string Globalization_ri_HU
        {
            get { return Resource.Globalization_ri_HU; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Indonesia.
        /// </summary>
        public static string Globalization_ri_ID
        {
            get { return Resource.Globalization_ri_ID; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Ireland.
        /// </summary>
        public static string Globalization_ri_IE
        {
            get { return Resource.Globalization_ri_IE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Israel.
        /// </summary>
        public static string Globalization_ri_IL
        {
            get { return Resource.Globalization_ri_IL; }
        }

        /// <summary>
        ///   Looks up a localized string similar to India.
        /// </summary>
        public static string Globalization_ri_IN
        {
            get { return Resource.Globalization_ri_IN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Iraq.
        /// </summary>
        public static string Globalization_ri_IQ
        {
            get { return Resource.Globalization_ri_IQ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Iran.
        /// </summary>
        public static string Globalization_ri_IR
        {
            get { return Resource.Globalization_ri_IR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Iceland.
        /// </summary>
        public static string Globalization_ri_IS
        {
            get { return Resource.Globalization_ri_IS; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Italy.
        /// </summary>
        public static string Globalization_ri_IT
        {
            get { return Resource.Globalization_ri_IT; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invariant Country.
        /// </summary>
        public static string Globalization_ri_IV
        {
            get { return Resource.Globalization_ri_IV; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Jamaica.
        /// </summary>
        public static string Globalization_ri_JM
        {
            get { return Resource.Globalization_ri_JM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Jordan.
        /// </summary>
        public static string Globalization_ri_JO
        {
            get { return Resource.Globalization_ri_JO; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Japan.
        /// </summary>
        public static string Globalization_ri_JP
        {
            get { return Resource.Globalization_ri_JP; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Kenya.
        /// </summary>
        public static string Globalization_ri_KE
        {
            get { return Resource.Globalization_ri_KE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Kyrgyzstan.
        /// </summary>
        public static string Globalization_ri_KG
        {
            get { return Resource.Globalization_ri_KG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cambodia.
        /// </summary>
        public static string Globalization_ri_KH
        {
            get { return Resource.Globalization_ri_KH; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Korea.
        /// </summary>
        public static string Globalization_ri_KR
        {
            get { return Resource.Globalization_ri_KR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Kuwait.
        /// </summary>
        public static string Globalization_ri_KW
        {
            get { return Resource.Globalization_ri_KW; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Kazakhstan.
        /// </summary>
        public static string Globalization_ri_KZ
        {
            get { return Resource.Globalization_ri_KZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Lao P.D.R..
        /// </summary>
        public static string Globalization_ri_LA
        {
            get { return Resource.Globalization_ri_LA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Lebanon.
        /// </summary>
        public static string Globalization_ri_LB
        {
            get { return Resource.Globalization_ri_LB; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Liechtenstein.
        /// </summary>
        public static string Globalization_ri_LI
        {
            get { return Resource.Globalization_ri_LI; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sri Lanka.
        /// </summary>
        public static string Globalization_ri_LK
        {
            get { return Resource.Globalization_ri_LK; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Lithuania.
        /// </summary>
        public static string Globalization_ri_LT
        {
            get { return Resource.Globalization_ri_LT; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Luxembourg.
        /// </summary>
        public static string Globalization_ri_LU
        {
            get { return Resource.Globalization_ri_LU; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Latvia.
        /// </summary>
        public static string Globalization_ri_LV
        {
            get { return Resource.Globalization_ri_LV; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Libya.
        /// </summary>
        public static string Globalization_ri_LY
        {
            get { return Resource.Globalization_ri_LY; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Morocco.
        /// </summary>
        public static string Globalization_ri_MA
        {
            get { return Resource.Globalization_ri_MA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Principality of Monaco.
        /// </summary>
        public static string Globalization_ri_MC
        {
            get { return Resource.Globalization_ri_MC; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Montenegro.
        /// </summary>
        public static string Globalization_ri_ME
        {
            get { return Resource.Globalization_ri_ME; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Macedonia (FYROM).
        /// </summary>
        public static string Globalization_ri_MK
        {
            get { return Resource.Globalization_ri_MK; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Mongolia.
        /// </summary>
        public static string Globalization_ri_MN
        {
            get { return Resource.Globalization_ri_MN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Macao S.A.R..
        /// </summary>
        public static string Globalization_ri_MO
        {
            get { return Resource.Globalization_ri_MO; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Malta.
        /// </summary>
        public static string Globalization_ri_MT
        {
            get { return Resource.Globalization_ri_MT; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Maldives.
        /// </summary>
        public static string Globalization_ri_MV
        {
            get { return Resource.Globalization_ri_MV; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Mexico.
        /// </summary>
        public static string Globalization_ri_MX
        {
            get { return Resource.Globalization_ri_MX; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Malaysia.
        /// </summary>
        public static string Globalization_ri_MY
        {
            get { return Resource.Globalization_ri_MY; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Nigeria.
        /// </summary>
        public static string Globalization_ri_NG
        {
            get { return Resource.Globalization_ri_NG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Nicaragua.
        /// </summary>
        public static string Globalization_ri_NI
        {
            get { return Resource.Globalization_ri_NI; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Netherlands.
        /// </summary>
        public static string Globalization_ri_NL
        {
            get { return Resource.Globalization_ri_NL; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Norway.
        /// </summary>
        public static string Globalization_ri_NO
        {
            get { return Resource.Globalization_ri_NO; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Nepal.
        /// </summary>
        public static string Globalization_ri_NP
        {
            get { return Resource.Globalization_ri_NP; }
        }

        /// <summary>
        ///   Looks up a localized string similar to New Zealand.
        /// </summary>
        public static string Globalization_ri_NZ
        {
            get { return Resource.Globalization_ri_NZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Oman.
        /// </summary>
        public static string Globalization_ri_OM
        {
            get { return Resource.Globalization_ri_OM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Panama.
        /// </summary>
        public static string Globalization_ri_PA
        {
            get { return Resource.Globalization_ri_PA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Peru.
        /// </summary>
        public static string Globalization_ri_PE
        {
            get { return Resource.Globalization_ri_PE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Philippines.
        /// </summary>
        public static string Globalization_ri_PH
        {
            get { return Resource.Globalization_ri_PH; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Islamic Republic of Pakistan.
        /// </summary>
        public static string Globalization_ri_PK
        {
            get { return Resource.Globalization_ri_PK; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Poland.
        /// </summary>
        public static string Globalization_ri_PL
        {
            get { return Resource.Globalization_ri_PL; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Puerto Rico.
        /// </summary>
        public static string Globalization_ri_PR
        {
            get { return Resource.Globalization_ri_PR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Portugal.
        /// </summary>
        public static string Globalization_ri_PT
        {
            get { return Resource.Globalization_ri_PT; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Paraguay.
        /// </summary>
        public static string Globalization_ri_PY
        {
            get { return Resource.Globalization_ri_PY; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Qatar.
        /// </summary>
        public static string Globalization_ri_QA
        {
            get { return Resource.Globalization_ri_QA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Romania.
        /// </summary>
        public static string Globalization_ri_RO
        {
            get { return Resource.Globalization_ri_RO; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Serbia.
        /// </summary>
        public static string Globalization_ri_RS
        {
            get { return Resource.Globalization_ri_RS; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Russia.
        /// </summary>
        public static string Globalization_ri_RU
        {
            get { return Resource.Globalization_ri_RU; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Rwanda.
        /// </summary>
        public static string Globalization_ri_RW
        {
            get { return Resource.Globalization_ri_RW; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Saudi Arabia.
        /// </summary>
        public static string Globalization_ri_SA
        {
            get { return Resource.Globalization_ri_SA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sweden.
        /// </summary>
        public static string Globalization_ri_SE
        {
            get { return Resource.Globalization_ri_SE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Singapore.
        /// </summary>
        public static string Globalization_ri_SG
        {
            get { return Resource.Globalization_ri_SG; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Slovenia.
        /// </summary>
        public static string Globalization_ri_SI
        {
            get { return Resource.Globalization_ri_SI; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Slovakia.
        /// </summary>
        public static string Globalization_ri_SK
        {
            get { return Resource.Globalization_ri_SK; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Senegal.
        /// </summary>
        public static string Globalization_ri_SN
        {
            get { return Resource.Globalization_ri_SN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to El Salvador.
        /// </summary>
        public static string Globalization_ri_SV
        {
            get { return Resource.Globalization_ri_SV; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Syria.
        /// </summary>
        public static string Globalization_ri_SY
        {
            get { return Resource.Globalization_ri_SY; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Thailand.
        /// </summary>
        public static string Globalization_ri_TH
        {
            get { return Resource.Globalization_ri_TH; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tajikistan.
        /// </summary>
        public static string Globalization_ri_TJ
        {
            get { return Resource.Globalization_ri_TJ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Turkmenistan.
        /// </summary>
        public static string Globalization_ri_TM
        {
            get { return Resource.Globalization_ri_TM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tunisia.
        /// </summary>
        public static string Globalization_ri_TN
        {
            get { return Resource.Globalization_ri_TN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Turkey.
        /// </summary>
        public static string Globalization_ri_TR
        {
            get { return Resource.Globalization_ri_TR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Trinidad and Tobago.
        /// </summary>
        public static string Globalization_ri_TT
        {
            get { return Resource.Globalization_ri_TT; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Taiwan.
        /// </summary>
        public static string Globalization_ri_TW
        {
            get { return Resource.Globalization_ri_TW; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Ukraine.
        /// </summary>
        public static string Globalization_ri_UA
        {
            get { return Resource.Globalization_ri_UA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to United States.
        /// </summary>
        public static string Globalization_ri_US
        {
            get { return Resource.Globalization_ri_US; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Uruguay.
        /// </summary>
        public static string Globalization_ri_UY
        {
            get { return Resource.Globalization_ri_UY; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Uzbekistan.
        /// </summary>
        public static string Globalization_ri_UZ
        {
            get { return Resource.Globalization_ri_UZ; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bolivarian Republic of Venezuela.
        /// </summary>
        public static string Globalization_ri_VE
        {
            get { return Resource.Globalization_ri_VE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Vietnam.
        /// </summary>
        public static string Globalization_ri_VN
        {
            get { return Resource.Globalization_ri_VN; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Yemen.
        /// </summary>
        public static string Globalization_ri_YE
        {
            get { return Resource.Globalization_ri_YE; }
        }

        /// <summary>
        ///   Looks up a localized string similar to South Africa.
        /// </summary>
        public static string Globalization_ri_ZA
        {
            get { return Resource.Globalization_ri_ZA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Zimbabwe.
        /// </summary>
        public static string Globalization_ri_ZW
        {
            get { return Resource.Globalization_ri_ZW; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Hash - {0} {1}.
        /// </summary>
        public static string Hash_ToString
        {
            get { return Resource.Hash_ToString; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The demanded resources were:.
        /// </summary>
        public static string HostProtection_DemandedResources
        {
            get { return Resource.HostProtection_DemandedResources; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attempted to perform an operation that was forbidden by the CLR host..
        /// </summary>
        public static string HostProtection_HostProtection
        {
            get { return Resource.HostProtection_HostProtection; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The protected resources (only available with full trust) were:.
        /// </summary>
        public static string HostProtection_ProtectedResources
        {
            get { return Resource.HostProtection_ProtectedResources; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Account name is too long..
        /// </summary>
        public static string IdentityReference_AccountNameTooLong
        {
            get { return Resource.IdentityReference_AccountNameTooLong; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Well-known SIDs of type LogonIdsSid cannot be created..
        /// </summary>
        public static string IdentityReference_CannotCreateLogonIdsSid
        {
            get { return Resource.IdentityReference_CannotCreateLogonIdsSid; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Domain name is too long..
        /// </summary>
        public static string IdentityReference_DomainNameTooLong
        {
            get { return Resource.IdentityReference_DomainNameTooLong; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The domainSid parameter must be specified for creating well-known SID of type {0}..
        /// </summary>
        public static string IdentityReference_DomainSidRequired
        {
            get { return Resource.IdentityReference_DomainSidRequired; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The size of the identifier authority must not exceed 6 bytes..
        /// </summary>
        public static string IdentityReference_IdentifierAuthorityTooLarge
        {
            get { return Resource.IdentityReference_IdentifierAuthorityTooLarge; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Some or all identity references could not be translated..
        /// </summary>
        public static string IdentityReference_IdentityNotMapped
        {
            get { return Resource.IdentityReference_IdentityNotMapped; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The number of sub-authorities must not exceed {0}..
        /// </summary>
        public static string IdentityReference_InvalidNumberOfSubauthorities
        {
            get { return Resource.IdentityReference_InvalidNumberOfSubauthorities; }
        }

        /// <summary>
        ///   Looks up a localized string similar to SIDs with revision other than &apos;1&apos; are not supported..
        /// </summary>
        public static string IdentityReference_InvalidSidRevision
        {
            get { return Resource.IdentityReference_InvalidSidRevision; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The targetType parameter must be of IdentityReference type..
        /// </summary>
        public static string IdentityReference_MustBeIdentityReference
        {
            get { return Resource.IdentityReference_MustBeIdentityReference; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The domainSid parameter is not a valid Windows domain SID..
        /// </summary>
        public static string IdentityReference_NotAWindowsDomain
        {
            get { return Resource.IdentityReference_NotAWindowsDomain; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Array does not have that many dimensions..
        /// </summary>
        public static string IndexOutOfRange_ArrayRankIndex
        {
            get { return Resource.IndexOutOfRange_ArrayRankIndex; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Probable I/O race condition detected while copying memory. The I/O package is not thread safe by default. In multithreaded applications, a stream must be accessed in a thread-safe way, such as a thread-safe wrapper returned by TextReader&apos;s or TextWriter&apos;s Synchronized methods. This also applies to classes like StreamWriter and StreamReader..
        /// </summary>
        public static string IndexOutOfRange_IORaceCondition
        {
            get { return Resource.IndexOutOfRange_IORaceCondition; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unmanaged memory stream position was beyond the capacity of the stream..
        /// </summary>
        public static string IndexOutOfRange_UMSPosition
        {
            get { return Resource.IndexOutOfRange_UMSPosition; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Insufficient available memory to meet the expected demands of an operation at this time.  Please try again later..
        /// </summary>
        public static string InsufficientMemory_MemFailPoint
        {
            get { return Resource.InsufficientMemory_MemFailPoint; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Insufficient memory to meet the expected demands of an operation, and this system is likely to never satisfy this request.  If this is a 32 bit system, consider booting in 3 GB mode..
        /// </summary>
        public static string InsufficientMemory_MemFailPoint_TooBig
        {
            get { return Resource.InsufficientMemory_MemFailPoint_TooBig; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Insufficient available memory to meet the expected demands of an operation at this time, possibly due to virtual address space fragmentation.  Please try again later..
        /// </summary>
        public static string InsufficientMemory_MemFailPoint_VAFrag
        {
            get { return Resource.InsufficientMemory_MemFailPoint_VAFrag; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type mismatch between source and destination types..
        /// </summary>
        public static string Interop_COM_TypeMismatch
        {
            get { return Resource.Interop_COM_TypeMismatch; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot marshal: Encountered unmappable character..
        /// </summary>
        public static string Interop_Marshal_Unmappable_Char
        {
            get { return Resource.Interop_Marshal_Unmappable_Char; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Null object cannot be converted to a value type..
        /// </summary>
        public static string InvalidCast_CannotCastNullToValueType
        {
            get { return Resource.InvalidCast_CannotCastNullToValueType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object cannot be coerced to the original type of the ByRef VARIANT it was obtained from..
        /// </summary>
        public static string InvalidCast_CannotCoerceByRefVariant
        {
            get { return Resource.InvalidCast_CannotCoerceByRefVariant; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object cannot be cast to DBNull..
        /// </summary>
        public static string InvalidCast_DBNull
        {
            get { return Resource.InvalidCast_DBNull; }
        }

        /// <summary>
        ///   Looks up a localized string similar to At least one element in the source array could not be cast down to the destination array type..
        /// </summary>
        public static string InvalidCast_DownCastArrayElement
        {
            get { return Resource.InvalidCast_DownCastArrayElement; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object cannot be cast to Empty..
        /// </summary>
        public static string InvalidCast_Empty
        {
            get { return Resource.InvalidCast_Empty; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object cannot be cast from DBNull to other types..
        /// </summary>
        public static string InvalidCast_FromDBNull
        {
            get { return Resource.InvalidCast_FromDBNull; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid cast from &apos;{0}&apos; to &apos;{1}&apos;..
        /// </summary>
        public static string InvalidCast_FromTo
        {
            get { return Resource.InvalidCast_FromTo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object must implement IConvertible..
        /// </summary>
        public static string InvalidCast_IConvertible
        {
            get { return Resource.InvalidCast_IConvertible; }
        }

        /// <summary>
        ///   Looks up a localized string similar to OleAut reported a type mismatch..
        /// </summary>
        public static string InvalidCast_OATypeMismatch
        {
            get { return Resource.InvalidCast_OATypeMismatch; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object cannot be stored in an array of this type..
        /// </summary>
        public static string InvalidCast_StoreArrayElement
        {
            get { return Resource.InvalidCast_StoreArrayElement; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object in an IPropertyValue is of type &apos;{0}&apos; which cannot be convereted to a &apos;{1}&apos; due to array element &apos;{2}&apos;: {3}..
        /// </summary>
        public static string InvalidCast_WinRTIPropertyValueArrayCoersion
        {
            get { return Resource.InvalidCast_WinRTIPropertyValueArrayCoersion; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object in an IPropertyValue is of type &apos;{0}&apos; with value &apos;{1}&apos;, which cannot be converted to a &apos;{2}&apos;..
        /// </summary>
        public static string InvalidCast_WinRTIPropertyValueCoersion
        {
            get { return Resource.InvalidCast_WinRTIPropertyValueCoersion; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object in an IPropertyValue is of type &apos;{0}&apos;, which cannot be converted to a &apos;{1}&apos;..
        /// </summary>
        public static string InvalidCast_WinRTIPropertyValueElement
        {
            get { return Resource.InvalidCast_WinRTIPropertyValueElement; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The activation arguments and application trust for the AppDomain must correspond to the same application identity..
        /// </summary>
        public static string InvalidOperation_ActivationArgsAppTrustMismatch
        {
            get { return Resource.InvalidOperation_ActivationArgsAppTrustMismatch; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attempted to add properties to a frozen context..
        /// </summary>
        public static string InvalidOperation_AddContextFrozen
        {
            get { return Resource.InvalidOperation_AddContextFrozen; }
        }

        /// <summary>
        ///   Looks up a localized string similar to An anonymous identity cannot perform an impersonation..
        /// </summary>
        public static string InvalidOperation_AnonymousCannotImpersonate
        {
            get { return Resource.InvalidOperation_AnonymousCannotImpersonate; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Failed to set the specified COM apartment state..
        /// </summary>
        public static string InvalidOperation_ApartmentStateSwitchFailed
        {
            get { return Resource.InvalidOperation_ApartmentStateSwitchFailed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The API &apos;{0}&apos; cannot be used on the current platform. See http://go.microsoft.com/fwlink/?LinkId=248273 for more information..
        /// </summary>
        public static string InvalidOperation_APIInvalidForCurrentContext
        {
            get { return Resource.InvalidOperation_APIInvalidForCurrentContext; }
        }

        /// <summary>
        ///   Looks up a localized string similar to This API requires the ApplicationBase to be specified explicitly in the AppDomainSetup parameter..
        /// </summary>
        public static string InvalidOperation_AppDomainSandboxAPINeedsExplicitAppBase
        {
            get { return Resource.InvalidOperation_AppDomainSandboxAPINeedsExplicitAppBase; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Assembly has been loaded as ReflectionOnly. This API requires an assembly capable of execution..
        /// </summary>
        public static string InvalidOperation_AsmLoadedForReflectionOnly
        {
            get { return Resource.InvalidOperation_AsmLoadedForReflectionOnly; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Assembly &apos;{0}&apos; has been saved..
        /// </summary>
        public static string InvalidOperation_AssemblyHasBeenSaved
        {
            get { return Resource.InvalidOperation_AssemblyHasBeenSaved; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot perform CAS Asserts in Security Transparent methods.
        /// </summary>
        public static string InvalidOperation_AssertTransparentCode
        {
            get { return Resource.InvalidOperation_AssertTransparentCode; }
        }

        /// <summary>
        ///   Looks up a localized string similar to AsyncFlowControl objects can be used to restore flow only on the Context that had its flow suppressed..
        /// </summary>
        public static string InvalidOperation_AsyncFlowCtrlCtxMismatch
        {
            get { return Resource.InvalidOperation_AsyncFlowCtrlCtxMismatch; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The stream is currently in use by a previous operation on the stream..
        /// </summary>
        public static string InvalidOperation_AsyncIOInProgress
        {
            get { return Resource.InvalidOperation_AsyncIOInProgress; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Method &apos;{0}&apos; does not have a method body..
        /// </summary>
        public static string InvalidOperation_BadEmptyMethodBody
        {
            get { return Resource.InvalidOperation_BadEmptyMethodBody; }
        }

        /// <summary>
        ///   Looks up a localized string similar to ILGenerator usage is invalid..
        /// </summary>
        public static string InvalidOperation_BadILGeneratorUsage
        {
            get { return Resource.InvalidOperation_BadILGeneratorUsage; }
        }

        /// <summary>
        ///   Looks up a localized string similar to MSIL instruction is invalid or index is out of bounds..
        /// </summary>
        public static string InvalidOperation_BadInstructionOrIndexOutOfBound
        {
            get { return Resource.InvalidOperation_BadInstructionOrIndexOutOfBound; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Interface must be declared abstract..
        /// </summary>
        public static string InvalidOperation_BadInterfaceNotAbstract
        {
            get { return Resource.InvalidOperation_BadInterfaceNotAbstract; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Method &apos;{0}&apos; cannot have a method body..
        /// </summary>
        public static string InvalidOperation_BadMethodBody
        {
            get { return Resource.InvalidOperation_BadMethodBody; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to add resource to transient module or transient assembly..
        /// </summary>
        public static string InvalidOperation_BadResourceContainer
        {
            get { return Resource.InvalidOperation_BadResourceContainer; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to make a reference to a transient module from a non-transient module..
        /// </summary>
        public static string InvalidOperation_BadTransientModuleReference
        {
            get { return Resource.InvalidOperation_BadTransientModuleReference; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type must be declared abstract if any of its methods are abstract..
        /// </summary>
        public static string InvalidOperation_BadTypeAttributesNotAbstract
        {
            get { return Resource.InvalidOperation_BadTypeAttributesNotAbstract; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The method cannot be called twice on the same instance..
        /// </summary>
        public static string InvalidOperation_CalledTwice
        {
            get { return Resource.InvalidOperation_CalledTwice; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to alter assembly information..
        /// </summary>
        public static string InvalidOperation_CannotAlterAssembly
        {
            get { return Resource.InvalidOperation_CannotAlterAssembly; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Only newly captured contexts can be copied.
        /// </summary>
        public static string InvalidOperation_CannotCopyUsedContext
        {
            get { return Resource.InvalidOperation_CannotCopyUsedContext; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to import a global method or field from a different module..
        /// </summary>
        public static string InvalidOperation_CannotImportGlobalFromDifferentModule
        {
            get { return Resource.InvalidOperation_CannotImportGlobalFromDifferentModule; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Must override both HostExecutionContextManager.SetHostExecutionContext and HostExecutionContextManager.Revert..
        /// </summary>
        public static string InvalidOperation_CannotOverrideSetWithoutRevert
        {
            get { return Resource.InvalidOperation_CannotOverrideSetWithoutRevert; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Removal is an invalid operation for Stack or Queue..
        /// </summary>
        public static string InvalidOperation_CannotRemoveFromStackOrQueue
        {
            get { return Resource.InvalidOperation_CannotRemoveFromStackOrQueue; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot remove the last element from an empty collection..
        /// </summary>
        public static string InvalidOperation_CannotRemoveLastFromEmptyCollection
        {
            get { return Resource.InvalidOperation_CannotRemoveLastFromEmptyCollection; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot restore context flow when it is not suppressed..
        /// </summary>
        public static string InvalidOperation_CannotRestoreUnsupressedFlow
        {
            get { return Resource.InvalidOperation_CannotRestoreUnsupressedFlow; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Context flow is already suppressed..
        /// </summary>
        public static string InvalidOperation_CannotSupressFlowMultipleTimes
        {
            get { return Resource.InvalidOperation_CannotSupressFlowMultipleTimes; }
        }

        /// <summary>
        ///   Looks up a localized string similar to AsyncFlowControl object can be used only once to call Undo()..
        /// </summary>
        public static string InvalidOperation_CannotUseAFCMultiple
        {
            get { return Resource.InvalidOperation_CannotUseAFCMultiple; }
        }

        /// <summary>
        ///   Looks up a localized string similar to AsyncFlowControl object must be used on the thread where it was created..
        /// </summary>
        public static string InvalidOperation_CannotUseAFCOtherThread
        {
            get { return Resource.InvalidOperation_CannotUseAFCOtherThread; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Undo operation must be performed on the thread where the corresponding context was Set..
        /// </summary>
        public static string InvalidOperation_CannotUseSwitcherOtherThread
        {
            get { return Resource.InvalidOperation_CannotUseSwitcherOtherThread; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Applications may not prevent control-break from terminating their process..
        /// </summary>
        public static string InvalidOperation_CantCancelCtrlBreak
        {
            get { return Resource.InvalidOperation_CantCancelCtrlBreak; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Instances of abstract classes cannot be created..
        /// </summary>
        public static string InvalidOperation_CantInstantiateAbstractClass
        {
            get { return Resource.InvalidOperation_CantInstantiateAbstractClass; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Instances of function pointers cannot be created..
        /// </summary>
        public static string InvalidOperation_CantInstantiateFunctionPointer
        {
            get { return Resource.InvalidOperation_CantInstantiateFunctionPointer; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot save a transient assembly..
        /// </summary>
        public static string InvalidOperation_CantSaveTransientAssembly
        {
            get { return Resource.InvalidOperation_CantSaveTransientAssembly; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The Claim &apos;{0}&apos; was not able to be removed.  It is either not part of this Identity or it is a claim that is owned by the Principal that contains this Identity. For example, the Principal will own the claim when creating a GenericPrincipal with roles. The roles will be exposed through the Identity that is passed in the constructor, but not actually owned by the Identity.  Similar logic exists for a RolePrincipal..
        /// </summary>
        public static string InvalidOperation_ClaimCannotBeRemoved
        {
            get { return Resource.InvalidOperation_ClaimCannotBeRemoved; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The collection backing this Dictionary contains too many elements..
        /// </summary>
        public static string InvalidOperation_CollectionBackingDictionaryTooLarge
        {
            get { return Resource.InvalidOperation_CollectionBackingDictionaryTooLarge; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The collection backing this List contains too many elements..
        /// </summary>
        public static string InvalidOperation_CollectionBackingListTooLarge
        {
            get { return Resource.InvalidOperation_CollectionBackingListTooLarge; }
        }

        /// <summary>
        ///   Looks up a localized string similar to A prior operation on this collection was interrupted by an exception. Collection&apos;s state is no longer trusted..
        /// </summary>
        public static string InvalidOperation_CollectionCorrupted
        {
            get { return Resource.InvalidOperation_CollectionCorrupted; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Computer name could not be obtained..
        /// </summary>
        public static string InvalidOperation_ComputerName
        {
            get { return Resource.InvalidOperation_ComputerName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot see if a key has been pressed when either application does not have a console or when console input has been redirected from a file. Try Console.In.Peek..
        /// </summary>
        public static string InvalidOperation_ConsoleKeyAvailableOnFile
        {
            get { return Resource.InvalidOperation_ConsoleKeyAvailableOnFile; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot read keys when either application does not have a console or when console input has been redirected from a file. Try Console.Read..
        /// </summary>
        public static string InvalidOperation_ConsoleReadKeyOnFile
        {
            get { return Resource.InvalidOperation_ConsoleReadKeyOnFile; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Interface cannot have constructors..
        /// </summary>
        public static string InvalidOperation_ConstructorNotAllowedOnInterface
        {
            get { return Resource.InvalidOperation_ConstructorNotAllowedOnInterface; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Context is already frozen..
        /// </summary>
        public static string InvalidOperation_ContextAlreadyFrozen
        {
            get { return Resource.InvalidOperation_ContextAlreadyFrozen; }
        }

        /// <summary>
        ///   Looks up a localized string similar to SecurityTransparent and SecurityCritical attributes cannot be applied to the assembly scope at the same time..
        /// </summary>
        public static string InvalidOperation_CriticalTransparentAreMutuallyExclusive
        {
            get { return Resource.InvalidOperation_CriticalTransparentAreMutuallyExclusive; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Internal Error in DateTime and Calendar operations..
        /// </summary>
        public static string InvalidOperation_DateTimeParsing
        {
            get { return Resource.InvalidOperation_DateTimeParsing; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Debugger unable to launch..
        /// </summary>
        public static string InvalidOperation_DebuggerLaunchFailed
        {
            get { return Resource.InvalidOperation_DebuggerLaunchFailed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The method body of the default constructor cannot be changed..
        /// </summary>
        public static string InvalidOperation_DefaultConstructorDefineBody
        {
            get { return Resource.InvalidOperation_DefaultConstructorDefineBody; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to access ILGenerator on a constructor created with DefineDefaultConstructor..
        /// </summary>
        public static string InvalidOperation_DefaultConstructorILGen
        {
            get { return Resource.InvalidOperation_DefaultConstructorILGen; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Another property by this name already exists..
        /// </summary>
        public static string InvalidOperation_DuplicatePropertyName
        {
            get { return Resource.InvalidOperation_DuplicatePropertyName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Queue empty..
        /// </summary>
        public static string InvalidOperation_EmptyQueue
        {
            get { return Resource.InvalidOperation_EmptyQueue; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Stack empty..
        /// </summary>
        public static string InvalidOperation_EmptyStack
        {
            get { return Resource.InvalidOperation_EmptyStack; }
        }

        /// <summary>
        ///   Looks up a localized string similar to EndInvoke can only be called once for each asynchronous operation..
        /// </summary>
        public static string InvalidOperation_EndInvokeCalledMultiple
        {
            get { return Resource.InvalidOperation_EndInvokeCalledMultiple; }
        }

        /// <summary>
        ///   Looks up a localized string similar to EndRead can only be called once for each asynchronous operation..
        /// </summary>
        public static string InvalidOperation_EndReadCalledMultiple
        {
            get { return Resource.InvalidOperation_EndReadCalledMultiple; }
        }

        /// <summary>
        ///   Looks up a localized string similar to EndWrite can only be called once for each asynchronous operation..
        /// </summary>
        public static string InvalidOperation_EndWriteCalledMultiple
        {
            get { return Resource.InvalidOperation_EndWriteCalledMultiple; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Entry method is not defined in the same assembly..
        /// </summary>
        public static string InvalidOperation_EntryMethodNotDefinedInAssembly
        {
            get { return Resource.InvalidOperation_EntryMethodNotDefinedInAssembly; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Enumeration already finished..
        /// </summary>
        public static string InvalidOperation_EnumEnded
        {
            get { return Resource.InvalidOperation_EnumEnded; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Collection was modified; enumeration operation may not execute..
        /// </summary>
        public static string InvalidOperation_EnumFailedVersion
        {
            get { return Resource.InvalidOperation_EnumFailedVersion; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Enumeration has not started. Call MoveNext..
        /// </summary>
        public static string InvalidOperation_EnumNotStarted
        {
            get { return Resource.InvalidOperation_EnumNotStarted; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Enumeration has either not started or has already finished..
        /// </summary>
        public static string InvalidOperation_EnumOpCantHappen
        {
            get { return Resource.InvalidOperation_EnumOpCantHappen; }
        }

        /// <summary>
        ///   Looks up a localized string similar to This API does not support EventInfo tokens..
        /// </summary>
        public static string InvalidOperation_EventInfoNotAvailable
        {
            get { return Resource.InvalidOperation_EventInfoNotAvailable; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type &apos;{0}&apos; is not a delegate type.  EventTokenTable may only be used with delegate types..
        /// </summary>
        public static string InvalidOperation_EventTokenTableRequiresDelegate
        {
            get { return Resource.InvalidOperation_EventTokenTableRequiresDelegate; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Thread.ExceptionState cannot access an ExceptionState from a different AppDomain..
        /// </summary>
        public static string InvalidOperation_ExceptionStateCrossAppDomain
        {
            get { return Resource.InvalidOperation_ExceptionStateCrossAppDomain; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The generic parameters are already defined on this MethodBuilder..
        /// </summary>
        public static string InvalidOperation_GenericParametersAlreadySet
        {
            get { return Resource.InvalidOperation_GenericParametersAlreadySet; }
        }

        /// <summary>
        ///   Looks up a localized string similar to OSVersion&apos;s call to GetVersionEx unsuccessfully..
        /// </summary>
        public static string InvalidOperation_GetVersion
        {
            get { return Resource.InvalidOperation_GetVersion; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type definition of the global function has been completed..
        /// </summary>
        public static string InvalidOperation_GlobalsHaveBeenCreated
        {
            get { return Resource.InvalidOperation_GlobalsHaveBeenCreated; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Handle is not initialized..
        /// </summary>
        public static string InvalidOperation_HandleIsNotInitialized
        {
            get { return Resource.InvalidOperation_HandleIsNotInitialized; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Handle is not pinned..
        /// </summary>
        public static string InvalidOperation_HandleIsNotPinned
        {
            get { return Resource.InvalidOperation_HandleIsNotPinned; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Hashtable insert unsuccessfully. Load factor too high. The most common cause is multiple threads writing to the Hashtable simultaneously..
        /// </summary>
        public static string InvalidOperation_HashInsertFailed
        {
            get { return Resource.InvalidOperation_HashInsertFailed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The security state of an AppDomain was modified by an AppDomainManager configured with the NoSecurityChanges flag..
        /// </summary>
        public static string InvalidOperation_HostModifiedSecurityState
        {
            get { return Resource.InvalidOperation_HostModifiedSecurityState; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Failed to compare two elements in the array..
        /// </summary>
        public static string InvalidOperation_IComparerFailed
        {
            get { return Resource.InvalidOperation_IComparerFailed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid internal state..
        /// </summary>
        public static string InvalidOperation_InternalState
        {
            get { return Resource.InvalidOperation_InternalState; }
        }

        /// <summary>
        ///   Looks up a localized string similar to COM register function must have a System.Type parameter and a void return type..
        /// </summary>
        public static string InvalidOperation_InvalidComRegFunctionSig
        {
            get { return Resource.InvalidOperation_InvalidComRegFunctionSig; }
        }

        /// <summary>
        ///   Looks up a localized string similar to COM unregister function must have a System.Type parameter and a void return type..
        /// </summary>
        public static string InvalidOperation_InvalidComUnRegFunctionSig
        {
            get { return Resource.InvalidOperation_InvalidComUnRegFunctionSig; }
        }

        /// <summary>
        ///    Looks up a localized string similar to Invalid code &quot;{0}&quot; for enum type &quot;{1}&quot;..
        /// </summary>
        public static string InvalidOperation_InvalidEnumCode
        {
            get { return Resource.InvalidOperation_InvalidEnumCode; }
        }

        /// <summary>
        ///    Looks up a localized string similar to Invalid value &quot;{0}&quot; for enum type &quot;{1}&quot;..
        /// </summary>
        public static string InvalidOperation_InvalidEnumValue
        {
            get { return Resource.InvalidOperation_InvalidEnumValue; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Metadata operation unsuccessfully..
        /// </summary>
        public static string InvalidOperation_MetaDataError
        {
            get { return Resource.InvalidOperation_MetaDataError; }
        }

        /// <summary>
        ///   Looks up a localized string similar to This method is not supported by the current object..
        /// </summary>
        public static string InvalidOperation_Method
        {
            get { return Resource.InvalidOperation_Method; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type definition of the method is complete..
        /// </summary>
        public static string InvalidOperation_MethodBaked
        {
            get { return Resource.InvalidOperation_MethodBaked; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The signature of the MethodBuilder can no longer be modified because an operation on the MethodBuilder caused the methodDef token to be created. For example, a call to SetCustomAttribute requires the methodDef token to emit the CustomAttribute token..
        /// </summary>
        public static string InvalidOperation_MethodBuilderBaked
        {
            get { return Resource.InvalidOperation_MethodBuilderBaked; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Method already has a body..
        /// </summary>
        public static string InvalidOperation_MethodHasBody
        {
            get { return Resource.InvalidOperation_MethodHasBody; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The IAsyncResult object provided does not match this delegate..
        /// </summary>
        public static string InvalidOperation_MismatchedAsyncResult
        {
            get { return Resource.InvalidOperation_MismatchedAsyncResult; }
        }

        /// <summary>
        ///   Looks up a localized string similar to This access control list is not in canonical form and therefore cannot be modified..
        /// </summary>
        public static string InvalidOperation_ModificationOfNonCanonicalAcl
        {
            get { return Resource.InvalidOperation_ModificationOfNonCanonicalAcl; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to modify a read-only NumberFormatInfo object..
        /// </summary>
        public static string InvalidOperation_ModifyRONumFmtInfo
        {
            get { return Resource.InvalidOperation_ModifyRONumFmtInfo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to ReadOnlyPermissionSet objects may not be modified..
        /// </summary>
        public static string InvalidOperation_ModifyROPermSet
        {
            get { return Resource.InvalidOperation_ModifyROPermSet; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Module &apos;{0}&apos; has been saved..
        /// </summary>
        public static string InvalidOperation_ModuleHasBeenSaved
        {
            get { return Resource.InvalidOperation_ModuleHasBeenSaved; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type &apos;{0}&apos; has more than one COM registration function..
        /// </summary>
        public static string InvalidOperation_MultipleComRegFunctions
        {
            get { return Resource.InvalidOperation_MultipleComRegFunctions; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type &apos;{0}&apos; has more than one COM unregistration function..
        /// </summary>
        public static string InvalidOperation_MultipleComUnRegFunctions
        {
            get { return Resource.InvalidOperation_MultipleComUnRegFunctions; }
        }

        /// <summary>
        ///   Looks up a localized string similar to This operation must take place on the same thread on which the object was created..
        /// </summary>
        public static string InvalidOperation_MustBeSameThread
        {
            get { return Resource.InvalidOperation_MustBeSameThread; }
        }

        /// <summary>
        ///   Looks up a localized string similar to You must call Initialize on this object instance before using it..
        /// </summary>
        public static string InvalidOperation_MustCallInitialize
        {
            get { return Resource.InvalidOperation_MustCallInitialize; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object must be locked for read or write..
        /// </summary>
        public static string InvalidOperation_MustLockForReadOrWrite
        {
            get { return Resource.InvalidOperation_MustLockForReadOrWrite; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object must be locked for read..
        /// </summary>
        public static string InvalidOperation_MustLockForWrite
        {
            get { return Resource.InvalidOperation_MustLockForWrite; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Must revert the privilege prior to attempting this operation..
        /// </summary>
        public static string InvalidOperation_MustRevertPrivilege
        {
            get { return Resource.InvalidOperation_MustRevertPrivilege; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Assembly does not have a code base..
        /// </summary>
        public static string InvalidOperation_NoAsmCodeBase
        {
            get { return Resource.InvalidOperation_NoAsmCodeBase; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Assembly does not have an assembly name. In order to be registered for use by COM, an assembly must have a valid assembly name..
        /// </summary>
        public static string InvalidOperation_NoAsmName
        {
            get { return Resource.InvalidOperation_NoAsmName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to You cannot have more than one dynamic module in each dynamic assembly in this version of the runtime..
        /// </summary>
        public static string InvalidOperation_NoMultiModuleAssembly
        {
            get { return Resource.InvalidOperation_NoMultiModuleAssembly; }
        }

        /// <summary>
        ///   Looks up a localized string similar to COM register function must be static..
        /// </summary>
        public static string InvalidOperation_NonStaticComRegFunction
        {
            get { return Resource.InvalidOperation_NonStaticComRegFunction; }
        }

        /// <summary>
        ///   Looks up a localized string similar to COM unregister function must be static..
        /// </summary>
        public static string InvalidOperation_NonStaticComUnRegFunction
        {
            get { return Resource.InvalidOperation_NonStaticComUnRegFunction; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot add the event handler since no public add method exists for the event..
        /// </summary>
        public static string InvalidOperation_NoPublicAddMethod
        {
            get { return Resource.InvalidOperation_NoPublicAddMethod; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot remove the event handler since no public remove method exists for the event..
        /// </summary>
        public static string InvalidOperation_NoPublicRemoveMethod
        {
            get { return Resource.InvalidOperation_NoPublicRemoveMethod; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The object does not contain a security descriptor..
        /// </summary>
        public static string InvalidOperation_NoSecurityDescriptor
        {
            get { return Resource.InvalidOperation_NoSecurityDescriptor; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Not a debug ModuleBuilder..
        /// </summary>
        public static string InvalidOperation_NotADebugModule
        {
            get { return Resource.InvalidOperation_NotADebugModule; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The requested operation is invalid for DynamicMethod..
        /// </summary>
        public static string InvalidOperation_NotAllowedInDynamicMethod
        {
            get { return Resource.InvalidOperation_NotAllowedInDynamicMethod; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The requested operation is invalid in the ReflectionOnly context..
        /// </summary>
        public static string InvalidOperation_NotAllowedInReflectionOnly
        {
            get { return Resource.InvalidOperation_NotAllowedInReflectionOnly; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Calling convention must be VarArgs..
        /// </summary>
        public static string InvalidOperation_NotAVarArgCallingConvention
        {
            get { return Resource.InvalidOperation_NotAVarArgCallingConvention; }
        }

        /// <summary>
        ///   Looks up a localized string similar to You can only define a dynamic assembly on the current AppDomain..
        /// </summary>
        public static string InvalidOperation_NotCurrentDomain
        {
            get { return Resource.InvalidOperation_NotCurrentDomain; }
        }

        /// <summary>
        ///   Looks up a localized string similar to This operation is only valid on generic types..
        /// </summary>
        public static string InvalidOperation_NotGenericType
        {
            get { return Resource.InvalidOperation_NotGenericType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot apply a context that has been marshaled across AppDomains, that was not acquired through a Capture operation or that has already been the argument to a Set call..
        /// </summary>
        public static string InvalidOperation_NotNewCaptureContext
        {
            get { return Resource.InvalidOperation_NotNewCaptureContext; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Adding or removing event handlers dynamically is not supported on WinRT events..
        /// </summary>
        public static string InvalidOperation_NotSupportedOnWinRTEvent
        {
            get { return Resource.InvalidOperation_NotSupportedOnWinRTEvent; }
        }

        /// <summary>
        ///   Looks up a localized string similar to This API is not available when the concurrent GC is enabled..
        /// </summary>
        public static string InvalidOperation_NotWithConcurrentGC
        {
            get { return Resource.InvalidOperation_NotWithConcurrentGC; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Underlying type information on enumeration is not specified..
        /// </summary>
        public static string InvalidOperation_NoUnderlyingTypeOnEnum
        {
            get { return Resource.InvalidOperation_NoUnderlyingTypeOnEnum; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Nullable object must have a value..
        /// </summary>
        public static string InvalidOperation_NoValue
        {
            get { return Resource.InvalidOperation_NoValue; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The underlying array is null..
        /// </summary>
        public static string InvalidOperation_NullArray
        {
            get { return Resource.InvalidOperation_NullArray; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot call Set on a null context.
        /// </summary>
        public static string InvalidOperation_NullContext
        {
            get { return Resource.InvalidOperation_NullContext; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The requested operation is invalid when called on a null ModuleHandle..
        /// </summary>
        public static string InvalidOperation_NullModuleHandle
        {
            get { return Resource.InvalidOperation_NullModuleHandle; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Adding ACEs with Object Flags and Object GUIDs is only valid for directory-object ACLs..
        /// </summary>
        public static string InvalidOperation_OnlyValidForDS
        {
            get { return Resource.InvalidOperation_OnlyValidForDS; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Local variable scope was not properly closed..
        /// </summary>
        public static string InvalidOperation_OpenLocalVariableScope
        {
            get { return Resource.InvalidOperation_OpenLocalVariableScope; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot pack a packed Overlapped again..
        /// </summary>
        public static string InvalidOperation_Overlapped_Pack
        {
            get { return Resource.InvalidOperation_Overlapped_Pack; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Primary interop assemblies must be strongly named..
        /// </summary>
        public static string InvalidOperation_PIAMustBeStrongNamed
        {
            get { return Resource.InvalidOperation_PIAMustBeStrongNamed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to This API does not support PropertyInfo tokens..
        /// </summary>
        public static string InvalidOperation_PropertyInfoNotAvailable
        {
            get { return Resource.InvalidOperation_PropertyInfoNotAvailable; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Instance is read-only..
        /// </summary>
        public static string InvalidOperation_ReadOnly
        {
            get { return Resource.InvalidOperation_ReadOnly; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Registry key has subkeys and recursive removes are not supported by this method..
        /// </summary>
        public static string InvalidOperation_RegRemoveSubKey
        {
            get { return Resource.InvalidOperation_RegRemoveSubKey; }
        }

        /// <summary>
        ///   Looks up a localized string similar to &apos;{0}&apos;: ResourceSet derived classes must provide a constructor that takes a String file name and a constructor that takes a Stream..
        /// </summary>
        public static string InvalidOperation_ResMgrBadResSet_Type
        {
            get { return Resource.InvalidOperation_ResMgrBadResSet_Type; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Resource &apos;{0}&apos; was not a Stream - call GetObject instead..
        /// </summary>
        public static string InvalidOperation_ResourceNotStream_Name
        {
            get { return Resource.InvalidOperation_ResourceNotStream_Name; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Resource &apos;{0}&apos; was not a String - call GetObject instead..
        /// </summary>
        public static string InvalidOperation_ResourceNotString_Name
        {
            get { return Resource.InvalidOperation_ResourceNotString_Name; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Resource was of type &apos;{0}&apos; instead of String - call GetObject instead..
        /// </summary>
        public static string InvalidOperation_ResourceNotString_Type
        {
            get { return Resource.InvalidOperation_ResourceNotString_Type; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The resource writer has already been closed and cannot be edited..
        /// </summary>
        public static string InvalidOperation_ResourceWriterSaved
        {
            get { return Resource.InvalidOperation_ResourceWriterSaved; }
        }

        /// <summary>
        ///   Looks up a localized string similar to An additional permission should not be supplied for setting loader information..
        /// </summary>
        public static string InvalidOperation_SetData
        {
            get { return Resource.InvalidOperation_SetData; }
        }

        /// <summary>
        ///   Looks up a localized string similar to SetData cannot be used to set the value for &apos;{0}&apos;..
        /// </summary>
        public static string InvalidOperation_SetData_OnlyLocationURI
        {
            get { return Resource.InvalidOperation_SetData_OnlyLocationURI; }
        }

        /// <summary>
        ///   Looks up a localized string similar to SetData can only be used to set the value of a given name once..
        /// </summary>
        public static string InvalidOperation_SetData_OnlyOnce
        {
            get { return Resource.InvalidOperation_SetData_OnlyOnce; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Volume labels can only be set for writable local volumes..
        /// </summary>
        public static string InvalidOperation_SetVolumeLabelFailed
        {
            get { return Resource.InvalidOperation_SetVolumeLabelFailed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Method body should not exist..
        /// </summary>
        public static string InvalidOperation_ShouldNotHaveMethodBody
        {
            get { return Resource.InvalidOperation_ShouldNotHaveMethodBody; }
        }

        /// <summary>
        ///   Looks up a localized string similar to LocalDataStoreSlot storage has been freed..
        /// </summary>
        public static string InvalidOperation_SlotHasBeenFreed
        {
            get { return Resource.InvalidOperation_SlotHasBeenFreed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to A strong name key pair is required to emit a strong-named dynamic assembly..
        /// </summary>
        public static string InvalidOperation_StrongNameKeyPairRequired
        {
            get { return Resource.InvalidOperation_StrongNameKeyPairRequired; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot set sub-classed {0} object to {1} object..
        /// </summary>
        public static string InvalidOperation_SubclassedObject
        {
            get { return Resource.InvalidOperation_SubclassedObject; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The Undo operation encountered a context that is different from what was applied in the corresponding Set operation. The possible cause is that a context was Set on the thread and not reverted(undone)..
        /// </summary>
        public static string InvalidOperation_SwitcherCtxMismatch
        {
            get { return Resource.InvalidOperation_SwitcherCtxMismatch; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Use CompressedStack.(Capture/Run) or ExecutionContext.(Capture/Run) APIs instead..
        /// </summary>
        public static string InvalidOperation_ThreadAPIsNotSupported
        {
            get { return Resource.InvalidOperation_ThreadAPIsNotSupported; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The thread was created with a ThreadStart delegate that does not accept a parameter..
        /// </summary>
        public static string InvalidOperation_ThreadWrongThreadStart
        {
            get { return Resource.InvalidOperation_ThreadWrongThreadStart; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Timeouts are not supported on this stream..
        /// </summary>
        public static string InvalidOperation_TimeoutsNotSupported
        {
            get { return Resource.InvalidOperation_TimeoutsNotSupported; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The given type cannot be boxed..
        /// </summary>
        public static string InvalidOperation_TypeCannotBeBoxed
        {
            get { return Resource.InvalidOperation_TypeCannotBeBoxed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to change after type has been created..
        /// </summary>
        public static string InvalidOperation_TypeHasBeenCreated
        {
            get { return Resource.InvalidOperation_TypeHasBeenCreated; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type has not been created..
        /// </summary>
        public static string InvalidOperation_TypeNotCreated
        {
            get { return Resource.InvalidOperation_TypeNotCreated; }
        }

        /// <summary>
        ///   Looks up a localized string similar to This range in the underlying list is invalid. A possible cause is that elements were removed..
        /// </summary>
        public static string InvalidOperation_UnderlyingArrayListChanged
        {
            get { return Resource.InvalidOperation_UnderlyingArrayListChanged; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unexpected error when calling an operating system function.  The returned error code is 0x{0:x}..
        /// </summary>
        public static string InvalidOperation_UnexpectedWin32Error
        {
            get { return Resource.InvalidOperation_UnexpectedWin32Error; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unknown enum type..
        /// </summary>
        public static string InvalidOperation_UnknownEnumType
        {
            get { return Resource.InvalidOperation_UnknownEnumType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to UserDomainName native call unsuccessfully..
        /// </summary>
        public static string InvalidOperation_UserDomainName
        {
            get { return Resource.InvalidOperation_UserDomainName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot wait on a transparent proxy..
        /// </summary>
        public static string InvalidOperation_WaitOnTransparentProxy
        {
            get { return Resource.InvalidOperation_WaitOnTransparentProxy; }
        }

        /// <summary>
        ///   Looks up a localized string similar to This API is not available when AppDomain Resource Monitoring is not turned on..
        /// </summary>
        public static string InvalidOperation_WithoutARM
        {
            get { return Resource.InvalidOperation_WithoutARM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to This property has already been set and cannot be modified..
        /// </summary>
        public static string InvalidOperation_WriteOnce
        {
            get { return Resource.InvalidOperation_WriteOnce; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Either the IAsyncResult object did not come from the corresponding async method on this type, or the End method was called multiple times with the same IAsyncResult..
        /// </summary>
        public static string InvalidOperation_WrongAsyncResultOrEndCalledMultiple
        {
            get { return Resource.InvalidOperation_WrongAsyncResultOrEndCalledMultiple; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Either the IAsyncResult object did not come from the corresponding async method on this type, or EndRead was called multiple times with the same IAsyncResult..
        /// </summary>
        public static string InvalidOperation_WrongAsyncResultOrEndReadCalledMultiple
        {
            get { return Resource.InvalidOperation_WrongAsyncResultOrEndReadCalledMultiple; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Either the IAsyncResult object did not come from the corresponding async method on this type, or EndWrite was called multiple times with the same IAsyncResult..
        /// </summary>
        public static string InvalidOperation_WrongAsyncResultOrEndWriteCalledMultiple
        {
            get { return Resource.InvalidOperation_WrongAsyncResultOrEndWriteCalledMultiple; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Actor cannot be set so that circular directed graph will exist chaining the subjects together..
        /// </summary>
        public static string InvalidOperationException_ActorGraphCircular
        {
            get { return Resource.InvalidOperationException_ActorGraphCircular; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Common Language Runtime detected an invalid program..
        /// </summary>
        public static string InvalidProgram_Default
        {
            get { return Resource.InvalidProgram_Default; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The time zone ID &apos;{0}&apos; was found on the local computer, but the file at &apos;{1}&apos; was corrupt..
        /// </summary>
        public static string InvalidTimeZone_InvalidFileData
        {
            get { return Resource.InvalidTimeZone_InvalidFileData; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The time zone ID &apos;{0}&apos; was found on the local computer, but the registry information was corrupt..
        /// </summary>
        public static string InvalidTimeZone_InvalidRegistryData
        {
            get { return Resource.InvalidTimeZone_InvalidRegistryData; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The Local time zone was found on the local computer, but the data was corrupt..
        /// </summary>
        public static string InvalidTimeZone_InvalidWin32APIData
        {
            get { return Resource.InvalidTimeZone_InvalidWin32APIData; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Julian dates in POSIX strings are unsupported..
        /// </summary>
        public static string InvalidTimeZone_JulianDayNotSupported
        {
            get { return Resource.InvalidTimeZone_JulianDayNotSupported; }
        }

        /// <summary>
        ///   Looks up a localized string similar to There are no ttinfo structures in the tzfile.  At least one ttinfo structure is required in order to construct a TimeZoneInfo object..
        /// </summary>
        public static string InvalidTimeZone_NoTTInfoStructures
        {
            get { return Resource.InvalidTimeZone_NoTTInfoStructures; }
        }

        /// <summary>
        ///   Looks up a localized string similar to &apos;{0}&apos; is not a valid POSIX-TZ-environment-variable MDate rule.  A valid rule has the format &apos;Mm.w.d&apos;..
        /// </summary>
        public static string InvalidTimeZone_UnparseablePosixMDateString
        {
            get { return Resource.InvalidTimeZone_UnparseablePosixMDateString; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invariant unsuccessfully..
        /// </summary>
        public static string InvariantFailed
        {
            get { return Resource.InvariantFailed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invariant unsuccessfully: {0}.
        /// </summary>
        public static string InvariantFailed_Cnd
        {
            get { return Resource.InvariantFailed_Cnd; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Could not find the drive &apos;{0}&apos;. The drive might not be ready or might not be mapped..
        /// </summary>
        public static string IO_DriveNotFound_Drive
        {
            get { return Resource.IO_DriveNotFound_Drive; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to read beyond the end of the stream..
        /// </summary>
        public static string IO_EOF_ReadBeyondEOF
        {
            get { return Resource.IO_EOF_ReadBeyondEOF; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Could not load the specified file..
        /// </summary>
        public static string IO_FileLoad
        {
            get { return Resource.IO_FileLoad; }
        }

        /// <summary>
        ///   Looks up a localized string similar to File name: &apos;{0}&apos;.
        /// </summary>
        public static string IO_FileName_Name
        {
            get { return Resource.IO_FileName_Name; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to find the specified file..
        /// </summary>
        public static string IO_FileNotFound
        {
            get { return Resource.IO_FileNotFound; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Could not find file &apos;{0}&apos;..
        /// </summary>
        public static string IO_FileNotFound_FileName
        {
            get { return Resource.IO_FileNotFound_FileName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot create &quot;{0}&quot; because a file or directory with the same name already exists..
        /// </summary>
        public static string IO_IO_AlreadyExists_Name
        {
            get { return Resource.IO_IO_AlreadyExists_Name; }
        }

        /// <summary>
        ///   Looks up a localized string similar to BindHandle for ThreadPool unsuccessfully on this handle..
        /// </summary>
        public static string IO_IO_BindHandleFailed
        {
            get { return Resource.IO_IO_BindHandleFailed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified directory &apos;{0}&apos; cannot be created..
        /// </summary>
        public static string IO_IO_CannotCreateDirectory
        {
            get { return Resource.IO_IO_CannotCreateDirectory; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The file &apos;{0}&apos; already exists..
        /// </summary>
        public static string IO_IO_FileExists_Name
        {
            get { return Resource.IO_IO_FileExists_Name; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The OS handle&apos;s position is not what FileStream expected. Do not use a handle simultaneously in one FileStream and in Win32 code or another FileStream. This may cause data loss..
        /// </summary>
        public static string IO_IO_FileStreamHandlePosition
        {
            get { return Resource.IO_IO_FileStreamHandlePosition; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The file is too long. This operation is currently limited to supporting files less than 2 gigabytes in size..
        /// </summary>
        public static string IO_IO_FileTooLong2GB
        {
            get { return Resource.IO_IO_FileTooLong2GB; }
        }

        /// <summary>
        ///   Looks up a localized string similar to IO operation will not work. Most likely the file will become too long or the handle was not opened to support synchronous IO operations..
        /// </summary>
        public static string IO_IO_FileTooLongOrHandleNotSync
        {
            get { return Resource.IO_IO_FileTooLongOrHandleNotSync; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to expand length of this stream beyond its capacity..
        /// </summary>
        public static string IO_IO_FixedCapacity
        {
            get { return Resource.IO_IO_FixedCapacity; }
        }

        /// <summary>
        ///   Looks up a localized string similar to BinaryReader encountered an invalid string length of {0} characters..
        /// </summary>
        public static string IO_IO_InvalidStringLen_Len
        {
            get { return Resource.IO_IO_InvalidStringLen_Len; }
        }

        /// <summary>
        ///   Looks up a localized string similar to There is no console..
        /// </summary>
        public static string IO_IO_NoConsole
        {
            get { return Resource.IO_IO_NoConsole; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Path discovery permission to the specified directory was denied..
        /// </summary>
        public static string IO_IO_NoPermissionToDirectoryName
        {
            get { return Resource.IO_IO_NoPermissionToDirectoryName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable seek backward to overwrite data that previously existed in a file opened in Append mode..
        /// </summary>
        public static string IO_IO_SeekAppendOverwrite
        {
            get { return Resource.IO_IO_SeekAppendOverwrite; }
        }

        /// <summary>
        ///   Looks up a localized string similar to An attempt was made to move the position before the beginning of the stream..
        /// </summary>
        public static string IO_IO_SeekBeforeBegin
        {
            get { return Resource.IO_IO_SeekBeforeBegin; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to truncate data that previously existed in a file opened in Append mode..
        /// </summary>
        public static string IO_IO_SetLengthAppendTruncate
        {
            get { return Resource.IO_IO_SetLengthAppendTruncate; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The process cannot access the file &apos;{0}&apos; because it is being used by another process..
        /// </summary>
        public static string IO_IO_SharingViolation_File
        {
            get { return Resource.IO_IO_SharingViolation_File; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The process cannot access the file because it is being used by another process..
        /// </summary>
        public static string IO_IO_SharingViolation_NoFileName
        {
            get { return Resource.IO_IO_SharingViolation_NoFileName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Source and destination path must be different..
        /// </summary>
        public static string IO_IO_SourceDestMustBeDifferent
        {
            get { return Resource.IO_IO_SourceDestMustBeDifferent; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Source and destination path must have identical roots. Move will not work across volumes..
        /// </summary>
        public static string IO_IO_SourceDestMustHaveSameRoot
        {
            get { return Resource.IO_IO_SourceDestMustHaveSameRoot; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Stream was too long..
        /// </summary>
        public static string IO_IO_StreamTooLong
        {
            get { return Resource.IO_IO_StreamTooLong; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Could not find a part of the path..
        /// </summary>
        public static string IO_PathNotFound_NoPathName
        {
            get { return Resource.IO_PathNotFound_NoPathName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Could not find a part of the path &apos;{0}&apos;..
        /// </summary>
        public static string IO_PathNotFound_Path
        {
            get { return Resource.IO_PathNotFound_Path; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified path, file name, or both are too long. The fully qualified file name must be less than 260 characters, and the directory name must be less than 248 characters..
        /// </summary>
        public static string IO_PathTooLong
        {
            get { return Resource.IO_PathTooLong; }
        }

        /// <summary>
        ///   Looks up a localized string similar to A StreamWriter was not closed and all buffered data within that StreamWriter was not flushed to the underlying stream.  (This was detected when the StreamWriter was finalized with data in its buffer.)  A portion of the data was lost.  Consider one of calling Close(), Flush(), setting the StreamWriter&apos;s AutoFlush property to true, or allocating the StreamWriter with a &quot;using&quot; statement.  Stream type: {0}\r\nFile name: {1}\r\nAllocated from:\r\n {2}.
        /// </summary>
        public static string IO_StreamWriterBufferedDataLost
        {
            get { return Resource.IO_StreamWriterBufferedDataLost; }
        }

        /// <summary>
        ///   Looks up a localized string similar to callstack information is not captured by default for performance reasons. Please enable captureAllocatedCallStack config switch for streamWriterBufferedDataLost MDA (refer to MSDN MDA documentation for how to do this).  .
        /// </summary>
        public static string IO_StreamWriterBufferedDataLostCaptureAllocatedFromCallstackNotEnabled
        {
            get { return Resource.IO_StreamWriterBufferedDataLostCaptureAllocatedFromCallstackNotEnabled; }
        }

        /// <summary>
        ///   Looks up a localized string similar to [Unknown].
        /// </summary>
        public static string IO_UnknownFileName
        {
            get { return Resource.IO_UnknownFileName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to determine granted permission for application..
        /// </summary>
        public static string IsolatedStorage_ApplicationGrantSet
        {
            get { return Resource.IsolatedStorage_ApplicationGrantSet; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to determine application identity of the caller..
        /// </summary>
        public static string IsolatedStorage_ApplicationMissingIdentity
        {
            get { return Resource.IsolatedStorage_ApplicationMissingIdentity; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to determine identity of application..
        /// </summary>
        public static string IsolatedStorage_ApplicationNoEvidence
        {
            get { return Resource.IsolatedStorage_ApplicationNoEvidence; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Application cannot be determined on an Assembly or Domain store..
        /// </summary>
        public static string IsolatedStorage_ApplicationUndefined
        {
            get { return Resource.IsolatedStorage_ApplicationUndefined; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to determine granted permission for assembly..
        /// </summary>
        public static string IsolatedStorage_AssemblyGrantSet
        {
            get { return Resource.IsolatedStorage_AssemblyGrantSet; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to determine assembly of the caller..
        /// </summary>
        public static string IsolatedStorage_AssemblyMissingIdentity
        {
            get { return Resource.IsolatedStorage_AssemblyMissingIdentity; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to determine identity of assembly..
        /// </summary>
        public static string IsolatedStorage_AssemblyNoEvidence
        {
            get { return Resource.IsolatedStorage_AssemblyNoEvidence; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Assembly cannot be determined for an Application store..
        /// </summary>
        public static string IsolatedStorage_AssemblyUndefined
        {
            get { return Resource.IsolatedStorage_AssemblyUndefined; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to create directory..
        /// </summary>
        public static string IsolatedStorage_CreateDirectory
        {
            get { return Resource.IsolatedStorage_CreateDirectory; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Current size cannot be determined for this store..
        /// </summary>
        public static string IsolatedStorage_CurrentSizeUndefined
        {
            get { return Resource.IsolatedStorage_CurrentSizeUndefined; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to delete; directory or files in the directory could be in use..
        /// </summary>
        public static string IsolatedStorage_DeleteDirectories
        {
            get { return Resource.IsolatedStorage_DeleteDirectories; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to delete, directory not empty or does not exist..
        /// </summary>
        public static string IsolatedStorage_DeleteDirectory
        {
            get { return Resource.IsolatedStorage_DeleteDirectory; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to delete file..
        /// </summary>
        public static string IsolatedStorage_DeleteFile
        {
            get { return Resource.IsolatedStorage_DeleteFile; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to determine granted permission for domain..
        /// </summary>
        public static string IsolatedStorage_DomainGrantSet
        {
            get { return Resource.IsolatedStorage_DomainGrantSet; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to determine domain of the caller..
        /// </summary>
        public static string IsolatedStorage_DomainMissingIdentity
        {
            get { return Resource.IsolatedStorage_DomainMissingIdentity; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to determine the identity of domain..
        /// </summary>
        public static string IsolatedStorage_DomainNoEvidence
        {
            get { return Resource.IsolatedStorage_DomainNoEvidence; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Domain cannot be determined on an Assembly or Application store..
        /// </summary>
        public static string IsolatedStorage_DomainUndefined
        {
            get { return Resource.IsolatedStorage_DomainUndefined; }
        }

        /// <summary>
        ///   Looks up a localized string similar to An error occurred while accessing IsolatedStorage..
        /// </summary>
        public static string IsolatedStorage_Exception
        {
            get { return Resource.IsolatedStorage_Exception; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid mode, see System.IO.FileMode..
        /// </summary>
        public static string IsolatedStorage_FileOpenMode
        {
            get { return Resource.IsolatedStorage_FileOpenMode; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Initialization unsuccessfully..
        /// </summary>
        public static string IsolatedStorage_Init
        {
            get { return Resource.IsolatedStorage_Init; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The Site scope is currently not supported..
        /// </summary>
        public static string IsolatedStorage_NotValidOnDesktop
        {
            get { return Resource.IsolatedStorage_NotValidOnDesktop; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The new quota must be larger than the old quota..
        /// </summary>
        public static string IsolatedStorage_OldQuotaLarger
        {
            get { return Resource.IsolatedStorage_OldQuotaLarger; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Increasing the quota of this scope is not supported.  Only the user application scope’s quota can be increased..
        /// </summary>
        public static string IsolatedStorage_OnlyIncreaseUserApplicationStore
        {
            get { return Resource.IsolatedStorage_OnlyIncreaseUserApplicationStore; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Operation not permitted..
        /// </summary>
        public static string IsolatedStorage_Operation
        {
            get { return Resource.IsolatedStorage_Operation; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Operation not permitted on IsolatedStorageFileStream..
        /// </summary>
        public static string IsolatedStorage_Operation_ISFS
        {
            get { return Resource.IsolatedStorage_Operation_ISFS; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Path must be a valid file name..
        /// </summary>
        public static string IsolatedStorage_Path
        {
            get { return Resource.IsolatedStorage_Path; }
        }

        /// <summary>
        ///   Looks up a localized string similar to {0} is not defined for this store. An operation was performed that requires access to {0}. Stores obtained using enumeration APIs do not have a well-defined {0}, since partial evidence is used to open the store..
        /// </summary>
        public static string IsolatedStorage_QuotaIsUndefined
        {
            get { return Resource.IsolatedStorage_QuotaIsUndefined; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid scope..
        /// </summary>
        public static string IsolatedStorage_Scope_Invalid
        {
            get { return Resource.IsolatedStorage_Scope_Invalid; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid scope, expected User, User|Roaming or Machine..
        /// </summary>
        public static string IsolatedStorage_Scope_U_R_M
        {
            get { return Resource.IsolatedStorage_Scope_U_R_M; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid origin, see System.IO.SeekOrigin..
        /// </summary>
        public static string IsolatedStorage_SeekOrigin
        {
            get { return Resource.IsolatedStorage_SeekOrigin; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Store must be open for this operation..
        /// </summary>
        public static string IsolatedStorage_StoreNotOpen
        {
            get { return Resource.IsolatedStorage_StoreNotOpen; }
        }

        /// <summary>
        ///   Looks up a localized string similar to There is not enough free space to perform the operation..
        /// </summary>
        public static string IsolatedStorage_UsageWillExceedQuota
        {
            get { return Resource.IsolatedStorage_UsageWillExceedQuota; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The lazily-initialized type does not have a public, parameterless constructor..
        /// </summary>
        public static string Lazy_CreateValue_NoParameterlessCtorForT
        {
            get { return Resource.Lazy_CreateValue_NoParameterlessCtorForT; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The Value cannot be null..
        /// </summary>
        public static string Lazy_ctor_deserialization_ValueInvalid
        {
            get { return Resource.Lazy_ctor_deserialization_ValueInvalid; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The info argument is null..
        /// </summary>
        public static string Lazy_ctor_InfoNull
        {
            get { return Resource.Lazy_ctor_InfoNull; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The mode argument specifies an invalid value..
        /// </summary>
        public static string Lazy_ctor_ModeInvalid
        {
            get { return Resource.Lazy_ctor_ModeInvalid; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The valueSelector argument is null..
        /// </summary>
        public static string Lazy_ctor_ValueSelectorNull
        {
            get { return Resource.Lazy_ctor_ValueSelectorNull; }
        }

        /// <summary>
        ///   Looks up a localized string similar to ValueFactory returned null..
        /// </summary>
        public static string Lazy_StaticInit_InvalidOperation
        {
            get { return Resource.Lazy_StaticInit_InvalidOperation; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Value is not created..
        /// </summary>
        public static string Lazy_ToString_ValueNotCreated
        {
            get { return Resource.Lazy_ToString_ValueNotCreated; }
        }

        /// <summary>
        ///   Looks up a localized string similar to ValueFactory attempted to access the Value property of this instance..
        /// </summary>
        public static string Lazy_Value_RecursiveCallsToValue
        {
            get { return Resource.Lazy_Value_RecursiveCallsToValue; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Context Policies:.
        /// </summary>
        public static string Loader_ContextPolicies
        {
            get { return Resource.Loader_ContextPolicies; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Relative path must be a string that contains the substring, &quot;..&quot;, or does not contain a root directory..
        /// </summary>
        public static string Loader_InvalidPath
        {
            get { return Resource.Loader_InvalidPath; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Name:.
        /// </summary>
        public static string Loader_Name
        {
            get { return Resource.Loader_Name; }
        }

        /// <summary>
        ///   Looks up a localized string similar to There are no context policies..
        /// </summary>
        public static string Loader_NoContextPolicies
        {
            get { return Resource.Loader_NoContextPolicies; }
        }

        /// <summary>
        ///   Looks up a localized string similar to {0} of .NET Framework assemblies is not supported in AppX..
        /// </summary>
        public static string LoadOfFxAssemblyNotSupported_AppX
        {
            get { return Resource.LoadOfFxAssemblyNotSupported_AppX; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The spinCount argument must be in the range 0 to {0}, inclusive..
        /// </summary>
        public static string ManualResetEventSlim_ctor_SpinCountOutOfRange
        {
            get { return Resource.ManualResetEventSlim_ctor_SpinCountOutOfRange; }
        }

        /// <summary>
        ///   Looks up a localized string similar to There are too many threads currently waiting on the event. A maximum of {0} waiting threads are supported..
        /// </summary>
        public static string ManualResetEventSlim_ctor_TooManyWaiters
        {
            get { return Resource.ManualResetEventSlim_ctor_TooManyWaiters; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The event has been disposed..
        /// </summary>
        public static string ManualResetEventSlim_Disposed
        {
            get { return Resource.ManualResetEventSlim_Disposed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Marshaler restriction: Excessively long string..
        /// </summary>
        public static string Marshaler_StringTooLong
        {
            get { return Resource.Marshaler_StringTooLong; }
        }

        /// <summary>
        ///   Looks up a localized string similar to First Match.
        /// </summary>
        public static string MergeLogic_FirstMatch
        {
            get { return Resource.MergeLogic_FirstMatch; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Union.
        /// </summary>
        public static string MergeLogic_Union
        {
            get { return Resource.MergeLogic_Union; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Constructor on type &apos;{0}&apos; not found..
        /// </summary>
        public static string MissingConstructor_Name
        {
            get { return Resource.MissingConstructor_Name; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Field not found..
        /// </summary>
        public static string MissingField
        {
            get { return Resource.MissingField; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Field &apos;{0}&apos; not found..
        /// </summary>
        public static string MissingField_Name
        {
            get { return Resource.MissingField_Name; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Could not find a manifest resource entry called &quot;{0}&quot; in assembly &quot;{1}&quot;. Please check spelling, capitalization, and build rules to ensure &quot;{0}&quot; is being linked into the assembly..
        /// </summary>
        public static string MissingManifestResource_LooselyLinked
        {
            get { return Resource.MissingManifestResource_LooselyLinked; }
        }

        /// <summary>
        ///   Looks up a localized string similar to A case-insensitive lookup for resource file &quot;{0}&quot; in assembly &quot;{1}&quot; found multiple entries. Remove the duplicates or specify the exact case..
        /// </summary>
        public static string MissingManifestResource_MultipleBlobs
        {
            get { return Resource.MissingManifestResource_MultipleBlobs; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Could not find any resources appropriate for the specified culture or the neutral culture.  Make sure &quot;{0}&quot; was correctly embedded or linked into assembly &quot;{1}&quot; at compile time, or that all the satellite assemblies required are loadable and fully signed..
        /// </summary>
        public static string MissingManifestResource_NoNeutralAsm
        {
            get { return Resource.MissingManifestResource_NoNeutralAsm; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Could not find any resources appropriate for the specified culture (or the neutral culture) on disk..
        /// </summary>
        public static string MissingManifestResource_NoNeutralDisk
        {
            get { return Resource.MissingManifestResource_NoNeutralDisk; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to open Package Resource Index..
        /// </summary>
        public static string MissingManifestResource_NoPRIresources
        {
            get { return Resource.MissingManifestResource_NoPRIresources; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to load resources for resource file &quot;{0}&quot; in package &quot;{1}&quot;..
        /// </summary>
        public static string MissingManifestResource_ResWFileNotLoaded
        {
            get { return Resource.MissingManifestResource_ResWFileNotLoaded; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Member not found..
        /// </summary>
        public static string MissingMember
        {
            get { return Resource.MissingMember; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Member &apos;{0}&apos; not found..
        /// </summary>
        public static string MissingMember_Name
        {
            get { return Resource.MissingMember_Name; }
        }

        /// <summary>
        ///   Looks up a localized string similar to TypedReference can only be made on nested value Types..
        /// </summary>
        public static string MissingMemberNestErr
        {
            get { return Resource.MissingMemberNestErr; }
        }

        /// <summary>
        ///   Looks up a localized string similar to FieldInfo does not match the target Type..
        /// </summary>
        public static string MissingMemberTypeRef
        {
            get { return Resource.MissingMemberTypeRef; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Method &apos;{0}&apos; not found..
        /// </summary>
        public static string MissingMethod_Name
        {
            get { return Resource.MissingMethod_Name; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Module &apos;{0}&apos; not found..
        /// </summary>
        public static string MissingModule
        {
            get { return Resource.MissingModule; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The satellite assembly named &quot;{1}&quot; for fallback culture &quot;{0}&quot; either could not be found or could not be loaded. This is generally a setup problem. Please consider reinstalling or repairing the application..
        /// </summary>
        public static string MissingSatelliteAssembly_Culture_Name
        {
            get { return Resource.MissingSatelliteAssembly_Culture_Name; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Resource lookup fell back to the ultimate fallback resources in a satellite assembly, but that satellite either was not found or could not be loaded. Please consider reinstalling or repairing the application..
        /// </summary>
        public static string MissingSatelliteAssembly_Default
        {
            get { return Resource.MissingSatelliteAssembly_Default; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type &apos;{0}&apos; not found..
        /// </summary>
        public static string MissingType
        {
            get { return Resource.MissingType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Delegates that are not of type MulticastDelegate may not be combined..
        /// </summary>
        public static string Multicast_Combine
        {
            get { return Resource.Multicast_Combine; }
        }

        /// <summary>
        ///   Looks up a localized string similar to An assembly (probably &quot;{1}&quot;) must be rewritten using the code contracts binary rewriter (CCRewrite) because it is calling Contract.{0} and the CONTRACTS_FULL symbol is defined.  Remove any explicit definitions of the CONTRACTS_FULL symbol from your project and rebuild.  CCRewrite can be downloaded from http://go.microsoft.com/fwlink/?LinkID=169180. \r\nAfter the rewriter is installed, it can be enabled in Visual Studio from the project&apos;s Properties page on the Code Contracts pane.  Ensure that &quot;Perform Runt [rest of string was truncated]&quot;;.
        /// </summary>
        public static string MustUseCCRewrite
        {
            get { return Resource.MustUseCCRewrite; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Same site Web.
        /// </summary>
        public static string NetCodeGroup_PermissionSet
        {
            get { return Resource.NetCodeGroup_PermissionSet; }
        }

        /// <summary>
        ///   Looks up a localized string similar to [{0}]\r\nArguments: {1}\r\nDebugging resource strings are unavailable. .
        /// </summary>
        public static string NoDebugResources
        {
            get { return Resource.NoDebugResources; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Resource files longer than 2^63 bytes are not currently implemented..
        /// </summary>
        public static string NotImplemented_ResourcesLongerThan2Of63Power
        {
            get { return Resource.NotImplemented_ResourcesLongerThan2Of63Power; }
        }

        /// <summary>
        ///   Looks up a localized string similar to This non-CLS method is not implemented..
        /// </summary>
        public static string NotSupported_AbstractNonCLS
        {
            get { return Resource.NotSupported_AbstractNonCLS; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Activation Attributes are not supported for types not deriving from MarshalByRefObject..
        /// </summary>
        public static string NotSupported_ActivAttrOnNonMBR
        {
            get { return Resource.NotSupported_ActivAttrOnNonMBR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Activation Attributes not supported for COM Objects..
        /// </summary>
        public static string NotSupported_ActivForCom
        {
            get { return Resource.NotSupported_ActivForCom; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The operation is ambiguous because the permission represents multiple identities..
        /// </summary>
        public static string NotSupported_AmbiguousIdentity
        {
            get { return Resource.NotSupported_AmbiguousIdentity; }
        }

        /// <summary>
        ///   Looks up a localized string similar to {0} is not supported in AppX..
        /// </summary>
        public static string NotSupported_AppX
        {
            get { return Resource.NotSupported_AppX; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Assembly.Load with a Codebase is not supported..
        /// </summary>
        public static string NotSupported_AssemblyLoadCodeBase
        {
            get { return Resource.NotSupported_AssemblyLoadCodeBase; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot create boxed ByRef-like values..
        /// </summary>
        public static string NotSupported_ByRefLike
        {
            get { return Resource.NotSupported_ByRefLike; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot create arrays of ByRef-like values..
        /// </summary>
        public static string NotSupported_ByRefLikeArray
        {
            get { return Resource.NotSupported_ByRefLikeArray; }
        }

        /// <summary>
        ///   Looks up a localized string similar to ByRef return value not supported in reflection invocation..
        /// </summary>
        public static string NotSupported_ByRefReturn
        {
            get { return Resource.NotSupported_ByRefReturn; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Vararg calling convention not supported..
        /// </summary>
        public static string NotSupported_CallToVarArg
        {
            get { return Resource.NotSupported_CallToVarArg; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to save a ModuleBuilder if it was created underneath an AssemblyBuilder. Call Save on the AssemblyBuilder instead..
        /// </summary>
        public static string NotSupported_CannotSaveModuleIndividually
        {
            get { return Resource.NotSupported_CannotSaveModuleIndividually; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot write to a BufferedStream while the read buffer is not empty if the underlying stream is not seekable. Ensure that the stream underlying this BufferedStream can seek or avoid interleaving read and write operations on this BufferedStream..
        /// </summary>
        public static string NotSupported_CannotWriteToBufferedStreamIfReadBufferCannotBeFlushed
        {
            get { return Resource.NotSupported_CannotWriteToBufferedStreamIfReadBufferCannotBeFlushed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The Deny stack modifier has been obsoleted by the .NET Framework.  Please see http://go.microsoft.com/fwlink/?LinkId=155571 for more information..
        /// </summary>
        public static string NotSupported_CasDeny
        {
            get { return Resource.NotSupported_CasDeny; }
        }

        /// <summary>
        ///   Looks up a localized string similar to ChangeType operation is not supported..
        /// </summary>
        public static string NotSupported_ChangeType
        {
            get { return Resource.NotSupported_ChangeType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The ISO-2022-CN Encoding (Code page 50229) is not supported..
        /// </summary>
        public static string NotSupported_CodePage50229
        {
            get { return Resource.NotSupported_CodePage50229; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Resolving to a collectible assembly is not supported..
        /// </summary>
        public static string NotSupported_CollectibleAssemblyResolve
        {
            get { return Resource.NotSupported_CollectibleAssemblyResolve; }
        }

        /// <summary>
        ///   Looks up a localized string similar to A non-collectible assembly may not reference a collectible assembly..
        /// </summary>
        public static string NotSupported_CollectibleBoundNonCollectible
        {
            get { return Resource.NotSupported_CollectibleBoundNonCollectible; }
        }

        /// <summary>
        ///   Looks up a localized string similar to COM Interop is not supported for collectible types..
        /// </summary>
        public static string NotSupported_CollectibleCOM
        {
            get { return Resource.NotSupported_CollectibleCOM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Delegate marshaling for types within collectible assemblies is not supported..
        /// </summary>
        public static string NotSupported_CollectibleDelegateMarshal
        {
            get { return Resource.NotSupported_CollectibleDelegateMarshal; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object cannot be created through this constructor..
        /// </summary>
        public static string NotSupported_Constructor
        {
            get { return Resource.NotSupported_Constructor; }
        }

        /// <summary>
        ///   Looks up a localized string similar to CreateInstance cannot be used with an object of type TypeBuilder..
        /// </summary>
        public static string NotSupported_CreateInstanceWithTypeBuilder
        {
            get { return Resource.NotSupported_CreateInstanceWithTypeBuilder; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Only one DBNull instance may exist, and calls to DBNull deserialization methods are not allowed..
        /// </summary>
        public static string NotSupported_DBNullSerial
        {
            get { return Resource.NotSupported_DBNullSerial; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Declarative unionizing of these permissions is not supported..
        /// </summary>
        public static string NotSupported_DeclarativeUnion
        {
            get { return Resource.NotSupported_DeclarativeUnion; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Assert, Deny, and PermitOnly are not supported on methods with a Vararg calling convention..
        /// </summary>
        public static string NotSupported_DeclSecVarArg
        {
            get { return Resource.NotSupported_DeclSecVarArg; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Application code cannot use Activator.CreateInstance to create types that derive from System.Delegate. Delegate.CreateDelegate can be used instead..
        /// </summary>
        public static string NotSupported_DelegateCreationFromPT
        {
            get { return Resource.NotSupported_DelegateCreationFromPT; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Delegates cannot be marshaled from native code into a domain other than their home domain..
        /// </summary>
        public static string NotSupported_DelegateMarshalToWrongDomain
        {
            get { return Resource.NotSupported_DelegateMarshalToWrongDomain; }
        }

        /// <summary>
        ///   Looks up a localized string similar to DelegateSerializationHolder objects are designed to represent a delegate during serialization and are not serializable themselves..
        /// </summary>
        public static string NotSupported_DelegateSerHolderSerial
        {
            get { return Resource.NotSupported_DelegateSerHolderSerial; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The invoked member is not supported in a dynamic assembly..
        /// </summary>
        public static string NotSupported_DynamicAssembly
        {
            get { return Resource.NotSupported_DynamicAssembly; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot execute code on a dynamic assembly without run access..
        /// </summary>
        public static string NotSupported_DynamicAssemblyNoRunAccess
        {
            get { return Resource.NotSupported_DynamicAssemblyNoRunAccess; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Wrong MethodAttributes or CallingConventions for DynamicMethod. Only public, static, standard supported.
        /// </summary>
        public static string NotSupported_DynamicMethodFlags
        {
            get { return Resource.NotSupported_DynamicMethodFlags; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The invoked member is not supported in a dynamic module..
        /// </summary>
        public static string NotSupported_DynamicModule
        {
            get { return Resource.NotSupported_DynamicModule; }
        }

        /// <summary>
        ///   Looks up a localized string similar to File encryption support only works on NTFS partitions..
        /// </summary>
        public static string NotSupported_EncryptionNeedsNTFS
        {
            get { return Resource.NotSupported_EncryptionNeedsNTFS; }
        }

        /// <summary>
        ///   Looks up a localized string similar to FileStream was asked to open a device that was not a file. For support for devices like &apos;com1:&apos; or &apos;lpt1:&apos;, call CreateFile, then use the FileStream constructors that take an OS handle as an IntPtr..
        /// </summary>
        public static string NotSupported_FileStreamOnNonFiles
        {
            get { return Resource.NotSupported_FileStreamOnNonFiles; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Collection was of a fixed size..
        /// </summary>
        public static string NotSupported_FixedSizeCollection
        {
            get { return Resource.NotSupported_FixedSizeCollection; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Generic methods with NativeCallableAttribute are not supported..
        /// </summary>
        public static string NotSupported_GenericMethod
        {
            get { return Resource.NotSupported_GenericMethod; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The &apos;get&apos; method is not supported on this property..
        /// </summary>
        public static string NotSupported_GetMethod
        {
            get { return Resource.NotSupported_GetMethod; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The type definition of the global function is not completed..
        /// </summary>
        public static string NotSupported_GlobalFunctionNotBaked
        {
            get { return Resource.NotSupported_GlobalFunctionNotBaked; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Serialization of global methods (including implicit serialization via the use of asynchronous delegates) is not supported..
        /// </summary>
        public static string NotSupported_GlobalMethodSerialization
        {
            get { return Resource.NotSupported_GlobalMethodSerialization; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invoking default method with named arguments is not supported..
        /// </summary>
        public static string NotSupported_IDispInvokeDefaultMemberWithNamedArgs
        {
            get { return Resource.NotSupported_IDispInvokeDefaultMemberWithNamedArgs; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Illegal one-byte branch at position: {0}. Requested branch was: {1}..
        /// </summary>
        public static string NotSupported_IllegalOneByteBranch
        {
            get { return Resource.NotSupported_IllegalOneByteBranch; }
        }

        /// <summary>
        ///   Looks up a localized string similar to A type must implement IComparable&lt;T&gt; or IComparable to support comparison..
        /// </summary>
        public static string NotSupported_InComparableType
        {
            get { return Resource.NotSupported_InComparableType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Mutating a key collection derived from a dictionary is not allowed..
        /// </summary>
        public static string NotSupported_KeyCollectionSet
        {
            get { return Resource.NotSupported_KeyCollectionSet; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot create uninitialized instances of types requiring managed activation..
        /// </summary>
        public static string NotSupported_ManagedActivation
        {
            get { return Resource.NotSupported_ManagedActivation; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The arithmetic type &apos;{0}&apos; does not have a maximum value..
        /// </summary>
        public static string NotSupported_MaxValue
        {
            get { return Resource.NotSupported_MaxValue; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The number of WaitHandles must be less than or equal to 64..
        /// </summary>
        public static string NotSupported_MaxWaitHandles
        {
            get { return Resource.NotSupported_MaxWaitHandles; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Memory stream is not expandable..
        /// </summary>
        public static string NotSupported_MemStreamNotExpandable
        {
            get { return Resource.NotSupported_MemStreamNotExpandable; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Method is not supported..
        /// </summary>
        public static string NotSupported_Method
        {
            get { return Resource.NotSupported_Method; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The arithmetic type &apos;{0}&apos; does not have a minimum value..
        /// </summary>
        public static string NotSupported_MinValue
        {
            get { return Resource.NotSupported_MinValue; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Module argument must be a ModuleBuilder..
        /// </summary>
        public static string NotSupported_MustBeModuleBuilder
        {
            get { return Resource.NotSupported_MustBeModuleBuilder; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Methods with NativeCallableAttribute cannot be used as delegate target..
        /// </summary>
        public static string NotSupported_NativeCallableTarget
        {
            get { return Resource.NotSupported_NativeCallableTarget; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The arithmetic type &apos;{0}&apos; cannot represent negative infinity..
        /// </summary>
        public static string NotSupported_NegativeInfinity
        {
            get { return Resource.NotSupported_NegativeInfinity; }
        }

        /// <summary>
        ///   Looks up a localized string similar to No data is available for encoding {0}. For information on defining a custom encoding, see the documentation for the Encoding.RegisterProvider method..
        /// </summary>
        public static string NotSupported_NoCodepageData
        {
            get { return Resource.NotSupported_NoCodepageData; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Non-blittable parameter types are not supported for NativeCallable methods..
        /// </summary>
        public static string NotSupported_NonBlittableTypes
        {
            get { return Resource.NotSupported_NonBlittableTypes; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Not supported in a non-reflected type..
        /// </summary>
        public static string NotSupported_NonReflectedType
        {
            get { return Resource.NotSupported_NonReflectedType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Non-static methods with NativeCallableAttribute are not supported..
        /// </summary>
        public static string NotSupported_NonStaticMethod
        {
            get { return Resource.NotSupported_NonStaticMethod; }
        }

        /// <summary>
        ///   Looks up a localized string similar to UrlAttribute is the only attribute supported for MarshalByRefObject..
        /// </summary>
        public static string NotSupported_NonUrlAttrOnMBR
        {
            get { return Resource.NotSupported_NonUrlAttrOnMBR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Parent does not have a default constructor. The default constructor must be explicitly defined..
        /// </summary>
        public static string NotSupported_NoParentDefaultConstructor
        {
            get { return Resource.NotSupported_NoParentDefaultConstructor; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type &apos;{0}&apos; was not completed..
        /// </summary>
        public static string NotSupported_NotAllTypesAreBaked
        {
            get { return Resource.NotSupported_NotAllTypesAreBaked; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The MethodRental.SwapMethodBody method can only be called to swap the method body of a method in a dynamic module..
        /// </summary>
        public static string NotSupported_NotDynamicModule
        {
            get { return Resource.NotSupported_NotDynamicModule; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot resolve {0} to a TypeInfo object..
        /// </summary>
        public static string NotSupported_NoTypeInfo
        {
            get { return Resource.NotSupported_NoTypeInfo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to This feature is not currently implemented..
        /// </summary>
        public static string NotSupported_NYI
        {
            get { return Resource.NotSupported_NYI; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Found an obsolete .resources file in assembly &apos;{0}&apos;. Rebuild that .resources file then rebuild that assembly..
        /// </summary>
        public static string NotSupported_ObsoleteResourcesFile
        {
            get { return Resource.NotSupported_ObsoleteResourcesFile; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The given Variant type is not supported by this OleAut function..
        /// </summary>
        public static string NotSupported_OleAutBadVarType
        {
            get { return Resource.NotSupported_OleAutBadVarType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The arithmetic type &apos;{0}&apos; cannot represent the number one..
        /// </summary>
        public static string NotSupported_One
        {
            get { return Resource.NotSupported_One; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot create arrays of open type. .
        /// </summary>
        public static string NotSupported_OpenType
        {
            get { return Resource.NotSupported_OpenType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Output streams do not support TypeBuilders..
        /// </summary>
        public static string NotSupported_OutputStreamUsingTypeBuilder
        {
            get { return Resource.NotSupported_OutputStreamUsingTypeBuilder; }
        }

        /// <summary>
        ///   Looks up a localized string similar to A Primary Interop Assembly is not supported in AppX..
        /// </summary>
        public static string NotSupported_PIAInAppxProcess
        {
            get { return Resource.NotSupported_PIAInAppxProcess; }
        }

        /// <summary>
        ///   Looks up a localized string similar to This Surrogate does not support PopulateData()..
        /// </summary>
        public static string NotSupported_PopulateData
        {
            get { return Resource.NotSupported_PopulateData; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The arithmetic type &apos;{0}&apos; cannot represent positive infinity..
        /// </summary>
        public static string NotSupported_PositiveInfinity
        {
            get { return Resource.NotSupported_PositiveInfinity; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified operation is not supported on Ranges..
        /// </summary>
        public static string NotSupported_RangeCollection
        {
            get { return Resource.NotSupported_RangeCollection; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Accessor does not support reading..
        /// </summary>
        public static string NotSupported_Reading
        {
            get { return Resource.NotSupported_Reading; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Collection is read-only..
        /// </summary>
        public static string NotSupported_ReadOnlyCollection
        {
            get { return Resource.NotSupported_ReadOnlyCollection; }
        }

        /// <summary>
        ///   Looks up a localized string similar to This method explicitly uses CAS policy, which has been obsoleted by the .NET Framework. In order to enable CAS policy for compatibility reasons, please use the NetFx40_LegacySecurityPolicy configuration switch. Please see http://go.microsoft.com/fwlink/?LinkID=155570 for more information..
        /// </summary>
        public static string NotSupported_RequiresCasPolicyExplicit
        {
            get { return Resource.NotSupported_RequiresCasPolicyExplicit; }
        }

        /// <summary>
        ///   Looks up a localized string similar to This method implicitly uses CAS policy, which has been obsoleted by the .NET Framework. In order to enable CAS policy for compatibility reasons, please use the NetFx40_LegacySecurityPolicy configuration switch. Please see http://go.microsoft.com/fwlink/?LinkID=155570 for more information..
        /// </summary>
        public static string NotSupported_RequiresCasPolicyImplicit
        {
            get { return Resource.NotSupported_RequiresCasPolicyImplicit; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot read resources that depend on serialization..
        /// </summary>
        public static string NotSupported_ResourceObjectSerialization
        {
            get { return Resource.NotSupported_ResourceObjectSerialization; }
        }

        /// <summary>
        ///   Looks up a localized string similar to SecurityContextSource.CurrentAppDomain is not supported in heterogenous AppDomains..
        /// </summary>
        public static string NotSupported_SecurityContextSourceAppDomainInHeterogenous
        {
            get { return Resource.NotSupported_SecurityContextSourceAppDomainInHeterogenous; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Union is not implemented..
        /// </summary>
        public static string NotSupported_SecurityPermissionUnion
        {
            get { return Resource.NotSupported_SecurityPermissionUnion; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The &apos;set&apos; method is not supported on this property..
        /// </summary>
        public static string NotSupported_SetMethod
        {
            get { return Resource.NotSupported_SetMethod; }
        }

        /// <summary>
        ///   Looks up a localized string similar to SignalAndWait on a STA thread is not supported..
        /// </summary>
        public static string NotSupported_SignalAndWaitSTAThread
        {
            get { return Resource.NotSupported_SignalAndWaitSTAThread; }
        }

        /// <summary>
        ///   Looks up a localized string similar to This operation is not supported on SortedList nested types because they require modifying the original SortedList..
        /// </summary>
        public static string NotSupported_SortedListNestedWrite
        {
            get { return Resource.NotSupported_SortedListNestedWrite; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The string comparison type passed in is currently not supported..
        /// </summary>
        public static string NotSupported_StringComparison
        {
            get { return Resource.NotSupported_StringComparison; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Derived classes must provide an implementation..
        /// </summary>
        public static string NotSupported_SubclassOverride
        {
            get { return Resource.NotSupported_SubclassOverride; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Not supported in an array method of a type definition that is not complete..
        /// </summary>
        public static string NotSupported_SymbolMethod
        {
            get { return Resource.NotSupported_SymbolMethod; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Stack size too deep. Possibly too many arguments..
        /// </summary>
        public static string NotSupported_TooManyArgs
        {
            get { return Resource.NotSupported_TooManyArgs; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type is not supported..
        /// </summary>
        public static string NotSupported_Type
        {
            get { return Resource.NotSupported_Type; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Direct deserialization of type &apos;{0}&apos; is not supported..
        /// </summary>
        public static string NotSupported_TypeCannotDeserialized
        {
            get { return Resource.NotSupported_TypeCannotDeserialized; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The invoked member is not supported before the type is created..
        /// </summary>
        public static string NotSupported_TypeNotYetCreated
        {
            get { return Resource.NotSupported_TypeNotYetCreated; }
        }

        /// <summary>
        ///   Looks up a localized string similar to This operation is not supported for an UnmanagedMemoryStream created from a SafeBuffer..
        /// </summary>
        public static string NotSupported_UmsSafeBuffer
        {
            get { return Resource.NotSupported_UmsSafeBuffer; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The UnitySerializationHolder object is designed to transmit information about other types and is not serializable itself..
        /// </summary>
        public static string NotSupported_UnitySerHolder
        {
            get { return Resource.NotSupported_UnitySerHolder; }
        }

        /// <summary>
        ///   Looks up a localized string similar to TypeCode &apos;{0}&apos; was not valid..
        /// </summary>
        public static string NotSupported_UnknownTypeCode
        {
            get { return Resource.NotSupported_UnknownTypeCode; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Stream does not support reading..
        /// </summary>
        public static string NotSupported_UnreadableStream
        {
            get { return Resource.NotSupported_UnreadableStream; }
        }

        /// <summary>
        ///   Looks up a localized string similar to This accessor was created with a SafeBuffer; use the SafeBuffer to gain access to the pointer..
        /// </summary>
        public static string NotSupported_UnsafePointer
        {
            get { return Resource.NotSupported_UnsafePointer; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Stream does not support seeking..
        /// </summary>
        public static string NotSupported_UnseekableStream
        {
            get { return Resource.NotSupported_UnseekableStream; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Stream does not support writing..
        /// </summary>
        public static string NotSupported_UnwritableStream
        {
            get { return Resource.NotSupported_UnwritableStream; }
        }

        /// <summary>
        ///   Looks up a localized string similar to COM Interop is not supported for user-defined types..
        /// </summary>
        public static string NotSupported_UserCOM
        {
            get { return Resource.NotSupported_UserCOM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to DllImport cannot be used on user-defined methods..
        /// </summary>
        public static string NotSupported_UserDllImport
        {
            get { return Resource.NotSupported_UserDllImport; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Custom marshalers for value types are not currently supported..
        /// </summary>
        public static string NotSupported_ValueClassCM
        {
            get { return Resource.NotSupported_ValueClassCM; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Mutating a value collection derived from a dictionary is not allowed..
        /// </summary>
        public static string NotSupported_ValueCollectionSet
        {
            get { return Resource.NotSupported_ValueCollectionSet; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Arrays of System.Void are not supported..
        /// </summary>
        public static string NotSupported_VoidArray
        {
            get { return Resource.NotSupported_VoidArray; }
        }

        /// <summary>
        ///   Looks up a localized string similar to WaitAll for multiple handles on a STA thread is not supported..
        /// </summary>
        public static string NotSupported_WaitAllSTAThread
        {
            get { return Resource.NotSupported_WaitAllSTAThread; }
        }

        /// <summary>
        ///   Looks up a localized string similar to {0} is not supported..
        /// </summary>
        public static string NotSupported_WindowsPhone
        {
            get { return Resource.NotSupported_WindowsPhone; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Windows Runtime is not supported in partial trust..
        /// </summary>
        public static string NotSupported_WinRT_PartialTrust
        {
            get { return Resource.NotSupported_WinRT_PartialTrust; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Accessor does not support writing..
        /// </summary>
        public static string NotSupported_Writing
        {
            get { return Resource.NotSupported_Writing; }
        }

        /// <summary>
        ///   Looks up a localized string similar to This .resources file should not be read with this reader. The resource reader type is &quot;{0}&quot;..
        /// </summary>
        public static string NotSupported_WrongResourceReader_Type
        {
            get { return Resource.NotSupported_WrongResourceReader_Type; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The arithmetic type &apos;{0}&apos; cannot represent the number zero..
        /// </summary>
        public static string NotSupported_Zero
        {
            get { return Resource.NotSupported_Zero; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The pointer for this method was null..
        /// </summary>
        public static string NullReference_This
        {
            get { return Resource.NullReference_This; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot access a closed file..
        /// </summary>
        public static string ObjectDisposed_FileClosed
        {
            get { return Resource.ObjectDisposed_FileClosed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot access a disposed object..
        /// </summary>
        public static string ObjectDisposed_Generic
        {
            get { return Resource.ObjectDisposed_Generic; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object name: &apos;{0}&apos;..
        /// </summary>
        public static string ObjectDisposed_ObjectName_Name
        {
            get { return Resource.ObjectDisposed_ObjectName_Name; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot read from a closed TextReader..
        /// </summary>
        public static string ObjectDisposed_ReaderClosed
        {
            get { return Resource.ObjectDisposed_ReaderClosed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot access a closed registry key..
        /// </summary>
        public static string ObjectDisposed_RegKeyClosed
        {
            get { return Resource.ObjectDisposed_RegKeyClosed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot access a closed resource set..
        /// </summary>
        public static string ObjectDisposed_ResourceSet
        {
            get { return Resource.ObjectDisposed_ResourceSet; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot access a closed Stream..
        /// </summary>
        public static string ObjectDisposed_StreamClosed
        {
            get { return Resource.ObjectDisposed_StreamClosed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot access a closed accessor..
        /// </summary>
        public static string ObjectDisposed_ViewAccessorClosed
        {
            get { return Resource.ObjectDisposed_ViewAccessorClosed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot write to a closed TextWriter..
        /// </summary>
        public static string ObjectDisposed_WriterClosed
        {
            get { return Resource.ObjectDisposed_WriterClosed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The operation was canceled..
        /// </summary>
        public static string OperationCanceled
        {
            get { return Resource.OperationCanceled; }
        }

        /// <summary>
        ///   Looks up a localized string similar to GetPartitions returned an incorrect number of partitions..
        /// </summary>
        public static string OrderablePartitioner_GetPartitions_WrongNumberOfPartitions
        {
            get { return Resource.OrderablePartitioner_GetPartitions_WrongNumberOfPartitions; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The GCHandle MDA has run out of available cookies..
        /// </summary>
        public static string OutOfMemory_GCHandleMDA
        {
            get { return Resource.OutOfMemory_GCHandleMDA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Value was either too large or too small for an unsigned byte..
        /// </summary>
        public static string Overflow_Byte
        {
            get { return Resource.Overflow_Byte; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Value was either too large or too small for a character..
        /// </summary>
        public static string Overflow_Char
        {
            get { return Resource.Overflow_Char; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Value was either too large or too small for a Currency..
        /// </summary>
        public static string Overflow_Currency
        {
            get { return Resource.Overflow_Currency; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Value was either too large or too small for a Decimal..
        /// </summary>
        public static string Overflow_Decimal
        {
            get { return Resource.Overflow_Decimal; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Value was either too large or too small for a Double..
        /// </summary>
        public static string Overflow_Double
        {
            get { return Resource.Overflow_Double; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The duration cannot be returned for TimeSpan.MinValue because the absolute value of TimeSpan.MinValue exceeds the value of TimeSpan.MaxValue..
        /// </summary>
        public static string Overflow_Duration
        {
            get { return Resource.Overflow_Duration; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Value was either too large or too small for an Int16..
        /// </summary>
        public static string Overflow_Int16
        {
            get { return Resource.Overflow_Int16; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Value was either too large or too small for an Int32..
        /// </summary>
        public static string Overflow_Int32
        {
            get { return Resource.Overflow_Int32; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Value was either too large or too small for an Int64..
        /// </summary>
        public static string Overflow_Int64
        {
            get { return Resource.Overflow_Int64; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Negating the minimum value of a twos complement number is invalid..
        /// </summary>
        public static string Overflow_NegateTwosCompNum
        {
            get { return Resource.Overflow_NegateTwosCompNum; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The string was being parsed as an unsigned number and could not have a negative sign..
        /// </summary>
        public static string Overflow_NegativeUnsigned
        {
            get { return Resource.Overflow_NegativeUnsigned; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Value was either too large or too small for a signed byte..
        /// </summary>
        public static string Overflow_SByte
        {
            get { return Resource.Overflow_SByte; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Value was either too large or too small for a Single..
        /// </summary>
        public static string Overflow_Single
        {
            get { return Resource.Overflow_Single; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The TimeSpan could not be parsed because at least one of the numeric components is out of range or contains too many digits..
        /// </summary>
        public static string Overflow_TimeSpanElementTooLarge
        {
            get { return Resource.Overflow_TimeSpanElementTooLarge; }
        }

        /// <summary>
        ///   Looks up a localized string similar to TimeSpan overflowed because the duration is too long..
        /// </summary>
        public static string Overflow_TimeSpanTooLong
        {
            get { return Resource.Overflow_TimeSpanTooLong; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Value was either too large or too small for a UInt16..
        /// </summary>
        public static string Overflow_UInt16
        {
            get { return Resource.Overflow_UInt16; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Value was either too large or too small for a UInt32..
        /// </summary>
        public static string Overflow_UInt32
        {
            get { return Resource.Overflow_UInt32; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Value was either too large or too small for a UInt64..
        /// </summary>
        public static string Overflow_UInt64
        {
            get { return Resource.Overflow_UInt64; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The Partitioner source returned a null enumerator..
        /// </summary>
        public static string Parallel_ForEach_NullEnumerator
        {
            get { return Resource.Parallel_ForEach_NullEnumerator; }
        }

        /// <summary>
        ///   Looks up a localized string similar to This method requires the use of an OrderedPartitioner with the KeysNormalized property set to true..
        /// </summary>
        public static string Parallel_ForEach_OrderedPartitionerKeysNotNormalized
        {
            get { return Resource.Parallel_ForEach_OrderedPartitionerKeysNotNormalized; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The Partitioner used here must support dynamic partitioning..
        /// </summary>
        public static string Parallel_ForEach_PartitionerNotDynamic
        {
            get { return Resource.Parallel_ForEach_PartitionerNotDynamic; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The Partitioner used here returned a null partitioner source..
        /// </summary>
        public static string Parallel_ForEach_PartitionerReturnedNull
        {
            get { return Resource.Parallel_ForEach_PartitionerReturnedNull; }
        }

        /// <summary>
        ///   Looks up a localized string similar to One of the actions was null..
        /// </summary>
        public static string Parallel_Invoke_ActionNull
        {
            get { return Resource.Parallel_Invoke_ActionNull; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Break was called after Stop was called..
        /// </summary>
        public static string ParallelState_Break_InvalidOperationException_BreakAfterStop
        {
            get { return Resource.ParallelState_Break_InvalidOperationException_BreakAfterStop; }
        }

        /// <summary>
        ///   Looks up a localized string similar to This method is not supported..
        /// </summary>
        public static string ParallelState_NotSupportedException_UnsupportedMethod
        {
            get { return Resource.ParallelState_NotSupportedException_UnsupportedMethod; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Stop was called after Break was called..
        /// </summary>
        public static string ParallelState_Stop_InvalidOperationException_StopAfterBreak
        {
            get { return Resource.ParallelState_Stop_InvalidOperationException_StopAfterBreak; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Dynamic partitions are not supported by this partitioner..
        /// </summary>
        public static string Partitioner_DynamicPartitionsNotSupported
        {
            get { return Resource.Partitioner_DynamicPartitionsNotSupported; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Can not call GetEnumerator on partitions after the source enumerable is disposed.
        /// </summary>
        public static string PartitionerStatic_CanNotCallGetEnumeratorAfterSourceHasBeenDisposed
        {
            get { return Resource.PartitionerStatic_CanNotCallGetEnumeratorAfterSourceHasBeenDisposed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to MoveNext must be called at least once before calling Current..
        /// </summary>
        public static string PartitionerStatic_CurrentCalledBeforeMoveNext
        {
            get { return Resource.PartitionerStatic_CurrentCalledBeforeMoveNext; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The named version of this synchronization primitive is not supported on this platform..
        /// </summary>
        public static string PlatformNotSupported_NamedSynchronizationPrimitives
        {
            get { return Resource.PlatformNotSupported_NamedSynchronizationPrimitives; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Wait operations on multiple wait handles including a named synchronization primitive are not supported on this platform..
        /// </summary>
        public static string PlatformNotSupported_NamedSyncObjectWaitAnyWaitAll
        {
            get { return Resource.PlatformNotSupported_NamedSyncObjectWaitAnyWaitAll; }
        }

        /// <summary>
        ///   Looks up a localized string similar to This operation is only supported on Windows Vista and above..
        /// </summary>
        public static string PlatformNotSupported_RequiresLonghorn
        {
            get { return Resource.PlatformNotSupported_RequiresLonghorn; }
        }

        /// <summary>
        ///   Looks up a localized string similar to This operation is only supported on Windows 2000, Windows XP, and higher..
        /// </summary>
        public static string PlatformNotSupported_RequiresNT
        {
            get { return Resource.PlatformNotSupported_RequiresNT; }
        }

        /// <summary>
        ///   Looks up a localized string similar to This operation is only supported on Windows 2000 SP3 or later operating systems..
        /// </summary>
        public static string PlatformNotSupported_RequiresW2kSP3
        {
            get { return Resource.PlatformNotSupported_RequiresW2kSP3; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Windows Runtime is not supported on this operating system..
        /// </summary>
        public static string PlatformNotSupported_WinRT
        {
            get { return Resource.PlatformNotSupported_WinRT; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Code group grants all code full trust and forms the root of the code group tree..
        /// </summary>
        public static string Policy_AllCode_DescriptionFullTrust
        {
            get { return Resource.Policy_AllCode_DescriptionFullTrust; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Code group grants no permissions and forms the root of the code group tree..
        /// </summary>
        public static string Policy_AllCode_DescriptionNothing
        {
            get { return Resource.Policy_AllCode_DescriptionNothing; }
        }

        /// <summary>
        ///   Looks up a localized string similar to All_Code.
        /// </summary>
        public static string Policy_AllCode_Name
        {
            get { return Resource.Policy_AllCode_Name; }
        }

        /// <summary>
        ///   Looks up a localized string similar to ApplicationTrust grant set does not contain ActivationContext&apos;s minimum request set..
        /// </summary>
        public static string Policy_AppTrustMustGrantAppRequest
        {
            get { return Resource.Policy_AppTrustMustGrantAppRequest; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Policy configuration XML is invalid. The required tag &apos;{0}&apos; is missing..
        /// </summary>
        public static string Policy_BadXml
        {
            get { return Resource.Policy_BadXml; }
        }

        /// <summary>
        ///   Looks up a localized string similar to All assemblies loaded as part of AppDomain initialization must be fully trusted..
        /// </summary>
        public static string Policy_CannotLoadSemiTrustAssembliesDuringInit
        {
            get { return Resource.Policy_CannotLoadSemiTrustAssembliesDuringInit; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Error occurred while performing a policy operation..
        /// </summary>
        public static string Policy_Default
        {
            get { return Resource.Policy_Default; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The evidence collection already contains evidence of type &apos;{0}&apos;. Multiple pieces of the same type of evidence are not allowed..
        /// </summary>
        public static string Policy_DuplicateEvidence
        {
            get { return Resource.Policy_DuplicateEvidence; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Code group grants full trust to code signed with the ECMA strong name..
        /// </summary>
        public static string Policy_Ecma_Description
        {
            get { return Resource.Policy_Ecma_Description; }
        }

        /// <summary>
        ///   Looks up a localized string similar to ECMA_Strong_Name.
        /// </summary>
        public static string Policy_Ecma_Name
        {
            get { return Resource.Policy_Ecma_Name; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Objects used as evidence must be serializable..
        /// </summary>
        public static string Policy_EvidenceMustBeSerializable
        {
            get { return Resource.Policy_EvidenceMustBeSerializable; }
        }

        /// <summary>
        ///   Looks up a localized string similar to An assembly was provided an invalid grant set by runtime host &apos;{0}&apos;. In a homogenous AppDomain, the only valid grant sets are FullTrust and the AppDomain&apos;s sandbox grant set..
        /// </summary>
        public static string Policy_GrantSetDoesNotMatchDomain
        {
            get { return Resource.Policy_GrantSetDoesNotMatchDomain; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Runtime host &apos;{0}&apos; returned evidence of type &apos;{1}&apos; from a request for evidence of type &apos;{2}&apos;..
        /// </summary>
        public static string Policy_IncorrectHostEvidence
        {
            get { return Resource.Policy_IncorrectHostEvidence; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Code group grants code from the Internet zone the Internet permission set. This permission set grants Internet code the right to use isolated storage and limited UI access..
        /// </summary>
        public static string Policy_Internet_Description
        {
            get { return Resource.Policy_Internet_Description; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Internet_Zone.
        /// </summary>
        public static string Policy_Internet_Name
        {
            get { return Resource.Policy_Internet_Name; }
        }

        /// <summary>
        ///   Looks up a localized string similar to All Internet code gets the right to connect back to the site of its origin..
        /// </summary>
        public static string Policy_InternetNet_Description
        {
            get { return Resource.Policy_InternetNet_Description; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Internet_Same_Site_Access.
        /// </summary>
        public static string Policy_InternetNet_Name
        {
            get { return Resource.Policy_InternetNet_Name; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Code group grants the intranet permission set to code from the intranet zone. This permission set grants intranet code the right to use isolated storage, full UI access, some capability to do reflection, and limited access to environment variables..
        /// </summary>
        public static string Policy_Intranet_Description
        {
            get { return Resource.Policy_Intranet_Description; }
        }

        /// <summary>
        ///   Looks up a localized string similar to LocalIntranet_Zone.
        /// </summary>
        public static string Policy_Intranet_Name
        {
            get { return Resource.Policy_Intranet_Name; }
        }

        /// <summary>
        ///   Looks up a localized string similar to All intranet code gets the right to read from its install directory..
        /// </summary>
        public static string Policy_IntranetFile_Description
        {
            get { return Resource.Policy_IntranetFile_Description; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Intranet_Same_Directory_Access.
        /// </summary>
        public static string Policy_IntranetFile_Name
        {
            get { return Resource.Policy_IntranetFile_Name; }
        }

        /// <summary>
        ///   Looks up a localized string similar to All intranet code gets the right to connect back to the site of its origin..
        /// </summary>
        public static string Policy_IntranetNet_Description
        {
            get { return Resource.Policy_IntranetNet_Description; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Intranet_Same_Site_Access.
        /// </summary>
        public static string Policy_IntranetNet_Name
        {
            get { return Resource.Policy_IntranetNet_Name; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Code group grants full trust to code signed with the Microsoft strong name..
        /// </summary>
        public static string Policy_Microsoft_Description
        {
            get { return Resource.Policy_Microsoft_Description; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Microsoft_Strong_Name.
        /// </summary>
        public static string Policy_Microsoft_Name
        {
            get { return Resource.Policy_Microsoft_Name; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The application evidence does not contain a Fusion activation context..
        /// </summary>
        public static string Policy_MissingActivationContextInAppEvidence
        {
            get { return Resource.Policy_MissingActivationContextInAppEvidence; }
        }

        /// <summary>
        ///   Looks up a localized string similar to More than one exclusive group is not allowed..
        /// </summary>
        public static string Policy_MultipleExclusive
        {
            get { return Resource.Policy_MultipleExclusive; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Code group grants full trust to all code originating on the local computer.
        /// </summary>
        public static string Policy_MyComputer_Description
        {
            get { return Resource.Policy_MyComputer_Description; }
        }

        /// <summary>
        ///   Looks up a localized string similar to My_Computer_Zone.
        /// </summary>
        public static string Policy_MyComputer_Name
        {
            get { return Resource.Policy_MyComputer_Name; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Execution permission cannot be acquired..
        /// </summary>
        public static string Policy_NoExecutionPermission
        {
            get { return Resource.Policy_NoExecutionPermission; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Policy references an assembly not in the full trust assemblies list..
        /// </summary>
        public static string Policy_NonFullTrustAssembly
        {
            get { return Resource.Policy_NonFullTrustAssembly; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Required permissions cannot be acquired..
        /// </summary>
        public static string Policy_NoRequiredPermission
        {
            get { return Resource.Policy_NoRequiredPermission; }
        }

        /// <summary>
        ///   Looks up a localized string similar to A trust manager could not be loaded for this application..
        /// </summary>
        public static string Policy_NoTrustManager
        {
            get { return Resource.Policy_NoTrustManager; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Runtime host &apos;{0}&apos; returned null when asked for assembly evidence for assembly &apos;{1}&apos;..
        /// </summary>
        public static string Policy_NullHostEvidence
        {
            get { return Resource.Policy_NullHostEvidence; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Runtime host &apos;{0}&apos; returned a null grant set from ResolvePolicy..
        /// </summary>
        public static string Policy_NullHostGrantSet
        {
            get { return Resource.Policy_NullHostGrantSet; }
        }

        /// <summary>
        ///   Looks up a localized string similar to AppDomain.
        /// </summary>
        public static string Policy_PL_AppDomain
        {
            get { return Resource.Policy_PL_AppDomain; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Enterprise.
        /// </summary>
        public static string Policy_PL_Enterprise
        {
            get { return Resource.Policy_PL_Enterprise; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Machine.
        /// </summary>
        public static string Policy_PL_Machine
        {
            get { return Resource.Policy_PL_Machine; }
        }

        /// <summary>
        ///   Looks up a localized string similar to User.
        /// </summary>
        public static string Policy_PL_User
        {
            get { return Resource.Policy_PL_User; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Policy for this domain cannot be set twice..
        /// </summary>
        public static string Policy_PolicyAlreadySet
        {
            get { return Resource.Policy_PolicyAlreadySet; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Default principal object cannot be set twice..
        /// </summary>
        public static string Policy_PrincipalTwice
        {
            get { return Resource.Policy_PrincipalTwice; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Allows unrestricted access to all resources covered by built-in permissions.
        /// </summary>
        public static string Policy_PS_Everything
        {
            get { return Resource.Policy_PS_Everything; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Permits execution.
        /// </summary>
        public static string Policy_PS_Execution
        {
            get { return Resource.Policy_PS_Execution; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Allows full access to all resources.
        /// </summary>
        public static string Policy_PS_FullTrust
        {
            get { return Resource.Policy_PS_FullTrust; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Default rights given to Internet applications.
        /// </summary>
        public static string Policy_PS_Internet
        {
            get { return Resource.Policy_PS_Internet; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Default rights given to applications on the local intranet.
        /// </summary>
        public static string Policy_PS_LocalIntranet
        {
            get { return Resource.Policy_PS_LocalIntranet; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Denies all resources, including the right to execute.
        /// </summary>
        public static string Policy_PS_Nothing
        {
            get { return Resource.Policy_PS_Nothing; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Grants right to bypass the verification.
        /// </summary>
        public static string Policy_PS_SkipVerification
        {
            get { return Resource.Policy_PS_SkipVerification; }
        }

        /// <summary>
        ///   Looks up a localized string similar to No old configuration file exists to recover..
        /// </summary>
        public static string Policy_RecoverNoConfigFile
        {
            get { return Resource.Policy_RecoverNoConfigFile; }
        }

        /// <summary>
        ///   Looks up a localized string similar to PolicyLevel object not based on a file cannot be recovered..
        /// </summary>
        public static string Policy_RecoverNotFileBased
        {
            get { return Resource.Policy_RecoverNotFileBased; }
        }

        /// <summary>
        ///   Looks up a localized string similar to PolicyLevel object not based on a file cannot be saved..
        /// </summary>
        public static string Policy_SaveNotFileBased
        {
            get { return Resource.Policy_SaveNotFileBased; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Code from a trusted zone is granted the Internet permission set. This permission set grants the right to use isolated storage and limited UI access..
        /// </summary>
        public static string Policy_Trusted_Description
        {
            get { return Resource.Policy_Trusted_Description; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Trusted_Zone.
        /// </summary>
        public static string Policy_Trusted_Name
        {
            get { return Resource.Policy_Trusted_Name; }
        }

        /// <summary>
        ///   Looks up a localized string similar to All Trusted Code gets the right to connect back to the site of its origin..
        /// </summary>
        public static string Policy_TrustedNet_Description
        {
            get { return Resource.Policy_TrustedNet_Description; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Trusted_Same_Site_Access.
        /// </summary>
        public static string Policy_TrustedNet_Name
        {
            get { return Resource.Policy_TrustedNet_Name; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Policy level &apos;{0}&apos; could not be saved: {1}..
        /// </summary>
        public static string Policy_UnableToSave
        {
            get { return Resource.Policy_UnableToSave; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Code coming from a restricted zone does not receive any permissions..
        /// </summary>
        public static string Policy_Untrusted_Description
        {
            get { return Resource.Policy_Untrusted_Description; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Restricted_Zone.
        /// </summary>
        public static string Policy_Untrusted_Name
        {
            get { return Resource.Policy_Untrusted_Name; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Postcondition unsuccessfully..
        /// </summary>
        public static string PostconditionFailed
        {
            get { return Resource.PostconditionFailed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Postcondition unsuccessfully: {0}.
        /// </summary>
        public static string PostconditionFailed_Cnd
        {
            get { return Resource.PostconditionFailed_Cnd; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Postcondition unsuccessfully after throwing an exception..
        /// </summary>
        public static string PostconditionOnExceptionFailed
        {
            get { return Resource.PostconditionOnExceptionFailed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Postcondition unsuccessfully after throwing an exception: {0}.
        /// </summary>
        public static string PostconditionOnExceptionFailed_Cnd
        {
            get { return Resource.PostconditionOnExceptionFailed_Cnd; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Precondition unsuccessfully..
        /// </summary>
        public static string PreconditionFailed
        {
            get { return Resource.PreconditionFailed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Precondition unsuccessfully: {0}.
        /// </summary>
        public static string PreconditionFailed_Cnd
        {
            get { return Resource.PreconditionFailed_Cnd; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The process does not possess some privilege required for this operation..
        /// </summary>
        public static string PrivilegeNotHeld_Default
        {
            get { return Resource.PrivilegeNotHeld_Default; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The process does not possess the &apos;{0}&apos; privilege which is required for this operation..
        /// </summary>
        public static string PrivilegeNotHeld_Named
        {
            get { return Resource.PrivilegeNotHeld_Named; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Publisher.
        /// </summary>
        public static string Publisher_ToString
        {
            get { return Resource.Publisher_ToString; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Publisher - {0}.
        /// </summary>
        public static string Publisher_ToStringArg
        {
            get { return Resource.Publisher_ToStringArg; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Only single dimension arrays are supported here..
        /// </summary>
        public static string Rank_MultiDimNotSupported
        {
            get { return Resource.Rank_MultiDimNotSupported; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified arrays must have the same number of dimensions..
        /// </summary>
        public static string Rank_MustMatch
        {
            get { return Resource.Rank_MustMatch; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to load one or more of the requested types. Retrieve the LoaderExceptions property for more information..
        /// </summary>
        public static string ReflectionTypeLoad_LoadFailed
        {
            get { return Resource.ReflectionTypeLoad_LoadFailed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Async Activation not supported..
        /// </summary>
        public static string Remoting_Activation_AsyncUnsupported
        {
            get { return Resource.Remoting_Activation_AsyncUnsupported; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Activation attribute does not implement the IContextAttribute interface..
        /// </summary>
        public static string Remoting_Activation_BadAttribute
        {
            get { return Resource.Remoting_Activation_BadAttribute; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Proxy Attribute returned an incompatible object when constructing an instance of type {0}..
        /// </summary>
        public static string Remoting_Activation_BadObject
        {
            get { return Resource.Remoting_Activation_BadObject; }
        }

        /// <summary>
        ///   Looks up a localized string similar to An attempt to connect to the remote activator unsuccessfully with exception &apos;{0}&apos;..
        /// </summary>
        public static string Remoting_Activation_ConnectFailed
        {
            get { return Resource.Remoting_Activation_ConnectFailed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Activation unsuccessfully due to an unknown reason..
        /// </summary>
        public static string Remoting_Activation_Failed
        {
            get { return Resource.Remoting_Activation_Failed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Inconsistent state during activation; there may be two proxies for the same object..
        /// </summary>
        public static string Remoting_Activation_InconsistentState
        {
            get { return Resource.Remoting_Activation_InconsistentState; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Proxy Attributes are supported on ContextBound types only..
        /// </summary>
        public static string Remoting_Activation_MBR_ProxyAttribute
        {
            get { return Resource.Remoting_Activation_MBR_ProxyAttribute; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot find an entry for remote application &apos;{0}&apos;..
        /// </summary>
        public static string Remoting_Activation_MissingRemoteAppEntry
        {
            get { return Resource.Remoting_Activation_MissingRemoteAppEntry; }
        }

        /// <summary>
        ///   Looks up a localized string similar to InternalUnmarshal of returned ObjRef from activation call returned null..
        /// </summary>
        public static string Remoting_Activation_NullFromInternalUnmarshal
        {
            get { return Resource.Remoting_Activation_NullFromInternalUnmarshal; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Return value of construction call was null..
        /// </summary>
        public static string Remoting_Activation_NullReturnValue
        {
            get { return Resource.Remoting_Activation_NullReturnValue; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type &apos;{0}&apos; is not registered for activation..
        /// </summary>
        public static string Remoting_Activation_PermissionDenied
        {
            get { return Resource.Remoting_Activation_PermissionDenied; }
        }

        /// <summary>
        ///   Looks up a localized string similar to A context property did not approve the candidate context for activating the object..
        /// </summary>
        public static string Remoting_Activation_PropertyUnhappy
        {
            get { return Resource.Remoting_Activation_PropertyUnhappy; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot run a non-default constructor when connecting to well-known objects..
        /// </summary>
        public static string Remoting_Activation_WellKnownCTOR
        {
            get { return Resource.Remoting_Activation_WellKnownCTOR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot resolve the invocation to the correct constructor..
        /// </summary>
        public static string Remoting_AmbiguousCTOR
        {
            get { return Resource.Remoting_AmbiguousCTOR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot resolve the invocation to the correct method..
        /// </summary>
        public static string Remoting_AmbiguousMethod
        {
            get { return Resource.Remoting_AmbiguousMethod; }
        }

        /// <summary>
        ///   Looks up a localized string similar to This feature is not yet supported for cross-application domain..
        /// </summary>
        public static string Remoting_AppDomains_NYI
        {
            get { return Resource.Remoting_AppDomains_NYI; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Permission denied: cannot call methods on the AppDomain class remotely..
        /// </summary>
        public static string Remoting_AppDomainsCantBeCalledRemotely
        {
            get { return Resource.Remoting_AppDomainsCantBeCalledRemotely; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The target application domain has been unloaded..
        /// </summary>
        public static string Remoting_AppDomainUnloaded
        {
            get { return Resource.Remoting_AppDomainUnloaded; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The application domain in which the thread was running has been unloaded..
        /// </summary>
        public static string Remoting_AppDomainUnloaded_ThreadUnwound
        {
            get { return Resource.Remoting_AppDomainUnloaded_ThreadUnwound; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot load assembly &apos;{0}&apos;..
        /// </summary>
        public static string Remoting_AssemblyLoadFailed
        {
            get { return Resource.Remoting_AssemblyLoadFailed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to UseAttribute not allowed in SoapTypeAttribute..
        /// </summary>
        public static string Remoting_Attribute_UseAttributeNotsettable
        {
            get { return Resource.Remoting_Attribute_UseAttributeNotsettable; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Remoting cannot find field &apos;{0}&apos; on type &apos;{1}&apos;..
        /// </summary>
        public static string Remoting_BadField
        {
            get { return Resource.Remoting_BadField; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid internal state: Activation service unsuccessfully to initialize..
        /// </summary>
        public static string Remoting_BadInternalState_ActivationFailure
        {
            get { return Resource.Remoting_BadInternalState_ActivationFailure; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid internal state: Failed to create an envoy sink for the object..
        /// </summary>
        public static string Remoting_BadInternalState_FailEnvoySink
        {
            get { return Resource.Remoting_BadInternalState_FailEnvoySink; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid internal state: A marshal by ref object should not have a proxy in its own AppDomain..
        /// </summary>
        public static string Remoting_BadInternalState_ProxySameAppDomain
        {
            get { return Resource.Remoting_BadInternalState_ProxySameAppDomain; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot load type &apos;{0}&apos;..
        /// </summary>
        public static string Remoting_BadType
        {
            get { return Resource.Remoting_BadType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot call disconnect on a proxy..
        /// </summary>
        public static string Remoting_CantDisconnectClientProxy
        {
            get { return Resource.Remoting_CantDisconnectClientProxy; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot invoke methods on IRemoteDispatch..
        /// </summary>
        public static string Remoting_CantInvokeIRemoteDispatch
        {
            get { return Resource.Remoting_CantInvokeIRemoteDispatch; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Pointer types cannot be passed in a remote call..
        /// </summary>
        public static string Remoting_CantRemotePointerType
        {
            get { return Resource.Remoting_CantRemotePointerType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Channel {0} cannot be secured. Please consider using a channel that implements ISecurableChannel.
        /// </summary>
        public static string Remoting_Channel_CannotBeSecured
        {
            get { return Resource.Remoting_Channel_CannotBeSecured; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot call the AsyncProcessResponse method on the previous channel sink because the stack is empty..
        /// </summary>
        public static string Remoting_Channel_CantCallAPRWhenStackEmpty
        {
            get { return Resource.Remoting_Channel_CantCallAPRWhenStackEmpty; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Called FlipRememberedStack() when stack was not null..
        /// </summary>
        public static string Remoting_Channel_CantCallFRSWhenStackEmtpy
        {
            get { return Resource.Remoting_Channel_CantCallFRSWhenStackEmtpy; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot call the GetResponseStream method on the previous channel sink because the stack is empty..
        /// </summary>
        public static string Remoting_Channel_CantCallGetResponseStreamWhenStackEmpty
        {
            get { return Resource.Remoting_Channel_CantCallGetResponseStreamWhenStackEmpty; }
        }

        /// <summary>
        ///   Looks up a localized string similar to No message was deserialized prior to calling the DispatchChannelSink..
        /// </summary>
        public static string Remoting_Channel_DispatchSinkMessageMissing
        {
            get { return Resource.Remoting_Channel_DispatchSinkMessageMissing; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The request stream should be null when the DispatchChannelSink is called. .
        /// </summary>
        public static string Remoting_Channel_DispatchSinkWantsNullRequestStream
        {
            get { return Resource.Remoting_Channel_DispatchSinkWantsNullRequestStream; }
        }

        /// <summary>
        ///   Looks up a localized string similar to A channel sink tried to pop data from the stack without first pushing data onto the stack..
        /// </summary>
        public static string Remoting_Channel_PopFromSinkStackWithoutPush
        {
            get { return Resource.Remoting_Channel_PopFromSinkStackWithoutPush; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Tried to pop data from an empty channel sink stack..
        /// </summary>
        public static string Remoting_Channel_PopOnEmptySinkStack
        {
            get { return Resource.Remoting_Channel_PopOnEmptySinkStack; }
        }

        /// <summary>
        ///   Looks up a localized string similar to A channel sink called the Store method when the sink stack was empty..
        /// </summary>
        public static string Remoting_Channel_StoreOnEmptySinkStack
        {
            get { return Resource.Remoting_Channel_StoreOnEmptySinkStack; }
        }

        /// <summary>
        ///   Looks up a localized string similar to A channel sink called the Store method on the sink stack without first pushing data onto the stack..
        /// </summary>
        public static string Remoting_Channel_StoreOnSinkStackWithoutPush
        {
            get { return Resource.Remoting_Channel_StoreOnSinkStackWithoutPush; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The channel &apos;{0}&apos; is already registered..
        /// </summary>
        public static string Remoting_ChannelNameAlreadyRegistered
        {
            get { return Resource.Remoting_ChannelNameAlreadyRegistered; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The channel &apos;{0}&apos; is not registered with remoting services..
        /// </summary>
        public static string Remoting_ChannelNotRegistered
        {
            get { return Resource.Remoting_ChannelNotRegistered; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The remoting application name, &apos;{0}&apos;, had already been set..
        /// </summary>
        public static string Remoting_Config_AppNameSet
        {
            get { return Resource.Remoting_Config_AppNameSet; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attempt to redirect activation for type &apos;{0}, {1}&apos;. This is not allowed since either a well-known service type has already been registered with that type or that type has been registered has a activated service type..
        /// </summary>
        public static string Remoting_Config_CantRedirectActivationOfWellKnownService
        {
            get { return Resource.Remoting_Config_CantRedirectActivationOfWellKnownService; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attempt to register a well-known or activated service type of type &apos;{0}, {1}&apos;. This is not allowed since the type has already been redirected to activate elsewhere..
        /// </summary>
        public static string Remoting_Config_CantUseRedirectedTypeForWellKnownService
        {
            get { return Resource.Remoting_Config_CantUseRedirectedTypeForWellKnownService; }
        }

        /// <summary>
        ///   Looks up a localized string similar to To be used from a .config file, the channel type &apos;{0}&apos; must have a constructor of the form &apos;{1}&apos;.
        /// </summary>
        public static string Remoting_Config_ChannelMissingCtor
        {
            get { return Resource.Remoting_Config_ChannelMissingCtor; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Remoting configuration unsuccessfully with the exception &apos;{0}&apos;..
        /// </summary>
        public static string Remoting_Config_ConfigurationFailure
        {
            get { return Resource.Remoting_Config_ConfigurationFailure; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The remoting custom errors mode had already been set..
        /// </summary>
        public static string Remoting_Config_ErrorsModeSet
        {
            get { return Resource.Remoting_Config_ErrorsModeSet; }
        }

        /// <summary>
        ///   Looks up a localized string similar to &apos;{0}&apos; does not implement IChannelReceiver or IChannelSender. All channels must implement one of these interfaces..
        /// </summary>
        public static string Remoting_Config_InvalidChannelType
        {
            get { return Resource.Remoting_Config_InvalidChannelType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to use &apos;{0}&apos; as a channel sink provider. It does not implement &apos;{1}&apos;..
        /// </summary>
        public static string Remoting_Config_InvalidSinkProviderType
        {
            get { return Resource.Remoting_Config_InvalidSinkProviderType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid time format &apos;{0}&apos;. Examples of valid time formats include 7D, 10H, 5M, 30S, or 20MS..
        /// </summary>
        public static string Remoting_Config_InvalidTimeFormat
        {
            get { return Resource.Remoting_Config_InvalidTimeFormat; }
        }

        /// <summary>
        ///   Looks up a localized string similar to &apos;{0}&apos; entries must contain a &apos;{1}&apos; attribute of the form &apos;typeName, assemblyName&apos;..
        /// </summary>
        public static string Remoting_Config_MissingTypeAttribute
        {
            get { return Resource.Remoting_Config_MissingTypeAttribute; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Well-known service entries must contain a &apos;mode&apos; attribute with a value of &apos;Singleton&apos; or &apos;SingleCall&apos;..
        /// </summary>
        public static string Remoting_Config_MissingWellKnownModeAttribute
        {
            get { return Resource.Remoting_Config_MissingWellKnownModeAttribute; }
        }

        /// <summary>
        ///   Looks up a localized string similar to &apos;{0}&apos; entries must contain a &apos;{1}&apos; attribute of the form &apos;xmlTypeName, xmlTypeNamespace&apos;..
        /// </summary>
        public static string Remoting_Config_MissingXmlTypeAttribute
        {
            get { return Resource.Remoting_Config_MissingXmlTypeAttribute; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Improper remoting configuration: missing ApplicationName property..
        /// </summary>
        public static string Remoting_Config_NoAppName
        {
            get { return Resource.Remoting_Config_NoAppName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to There can be only one &apos;{0}&apos; node in the &apos;{1}&apos; section of a config file..
        /// </summary>
        public static string Remoting_Config_NodeMustBeUnique
        {
            get { return Resource.Remoting_Config_NodeMustBeUnique; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Only &apos;{0}&apos; templates can have an &apos;id&apos; attribute..
        /// </summary>
        public static string Remoting_Config_NonTemplateIdAttribute
        {
            get { return Resource.Remoting_Config_NonTemplateIdAttribute; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Preload entries require a type or assembly attribute..
        /// </summary>
        public static string Remoting_Config_PreloadRequiresTypeOrAssembly
        {
            get { return Resource.Remoting_Config_PreloadRequiresTypeOrAssembly; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Sink providers must have an element name of &apos;formatter&apos; or &apos;provider&apos;..
        /// </summary>
        public static string Remoting_Config_ProviderNeedsElementName
        {
            get { return Resource.Remoting_Config_ProviderNeedsElementName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to .Config file &apos;{0}&apos; cannot be read successfully due to exception &apos;{1}&apos;..
        /// </summary>
        public static string Remoting_Config_ReadFailure
        {
            get { return Resource.Remoting_Config_ReadFailure; }
        }

        /// <summary>
        ///   Looks up a localized string similar to &apos;{0}&apos; entries require a &apos;{1}&apos; attribute..
        /// </summary>
        public static string Remoting_Config_RequiredXmlAttribute
        {
            get { return Resource.Remoting_Config_RequiredXmlAttribute; }
        }

        /// <summary>
        ///   Looks up a localized string similar to To be used from a .config file, the sink provider type &apos;{0}&apos; must have a constructor of the form &apos;{1}&apos;.
        /// </summary>
        public static string Remoting_Config_SinkProviderMissingCtor
        {
            get { return Resource.Remoting_Config_SinkProviderMissingCtor; }
        }

        /// <summary>
        ///   Looks up a localized string similar to A sink provider of type &apos;{0}&apos; is incorrectly labeled as a &apos;formatter&apos;..
        /// </summary>
        public static string Remoting_Config_SinkProviderNotFormatter
        {
            get { return Resource.Remoting_Config_SinkProviderNotFormatter; }
        }

        /// <summary>
        ///   Looks up a localized string similar to A &apos;{0}&apos; template cannot reference another &apos;{0}&apos; template..
        /// </summary>
        public static string Remoting_Config_TemplateCannotReferenceTemplate
        {
            get { return Resource.Remoting_Config_TemplateCannotReferenceTemplate; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attempt to redirect activation of type &apos;{0}, {1}&apos; which is already redirected..
        /// </summary>
        public static string Remoting_Config_TypeAlreadyRedirected
        {
            get { return Resource.Remoting_Config_TypeAlreadyRedirected; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot resolve &apos;{0}&apos; template reference: &apos;{1}&apos;..
        /// </summary>
        public static string Remoting_Config_UnableToResolveTemplate
        {
            get { return Resource.Remoting_Config_UnableToResolveTemplate; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unknown value {1} was found on the {0} node..
        /// </summary>
        public static string Remoting_Config_UnknownValue
        {
            get { return Resource.Remoting_Config_UnknownValue; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Version information is present in the assembly name &apos;{0}&apos; which is not allowed for &apos;{1}&apos; entries..
        /// </summary>
        public static string Remoting_Config_VersionPresent
        {
            get { return Resource.Remoting_Config_VersionPresent; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot create channel sink to connect to URL &apos;{0}&apos;. An appropriate channel has probably not been registered..
        /// </summary>
        public static string Remoting_Connect_CantCreateChannelSink
        {
            get { return Resource.Remoting_Connect_CantCreateChannelSink; }
        }

        /// <summary>
        ///   Looks up a localized string similar to A property that contributed a bad sink to the chain was found..
        /// </summary>
        public static string Remoting_Contexts_BadProperty
        {
            get { return Resource.Remoting_Contexts_BadProperty; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Context should be frozen before calling the DoCallBack method..
        /// </summary>
        public static string Remoting_Contexts_ContextNotFrozenForCallBack
        {
            get { return Resource.Remoting_Contexts_ContextNotFrozenForCallBack; }
        }

        /// <summary>
        ///   Looks up a localized string similar to A property with the name &apos;{0}&apos; was not found..
        /// </summary>
        public static string Remoting_Contexts_NoProperty
        {
            get { return Resource.Remoting_Contexts_NoProperty; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unknown remoting error..
        /// </summary>
        public static string Remoting_Default
        {
            get { return Resource.Remoting_Default; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The delegate must have only one target..
        /// </summary>
        public static string Remoting_Delegate_TooManyTargets
        {
            get { return Resource.Remoting_Delegate_TooManyTargets; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object &apos;{0}&apos; has been disconnected or does not exist at the server..
        /// </summary>
        public static string Remoting_Disconnected
        {
            get { return Resource.Remoting_Disconnected; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The tracking handler of type &apos;{0}&apos; is not registered with Remoting Services..
        /// </summary>
        public static string Remoting_HandlerNotRegistered
        {
            get { return Resource.Remoting_HandlerNotRegistered; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Server encountered an internal error. For more information, turn off customErrors in the server&apos;s .config file..
        /// </summary>
        public static string Remoting_InternalError
        {
            get { return Resource.Remoting_InternalError; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attempted to call a method declared on type &apos;{0}&apos; on an object which exposes &apos;{1}&apos;..
        /// </summary>
        public static string Remoting_InvalidCallingType
        {
            get { return Resource.Remoting_InvalidCallingType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The context is not valid..
        /// </summary>
        public static string Remoting_InvalidContext
        {
            get { return Resource.Remoting_InvalidContext; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid Message Object..
        /// </summary>
        public static string Remoting_InvalidMsg
        {
            get { return Resource.Remoting_InvalidMsg; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The server object type cannot be cast to the requested type &apos;{0}&apos;..
        /// </summary>
        public static string Remoting_InvalidRequestedType
        {
            get { return Resource.Remoting_InvalidRequestedType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to An attempt was made to calculate the address of a value type field on a remote object. This was likely caused by an attempt to directly get or set the value of a field within this embedded value type. Avoid this and instead provide and use access methods for each field in the object that will be accessed remotely..
        /// </summary>
        public static string Remoting_InvalidValueTypeFieldAccess
        {
            get { return Resource.Remoting_InvalidValueTypeFieldAccess; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Expected a return object of type ILease, but received &apos;{0}&apos;..
        /// </summary>
        public static string Remoting_Lifetime_ILeaseReturn
        {
            get { return Resource.Remoting_Lifetime_ILeaseReturn; }
        }

        /// <summary>
        ///   Looks up a localized string similar to InitialLeaseTime property can only be set when the lease is in initial state. The state is &apos;{0}&apos;..
        /// </summary>
        public static string Remoting_Lifetime_InitialStateInitialLeaseTime
        {
            get { return Resource.Remoting_Lifetime_InitialStateInitialLeaseTime; }
        }

        /// <summary>
        ///   Looks up a localized string similar to RenewOnCallTime property can only be set when the lease is in initial state. The state is &apos;{0}&apos;..
        /// </summary>
        public static string Remoting_Lifetime_InitialStateRenewOnCall
        {
            get { return Resource.Remoting_Lifetime_InitialStateRenewOnCall; }
        }

        /// <summary>
        ///   Looks up a localized string similar to SponsorshipTimeout property can only be set when the lease is in initial state. State is &apos;{0}&apos;..
        /// </summary>
        public static string Remoting_Lifetime_InitialStateSponsorshipTimeout
        {
            get { return Resource.Remoting_Lifetime_InitialStateSponsorshipTimeout; }
        }

        /// <summary>
        ///   Looks up a localized string similar to &apos;{0}&apos; can only be set once within an AppDomain..
        /// </summary>
        public static string Remoting_Lifetime_SetOnce
        {
            get { return Resource.Remoting_Lifetime_SetOnce; }
        }

        /// <summary>
        ///   Looks up a localized string similar to {2} arguments were passed to &apos;{0}::{1}&apos;. {3} arguments were expected by this method..
        /// </summary>
        public static string Remoting_Message_ArgMismatch
        {
            get { return Resource.Remoting_Message_ArgMismatch; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The async result object is null or of an unexpected type..
        /// </summary>
        public static string Remoting_Message_BadAsyncResult
        {
            get { return Resource.Remoting_Message_BadAsyncResult; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bad return value or out-argument inside the return message..
        /// </summary>
        public static string Remoting_Message_BadRetValOrOutArg
        {
            get { return Resource.Remoting_Message_BadRetValOrOutArg; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid or malformed serialization information for the message object..
        /// </summary>
        public static string Remoting_Message_BadSerialization
        {
            get { return Resource.Remoting_Message_BadSerialization; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The method was called with a Message of an unexpected type..
        /// </summary>
        public static string Remoting_Message_BadType
        {
            get { return Resource.Remoting_Message_BadType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The argument type &apos;{0}&apos; cannot be converted into parameter type &apos;{1}&apos;..
        /// </summary>
        public static string Remoting_Message_CoercionFailed
        {
            get { return Resource.Remoting_Message_CoercionFailed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The method &apos;{0}&apos; was not found on the interface/type &apos;{1}&apos;..
        /// </summary>
        public static string Remoting_Message_MethodMissing
        {
            get { return Resource.Remoting_Message_MethodMissing; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Expecting an instance of type &apos;{0}&apos; at pos {1} in the args array..
        /// </summary>
        public static string Remoting_Message_MissingArgValue
        {
            get { return Resource.Remoting_Message_MissingArgValue; }
        }

        /// <summary>
        ///   Looks up a localized string similar to No remoting information was found for this object..
        /// </summary>
        public static string Remoting_NoIdentityEntry
        {
            get { return Resource.Remoting_NoIdentityEntry; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Permission denied: cannot call non-public or static methods remotely..
        /// </summary>
        public static string Remoting_NonPublicOrStaticCantBeCalledRemotely
        {
            get { return Resource.Remoting_NonPublicOrStaticCantBeCalledRemotely; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Trying to create a proxy to an unbound type..
        /// </summary>
        public static string Remoting_NotRemotableByReference
        {
            get { return Resource.Remoting_NotRemotableByReference; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The method was called with a null message..
        /// </summary>
        public static string Remoting_NullMessage
        {
            get { return Resource.Remoting_NullMessage; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Return argument has an invalid type..
        /// </summary>
        public static string Remoting_Proxy_BadReturnType
        {
            get { return Resource.Remoting_Proxy_BadReturnType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Bad return type for activation call via Invoke: must be of type IConstructionReturnMessage..
        /// </summary>
        public static string Remoting_Proxy_BadReturnTypeForActivation
        {
            get { return Resource.Remoting_Proxy_BadReturnTypeForActivation; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The proxy is of an unsupported type..
        /// </summary>
        public static string Remoting_Proxy_BadType
        {
            get { return Resource.Remoting_Proxy_BadType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type mismatch between proxy type &apos;{0}&apos; and activation type &apos;{1}&apos;..
        /// </summary>
        public static string Remoting_Proxy_BadTypeForActivation
        {
            get { return Resource.Remoting_Proxy_BadTypeForActivation; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The message passed to Invoke should be passed to PropagateOutParameters..
        /// </summary>
        public static string Remoting_Proxy_ExpectedOriginalMessage
        {
            get { return Resource.Remoting_Proxy_ExpectedOriginalMessage; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Trying to call proxy while constructor call is in progress..
        /// </summary>
        public static string Remoting_Proxy_InvalidCall
        {
            get { return Resource.Remoting_Proxy_InvalidCall; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Only the synchronous call type is supported for messages that are not of type Message..
        /// </summary>
        public static string Remoting_Proxy_InvalidCallType
        {
            get { return Resource.Remoting_Proxy_InvalidCallType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Channel sink does not exist. Failed to dispatch async call..
        /// </summary>
        public static string Remoting_Proxy_InvalidState
        {
            get { return Resource.Remoting_Proxy_InvalidState; }
        }

        /// <summary>
        ///   Looks up a localized string similar to This remoting proxy has no channel sink which means either the server has no registered server channels that are listening, or this application has no suitable client channel to talk to the server..
        /// </summary>
        public static string Remoting_Proxy_NoChannelSink
        {
            get { return Resource.Remoting_Proxy_NoChannelSink; }
        }

        /// <summary>
        ///   Looks up a localized string similar to classToProxy argument must derive from MarshalByRef type..
        /// </summary>
        public static string Remoting_Proxy_ProxyTypeIsNotMBR
        {
            get { return Resource.Remoting_Proxy_ProxyTypeIsNotMBR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to ByRef value type parameter cannot be null..
        /// </summary>
        public static string Remoting_Proxy_ReturnValueTypeCannotBeNull
        {
            get { return Resource.Remoting_Proxy_ReturnValueTypeCannotBeNull; }
        }

        /// <summary>
        ///   Looks up a localized string similar to  ExecuteMessage can be called only from the native context of the object..
        /// </summary>
        public static string Remoting_Proxy_WrongContext
        {
            get { return Resource.Remoting_Proxy_WrongContext; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attempt to reset the Uri for an object from &apos;{0}&apos; to &apos;{1}&apos;..
        /// </summary>
        public static string Remoting_ResetURI
        {
            get { return Resource.Remoting_ResetURI; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The server object for Uri &apos;{0}&apos; is not registered with the remoting infrastructure (it may have been disconnected)..
        /// </summary>
        public static string Remoting_ServerObjectNotFound
        {
            get { return Resource.Remoting_ServerObjectNotFound; }
        }

        /// <summary>
        ///   Looks up a localized string similar to SetObjectUriForMarshal method should only be called for MarshalByRefObjects that exist in the current AppDomain..
        /// </summary>
        public static string Remoting_SetObjectUriForMarshal__ObjectNeedsToBeLocal
        {
            get { return Resource.Remoting_SetObjectUriForMarshal__ObjectNeedsToBeLocal; }
        }

        /// <summary>
        ///   Looks up a localized string similar to SetObjectUriForMarshal method has already been called on this object or the object has already been marshaled..
        /// </summary>
        public static string Remoting_SetObjectUriForMarshal__UriExists
        {
            get { return Resource.Remoting_SetObjectUriForMarshal__UriExists; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Soap Parse error, xsd:type &apos;{0}&apos; invalid {1}.
        /// </summary>
        public static string Remoting_SOAPInteropxsdInvalid
        {
            get { return Resource.Remoting_SOAPInteropxsdInvalid; }
        }

        /// <summary>
        ///   Looks up a localized string similar to SoapQName missing a Namespace value &apos;{0}&apos;..
        /// </summary>
        public static string Remoting_SOAPQNameNamespace
        {
            get { return Resource.Remoting_SOAPQNameNamespace; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified flag &apos;{0}&apos; does not have one of the valid values..
        /// </summary>
        public static string Remoting_ThreadAffinity_InvalidFlag
        {
            get { return Resource.Remoting_ThreadAffinity_InvalidFlag; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The transparent proxy field of a real proxy must be null..
        /// </summary>
        public static string Remoting_TP_NonNull
        {
            get { return Resource.Remoting_TP_NonNull; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The handler has already been registered with TrackingServices..
        /// </summary>
        public static string Remoting_TrackingHandlerAlreadyRegistered
        {
            get { return Resource.Remoting_TrackingHandlerAlreadyRegistered; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The given type cannot be passed in a remote call..
        /// </summary>
        public static string Remoting_TypeCantBeRemoted
        {
            get { return Resource.Remoting_TypeCantBeRemoted; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Failed to create a transparent proxy. If a custom RealProxy is being used ensure it sets the proxy type..
        /// </summary>
        public static string Remoting_UnexpectedNullTP
        {
            get { return Resource.Remoting_UnexpectedNullTP; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Found two different objects associated with the same Uri, &apos;{0}&apos;..
        /// </summary>
        public static string Remoting_URIClash
        {
            get { return Resource.Remoting_URIClash; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The remoted object already has an associated Uri..
        /// </summary>
        public static string Remoting_URIExists
        {
            get { return Resource.Remoting_URIExists; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Trying to associate the Uri with a proxy..
        /// </summary>
        public static string Remoting_URIToProxy
        {
            get { return Resource.Remoting_URIToProxy; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attempt to connect to a server using its object Uri: &apos;{0}&apos;. A valid, complete URL must be used..
        /// </summary>
        public static string Remoting_WellKnown_CantDirectlyConnect
        {
            get { return Resource.Remoting_WellKnown_CantDirectlyConnect; }
        }

        /// <summary>
        ///   Looks up a localized string similar to &apos;{0}&apos;: A well-known object cannot marshal itself in its constructor, or perform any action that would cause it to be marshaled (such as passing the &apos;this&apos; pointer as a parameter to a remote method)..
        /// </summary>
        public static string Remoting_WellKnown_CtorCantMarshal
        {
            get { return Resource.Remoting_WellKnown_CtorCantMarshal; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attempted to create well-known object of type &apos;{0}&apos;. Well-known objects must derive from the MarshalByRefObject class..
        /// </summary>
        public static string Remoting_WellKnown_MustBeMBR
        {
            get { return Resource.Remoting_WellKnown_MustBeMBR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to ResourceReader is closed..
        /// </summary>
        public static string ResourceReaderIsClosed
        {
            get { return Resource.ResourceReaderIsClosed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Stream is not a valid resource file..
        /// </summary>
        public static string Resources_StreamNotValid
        {
            get { return Resource.Resources_StreamNotValid; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Multiple custom attributes of the same type found..
        /// </summary>
        public static string RFLCT_AmbigCust
        {
            get { return Resource.RFLCT_AmbigCust; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Ambiguous match found..
        /// </summary>
        public static string RFLCT_Ambiguous
        {
            get { return Resource.RFLCT_Ambiguous; }
        }

        /// <summary>
        ///   Looks up a localized string similar to An Int32 must be provided for the filter criteria..
        /// </summary>
        public static string RFLCT_FltCritInt
        {
            get { return Resource.RFLCT_FltCritInt; }
        }

        /// <summary>
        ///   Looks up a localized string similar to A String must be provided for the filter criteria..
        /// </summary>
        public static string RFLCT_FltCritString
        {
            get { return Resource.RFLCT_FltCritString; }
        }

        /// <summary>
        ///   Looks up a localized string similar to &apos;{0}&apos; field specified was not found..
        /// </summary>
        public static string RFLCT_InvalidFieldFail
        {
            get { return Resource.RFLCT_InvalidFieldFail; }
        }

        /// <summary>
        ///   Looks up a localized string similar to &apos;{0}&apos; property specified was not found..
        /// </summary>
        public static string RFLCT_InvalidPropFail
        {
            get { return Resource.RFLCT_InvalidPropFail; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object does not match target type..
        /// </summary>
        public static string RFLCT_Targ_ITargMismatch
        {
            get { return Resource.RFLCT_Targ_ITargMismatch; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Non-static field requires a target..
        /// </summary>
        public static string RFLCT_Targ_StatFldReqTarg
        {
            get { return Resource.RFLCT_Targ_StatFldReqTarg; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Non-static method requires a target..
        /// </summary>
        public static string RFLCT_Targ_StatMethReqTarg
        {
            get { return Resource.RFLCT_Targ_StatMethReqTarg; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Caller is not a friend..
        /// </summary>
        public static string RtType_InvalidCaller
        {
            get { return Resource.RtType_InvalidCaller; }
        }

        /// <summary>
        ///   Looks up a localized string similar to An object that does not derive from System.Exception has been wrapped in a RuntimeWrappedException..
        /// </summary>
        public static string RuntimeWrappedException
        {
            get { return Resource.RuntimeWrappedException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The action that unsuccessfully was:.
        /// </summary>
        public static string Security_Action
        {
            get { return Resource.Security_Action; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The demand unsuccessfully due to the code access security information captured during the creation of an anonymously hosted dynamic method. In order for this operation to succeed, ensure that the demand would have succeeded at the time the method was created. See http://go.microsoft.com/fwlink/?LinkId=288746 for more information..
        /// </summary>
        public static string Security_AnonymouslyHostedDynamicMethodCheckFailed
        {
            get { return Resource.Security_AnonymouslyHostedDynamicMethodCheckFailed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The assembly or AppDomain that unsuccessfully was:.
        /// </summary>
        public static string Security_Assembly
        {
            get { return Resource.Security_Assembly; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Hash for the assembly cannot be generated..
        /// </summary>
        public static string Security_CannotGenerateHash
        {
            get { return Resource.Security_CannotGenerateHash; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Assembly bytes could not be retrieved..
        /// </summary>
        public static string Security_CannotGetRawData
        {
            get { return Resource.Security_CannotGetRawData; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The time zone ID &apos;{0}&apos; was found on the local computer, but the application does not have permission to read the file..
        /// </summary>
        public static string Security_CannotReadFileData
        {
            get { return Resource.Security_CannotReadFileData; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The time zone ID &apos;{0}&apos; was found on the local computer, but the application does not have permission to read the registry information..
        /// </summary>
        public static string Security_CannotReadRegistryData
        {
            get { return Resource.Security_CannotReadRegistryData; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The demand was for:.
        /// </summary>
        public static string Security_Demanded
        {
            get { return Resource.Security_Demanded; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The denied permissions were:.
        /// </summary>
        public static string Security_Denied
        {
            get { return Resource.Security_Denied; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The first permission that unsuccessfully was:.
        /// </summary>
        public static string Security_FirstPermThatFailed
        {
            get { return Resource.Security_FirstPermThatFailed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Request for the permission of type &apos;{0}&apos; unsuccessfully..
        /// </summary>
        public static string Security_Generic
        {
            get { return Resource.Security_Generic; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Request unsuccessfully..
        /// </summary>
        public static string Security_GenericNoType
        {
            get { return Resource.Security_GenericNoType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The granted set of the failing assembly was:.
        /// </summary>
        public static string Security_GrantedSet
        {
            get { return Resource.Security_GrantedSet; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The method that caused the failure was:.
        /// </summary>
        public static string Security_Method
        {
            get { return Resource.Security_Method; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Stack walk modifier must be reverted before another modification of the same type can be performed..
        /// </summary>
        public static string Security_MustRevertOverride
        {
            get { return Resource.Security_MustRevertOverride; }
        }

        /// <summary>
        ///   Looks up a localized string similar to That assembly does not allow partially trusted callers..
        /// </summary>
        public static string Security_NoAPTCA
        {
            get { return Resource.Security_NoAPTCA; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The only permitted permissions were:.
        /// </summary>
        public static string Security_PermitOnly
        {
            get { return Resource.Security_PermitOnly; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Request for principal permission unsuccessfully..
        /// </summary>
        public static string Security_PrincipalPermission
        {
            get { return Resource.Security_PrincipalPermission; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The refused set of the failing assembly was:.
        /// </summary>
        public static string Security_RefusedSet
        {
            get { return Resource.Security_RefusedSet; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Requested registry access is not allowed..
        /// </summary>
        public static string Security_RegistryPermission
        {
            get { return Resource.Security_RegistryPermission; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The type of the first permission that unsuccessfully was:.
        /// </summary>
        public static string Security_TypeFirstPermThatFailed
        {
            get { return Resource.Security_TypeFirstPermThatFailed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The Url of the assembly that unsuccessfully was:.
        /// </summary>
        public static string Security_Url
        {
            get { return Resource.Security_Url; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The Zone of the assembly that unsuccessfully was:.
        /// </summary>
        public static string Security_Zone
        {
            get { return Resource.Security_Zone; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The initialCount argument must be non-negative and less than or equal to the maximumCount..
        /// </summary>
        public static string SemaphoreSlim_ctor_InitialCountWrong
        {
            get { return Resource.SemaphoreSlim_ctor_InitialCountWrong; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The maximumCount argument must be a positive number. If a maximum is not required, use the constructor without a maxCount parameter..
        /// </summary>
        public static string SemaphoreSlim_ctor_MaxCountWrong
        {
            get { return Resource.SemaphoreSlim_ctor_MaxCountWrong; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The semaphore has been disposed..
        /// </summary>
        public static string SemaphoreSlim_Disposed
        {
            get { return Resource.SemaphoreSlim_Disposed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The releaseCount argument must be greater than zero..
        /// </summary>
        public static string SemaphoreSlim_Release_CountWrong
        {
            get { return Resource.SemaphoreSlim_Release_CountWrong; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The timeout must represent a value between -1 and Int32.MaxValue, inclusive..
        /// </summary>
        public static string SemaphoreSlim_Wait_TimeoutWrong
        {
            get { return Resource.SemaphoreSlim_Wait_TimeoutWrong; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Array specifies an invalid length..
        /// </summary>
        public static string Serialization_ArrayInvalidLength
        {
            get { return Resource.Serialization_ArrayInvalidLength; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Array does not specify a length..
        /// </summary>
        public static string Serialization_ArrayNoLength
        {
            get { return Resource.Serialization_ArrayNoLength; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid array type &apos;{0}&apos;..
        /// </summary>
        public static string Serialization_ArrayType
        {
            get { return Resource.Serialization_ArrayType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Array element type is Object, &apos;dt&apos; attribute is null..
        /// </summary>
        public static string Serialization_ArrayTypeObject
        {
            get { return Resource.Serialization_ArrayTypeObject; }
        }

        /// <summary>
        ///   Looks up a localized string similar to No assembly information is available for object on the wire, &apos;{0}&apos;..
        /// </summary>
        public static string Serialization_Assembly
        {
            get { return Resource.Serialization_Assembly; }
        }

        /// <summary>
        ///   Looks up a localized string similar to No assembly ID for object type &apos;{0}&apos;..
        /// </summary>
        public static string Serialization_AssemblyId
        {
            get { return Resource.Serialization_AssemblyId; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to find assembly &apos;{0}&apos;..
        /// </summary>
        public static string Serialization_AssemblyNotFound
        {
            get { return Resource.Serialization_AssemblyNotFound; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Non existent ParameterInfo. Position bigger than member&apos;s parameters length..
        /// </summary>
        public static string Serialization_BadParameterInfo
        {
            get { return Resource.Serialization_BadParameterInfo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Binary stream &apos;{0}&apos; does not contain a valid BinaryHeader. Possible causes are invalid stream or object version change between serialization and deserialization..
        /// </summary>
        public static string Serialization_BinaryHeader
        {
            get { return Resource.Serialization_BinaryHeader; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot get the type &apos;{0}&apos;..
        /// </summary>
        public static string Serialization_CannotGetType
        {
            get { return Resource.Serialization_CannotGetType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The constructor to deserialize an object of type &apos;{0}&apos; was not found..
        /// </summary>
        public static string Serialization_ConstructorNotFound
        {
            get { return Resource.Serialization_ConstructorNotFound; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid BinaryFormatter stream..
        /// </summary>
        public static string Serialization_CorruptedStream
        {
            get { return Resource.Serialization_CorruptedStream; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The value of the field &apos;{0}&apos; is invalid.  The serialized data is corrupt..
        /// </summary>
        public static string Serialization_CorruptField
        {
            get { return Resource.Serialization_CorruptField; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cross-AppDomain BinaryFormatter error; expected &apos;{0}&apos; but received &apos;{1}&apos;..
        /// </summary>
        public static string Serialization_CrossAppDomainError
        {
            get { return Resource.Serialization_CrossAppDomainError; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid serialized DateTime data. Ticks must be between DateTime.MinValue.Ticks and DateTime.MaxValue.Ticks. .
        /// </summary>
        public static string Serialization_DateTimeTicksOutOfRange
        {
            get { return Resource.Serialization_DateTimeTicksOutOfRange; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Selector is already on the list of checked selectors..
        /// </summary>
        public static string Serialization_DuplicateSelector
        {
            get { return Resource.Serialization_DuplicateSelector; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Header reflection error: number of value members: {0}..
        /// </summary>
        public static string Serialization_HeaderReflection
        {
            get { return Resource.Serialization_HeaderReflection; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object IDs must be greater than zero..
        /// </summary>
        public static string Serialization_IdTooSmall
        {
            get { return Resource.Serialization_IdTooSmall; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The ObjectManager found an invalid number of fixups. This usually indicates a problem in the Formatter..
        /// </summary>
        public static string Serialization_IncorrectNumberOfFixups
        {
            get { return Resource.Serialization_IncorrectNumberOfFixups; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Insufficient state to deserialize the object. Missing field &apos;{0}&apos;. More information is needed..
        /// </summary>
        public static string Serialization_InsufficientDeserializationState
        {
            get { return Resource.Serialization_InsufficientDeserializationState; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Insufficient state to return the real object..
        /// </summary>
        public static string Serialization_InsufficientState
        {
            get { return Resource.Serialization_InsufficientState; }
        }

        /// <summary>
        ///   Looks up a localized string similar to An error occurred while deserializing the object.  The serialized data is corrupt..
        /// </summary>
        public static string Serialization_InvalidData
        {
            get { return Resource.Serialization_InvalidData; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot serialize delegates over unmanaged function pointers, dynamic methods or methods outside the delegate creator&apos;s assembly..
        /// </summary>
        public static string Serialization_InvalidDelegateType
        {
            get { return Resource.Serialization_InvalidDelegateType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The serialized data contained an invalid escape sequence &apos;\\{0}&apos;..
        /// </summary>
        public static string Serialization_InvalidEscapeSequence
        {
            get { return Resource.Serialization_InvalidEscapeSequence; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object fields may not be properly initialized..
        /// </summary>
        public static string Serialization_InvalidFieldState
        {
            get { return Resource.Serialization_InvalidFieldState; }
        }

        /// <summary>
        ///   Looks up a localized string similar to A fixup on an object implementing ISerializable or having a surrogate was discovered for an object which does not have a SerializationInfo available..
        /// </summary>
        public static string Serialization_InvalidFixupDiscovered
        {
            get { return Resource.Serialization_InvalidFixupDiscovered; }
        }

        /// <summary>
        ///   Looks up a localized string similar to A member fixup was registered for an object which implements ISerializable or has a surrogate. In this situation, a delayed fixup must be used..
        /// </summary>
        public static string Serialization_InvalidFixupType
        {
            get { return Resource.Serialization_InvalidFixupType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The input stream is not a valid binary format. The starting contents (in bytes) are: {0} ....
        /// </summary>
        public static string Serialization_InvalidFormat
        {
            get { return Resource.Serialization_InvalidFormat; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object specifies an invalid ID..
        /// </summary>
        public static string Serialization_InvalidID
        {
            get { return Resource.Serialization_InvalidID; }
        }

        /// <summary>
        ///   Looks up a localized string similar to OnDeserialization method was called while the object was not being deserialized..
        /// </summary>
        public static string Serialization_InvalidOnDeser
        {
            get { return Resource.Serialization_InvalidOnDeser; }
        }

        /// <summary>
        ///   Looks up a localized string similar to An IntPtr or UIntPtr with an eight byte value cannot be deserialized on a machine with a four byte word size..
        /// </summary>
        public static string Serialization_InvalidPtrValue
        {
            get { return Resource.Serialization_InvalidPtrValue; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Only system-provided types can be passed to the GetUninitializedObject method. &apos;{0}&apos; is not a valid instance of a type..
        /// </summary>
        public static string Serialization_InvalidType
        {
            get { return Resource.Serialization_InvalidType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The object with ID {0} implements the IObjectReference interface for which all dependencies cannot be resolved. The likely cause is two instances of IObjectReference that have a mutual dependency on each other..
        /// </summary>
        public static string Serialization_IORIncomplete
        {
            get { return Resource.Serialization_IORIncomplete; }
        }

        /// <summary>
        ///   Looks up a localized string similar to MemberInfo requested for ISerializable type..
        /// </summary>
        public static string Serialization_ISerializableMemberInfo
        {
            get { return Resource.Serialization_ISerializableMemberInfo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Types not available for ISerializable object &apos;{0}&apos;..
        /// </summary>
        public static string Serialization_ISerializableTypes
        {
            get { return Resource.Serialization_ISerializableTypes; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The keys and values arrays have different sizes..
        /// </summary>
        public static string Serialization_KeyValueDifferentSizes
        {
            get { return Resource.Serialization_KeyValueDifferentSizes; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The array information in the stream is invalid..
        /// </summary>
        public static string Serialization_MalformedArray
        {
            get { return Resource.Serialization_MalformedArray; }
        }

        /// <summary>
        ///   Looks up a localized string similar to No map for object &apos;{0}&apos;..
        /// </summary>
        public static string Serialization_Map
        {
            get { return Resource.Serialization_Map; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type {0} must be marshaled by reference in this context..
        /// </summary>
        public static string Serialization_MBRAsMBV
        {
            get { return Resource.Serialization_MBRAsMBV; }
        }

        /// <summary>
        ///   Looks up a localized string similar to MemberInfo cannot be obtained for ISerialized Object &apos;{0}&apos;..
        /// </summary>
        public static string Serialization_MemberInfo
        {
            get { return Resource.Serialization_MemberInfo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The deserialized value of the member &quot;{0}&quot; in the class &quot;{1}&quot; is out of range..
        /// </summary>
        public static string Serialization_MemberOutOfRange
        {
            get { return Resource.Serialization_MemberOutOfRange; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unknown member type..
        /// </summary>
        public static string Serialization_MemberTypeNotRecognized
        {
            get { return Resource.Serialization_MemberTypeNotRecognized; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid MethodCall or MethodReturn stream format..
        /// </summary>
        public static string Serialization_Method
        {
            get { return Resource.Serialization_Method; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Field {0} is missing..
        /// </summary>
        public static string Serialization_MissField
        {
            get { return Resource.Serialization_MissField; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid serialized DateTime data. Unable to find &apos;ticks&apos; or &apos;dateData&apos;..
        /// </summary>
        public static string Serialization_MissingDateTimeData
        {
            get { return Resource.Serialization_MissingDateTimeData; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The Keys for this Hashtable are missing..
        /// </summary>
        public static string Serialization_MissingKeys
        {
            get { return Resource.Serialization_MissingKeys; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The KeyValuePairs for this Dictionary are missing..
        /// </summary>
        public static string Serialization_MissingKeyValuePairs
        {
            get { return Resource.Serialization_MissingKeyValuePairs; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Member &apos;{0}&apos; in class &apos;{1}&apos; is not present in the serialized stream and is not marked with {2}..
        /// </summary>
        public static string Serialization_MissingMember
        {
            get { return Resource.Serialization_MissingMember; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The object with ID {0} was referenced in a fixup but has not been registered..
        /// </summary>
        public static string Serialization_MissingObject
        {
            get { return Resource.Serialization_MissingObject; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The values for this dictionary are missing..
        /// </summary>
        public static string Serialization_MissingValues
        {
            get { return Resource.Serialization_MissingValues; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot resolve multiple members with the same name..
        /// </summary>
        public static string Serialization_MultipleMembers
        {
            get { return Resource.Serialization_MultipleMembers; }
        }

        /// <summary>
        ///   Looks up a localized string similar to A fixup is registered to the object with ID {0}, but the object does not appear in the graph..
        /// </summary>
        public static string Serialization_NeverSeen
        {
            get { return Resource.Serialization_NeverSeen; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object does not specify a base type..
        /// </summary>
        public static string Serialization_NoBaseType
        {
            get { return Resource.Serialization_NoBaseType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object has never been assigned an objectID..
        /// </summary>
        public static string Serialization_NoID
        {
            get { return Resource.Serialization_NoID; }
        }

        /// <summary>
        ///   Looks up a localized string similar to No MemberInfo for Object {0}..
        /// </summary>
        public static string Serialization_NoMemberInfo
        {
            get { return Resource.Serialization_NoMemberInfo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type &apos;{0}&apos; in Assembly &apos;{1}&apos; is not marked as serializable..
        /// </summary>
        public static string Serialization_NonSerType
        {
            get { return Resource.Serialization_NonSerType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Serialized member does not have a ParameterInfo..
        /// </summary>
        public static string Serialization_NoParameterInfo
        {
            get { return Resource.Serialization_NoParameterInfo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to {0}.SetObjectData returns a value that is neither null nor equal to the first parameter. Such Surrogates cannot be part of cyclical reference..
        /// </summary>
        public static string Serialization_NotCyclicallyReferenceableSurrogate
        {
            get { return Resource.Serialization_NotCyclicallyReferenceableSurrogate; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Member &apos;{0}&apos; was not found..
        /// </summary>
        public static string Serialization_NotFound
        {
            get { return Resource.Serialization_NotFound; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The given object does not implement the ISerializable interface..
        /// </summary>
        public static string Serialization_NotISer
        {
            get { return Resource.Serialization_NotISer; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object does not specify a type..
        /// </summary>
        public static string Serialization_NoType
        {
            get { return Resource.Serialization_NoType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to One of the serialized keys is null..
        /// </summary>
        public static string Serialization_NullKey
        {
            get { return Resource.Serialization_NullKey; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The method signature cannot be null..
        /// </summary>
        public static string Serialization_NullSignature
        {
            get { return Resource.Serialization_NullSignature; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The object with ID {0} was referenced in a fixup but does not exist..
        /// </summary>
        public static string Serialization_ObjectNotSupplied
        {
            get { return Resource.Serialization_ObjectNotSupplied; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid ObjectTypeEnum {0}..
        /// </summary>
        public static string Serialization_ObjectTypeEnum
        {
            get { return Resource.Serialization_ObjectTypeEnum; }
        }

        /// <summary>
        ///   Looks up a localized string similar to An object was used before its deserialization callback ran, which may break higher-level consistency guarantees in the application..
        /// </summary>
        public static string Serialization_ObjectUsedBeforeDeserCallback
        {
            get { return Resource.Serialization_ObjectUsedBeforeDeserCallback; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Object {0} has never been assigned an objectID..
        /// </summary>
        public static string Serialization_ObjNoID
        {
            get { return Resource.Serialization_ObjNoID; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Version value must be positive..
        /// </summary>
        public static string Serialization_OptionalFieldVersionValue
        {
            get { return Resource.Serialization_OptionalFieldVersionValue; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The ID of the containing object cannot be the same as the object ID..
        /// </summary>
        public static string Serialization_ParentChildIdentical
        {
            get { return Resource.Serialization_ParentChildIdentical; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Parse error. Current element is not compatible with the next element, {0}..
        /// </summary>
        public static string Serialization_ParseError
        {
            get { return Resource.Serialization_ParseError; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Fixing up a partially available ValueType chain is not implemented..
        /// </summary>
        public static string Serialization_PartialValueTypeFixup
        {
            get { return Resource.Serialization_PartialValueTypeFixup; }
        }

        /// <summary>
        ///   Looks up a localized string similar to An object cannot be registered twice..
        /// </summary>
        public static string Serialization_RegisterTwice
        {
            get { return Resource.Serialization_RegisterTwice; }
        }

        /// <summary>
        ///   Looks up a localized string similar to A type &apos;{0}&apos; that is defined in a partially trusted assembly cannot be type forwarded from an assembly with a different Public Key Token or without a public key token. To fix this, please either turn on unsafeTypeForwarding flag in the configuration file or remove the TypeForwardedFrom attribute..
        /// </summary>
        public static string Serialization_RequireFullTrust
        {
            get { return Resource.Serialization_RequireFullTrust; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot add the same member twice to a SerializationInfo object..
        /// </summary>
        public static string Serialization_SameNameTwice
        {
            get { return Resource.Serialization_SameNameTwice; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Because of security restrictions, the type {0} cannot be accessed..
        /// </summary>
        public static string Serialization_Security
        {
            get { return Resource.Serialization_Security; }
        }

        /// <summary>
        ///   Looks up a localized string similar to MemberInfo type {0} cannot be serialized..
        /// </summary>
        public static string Serialization_SerMemberInfo
        {
            get { return Resource.Serialization_SerMemberInfo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Attempting to deserialize an empty stream..
        /// </summary>
        public static string Serialization_Stream
        {
            get { return Resource.Serialization_Stream; }
        }

        /// <summary>
        ///   Looks up a localized string similar to End of Stream encountered before parsing was completed..
        /// </summary>
        public static string Serialization_StreamEnd
        {
            get { return Resource.Serialization_StreamEnd; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The serialized Capacity property of StringBuilder must be positive, less than or equal to MaxCapacity and greater than or equal to the String length..
        /// </summary>
        public static string Serialization_StringBuilderCapacity
        {
            get { return Resource.Serialization_StringBuilderCapacity; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The serialized MaxCapacity property of StringBuilder must be positive and greater than or equal to the String length..
        /// </summary>
        public static string Serialization_StringBuilderMaxCapacity
        {
            get { return Resource.Serialization_StringBuilderMaxCapacity; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Adding selector will introduce a cycle..
        /// </summary>
        public static string Serialization_SurrogateCycle
        {
            get { return Resource.Serialization_SurrogateCycle; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Selector contained a cycle..
        /// </summary>
        public static string Serialization_SurrogateCycleInArgument
        {
            get { return Resource.Serialization_SurrogateCycleInArgument; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The internal array cannot expand to greater than Int32.MaxValue elements..
        /// </summary>
        public static string Serialization_TooManyElements
        {
            get { return Resource.Serialization_TooManyElements; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The implementation of the IObjectReference interface returns too many nested references to other objects that implement IObjectReference..
        /// </summary>
        public static string Serialization_TooManyReferences
        {
            get { return Resource.Serialization_TooManyReferences; }
        }

        /// <summary>
        ///   Looks up a localized string similar to No top object..
        /// </summary>
        public static string Serialization_TopObject
        {
            get { return Resource.Serialization_TopObject; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Top object cannot be instantiated for element &apos;{0}&apos;..
        /// </summary>
        public static string Serialization_TopObjectInstantiate
        {
            get { return Resource.Serialization_TopObjectInstantiate; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid type code in stream &apos;{0}&apos;..
        /// </summary>
        public static string Serialization_TypeCode
        {
            get { return Resource.Serialization_TypeCode; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid expected type..
        /// </summary>
        public static string Serialization_TypeExpected
        {
            get { return Resource.Serialization_TypeExpected; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to load type {0} required for deserialization..
        /// </summary>
        public static string Serialization_TypeLoadFailure
        {
            get { return Resource.Serialization_TypeLoadFailure; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type is missing for member of type Object &apos;{0}&apos;..
        /// </summary>
        public static string Serialization_TypeMissing
        {
            get { return Resource.Serialization_TypeMissing; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid read type request &apos;{0}&apos;..
        /// </summary>
        public static string Serialization_TypeRead
        {
            get { return Resource.Serialization_TypeRead; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type is not resolved for member &apos;{0}&apos;..
        /// </summary>
        public static string Serialization_TypeResolved
        {
            get { return Resource.Serialization_TypeResolved; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type {0} and the types derived from it (such as {1}) are not permitted to be deserialized at this security level..
        /// </summary>
        public static string Serialization_TypeSecurity
        {
            get { return Resource.Serialization_TypeSecurity; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid write type request &apos;{0}&apos;..
        /// </summary>
        public static string Serialization_TypeWrite
        {
            get { return Resource.Serialization_TypeWrite; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The given module {0} cannot be found within the assembly {1}..
        /// </summary>
        public static string Serialization_UnableToFindModule
        {
            get { return Resource.Serialization_UnableToFindModule; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot perform fixup..
        /// </summary>
        public static string Serialization_UnableToFixup
        {
            get { return Resource.Serialization_UnableToFixup; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot get the member &apos;{0}&apos;..
        /// </summary>
        public static string Serialization_UnknownMember
        {
            get { return Resource.Serialization_UnknownMember; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Only FieldInfo, PropertyInfo, and SerializationMemberInfo are recognized..
        /// </summary>
        public static string Serialization_UnknownMemberInfo
        {
            get { return Resource.Serialization_UnknownMemberInfo; }
        }

        /// <summary>
        ///   Looks up a localized string similar to ValueType fixup on Arrays is not implemented..
        /// </summary>
        public static string Serialization_ValueTypeFixup
        {
            get { return Resource.Serialization_ValueTypeFixup; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid element &apos;{0}&apos;..
        /// </summary>
        public static string Serialization_XMLElement
        {
            get { return Resource.Serialization_XMLElement; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Site.
        /// </summary>
        public static string Site_ToString
        {
            get { return Resource.Site_ToString; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Site - {0}.
        /// </summary>
        public static string Site_ToStringArg
        {
            get { return Resource.Site_ToStringArg; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The calling thread does not hold the lock..
        /// </summary>
        public static string SpinLock_Exit_SynchronizationLockException
        {
            get { return Resource.SpinLock_Exit_SynchronizationLockException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Thread tracking is disabled..
        /// </summary>
        public static string SpinLock_IsHeldByCurrentThread
        {
            get { return Resource.SpinLock_IsHeldByCurrentThread; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The timeout must be a value between -1 and Int32.MaxValue, inclusive..
        /// </summary>
        public static string SpinLock_TryEnter_ArgumentOutOfRange
        {
            get { return Resource.SpinLock_TryEnter_ArgumentOutOfRange; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The calling thread already holds the lock..
        /// </summary>
        public static string SpinLock_TryEnter_LockRecursionException
        {
            get { return Resource.SpinLock_TryEnter_LockRecursionException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The tookLock argument must be set to false before calling this method..
        /// </summary>
        public static string SpinLock_TryReliableEnter_ArgumentException
        {
            get { return Resource.SpinLock_TryReliableEnter_ArgumentException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The condition argument is null..
        /// </summary>
        public static string SpinWait_SpinUntil_ArgumentNull
        {
            get { return Resource.SpinWait_SpinUntil_ArgumentNull; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The timeout must represent a value between -1 and Int32.MaxValue, inclusive..
        /// </summary>
        public static string SpinWait_SpinUntil_TimeoutWrong
        {
            get { return Resource.SpinWait_SpinUntil_TimeoutWrong; }
        }

        /// <summary>
        ///   Looks up a localized string similar to in {0}:line {1}.
        /// </summary>
        public static string StackTrace_InFileLineNumber
        {
            get { return Resource.StackTrace_InFileLineNumber; }
        }

        /// <summary>
        ///   Looks up a localized string similar to name {0}.
        /// </summary>
        public static string StrongName_Name
        {
            get { return Resource.StrongName_Name; }
        }

        /// <summary>
        ///   Looks up a localized string similar to StrongName - {0}{1}{2}.
        /// </summary>
        public static string StrongName_ToString
        {
            get { return Resource.StrongName_ToString; }
        }

        /// <summary>
        ///   Looks up a localized string similar to version {0}.
        /// </summary>
        public static string StrongName_Version
        {
            get { return Resource.StrongName_Version; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified TaskContinuationOptions combined LongRunning and ExecuteSynchronously.  Synchronous continuations should not be long running..
        /// </summary>
        public static string Task_ContinueWith_ESandLR
        {
            get { return Resource.Task_ContinueWith_ESandLR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The specified TaskContinuationOptions excluded all continuation kinds..
        /// </summary>
        public static string Task_ContinueWith_NotOnAnything
        {
            get { return Resource.Task_ContinueWith_NotOnAnything; }
        }

        /// <summary>
        ///   Looks up a localized string similar to (Internal)An attempt was made to create a LongRunning SelfReplicating task..
        /// </summary>
        public static string Task_ctor_LRandSR
        {
            get { return Resource.Task_ctor_LRandSR; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The value needs to translate in milliseconds to -1 (signifying an infinite timeout), 0 or a positive integer less than or equal to Int32.MaxValue..
        /// </summary>
        public static string Task_Delay_InvalidDelay
        {
            get { return Resource.Task_Delay_InvalidDelay; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The value needs to be either -1 (signifying an infinite timeout), 0 or a positive integer..
        /// </summary>
        public static string Task_Delay_InvalidMillisecondsDelay
        {
            get { return Resource.Task_Delay_InvalidMillisecondsDelay; }
        }

        /// <summary>
        ///   Looks up a localized string similar to A task may only be disposed if it is in a completion state (RanToCompletion, Faulted or Canceled)..
        /// </summary>
        public static string Task_Dispose_NotCompleted
        {
            get { return Resource.Task_Dispose_NotCompleted; }
        }

        /// <summary>
        ///   Looks up a localized string similar to It is invalid to specify TaskCreationOptions.LongRunning in calls to FromAsync..
        /// </summary>
        public static string Task_FromAsync_LongRunning
        {
            get { return Resource.Task_FromAsync_LongRunning; }
        }

        /// <summary>
        ///   Looks up a localized string similar to It is invalid to specify TaskCreationOptions.PreferFairness in calls to FromAsync..
        /// </summary>
        public static string Task_FromAsync_PreferFairness
        {
            get { return Resource.Task_FromAsync_PreferFairness; }
        }

        /// <summary>
        ///   Looks up a localized string similar to It is invalid to specify TaskCreationOptions.SelfReplicating in calls to FromAsync..
        /// </summary>
        public static string Task_FromAsync_SelfReplicating
        {
            get { return Resource.Task_FromAsync_SelfReplicating; }
        }

        /// <summary>
        ///   Looks up a localized string similar to FromAsync was called with a TaskManager that had already shut down..
        /// </summary>
        public static string Task_FromAsync_TaskManagerShutDown
        {
            get { return Resource.Task_FromAsync_TaskManagerShutDown; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The tasks argument contains no tasks..
        /// </summary>
        public static string Task_MultiTaskContinuation_EmptyTaskList
        {
            get { return Resource.Task_MultiTaskContinuation_EmptyTaskList; }
        }

        /// <summary>
        ///   Looks up a localized string similar to It is invalid to exclude specific continuation kinds for continuations off of multiple tasks..
        /// </summary>
        public static string Task_MultiTaskContinuation_FireOptions
        {
            get { return Resource.Task_MultiTaskContinuation_FireOptions; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The tasks argument included a null value..
        /// </summary>
        public static string Task_MultiTaskContinuation_NullTask
        {
            get { return Resource.Task_MultiTaskContinuation_NullTask; }
        }

        /// <summary>
        ///   Looks up a localized string similar to RunSynchronously may not be called on a task that was already started..
        /// </summary>
        public static string Task_RunSynchronously_AlreadyStarted
        {
            get { return Resource.Task_RunSynchronously_AlreadyStarted; }
        }

        /// <summary>
        ///   Looks up a localized string similar to RunSynchronously may not be called on a continuation task..
        /// </summary>
        public static string Task_RunSynchronously_Continuation
        {
            get { return Resource.Task_RunSynchronously_Continuation; }
        }

        /// <summary>
        ///   Looks up a localized string similar to RunSynchronously may not be called on a task not bound to a delegate, such as the task returned from an asynchronous method..
        /// </summary>
        public static string Task_RunSynchronously_Promise
        {
            get { return Resource.Task_RunSynchronously_Promise; }
        }

        /// <summary>
        ///   Looks up a localized string similar to RunSynchronously may not be called on a task that has already completed..
        /// </summary>
        public static string Task_RunSynchronously_TaskCompleted
        {
            get { return Resource.Task_RunSynchronously_TaskCompleted; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Start may not be called on a task that was already started..
        /// </summary>
        public static string Task_Start_AlreadyStarted
        {
            get { return Resource.Task_Start_AlreadyStarted; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Start may not be called on a continuation task..
        /// </summary>
        public static string Task_Start_ContinuationTask
        {
            get { return Resource.Task_Start_ContinuationTask; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Start may not be called on a promise-style task..
        /// </summary>
        public static string Task_Start_Promise
        {
            get { return Resource.Task_Start_Promise; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Start may not be called on a task that has completed..
        /// </summary>
        public static string Task_Start_TaskCompleted
        {
            get { return Resource.Task_Start_TaskCompleted; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The task has been disposed..
        /// </summary>
        public static string Task_ThrowIfDisposed
        {
            get { return Resource.Task_ThrowIfDisposed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The tasks array included at least one null element..
        /// </summary>
        public static string Task_WaitMulti_NullTask
        {
            get { return Resource.Task_WaitMulti_NullTask; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The awaited task has not yet completed..
        /// </summary>
        public static string TaskAwaiter_TaskNotCompleted
        {
            get { return Resource.TaskAwaiter_TaskNotCompleted; }
        }

        /// <summary>
        ///   Looks up a localized string similar to A task was canceled..
        /// </summary>
        public static string TaskCanceledException_ctor_DefaultMessage
        {
            get { return Resource.TaskCanceledException_ctor_DefaultMessage; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The exceptions collection was empty..
        /// </summary>
        public static string TaskCompletionSourceT_TrySetException_NoExceptions
        {
            get { return Resource.TaskCompletionSourceT_TrySetException_NoExceptions; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The exceptions collection included at least one null element..
        /// </summary>
        public static string TaskCompletionSourceT_TrySetException_NullException
        {
            get { return Resource.TaskCompletionSourceT_TrySetException_NullException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to A Task&apos;s exception(s) were not observed either by Waiting on the Task or accessing its Exception property. As a result, the unobserved exception was rethrown by the finalizer thread..
        /// </summary>
        public static string TaskExceptionHolder_UnhandledException
        {
            get { return Resource.TaskExceptionHolder_UnhandledException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to (Internal)Expected an Exception or an IEnumerable&lt;Exception&gt;.
        /// </summary>
        public static string TaskExceptionHolder_UnknownExceptionType
        {
            get { return Resource.TaskExceptionHolder_UnknownExceptionType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to ExecuteTask may not be called for a task which was already executed..
        /// </summary>
        public static string TaskScheduler_ExecuteTask_TaskAlreadyExecuted
        {
            get { return Resource.TaskScheduler_ExecuteTask_TaskAlreadyExecuted; }
        }

        /// <summary>
        ///   Looks up a localized string similar to ExecuteTask may not be called for a task which was previously queued to a different TaskScheduler..
        /// </summary>
        public static string TaskScheduler_ExecuteTask_WrongTaskScheduler
        {
            get { return Resource.TaskScheduler_ExecuteTask_WrongTaskScheduler; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The current SynchronizationContext may not be used as a TaskScheduler..
        /// </summary>
        public static string TaskScheduler_FromCurrentSynchronizationContext_NoCurrent
        {
            get { return Resource.TaskScheduler_FromCurrentSynchronizationContext_NoCurrent; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The TryExecuteTaskInline call to the underlying scheduler succeeded, but the task body was not invoked..
        /// </summary>
        public static string TaskScheduler_InconsistentStateAfterTryExecuteTaskInline
        {
            get { return Resource.TaskScheduler_InconsistentStateAfterTryExecuteTaskInline; }
        }

        /// <summary>
        ///   Looks up a localized string similar to An exception was thrown by a TaskScheduler..
        /// </summary>
        public static string TaskSchedulerException_ctor_DefaultMessage
        {
            get { return Resource.TaskSchedulerException_ctor_DefaultMessage; }
        }

        /// <summary>
        ///   Looks up a localized string similar to It is invalid to specify TaskCreationOptions.SelfReplicating for a Task&lt;TResult&gt;..
        /// </summary>
        public static string TaskT_ctor_SelfReplicating
        {
            get { return Resource.TaskT_ctor_SelfReplicating; }
        }

        /// <summary>
        ///   Looks up a localized string similar to {Not yet computed}.
        /// </summary>
        public static string TaskT_DebuggerNoResult
        {
            get { return Resource.TaskT_DebuggerNoResult; }
        }

        /// <summary>
        ///   Looks up a localized string similar to A task&apos;s Exception may only be set directly if the task was created without a function..
        /// </summary>
        public static string TaskT_SetException_HasAnInitializer
        {
            get { return Resource.TaskT_SetException_HasAnInitializer; }
        }

        /// <summary>
        ///   Looks up a localized string similar to An attempt was made to transition a task to a final state when it had already completed..
        /// </summary>
        public static string TaskT_TransitionToFinal_AlreadyCompleted
        {
            get { return Resource.TaskT_TransitionToFinal_AlreadyCompleted; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The wait completed due to an abandoned mutex..
        /// </summary>
        public static string Threading_AbandonedMutexException
        {
            get { return Resource.Threading_AbandonedMutexException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Adding the specified count to the semaphore would cause it to exceed its maximum count..
        /// </summary>
        public static string Threading_SemaphoreFullException
        {
            get { return Resource.Threading_SemaphoreFullException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to No handle of the given name exists..
        /// </summary>
        public static string Threading_WaitHandleCannotBeOpenedException
        {
            get { return Resource.Threading_WaitHandleCannotBeOpenedException; }
        }

        /// <summary>
        ///   Looks up a localized string similar to A WaitHandle with system-wide name &apos;{0}&apos; cannot be created. A WaitHandle of a different type might have the same name..
        /// </summary>
        public static string Threading_WaitHandleCannotBeOpenedException_InvalidHandle
        {
            get { return Resource.Threading_WaitHandleCannotBeOpenedException_InvalidHandle; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The WaitHandle cannot be signaled because it would exceed its maximum count..
        /// </summary>
        public static string Threading_WaitHandleTooManyPosts
        {
            get { return Resource.Threading_WaitHandleTooManyPosts; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The ThreadLocal object has been disposed..
        /// </summary>
        public static string ThreadLocal_Disposed
        {
            get { return Resource.ThreadLocal_Disposed; }
        }

        /// <summary>
        ///   Looks up a localized string similar to ValueFactory attempted to access the Value property of this instance..
        /// </summary>
        public static string ThreadLocal_Value_RecursiveCallsToValue
        {
            get { return Resource.ThreadLocal_Value_RecursiveCallsToValue; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The ThreadLocal object is not tracking values. To use the Values property, use a ThreadLocal constructor that accepts the trackAllValues parameter and set the parameter to true..
        /// </summary>
        public static string ThreadLocal_ValuesNotAvailable
        {
            get { return Resource.ThreadLocal_ValuesNotAvailable; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unable to reset abort because no abort was requested..
        /// </summary>
        public static string ThreadState_NoAbortRequested
        {
            get { return Resource.ThreadState_NoAbortRequested; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The time zone ID &apos;{0}&apos; was not found on the local computer..
        /// </summary>
        public static string TimeZoneNotFound_MissingData
        {
            get { return Resource.TimeZoneNotFound_MissingData; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Type constructor threw an exception..
        /// </summary>
        public static string TypeInitialization_Default
        {
            get { return Resource.TypeInitialization_Default; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The type initializer for &apos;{0}&apos; threw an exception..
        /// </summary>
        public static string TypeInitialization_Type
        {
            get { return Resource.TypeInitialization_Type; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Assembly imported from type library &apos;{0}&apos;..
        /// </summary>
        public static string TypeLibConverter_ImportedTypeLibProductName
        {
            get { return Resource.TypeLibConverter_ImportedTypeLibProductName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Could not resolve nested type &apos;{0}&apos; in type &quot;{1}&apos;..
        /// </summary>
        public static string TypeLoad_ResolveNestedType
        {
            get { return Resource.TypeLoad_ResolveNestedType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Could not resolve type &apos;{0}&apos;..
        /// </summary>
        public static string TypeLoad_ResolveType
        {
            get { return Resource.TypeLoad_ResolveType; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Could not resolve type &apos;{0}&apos; in assembly &apos;{1}&apos;..
        /// </summary>
        public static string TypeLoad_ResolveTypeFromAssembly
        {
            get { return Resource.TypeLoad_ResolveTypeFromAssembly; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Access to the path is denied..
        /// </summary>
        public static string UnauthorizedAccess_IODenied_NoPathName
        {
            get { return Resource.UnauthorizedAccess_IODenied_NoPathName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Access to the path &apos;{0}&apos; is denied..
        /// </summary>
        public static string UnauthorizedAccess_IODenied_Path
        {
            get { return Resource.UnauthorizedAccess_IODenied_Path; }
        }

        /// <summary>
        ///   Looks up a localized string similar to MemoryStream&apos;s internal buffer cannot be accessed..
        /// </summary>
        public static string UnauthorizedAccess_MemStreamBuffer
        {
            get { return Resource.UnauthorizedAccess_MemStreamBuffer; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Access to the registry key &apos;{0}&apos; is denied..
        /// </summary>
        public static string UnauthorizedAccess_RegistryKeyGeneric_Key
        {
            get { return Resource.UnauthorizedAccess_RegistryKeyGeneric_Key; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot write to the registry key..
        /// </summary>
        public static string UnauthorizedAccess_RegistryNoWrite
        {
            get { return Resource.UnauthorizedAccess_RegistryNoWrite; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot execute an assembly in the system domain..
        /// </summary>
        public static string UnauthorizedAccess_SystemDomain
        {
            get { return Resource.UnauthorizedAccess_SystemDomain; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unknown error..
        /// </summary>
        public static string UnknownError
        {
            get { return Resource.UnknownError; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unknown error &quot;{0}&quot;..
        /// </summary>
        public static string UnknownError_Num
        {
            get { return Resource.UnknownError_Num; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Url.
        /// </summary>
        public static string Url_ToString
        {
            get { return Resource.Url_ToString; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Url - {0}.
        /// </summary>
        public static string Url_ToStringArg
        {
            get { return Resource.Url_ToStringArg; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Operation could destabilize the runtime..
        /// </summary>
        public static string Verification_Exception
        {
            get { return Resource.Verification_Exception; }
        }

        /// <summary>
        ///   Looks up a localized string similar to The weak reference is no longer valid..
        /// </summary>
        public static string WeakReference_NoLongerValid
        {
            get { return Resource.WeakReference_NoLongerValid; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Windows Runtime Object Host Domain for &apos;{0}&apos;.
        /// </summary>
        public static string WinRTHostDomainName
        {
            get { return Resource.WinRTHostDomainName; }
        }

        /// <summary>
        ///   Looks up a localized string similar to at.
        /// </summary>
        public static string Word_At
        {
            get { return Resource.Word_At; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid XML in file &apos;{0}&apos; near element &apos;{1}&apos;..
        /// </summary>
        public static string XML_Syntax_InvalidSyntaxInFile
        {
            get { return Resource.XML_Syntax_InvalidSyntaxInFile; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Expected &gt; character..
        /// </summary>
        public static string XMLSyntax_ExpectedCloseBracket
        {
            get { return Resource.XMLSyntax_ExpectedCloseBracket; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Expected / character or string..
        /// </summary>
        public static string XMLSyntax_ExpectedSlashOrString
        {
            get { return Resource.XMLSyntax_ExpectedSlashOrString; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid syntax..
        /// </summary>
        public static string XMLSyntax_InvalidSyntax
        {
            get { return Resource.XMLSyntax_InvalidSyntax; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid XML in file &quot;{0}&quot; near element &quot;{1}&quot;. The &lt;satelliteassemblies&gt; section only supports &lt;assembly&gt; tags..
        /// </summary>
        public static string XMLSyntax_InvalidSyntaxSatAssemTag
        {
            get { return Resource.XMLSyntax_InvalidSyntaxSatAssemTag; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid XML in file &quot;{0}&quot; near &quot;{1}&quot; and &quot;{2}&quot;. In the &lt;satelliteassemblies&gt; section, the &lt;assembly&gt; tag must have exactly 1 attribute called &apos;name&apos;, whose value is a fully-qualified assembly name..
        /// </summary>
        public static string XMLSyntax_InvalidSyntaxSatAssemTagBadAttr
        {
            get { return Resource.XMLSyntax_InvalidSyntaxSatAssemTagBadAttr; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid XML in file &quot;{0}&quot;. In the &lt;satelliteassemblies&gt; section, the &lt;assembly&gt; tag must have exactly 1 attribute called &apos;name&apos;, whose value is a fully-qualified assembly name..
        /// </summary>
        public static string XMLSyntax_InvalidSyntaxSatAssemTagNoAttr
        {
            get { return Resource.XMLSyntax_InvalidSyntaxSatAssemTagNoAttr; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid syntax on line {0}..
        /// </summary>
        public static string XMLSyntax_SyntaxError
        {
            get { return Resource.XMLSyntax_SyntaxError; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Invalid syntax on line {0} - &apos;{1}&apos;..
        /// </summary>
        public static string XMLSyntax_SyntaxErrorEx
        {
            get { return Resource.XMLSyntax_SyntaxErrorEx; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unexpected &gt; character..
        /// </summary>
        public static string XMLSyntax_UnexpectedCloseBracket
        {
            get { return Resource.XMLSyntax_UnexpectedCloseBracket; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Unexpected end of file..
        /// </summary>
        public static string XMLSyntax_UnexpectedEndOfFile
        {
            get { return Resource.XMLSyntax_UnexpectedEndOfFile; }
        }

        /// <summary>
        ///   Looks up a localized string similar to Zone - {0}.
        /// </summary>
        public static string Zone_ToString
        {
            get { return Resource.Zone_ToString; }
        }
    }
}